package com.ibm.btools.blm.ie;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.blm.ui.content.businessruletask.BusinessRuleTaskUtil;
import com.ibm.btools.blm.ui.resource.BLMUiMessageKeys;
import com.ibm.btools.ui.UiPlugin;
import com.ibm.btools.util.logging.LogHelper;
import com.ibm.btools.util.resource.UtilResourceBundleSingleton;

public class BusinessRuleTaskPresentationUtil {

	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	private static BusinessRuleTaskPresentationUtil instance;

	public static final String IF
		= UtilResourceBundleSingleton.INSTANCE.getMessage(
				BLMUiMessageKeys.class,
				BLMUiMessageKeys.UTIL_IF);
	
	public static final String THEN
		= UtilResourceBundleSingleton.INSTANCE.getMessage(
				BLMUiMessageKeys.class,
				BLMUiMessageKeys.UTIL_THEN);
	
	public static BusinessRuleTaskPresentationUtil getInstance() {
		if (instance == null) {
			instance = new BusinessRuleTaskPresentationUtil();
		}
		return instance;
	}

	public String getDisplayablePresentation(final Object source) {
		if (LogHelper.isTraceEnabled()) {
			LogHelper.traceEntry(null, this, "getDisplayablePresentation", 
					"source -->, " + source, "com.ibm.btools.blm.ui");
		}
		UiPlugin.setShowBusinessRulePresentationWithoutTimezoneKey(true);
		String condition = BusinessRuleTaskUtil.getInstance().getDisplayableRuleCondition(source);
		condition = condition.equals("") ? "" : IF + condition;
		String action = BusinessRuleTaskUtil.getInstance().getDisplayableRuleAction(source);
		action = action.equals("") ? "" : THEN + action;
		UiPlugin.setShowBusinessRulePresentationWithoutTimezoneKey(false);
		return condition + action;
	}
}
