package com.ibm.btools.blm.ie.exprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.HashMap;
import java.util.Map;

/**
 * Export options
 */
public class ExportOptions {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	private boolean alwaysOverwrite;
	
	private Map options;

	/**
	 * Check always overwrite
	 * @return
	 */
	public boolean isAlwaysOverwrite() {
		return alwaysOverwrite;
	}

	/**
	 * Set always overwrite
	 * @param alwaysOverwrite
	 */
	public void setAlwaysOverwrite(final boolean alwaysOverwrite) {
		this.alwaysOverwrite = alwaysOverwrite;
	}

	/**
	 * Set additional option by key and value
	 * @param key
	 * @param value
	 */
	public void setAdditionalOption(final String key, Object value) {
		if (options == null) {
			options = new HashMap();
		}
		options.put(key, value);
	}	
	
	/**
	 * Get additional option by name
	 * @param overwrite
	 */
	public Object getAdditionalOption(final String key) {
		if (options == null) {
			return null;
		}
		return options.get(key);
	}
	
	/**
	 * Set the additional options.
	 * @param options
	 */
	public void setAdditionalOptions(Map options) {
		this.options = options;
	}
	
	/**
	 * Get the additional options.
	 * @return options
	 */
	public Map getAdditionalOptions() {
		return options;
	}	
}
