package com.ibm.btools.blm.ie.exprt.filter;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Iterator;
import java.util.List;

import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ui.navigation.model.*;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.resources.BulkResource;
import com.ibm.btools.bom.model.resources.IndividualResource;

/**
 * @author raykong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FdlExportFilter implements IExportFilter {
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	private static FdlExportFilter fdlExportFilter=null;

	private FdlExportFilter() {
	}
	
	public static FdlExportFilter getInstance() {
		if (fdlExportFilter==null) {
			fdlExportFilter = new FdlExportFilter();
		}
		return fdlExportFilter;
	}
	/* (non-Javadoc)
	 * @see com.ibm.btools.blm.ie.exprt.filter.IExportFilter#isNodeSupported(com.ibm.btools.blm.ui.navigation.model.AbstractNode)
	 */
	public boolean isNodeSupported(AbstractNode node) {
		if (
			node instanceof NavigationBusinessEntitiesNode ||
			node instanceof NavigationBusinessEntityNode ||
//			node instanceof NavigationBusinessGroupNode || //??
//			node instanceof NavigationBusinessGroupsNode || // ??
			node instanceof NavigationCategoriesNode || //??
			node instanceof NavigationCategoryNode || //??
			node instanceof NavigationDataCatalogNode || 
			node instanceof NavigationDataCatalogsNode ||
//			node instanceof NavigationLibraryNode || //??
			node instanceof NavigationLocationDefinitionCategoriesNode ||
			node instanceof NavigationLocationDefinitionCategoryNode ||
			node instanceof NavigationLocationDefinitionNode ||
			node instanceof NavigationLocationDefinitionsNode ||
			node instanceof NavigationOrganizationCatalogNode ||
			node instanceof NavigationOrganizationCatalogsNode ||
			node instanceof NavigationOrganizationDefinitionCategoriesNode ||
			node instanceof NavigationOrganizationDefinitionCategoryNode ||
			node instanceof NavigationOrganizationDefinitionNode ||
			node instanceof NavigationOrganizationDefinitionsNode ||
			node instanceof NavigationOrganizationUnitNode || // needs subfilter
			node instanceof NavigationOrganizationUnitsNode ||
//			node instanceof NavigationPackage || //??
			node instanceof NavigationProcessCatalogNode ||
			node instanceof NavigationProcessCatalogsNode ||
			node instanceof NavigationProcessesNode ||
			node instanceof NavigationProcessNode ||
			node instanceof NavigationProjectNode ||
			node instanceof NavigationResourceCatalogNode ||
			node instanceof NavigationResourceCatalogsNode ||
			node instanceof NavigationResourceDefinitionCategoriesNode ||
			node instanceof NavigationResourceDefinitionCategoryNode ||
			node instanceof NavigationResourceDefinitionNode ||
			node instanceof NavigationResourceDefinitionsNode ||
			(node instanceof NavigationResourceNode && isStaffResource(node)) || // needs subfilter
			node instanceof NavigationResourcesNode ||
			node instanceof NavigationRoleNode ||
			node instanceof NavigationRolesNode ||
			node instanceof NavigationSignalCategoriesNode ||
			node instanceof NavigationSignalCategoryNode ||
			node instanceof NavigationSignalNode ||
			node instanceof NavigationSignalsNode
		) {
			return true;
		}
		return false;
	}
	//defect 110289 should not expoirt BulkResource
	private boolean isStaffResource(AbstractNode node){
		AbstractLibraryChildNode thisNode = (AbstractLibraryChildNode)node;
		Object bomObject = BOMUtil.loadRootObject(thisNode);
		if(bomObject instanceof BulkResource){
			return false;
		}else if(bomObject instanceof IndividualResource && isKindOfStaff((IndividualResource)bomObject)){
			return true;
		}else{
			return false;
		}
	}
	
	//TODO add subfilter for Resources that are not of type Staff
	private boolean isKindOfStaff(IndividualResource resource){
		return true;
	}


}
