package com.ibm.btools.blm.ie.exprt.filter;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.blm.ui.navigation.model.*;

/**
 * Filter class for UML export
 */
public class UmlExportFilter implements IExportFilter {
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	private static UmlExportFilter umlExportFilter=null;

	private UmlExportFilter() {
	}
	
	public static UmlExportFilter getInstance() {
		if (umlExportFilter==null) {
			umlExportFilter = new UmlExportFilter();
		}
		return umlExportFilter;
	}
	/* (non-Javadoc)
	 * @see com.ibm.btools.blm.ie.exprt.filter.IExportFilter#isNodeSupported(com.ibm.btools.blm.ui.navigation.model.AbstractNode)
	 */
	public boolean isNodeSupported(AbstractNode node) {
		if (
			node instanceof NavigationBusinessEntitiesNode ||
			node instanceof NavigationBusinessEntityNode ||
//			node instanceof NavigationBusinessGroupNode || //??
//			node instanceof NavigationBusinessGroupsNode || // ??
			node instanceof NavigationCategoriesNode || //??
			node instanceof NavigationCategoryNode || 
			node instanceof NavigationDataCatalogNode || 
			node instanceof NavigationDataCatalogsNode ||
//			node instanceof NavigationLibraryNode || //??
			node instanceof NavigationLocationDefinitionCategoriesNode ||
			node instanceof NavigationLocationDefinitionCategoryNode ||
			node instanceof NavigationLocationDefinitionNode ||
			node instanceof NavigationLocationDefinitionsNode ||
			node instanceof NavigationOrganizationCatalogNode ||
			node instanceof NavigationOrganizationCatalogsNode ||
			node instanceof NavigationOrganizationDefinitionCategoriesNode ||
			node instanceof NavigationOrganizationDefinitionCategoryNode ||
			node instanceof NavigationOrganizationDefinitionNode ||
			node instanceof NavigationOrganizationDefinitionsNode ||
//			node instanceof NavigationOrganizationUnitNode || // needs subfilter
//			node instanceof NavigationOrganizationUnitsNode ||
//			node instanceof NavigationPackage || //??
			node instanceof NavigationProcessCatalogNode ||
			node instanceof NavigationProcessCatalogsNode ||
			node instanceof NavigationProcessesNode ||
			node instanceof NavigationProcessNode ||
			node instanceof NavigationProjectNode ||
			node instanceof NavigationResourceCatalogNode ||
			node instanceof NavigationResourceCatalogsNode ||
			node instanceof NavigationResourceDefinitionCategoriesNode ||
			node instanceof NavigationResourceDefinitionCategoryNode ||
			node instanceof NavigationResourceDefinitionNode ||
			node instanceof NavigationResourceDefinitionsNode ||
//			node instanceof NavigationResourceNode || // needs subfilter
//			node instanceof NavigationResourcesNode ||
//			node instanceof NavigationRoleNode ||
//			node instanceof NavigationRolesNode ||
			node instanceof NavigationSignalCategoriesNode ||
			node instanceof NavigationSignalCategoryNode ||
			node instanceof NavigationSignalNode ||
			node instanceof NavigationSignalsNode
		) {
			return true;
		}
		return false;
	}

}
