package com.ibm.btools.blm.ie.exprt.filter;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.blm.ui.navigation.model.AbstractNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBOCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBOCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntitiesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntityNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntitySampleNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessEntitySamplesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessRuleTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationBusinessRuleTasksNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCalendarNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCalendarsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryInstanceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationCategoryValueInstanceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDataCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDatastoreNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationDatastoresNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationExternalModelCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationExternalServiceCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationExternalServiceCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationHumanTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationHumanTasksNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationLocationsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationUnitNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationOrganizationUnitsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProcessesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProjectNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceCatalogNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceCatalogsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceDefinitionsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationResourcesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationRoleNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationRolesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationServiceNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationServicesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalCategoriesNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalCategoryNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationSignalsNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationTaskNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationTasksNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationWSDLFileNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationXSDFileNode;

/**
 * Filter class for XML export
 */
public class XmlExportFilter implements IExportFilter {
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	private static XmlExportFilter xmlExportFilter=null;

	private XmlExportFilter() {
	}
	
	public static XmlExportFilter getInstance() {
		if (xmlExportFilter==null) {
			xmlExportFilter = new XmlExportFilter();
		}
		return xmlExportFilter;
	}
	/* (non-Javadoc)
	 * @see com.ibm.btools.blm.ie.exprt.filter.IExportFilter#isNodeSupported(com.ibm.btools.blm.ui.navigation.model.AbstractNode)
	 */
	public boolean isNodeSupported(AbstractNode node) {
		if (
			node instanceof NavigationBusinessEntitiesNode ||
			node instanceof NavigationBusinessEntityNode ||
			node instanceof NavigationBusinessEntitySamplesNode ||
			node instanceof NavigationBusinessEntitySampleNode ||
//			node instanceof NavigationBusinessGroupNode || //??
//			node instanceof NavigationBusinessGroupsNode || // ??
			node instanceof NavigationCategoriesNode || //??
			node instanceof NavigationCategoryNode || 
			node instanceof NavigationDataCatalogNode || 
			node instanceof NavigationDataCatalogsNode ||
//			node instanceof NavigationLibraryNode || //??
			node instanceof NavigationLocationNode ||
			node instanceof NavigationLocationsNode ||
			node instanceof NavigationLocationDefinitionCategoriesNode ||
			node instanceof NavigationLocationDefinitionCategoryNode ||
			node instanceof NavigationLocationDefinitionNode ||
			node instanceof NavigationLocationDefinitionsNode ||
			node instanceof NavigationOrganizationCatalogNode ||
			node instanceof NavigationOrganizationCatalogsNode ||
			node instanceof NavigationOrganizationDefinitionCategoriesNode ||
			node instanceof NavigationOrganizationDefinitionCategoryNode ||
			node instanceof NavigationOrganizationDefinitionNode ||
			node instanceof NavigationOrganizationDefinitionsNode ||
			node instanceof NavigationOrganizationUnitNode || // needs subfilter
			node instanceof NavigationOrganizationUnitsNode ||
//			node instanceof NavigationPackage || //??
			node instanceof NavigationProcessCatalogNode ||
			node instanceof NavigationProcessCatalogsNode ||
			node instanceof NavigationProcessesNode ||
			node instanceof NavigationProcessNode ||
			node instanceof NavigationTasksNode ||
			node instanceof NavigationTaskNode ||
			node instanceof NavigationServicesNode ||
			node instanceof NavigationServiceNode ||
			node instanceof NavigationDatastoresNode |
			node instanceof NavigationDatastoreNode ||
			node instanceof NavigationProjectNode ||
			node instanceof NavigationResourceCatalogNode ||
			node instanceof NavigationResourceCatalogsNode ||
			node instanceof NavigationResourceDefinitionCategoriesNode ||
			node instanceof NavigationResourceDefinitionCategoryNode ||
			node instanceof NavigationResourceDefinitionNode ||
			node instanceof NavigationResourceDefinitionsNode ||
			node instanceof NavigationResourceNode || // needs subfilter
			node instanceof NavigationResourcesNode ||
			node instanceof NavigationCalendarNode ||
			node instanceof NavigationCalendarsNode ||
			node instanceof NavigationRoleNode ||
			node instanceof NavigationRolesNode ||
			node instanceof NavigationSignalCategoriesNode ||
			node instanceof NavigationSignalCategoryNode ||
			node instanceof NavigationSignalNode ||
			node instanceof NavigationSignalsNode ||
			// additional support for classification
			node instanceof NavigationCategoryValueInstanceNode ||
			node instanceof NavigationCategoryInstanceNode ||
			node instanceof NavigationCategoryCatalogNode ||
			node instanceof NavigationCategoryCatalogsNode ||
			node instanceof NavigationExternalModelCatalogsNode ||
			node instanceof NavigationBOCatalogsNode ||
			node instanceof NavigationBOCatalogNode ||
			node instanceof NavigationExternalServiceCatalogsNode ||
			node instanceof NavigationExternalServiceCatalogNode ||
			node instanceof NavigationWSDLFileNode ||
			node instanceof NavigationXSDFileNode||
			node instanceof NavigationHumanTasksNode ||
			node instanceof NavigationHumanTaskNode ||			
			node instanceof NavigationBusinessRuleTaskNode ||
			node instanceof NavigationBusinessRuleTasksNode
			// end of additional support for classification
		) {
			return true;
		}
		return false;
	}

}
