package com.ibm.btools.blm.ie.exprt.option;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.HashMap;
import java.util.Map;

import com.ibm.btools.blm.ie.exprt.ExportOptions;
import com.ibm.btools.blm.ie.exprt.ExportSession;

public class BpelOptions {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
		
	public static final String BPEL_OPTIONS = "com.ibm.btools.blm.ie.imprt.option.BpelOptions";
	
	public static final String BPEL_OPTIONS_EXECUTION_MODE = "BPEL_OPTIONS_EXECUTION_MODE";
	
	public static final String BPEL_OPTIONS_LONG_RUNNING_RECEIVE_REPLY = "BPEL_OPTIONS_LONG_RUNNING_RECEIVE_REPLY";
	public static final String BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK = "BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK";
	public static final String BPEL_OPTIONS_MICROFLOW = "BPEL_OPTIONS_MICROFLOW";
	
	public static final String BPEL_OPTIONS_TARGET_RUNTIME = "BPEL_OPTIONS_TARGET_RUNTIME";
	
	public static final String BPEL_OPTIONS_WBISF_511 = "BPEL_OPTIONS_WBISF_511";
	public static final String BPEL_OPTIONS_DIAMOND = "BPEL_OPTIONS_DIAMOND";
	
	public static final String BPEL_OPTIONS_STAFF_ASSIGNMENT = "BPEL_OPTIONS_STAFF_ASSIGNMENT";
	
	public static final String BPEL_OPTIONS_STAFF_511_COMPATIBLE = "BPEL_OPTIONS_STAFF_511_COMPATIBLE";
	public static final String BPEL_OPTIONS_STAFF_DIAMOND_COMPATIBLE = "BPEL_OPTIONS_STAFF_DIAMOND_COMPATIBLE";


	public static final String BPEL_OPTIONS_WSDL = "BPEL_OPTIONS_WSDL";
	
	public static final String BPEL_OPTIONS_WSI_COMPLIANT_WSDL = "BPEL_OPTIONS_WSI_COMPLIANT_WSDL";
	public static final String BPEL_OPTIONS_MULTI_PART_WSDL = "BPEL_OPTIONS_MULTI_PART_WSDL";
	
	public static final String BPEL_OPTIONS_REUSE_VARIABLE = "BPEL_OPTIONS_REUSE_VARIABLE";
	
	public static final String BPEL_OPTIONS_REUSE_VAR = "BPEL_OPTIONS_REUSE_VAR";
	public static final String BPEL_OPTIONS_DO_NO_REUSE_VARIABLE = "BPEL_OPTIONS_DO_NO_REUSE_VARIABLE";
	
	//options for WPS-diamond
	public static final String WPS_OPTIONS = "com.ibm.btools.blm.ie.export.option.WpsOptions";
	//public static final String WPS_EXPORT_LOCATION = "WPS_EXPORT_LOCATION";
	//public static final String WPS_EXPORT_FILE_SYSTEM = "WPS_EXPORT_FILE_SYSTEM";
	//public static final String WPS_EXPORT_MODULE = "WPS_EXPORT_MODULE";
	public static final String WPS_MODULE_OPTION = "WPS_MODULE_OPTION";
	public static final String WPS_EXPORT_FILE_SYSTEM = "WPS_EXPORT_FILE_SYSTEM";
	public static final String WPS_USE_EXISTING_MODULE = "WPS_USE_EXISTING_MODULE";
	public static final String WPS_EXPORT_MODULE_DIRECTORY = "WPS_EXPORT_MODULE_DIRECTORY";
	public static final String WPS_EXPORT_GENERAL_MODULE_DIRECTORY = "WPS_EXPORT_GENERAL_MODULE_DIRECTORY";
	public static final String WPS_EXPORT_SHARED_MODULE_DIRECTORY = "WPS_EXPORT_SHARED_MODULE_DIRECTORY";
	public static final String WPS_EXPORT_GENERAL_MODULE_NAME = "WPS_EXPORT_GENERAL_MODULE_NAME";
	public static final String WPS_EXPORT_SHARED_MODULE_NAME = "WPS_EXPORT_SHARED_MODULE_NAME";
	public static final String WPS_EXPORT_PROJECT_INTERCHANGE = "WPS_EXPORT_PROJECT_INTERCHANGE";
	public static final String WPS_ENABLE_DEFAULT_EVENTS = "WPS_ENABLE_DEFAULT_EVENTS";
	public static final String MODE_SETTING_WBSF = "MODE_SETTING_WBSF"; //value Boolean
	
	// Add BmMM monitor model option
	public static final String BM_MM_OPTIONS = "BM_MM_OPTIONS";
	
	public static Map getBpelOptions(ExportSession exportSession) {
		ExportOptions exportOptions = exportSession.getExportOptions();
		if (exportOptions == null) {
			exportOptions = new ExportOptions();
			exportSession.setExportOption(exportOptions);
		}
		Map bpelOptions = (Map)exportOptions.getAdditionalOption(BPEL_OPTIONS);;
		if (bpelOptions == null) {
			bpelOptions = new HashMap();
			exportOptions.setAdditionalOption(BPEL_OPTIONS, bpelOptions);
		} 
		return bpelOptions;
	}
	
	
	public static void setBpelExecutionMode(ExportSession exportSession, String executionMode) {
		Map options = getBpelOptions(exportSession);
		options.put(BPEL_OPTIONS_EXECUTION_MODE, executionMode);
	}
	
	public static String getBpelExecutionMode(ExportSession exportSession) {
		Map options = getBpelOptions(exportSession);
		String tarType = (String)options.get(BPEL_OPTIONS_EXECUTION_MODE);	
		if (tarType == null) {
			tarType = BPEL_OPTIONS_LONG_RUNNING_RECEIVE_REPLY; // default
			//tarType = BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK; // default
		}
		return tarType;	
	}
	
	public static String getBpelTargetRuntime(ExportSession exportSession) {
		Map options = getBpelOptions(exportSession);
		String tarType = (String)options.get(BPEL_OPTIONS_TARGET_RUNTIME);	
		if (tarType == null) {
			tarType = BPEL_OPTIONS_DIAMOND; // default
			//tarType = BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK; // default
		}
		return tarType;	
	}
	
	public static String getBpelStaffAssignmentOption(ExportSession exportSession) {
		Map options = getBpelOptions(exportSession);
		String tarType = (String)options.get(BPEL_OPTIONS_STAFF_ASSIGNMENT);	
		if (tarType == null) {
			tarType = BPEL_OPTIONS_STAFF_511_COMPATIBLE; // default
			//tarType = BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK; // default
		}
		return tarType;	
	}
	
	public static String getBpelWSDLStyleOption(ExportSession exportSession) {
		Map options = getBpelOptions(exportSession);
		String tarType = (String)options.get(BPEL_OPTIONS_WSDL);	
		if (tarType == null) {
			tarType = BPEL_OPTIONS_WSI_COMPLIANT_WSDL; // default
			//tarType = BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK; // default
		}
		return tarType;	
	}
	public static String getBpelReuseVariable(ExportSession exportSession) {
		Map options = getBpelOptions(exportSession);
		String tarType = (String)options.get(BPEL_OPTIONS_REUSE_VARIABLE);	
		if (tarType == null) {
			tarType = BPEL_OPTIONS_REUSE_VAR; // default
			//tarType = BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK; // default
		}
		return tarType;	
	}
	
	public static void setBpelExecutionModelToLongRunningReceiveReply(ExportSession exportSession, boolean bSupportTwoWayMacroflow){
		setBpelExecutionMode(exportSession, BPEL_OPTIONS_LONG_RUNNING_RECEIVE_REPLY);
	}
	
	public static boolean isBpelOptionsLongRunningReceiveReply(ExportSession exportSession) {
		return getBpelExecutionMode(exportSession).equals(BPEL_OPTIONS_LONG_RUNNING_RECEIVE_REPLY);	
	}
	
	public static void setBpelOptionsLongRunningReceiveCallback(ExportSession exportSession, boolean bSupportOneWayMacroflow){
		setBpelExecutionMode(exportSession, BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK);
	}
	
	public static boolean isBpelOptionsLongRunningReceiveCallback(ExportSession exportSession) {
		return getBpelExecutionMode(exportSession).equals(BPEL_OPTIONS_LONG_RUNNING_RECEIVE_CALLBACK);	
	}

	public static void setBpelOptionsMicroflow(ExportSession exportSession, boolean bSupportMicroflow){
		setBpelExecutionMode(exportSession, BPEL_OPTIONS_MICROFLOW);
	}
	
	public static boolean isBpelOptionsMicroflow(ExportSession exportSession) {
		return getBpelExecutionMode(exportSession).equals(BPEL_OPTIONS_MICROFLOW);	
	}
	
	public static boolean isTargetWSICompliant(ExportSession exportSession) {
		return getBpelWSDLStyleOption(exportSession).equals(BPEL_OPTIONS_WSI_COMPLIANT_WSDL);	
	}
	
	public static boolean generateStaffActivity51Compliant(ExportSession exportSession) {
		return getBpelStaffAssignmentOption(exportSession).equals(BPEL_OPTIONS_STAFF_511_COMPATIBLE);	
	}
	
	public static boolean isTargetDiamondCompatible(ExportSession exportSession) {
		return getBpelTargetRuntime(exportSession).equals(BPEL_OPTIONS_DIAMOND);	
	}

	public static boolean reuseBPELVariableForInputAndOutput(ExportSession exportSession) {
		return getBpelReuseVariable(exportSession).equals(BPEL_OPTIONS_REUSE_VAR);	
	}
	
	//public static Map getWpsOptions(ExportSession exportSession) {
	public static WpsExportOptionsBean getWpsOptions(ExportSession exportSession) {
		//AZ 20070511 This is for the case of generate default attributes
		if(exportSession == null){
			return null;
		}
		ExportOptions exportOptions = exportSession.getExportOptions();
		if (exportOptions == null) {
			exportOptions = new ExportOptions();
			exportSession.setExportOption(exportOptions);
		}
//		Map wisOptions = (Map)exportOptions.getAdditionalOption(WPS_OPTIONS);;
//		if (wisOptions == null) {
//			wisOptions = new HashMap();
//			exportOptions.setAdditionalOption(WPS_OPTIONS, wisOptions);
//		} 
//		return wisOptions;
		WpsExportOptionsBean optionsBean = (WpsExportOptionsBean)exportOptions.getAdditionalOption(WPS_OPTIONS);
		return optionsBean;
	}
	

	private static String getWpsModuleOption(ExportSession exportSession){
//		String moduleOption = (String)getWpsOptions(exportSession).get(WPS_MODULE_OPTION);
//		if(moduleOption == null){
//			moduleOption = WPS_EXPORT_FILE_SYSTEM;
//		}
		String moduleOption = (String)getWpsOptions(exportSession).getWpsModuleOption();//get(WPS_MODULE_OPTION);
		return moduleOption;
	}
	
	public static boolean isWpsExportFileSystem(ExportSession exportSession){
		return getWpsModuleOption(exportSession).equals(WPS_EXPORT_FILE_SYSTEM);
	}
	
	public static void setWpsExportFileSystem(ExportSession exportSession, boolean createModule){
		if(createModule){
			getWpsOptions(exportSession).setWpsModuleOption(WPS_EXPORT_FILE_SYSTEM);//(WPS_MODULE_OPTION, WPS_EXPORT_FILE_SYSTEM);
		}else{
			getWpsOptions(exportSession).setWpsModuleOption(WPS_USE_EXISTING_MODULE);//.put(WPS_MODULE_OPTION, WPS_USE_EXISTING_MODULE);
		}
	}
	
	public static boolean isWpsUseExistingModule(ExportSession exportSession){
		return getWpsModuleOption(exportSession).equals(WPS_USE_EXISTING_MODULE);
	}
	
	public static void setWpsUseExistingModule(ExportSession exportSession, boolean useOldModule){
		if(useOldModule){
			getWpsOptions(exportSession).setWpsModuleOption(WPS_USE_EXISTING_MODULE);//t(WPS_MODULE_OPTION, WPS_USE_EXISTING_MODULE);
		}else{
			getWpsOptions(exportSession).setWpsModuleOption(WPS_EXPORT_FILE_SYSTEM);//.put(WPS_MODULE_OPTION, WPS_EXPORT_FILE_SYSTEM);
		}
	}

   /**
    * AZ WMT 20070321 Determine whether best practice pattern enabled or not based on
    * UI settings passed from the export session
    * @param session
    * @return
    */
	public static boolean isBestPracticePatternEnabed(ExportSession session) {		
		if(getWpsOptions(session)!= null){
			boolean isEnforced = getWpsOptions(session).isBestPracticePatternEnforced();
			boolean patternEnabled = (getWpsOptions(session).getExportOption()== WpsExportOptionsBean.TOP_IMP_LIB);
			return isEnforced || patternEnabled;
		}
		return false;
	}		
	
//	public static String getModuleDirectory(ExportSession exportSession){
//		return (String)getWpsOptions(exportSession).get(WPS_EXPORT_MODULE_DIRECTORY);
//	}
//	
//	public static String setModuleDirectory(ExportSession exportSession, String dir){
//		return (String)getWpsOptions(exportSession).put(WPS_EXPORT_MODULE_DIRECTORY, dir);
//	}	
	
//	public static String getGeneralModuleDirectory(ExportSession exportSession){
//		return (String)getWpsOptions(exportSession).get(WPS_EXPORT_GENERAL_MODULE_DIRECTORY);
//	}
//	
//	public static String setGeneralModuleDirectory(ExportSession exportSession, String dir){
//		return (String)getWpsOptions(exportSession).put(WPS_EXPORT_GENERAL_MODULE_DIRECTORY, dir);
//	}
//	
//	public static String getSharedModuleDirectory(ExportSession exportSession){
//		return (String)getWpsOptions(exportSession).get(WPS_EXPORT_SHARED_MODULE_DIRECTORY);
//	}
//	
//	public static String setSharedModuleDirectory(ExportSession exportSession, String dir){
//		return (String)getWpsOptions(exportSession).put(WPS_EXPORT_SHARED_MODULE_DIRECTORY, dir);
//	}
	
}
