/**
 * 
 */
package com.ibm.btools.blm.ie.exprt.option;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.List;
/**
 * 
 * Deployment options at the Modeler  top level element level. Will allow to specify the name
 * of the WPS Module, Library and their version. Also allow to pass in the name of the template to 
 * use for that element  
 *
 */
public class DeployableElementWpsOptionsBean {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$


		public class RuntimeProjectArtifact{
			private String wpsName;
			private String wpsVersion;
			
			RuntimeProjectArtifact(String name, String version){
				this.wpsName = name;
				this.wpsVersion = version;
			}
			
			public String getWpsName() {
				return wpsName;
			}
			public void setWpsName(String wpsName) {
				this.wpsName = wpsName;
			}
			public String getWpsVersion() {
				return wpsVersion;
			}
			public void setWpsVersion(String wpsVersion) {
				this.wpsVersion = wpsVersion;
			}
			
		}
		private String blmID;
		private String templateSuffix;
		private RuntimeProjectArtifact module;
		private RuntimeProjectArtifact library;
	
		private List<String> dependendBLMID;

		public String getBlmID() {
			return blmID;
		}

		public void setBlmID(String blmID) {
			this.blmID = blmID;
		}

		public String getWpsModuleVersion() {
			if(module != null) return module.getWpsVersion();
			return null;
		}

		public String getWpsLibraryVersion() {
			if(library != null) return library.getWpsVersion();
			return null;
		
		}

		public String getTemplateSuffix() {
			return templateSuffix;
		}

		public void setTemplateSuffix(String templateName) {
			this.templateSuffix = templateName;
		}

		public List<String> getDependendBLMID() {
			return dependendBLMID;
		}

		public void setDependendBLMID(List<String> dependendBLMID) {
			this.dependendBLMID = dependendBLMID;
		}

		public String getWpsModuleName() {
			if(module != null) return module.getWpsName();
			return null;
		}

		public String getWpsLibraryName() {
			if(library != null) return library.getWpsName();
			return null;
			
		}

		public void setModule(RuntimeProjectArtifact module) {
			this.module = module;
			
		}
		
		public void setLibrary(RuntimeProjectArtifact library) {
			this.library = library;
			
		}


}