package com.ibm.btools.blm.ie.imprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * An interface that contains constants used during import.
 */
public interface IImportConstants {
	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	//WSRR MetaData constants
	public static final String NO_BSR_FOUND = "no bsr info found";
	public static final String BSR_PREFIX = "bsr_uri=";
	public static final String HOST_ADDRESS_PREFIX = "hostAddressURL=";
	public static final String META_DATA_SOURCE = "IBM Websphere Business Modeler IBM WebSphere Service Registry And Repository MetaData";
	public static final String APP_INFO_SOURCE_ATTRIBUTE_NAME = "source";
	public static final String HOST_ADDRESS_BSR_URI_SEPERATOR ="#";
	public static final String TEMPLATE_REGISTRY_ENTRY = "TEMPLATE_REGISTRY";
	public static final String XML_IMPORT_CATALOG_KEY= "XML_IMPORT_CATALOG_KEY";
	public static final String XML_IMPORT_BO_CATALOG_KEY = "XML_IMPORT_BO_CATALOG_KEY";
	public static final String XML_IMPORT_SERVICE_CATALOG_KEY = "XML_IMPORT_SERVICE_CATALOG_KEY";
	public static final String CREATE_CATALOG_USING_TARGETNAMESPACE_KEY = "CREATE_CATALOG_USING_TARGETNAMESPACE_KEY";
	public static final String ARTIFICIAL_DEFAULT_CATALOG_FOR_EXTERNAL_DOCUMENT_KEY = "ARTIFICIAL_DEFAULT_CATALOG_FOR_EXTERNAL_DOCUMENT_KEY";
	public static final String ARTIFICIAL_DEFAULT_CATALOG_UID_PREFIX ="BLM-ARTIFICIAL-FLAG-";
	public static final String DEFAULT_FLAG = "";
	/**	 
	 * The EXTERNALMODEL_CATALOG_REGISTRY_KEY key refers to a registry which is a Map with XSD schema or WSDL document 
	 * location URL as the key with value the ExternalModel that contains the BusinessService (WSDL) or BusinessServiceObject (XSD). 
	 * This helps the ImportEngine to fix the import/include/redefine location.
	 */
	public static final String EXTERNALMODEL_CATALOG_REGISTRY_KEY = "EXTERNALMODEL_CATALOG_REGISTRY_KEY";

	public static final String CREATE_CATALOG_USING_FILE_STRUCTURE_KEY = "CREATE_CATALOG_USING_FILE_STRUCTURE_KEY";
	
	public static final int CATALOG_CREATION_DEFAULT = 0;
	
	public static final int CATALOG_CREATION_TNS = 1;
	
	public static final int CATALOG_CREATION_FS = 2;
    
	public static final String IMPORT_SOURCE_DIRECTORY_KEY = "IMPORT_SOURCE_DIRECTORY_KEY";
	
	public static final String MODELER_XML_IMPORT_KEY = "MODELER_XML_IMPORT_KEY";
	
	public static final String ROOT_TEMP_DIR  = "ROOT_TEMP_DIR";
	
	public static final String MODELER_IMPORT_TEMP_DIRECTORY_ROOT = "Temp_0_EM";

	public static final String PROCESS_STYLE = "processStyle";
	
	// Key for page contributors to provide an instance of the command to run during
	// import instead of using the ImportEngine
	public static final String ALT_IMPORT_COMMAND = "RUN_IMPORT_COMMAND";
}
