package com.ibm.btools.blm.ie.imprt;

import com.ibm.btools.bom.command.compound.PredefTypesConst;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * Constants for the Import Framework
 */
public interface IImportFramework {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	// Component name
	public final static String COMPONENT_IMPORT_ENGINE										= "Import Engine";

	// Import Operation Extension Point
	public final static String IMPORT_OPERATION_EXTENSION_POINT								= "com.ibm.btools.blm.ie.importOperations";
	public final static String IMPORT_OPERATION_ELEMENT_OPERATION							= "operation";
	public final static String IMPORT_OPERATION_ATT_ID										= "id";
	public final static String IMPORT_OPERATION_ATT_CLASS									= "class";
	public final static String IMPORT_OPERATION_ATT_NAME									= "name";
	
	
	// Import Rule Extension Point
	public final static String IMPORT_RULE_EXTENSION_POINT									= "com.ibm.btools.blm.ie.importRules";
	public final static String IMPORT_RULE_ELEMENT_RULE										= "rule";
	public final static String IMPORT_RULE_ATT_CLASS										= "class";
	public final static String IMPORT_RULE_ATT_NAME											= "name";
	public final static String IMPORT_RULE_ATT_SEQUENCE										= "sequence";	
	
	
	// Import Rule Extension Name
	public final static String IMPORT_RULE_UPDATE_PROCESS									= "Update Process";
	public final static String IMPORT_RULE_UPDATE_TASK										= "Update Task";
	public final static String IMPORT_RULE_UPDATE_HUMAN_TASK								= "Update Human Task";
	public final static String IMPORT_RULE_UPDATE_BUSINESS_RULES_TASK						= "Update Business Rules Task";
	public final static String IMPORT_RULE_UPDATE_SERVICE									= "Update Service";
	public final static String IMPORT_RULE_UPDATE_REPOSITORY								= "Update Repository";
	public final static String IMPORT_RULE_UPDATE_BUSINESS_ITEM								= "Update Business Item";
	public final static String IMPORT_RULE_UPDATE_BUSINESS_ITEM_CATEGORY					= "Update Business Item Category";	
	public final static String IMPORT_RULE_UPDATE_SIGNAL									= "Update Signal";
	public final static String IMPORT_RULE_UPDATE_SIGNAL_CATEGORY							= "Update Signal Category";	
	public final static String IMPORT_RULE_UPDATE_BUSINESS_ITEM_INSTANCE					= "Update Business Item Instance";
	public final static String IMPORT_RULE_UPDATE_INDIVIDUAL_RESOURCE_DEFINITION_CATEGORY	= "Update Individual Resource Definition Category";
	public final static String IMPORT_RULE_UPDATE_BULK_RESOURCE_DEFINITION_CATEGORY			= "Update Bulk Resource Definition Category";
	public final static String IMPORT_RULE_UPDATE_INDIVIDUAL_RESOURCE_DEFINITION			= "Update Individual Resource Definition";
	public final static String IMPORT_RULE_UPDATE_BULK_RESOURCE_DEFINITION					= "Update Bulk Resource Definition";
	public final static String IMPORT_RULE_UPDATE_INDIVIDUAL_RESOURCE						= "Update Individual Resource";
	public final static String IMPORT_RULE_UPDATE_BULK_RESOURCE								= "Update Bulk Resource";
	public final static String IMPORT_RULE_UPDATE_ROLE										= "Update Role";
	public final static String IMPORT_RULE_UPDATE_TIMETABLE									= "Update Timetable";
	public final static String IMPORT_RULE_UPDATE_ORGANIZATION_DEFINITION_CATEGORY			= "Update Organization Definition Category";
	public final static String IMPORT_RULE_UPDATE_LOCATION_DEFINITION_CATEGORY				= "Update Location Definition Category";
	public final static String IMPORT_RULE_UPDATE_ORGANIZATION_DEFINITION					= "Update Organization Definition";
	public final static String IMPORT_RULE_UPDATE_LOCATION_DEFINITION						= "Update Location Definition";
	public final static String IMPORT_RULE_UPDATE_HIERARCHY_STRUCTURE_DEFINITION			= "Update Hierarchy Structure Definition";
	public final static String IMPORT_RULE_UPDATE_HIERARCHY									= "Update Hierarchy";
	public final static String IMPORT_RULE_UPDATE_ORGANIZATION_UNIT							= "Update Organization Unit";
	public final static String IMPORT_RULE_UPDATE_LOCATION									= "Update Location";
	public final static String IMPORT_RULE_UPDATE_PROCESS_OBSERVATION_MODEL					= "Update Process Observation Model";
	public final static String IMPORT_RULE_UPDATE_FORM										= "Update Form";
	
	// Default Model name
	public static final String ROOT_PROC_MODEL_NAME 										= PredefTypesConst.ROOT_PROC_MODEL_NAME;
	public static final String ROOT_INFO_MODEL_NAME 										= PredefTypesConst.ROOT_INFO_MODEL_NAME;
	public static final String ROOT_ORG_MODEL_NAME 											= PredefTypesConst.ROOT_ORG_MODEL_NAME;
	public static final String ROOT_RES_MODEL_NAME 											= PredefTypesConst.ROOT_RES_MODEL_NAME;
	public static final String ROOT_SERV_MODEL_NAME 										= PredefTypesConst.ROOT_SERV_MODEL_NAME;
	public static final String ROOT_CATEGORY_MODEL_NAME										= PredefTypesConst.ROOT_CATEGORY_MODEL_NAME;
	public static final String ROOT_EXTERNAL_MODEL_NAME 									= PredefTypesConst.ROOT_EXT_MODEL_NAME;
	
	// Element type
	public static final String TYPE_DATA_CATALOG											= "Data Catalog";
	public static final String TYPE_BUSINESS_ITEM											= "Business Item";
	public static final String TYPE_BUSINESS_ITEM_TEMPLATE									= "Business Item Template";
	public static final String TYPE_BUSINESS_ITEM_INSTANCE									= "Business Item Instance";
	public static final String TYPE_SIGNAL													= "Signal";
	public static final String TYPE_SIGNAL_TEMPLATE											= "Signal Template";
	
	public static final String TYPE_PROCESS_CATALOG											= "Process Catalog";
	public static final String TYPE_PROCESS													= "Process";
	public static final String TYPE_DATASTORE												= "Datastore";
	public static final String TYPE_TASK													= "Task";
	public static final String TYPE_SERVICE													= "Service";
	
	public static final String TYPE_RESOURCE_CATALOG										= "Resource Catalog";
	public static final String TYPE_CALENDAR												= "Calendar";	
	public static final String TYPE_RESOURCE_DEFINITION_CATEGORY							= "Resource Definition Category";	
	public static final String TYPE_RESOURCE_DEFINITION										= "Resource Definition";		
	public static final String TYPE_RESOURCE												= "Resource";
	public static final String TYPE_ROLE													= "Role";	
	
	public static final String TYPE_ORGANIZATION_CATALOG									= "Organization Catalog";
	public static final String TYPE_HIERARCHY												= "Hierarchy";
	public static final String TYPE_HIERARCHY_STRUCTURE_DEFINITION							= "Hierarchy Structure Definition";
	public static final String TYPE_LOCATION_DEFINITION_CATEGORY							= "Location Definition Category";	
	public static final String TYPE_LOCATION_DEFINITION										= "Location Definition";
	public static final String TYPE_LOCATION												= "Location";	
	public static final String TYPE_ORGANIZATION_DEFINITION_CATEGORY						= "Organization Definition Category";	
	public static final String TYPE_ORGANIZATION_DEFINITION									= "Organization Definition";
	public static final String TYPE_ORGANIZATION_UNIT										= "Organization Unit";
		
	// Default Model Name
	public static final String DEFAULT_DATA_CATALOG_KEY										= "PredefinedDataCatalogName";	
	public static final String DEFAULT_PROCESS_CATALOG_KEY									= "PredefinedProcessCatalogName";	
	public static final String DEFAULT_ORGANIZATION_CATALOG_KEY								= "PredefinedOrganizationCatalogName";	
	public static final String DEFAULT_RESOURCE_CATALOG_KEY									= "PredefinedResourceCatalogName";
	
	// Default context key
	public static final String CONTEXT_EXPRESSION_REGISTRY_KEY								= ":ExpressionRegistry";
	public static final String CONTEXT_PREDEFINED_REGISTRY_KEY								= ":PredefinedTypeRegistry";
	public static final String CONTEXT_PROCESS_KEY											= ":ProcessContext";
	public static final String CONTEXT_RESOLVED_TYPE										= ":ResolvedType";
	public static final String CONTEXT_SIMULATION											= ":SimulationRegistry";
	public static final String CONTEXT_SCOPE_DIMNENSION										= ":ScopeDimensionRegistry";
	public static final String CONTEXT_PE_CMD_FACTORY_KEY									= ":PeCmdFactory";
	public static final String CONTEXT_UID_KEY												= ":UIDRegistry";
	
	// Default predefined catalog
	public static final String PREDEFINED_RESOURCE_CATALOG_NAME								= "Predefined resource catalog";
	public static final String PREDEFINED_ORGANIZATION_CATALOG_NAME							= "Predefined organization catalog";
	
	// Use this flag in first step model action's aspect to indicate decision is simple decision
	public static final String SIMPLE_DECISION_ASPECT 										= "SIMPLE";
	
	//Common key for file url hashmap
	public static final String FILE_URLS_KEY 												= "urlFiles";
	
	//Common key for temp file url hashmap
	public static final String TEMP_FILE_URLS_KEY 											= "xmlTempFiles";
	public static final String DEFAULT_BUSINESS_SERVICES									="Business services";
	public static final String DEFAULT_BUSINESS_SERVICE_OBJECTS								="Business service objects";
	
	//Common key for model element file attachement url hashmap, 
	//use this flag to attach a map of uri of the file keyed by the model element object to the session context in first step 
	public static final String FILE_ATTACHMENT_URIS_KEY										="fileAttachmentUrls";
	
	//JR31715 Key for additional import options map
	public static final String BSO_TEMPLATE_CREATION_FLAG = "_BSO_TEMPLATE_CREATION_FLAG";
}
