package com.ibm.btools.blm.ie.imprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * The Message for the model import
 */
public class ImportMessage {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		
	public final static int WARNING = 0;
	public final static int ERROR = 1;
	public final static int INFO = 2;
	public final static String FILE_LENGTH_EXCEEDED = "CCB9999E";
	
	private final int DEFAULT = INFO;
	
	private int severity;
	private String message;
	private String errorCode;

	/**
	 * The constructor of the message
	 * @param severity
	 * @param message localized message
	 */
	public ImportMessage(final int severity, final String message) {
		setMessage(message);
		setSeverity(severity);
	}
	
	/**
	 * Set error code
	 * @param error code
	 */
	public void setErrorCode(final String errorCode) {
		this.errorCode = errorCode;
	}

	/**
	 * Set message text of the message
	 * @param message
	 */
	public void setMessage(final String message) {
		this.message = message;
	}

	/**
	 * Set the severity of the message.
	 * @param severity
	 */
	public void setSeverity(final int severity) {
		if (severity < WARNING || severity > INFO) {
			// Default severity is INFO
			this.severity = DEFAULT;
		} else {
			this.severity = severity;
		}
	}
	
	/**
	 * Return the error code
	 * @return
	 */
	public String getErrorCode() {
		return errorCode;
	}	
	
	/**
	 * Return the message text
	 * @return
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * Return the severity
	 * @return
	 */
	public int getSeverity() {
		return severity;
	}

}