package com.ibm.btools.blm.ie.imprt;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;

/**
 * The result of the model import
 */
public class ImportResult {
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	private List messages;

	/**
	 * Add message to the result
	 * @param message
	 */
	public void addMessage(final ImportMessage message) {
		getMessages().add(message);
	}
	
	/**
	 * Get all messages of the result
	 * @return the messages
	 */
	public List getMessages() {
		if (messages == null) {
			messages = new ArrayList();
		}
		
		return messages;
	}
	
	/**
	 * Return the number of messages with the specific severity
	 * @param severity
	 * @return
	 */
	public int numOfSeverity(final int severity) {
		LoggingUtil.traceEntry(this, "numOfSeverity");
		
		int count = 0;
		Iterator iterator = getMessages().iterator();
		ImportMessage message = null;
		while(iterator.hasNext()) {
			message = (ImportMessage) iterator.next();
			if (message.getSeverity() == severity) {
				count++;
			}
		}
		
		LoggingUtil.traceExit(this, "numOfSeverity");		
		return count;
	}
}
