package com.ibm.btools.blm.ie.imprt.option;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.HashMap;
import java.util.Map;

import com.ibm.btools.blm.ie.imprt.ImportOptions;
import com.ibm.btools.blm.ie.imprt.ImportSession;

public class FdlOptions {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
		
	public static final String FDL_OPTIONS = "com.ibm.btools.blm.ie.imprt.option.FdlOptions";

	public static final String FDL_OPTIONS_ABSTRACT_LOGIC_IN_SUBPROCESS = "FDL_OPTIONS_ABSTRACT_LOGIC_IN_SUBPROCESS";

	public static Map getFdlOptions(ImportSession importSession) {
		ImportOptions importOptions = importSession.getImportOptions();
		if (importOptions == null) {
			importOptions = new ImportOptions();
			importSession.setImportOption(importOptions);
		}
		Map fdlOptions = (Map)importOptions.getAdditionalOption(FDL_OPTIONS);;
		if (fdlOptions == null) {
			fdlOptions = new HashMap();
			importOptions.setAdditionalOption(FDL_OPTIONS,fdlOptions);
		} 
		return fdlOptions;
	}

	public static void setAbstractLogicInSubprocess(ImportSession importSession, boolean useAbstractedStructure) {
		Map options = getFdlOptions(importSession);
		options.put(FDL_OPTIONS_ABSTRACT_LOGIC_IN_SUBPROCESS,new Boolean(useAbstractedStructure));
	}
	
	public static boolean getAbstractLogicInSubprocess(ImportSession importSession) {
		Map options = getFdlOptions(importSession);
		Boolean b = (Boolean)options.get(FDL_OPTIONS_ABSTRACT_LOGIC_IN_SUBPROCESS);	
		if (b == null) {
			return true; // use Abstracted Structure by default
		}
		return b.booleanValue();	
	}
	
}
