package com.ibm.btools.blm.ie.imprt.rule.expressionModel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.ie.imprt.IImportFramework;
import com.ibm.btools.blm.ie.imprt.ImportContext;
import com.ibm.btools.blm.ie.imprt.rule.AbstractImportRule;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.emf.cf.BtCompoundCommand;
import com.ibm.btools.expression.bom.command.AddExpressionToStructuredOpaqueExpressionBEXCmd;
import com.ibm.btools.expression.bom.model.StructuredOpaqueExpression;
import com.ibm.btools.expression.command.CreateBinaryLogicalBooleanExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateBinaryNumericExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateBooleanLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateComparisonExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateDateLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateDateTimeLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateDurationLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateFuncionExpressionEXPCmd;
//import com.ibm.btools.expression.command.CreateLiteralIntegerExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateModelPathExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateNegationExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateNotExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateNumericLiteralExpressionEXPCmd;
//import com.ibm.btools.expression.command.CreateRealLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.AddVariableDeclarationToVariableExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateStringLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateTimeLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateUnionExpressionEXPCmd;
import com.ibm.btools.expression.command.CreateVariableExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateBinaryLogicalBooleanExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateBinaryNumericExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateBooleanLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateComparisonExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateDateLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateDateTimeLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateDurationLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateFunctionExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateVariableDeclarationEXPCmd;
//import com.ibm.btools.expression.command.UpdateIntegerLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateModelPathExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateNegationExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateNotExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateNumericLiteralExpressionEXPCmd;
//import com.ibm.btools.expression.command.UpdateRealLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateStringLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateTimeLiteralExpressionEXPCmd;
import com.ibm.btools.expression.command.UpdateUnionExpressionEXPCmd;
import com.ibm.btools.expression.model.BinaryLogicalBooleanExpression;
import com.ibm.btools.expression.model.BinaryNumericExpression;
import com.ibm.btools.expression.model.BooleanLiteralExpression;
import com.ibm.btools.expression.model.ComparisonExpression;
import com.ibm.btools.expression.model.DateLiteralExpression;
import com.ibm.btools.expression.model.DateTimeLiteralExpression;
import com.ibm.btools.expression.model.DurationLiteralExpression;
import com.ibm.btools.expression.model.Expression;
import com.ibm.btools.expression.model.FunctionExpression;
import com.ibm.btools.expression.model.VariableDeclaration;
//import com.ibm.btools.expression.model.IntegerLiteralExpression;
import com.ibm.btools.expression.model.ModelPathExpression;
import com.ibm.btools.expression.model.NegationExpression;
import com.ibm.btools.expression.model.NotExpression;
import com.ibm.btools.expression.model.NumericLiteralExpression;
//import com.ibm.btools.expression.model.RealLiteralExpression;
import com.ibm.btools.expression.model.StringLiteralExpression;
import com.ibm.btools.expression.model.TimeLiteralExpression;
import com.ibm.btools.expression.model.UnionExpression;
import com.ibm.btools.expression.model.VariableExpression;

/**
 * Updates Expression
 */
public class UpdateExpressionRule extends AbstractImportRule{
	//	copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	private StructuredOpaqueExpression sourceExpr;
	private StructuredOpaqueExpression workingCopy;
	protected Object process;
	protected static BtCompoundCommand wrapperCmd;
	protected static final int FIRST_OPERAND = 1;
	protected static final int SECOND_OPERAND = 2;
	protected static final int NOT_OPERAND = -1;
	protected static ImportContext importContext;
	protected static ImportContext importSubContext;
	
	/**
	 * Set Original StructuredOpaqueExpression
	 * @param expr
	 */
	public void setSource(final Object expression) {
		this.sourceExpr = (StructuredOpaqueExpression) expression;
	}
	
	/**
	 * Set the working copy
	 * @param workingCopy
	 */
	public void setWorkingCopy(final Object workingCopy) {
		this.workingCopy = (StructuredOpaqueExpression) workingCopy;
	}

	/**
	 * Set Original process
	 * @pin process
	 */
	public void setProcess(final Object process) {
		this.process = process;
	}	
	
	/**
	 * Invoke the rule
	 */
	public void invoke() {
		//System.out.println("Invoking com.ibm.btools.blm.ie.imprt.rule.expressionModel.UpdateExpressionRule");
		LoggingUtil.traceEntry(this, "invoke");
		wrapperCmd = new BtCompoundCommand();
		importContext = getImportSession().getContext();
		importSubContext = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);				
		//Expression workingCopyExpr = workingCopy.getExpression();
		Expression resultExpr = createAndUpdateExpression(sourceExpr.getExpression(), null, NOT_OPERAND);		
		if (sourceExpr.getName()!=null && !sourceExpr.getName().equals(""))
			workingCopy.setName(sourceExpr.getName());
			
		String description = sourceExpr.getDescription();		
		if( description!= null && !description.equals("")){
			workingCopy.setDescription(description);		
		}
					
		LoggingUtil.traceExit(this, "invoke");		
		
	}
	
	protected Expression createAndUpdateExpression(Expression expr, EObject parentExpr, int operandCount){
		LoggingUtil.traceEntry(this, "createAndUpdateExpression");
		if (expr instanceof BinaryLogicalBooleanExpression){
			try{
				CreateBinaryLogicalBooleanExpressionEXPCmd createCmd = new CreateBinaryLogicalBooleanExpressionEXPCmd();
				wrapperCmd.appendAndExecute(createCmd);
				BinaryLogicalBooleanExpression boolExpr = createCmd.getExpression();
									
				//BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				//Update
				UpdateBinaryLogicalBooleanExpressionEXPCmd updateCmd = new UpdateBinaryLogicalBooleanExpressionEXPCmd(boolExpr);
				updateCmd.setOperator(((BinaryLogicalBooleanExpression)expr).getOperator());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				
				if (((BinaryLogicalBooleanExpression)expr).getFirstOperand()!=null){				
					Expression firstOperandExpr = createAndUpdateExpression(((BinaryLogicalBooleanExpression)expr).getFirstOperand(), (Expression)updateCmd.getObject(), FIRST_OPERAND);
					
					//updateFirstOperand(firstOperandExpr, boolExpr);
				}
				if (((BinaryLogicalBooleanExpression)expr).getSecondOperand()!=null){				
					Expression secondOperandExpr = createAndUpdateExpression(((BinaryLogicalBooleanExpression)expr).getSecondOperand(), (Expression)updateCmd.getObject(), SECOND_OPERAND);
				
					//updateSecondOperand(secondOperandExpr, boolExpr);				
				}
				LoggingUtil.traceExit(this, "createAndUpdateExpression");		
				return (BinaryLogicalBooleanExpression)updateCmd.getObject();
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_BINARY_LOGICAL_BOOLEAN_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);				
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return null;		
			}
		}else if (expr instanceof BinaryNumericExpression){
			try{
				CreateBinaryNumericExpressionEXPCmd createCmd = new CreateBinaryNumericExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				BinaryNumericExpression binaryExpr = createCmd.getExpression();
				
				//BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				//Update
				UpdateBinaryNumericExpressionEXPCmd updateCmd = new UpdateBinaryNumericExpressionEXPCmd(binaryExpr);
				updateCmd.setOperator(((BinaryNumericExpression)expr).getOperator());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				
				if (((BinaryNumericExpression)expr).getFirstOperand()!=null){
					Expression firstOperandExpr = createAndUpdateExpression(((BinaryNumericExpression)expr).getFirstOperand(), (Expression)updateCmd.getObject(), FIRST_OPERAND);
					
					//updateFirstOperand(firstOperandExpr, binaryExpr);
				}
				if (((BinaryNumericExpression)expr).getSecondOperand()!=null){
					Expression secondOperandExpr = createAndUpdateExpression(((BinaryNumericExpression)expr).getSecondOperand(), (Expression)updateCmd.getObject(), SECOND_OPERAND);
									
					//updateSecondOperand(secondOperandExpr, binaryExpr);				
				}
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return (BinaryNumericExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_BINARY_NUMERIC_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return null;				
			}
		}else if (expr instanceof BooleanLiteralExpression){
			try{
				//Create
				CreateBooleanLiteralExpressionEXPCmd createCmd = new CreateBooleanLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				BooleanLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateBooleanLiteralExpressionEXPCmd updateCmd = new UpdateBooleanLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setBooleanSymbol(((BooleanLiteralExpression)expr).getBooleanSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return (BooleanLiteralExpression)updateCmd.getObject();
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_BOOLEAN_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return null;				
			}						
		}else if (expr instanceof ComparisonExpression){
			try{
				//Create
				CreateComparisonExpressionEXPCmd createCmd = new CreateComparisonExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				ComparisonExpression cmpExpr = createCmd.getExpression();
							
				//BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				//Update
				UpdateComparisonExpressionEXPCmd updateCmd = new UpdateComparisonExpressionEXPCmd(cmpExpr);
				updateCmd.setOperator(((ComparisonExpression)expr).getOperator());
				wrapperCmd.appendAndExecute(updateCmd);
				
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);	
				
				//updateFirstOperand((Expression)updateCmd.getObject(), parentExpr);
				
				if (((ComparisonExpression)expr).getFirstOperand()!=null){
					Expression firstOperandExpr = createAndUpdateExpression(((ComparisonExpression)expr).getFirstOperand(), (Expression)updateCmd.getObject(), FIRST_OPERAND);
							
					//updateFirstOperand(firstOperandExpr, cmpExpr);
				}
				if (((ComparisonExpression)expr).getSecondOperand()!=null){
					Expression secondOperandExpr = createAndUpdateExpression(((ComparisonExpression)expr).getSecondOperand(), (Expression)updateCmd.getObject(), SECOND_OPERAND);
							
					//updateSecondOperand(secondOperandExpr, cmpExpr);				
				}
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (ComparisonExpression)updateCmd.getObject();		
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_COMPARISON_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}
		}else if (expr instanceof FunctionExpression){
			try{
				//Create
				CreateFuncionExpressionEXPCmd createCmd = new CreateFuncionExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				FunctionExpression funcExpr = createCmd.getExpression();
				
				//Update
				UpdateFunctionExpressionEXPCmd updateCmd = new UpdateFunctionExpressionEXPCmd(funcExpr);					
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);	
				
				UpdateFunctionExpressionRule funcRule = new UpdateFunctionExpressionRule();
				funcRule.setSource((FunctionExpression)expr);
				funcRule.setWorkingCopy((FunctionExpression)funcExpr);
				funcRule.setProjectName(getProjectName());
				funcRule.invoke();	
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (FunctionExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_FUNCTION_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}
		/*
		}else if (expr instanceof IntegerLiteralExpression){
			try{
				//Create
				CreateLiteralIntegerExpressionEXPCmd createCmd = new CreateLiteralIntegerExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				IntegerLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateIntegerLiteralExpressionEXPCmd updateCmd = new UpdateIntegerLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setIntegerSymbol(((IntegerLiteralExpression)expr).getIntegerSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);	
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (IntegerLiteralExpression)updateCmd.getObject();		
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_INTEGER_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}
		*/
		}else if (expr instanceof ModelPathExpression){
			try{
				//Create
				CreateModelPathExpressionEXPCmd createCmd = new CreateModelPathExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				ModelPathExpression mpeExpr = createCmd.getExpression();
				
				//Update
				UpdateModelPathExpressionEXPCmd updateCmd = new UpdateModelPathExpressionEXPCmd(mpeExpr);
				updateCmd.setIsAbsolute(((ModelPathExpression)expr).getIsAbsolute());						
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);	
				
				//Call UpdateModelPathExpressionRule
				UpdateModelPathExpressionRule mpeRule = new UpdateModelPathExpressionRule();
				mpeRule.setSource(expr);
				mpeRule.setWorkingCopy(updateCmd.getObject());	
				mpeRule.setProjectName(getProjectName());							
				mpeRule.invoke();
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (ModelPathExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_MODEL_PATH_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}		
		}else if (expr instanceof NegationExpression){
			try{
				//Create
				CreateNegationExpressionEXPCmd createCmd = new CreateNegationExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				NegationExpression negExpr = createCmd.getExpression();
				
				//BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				//Update
				UpdateNegationExpressionEXPCmd updateCmd = new UpdateNegationExpressionEXPCmd(negExpr);			
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);		
				if (((NegationExpression)expr).getExpression()!=null){
					Expression firstOperandExpr = createAndUpdateExpression(((NegationExpression)expr).getExpression(), (Expression)updateCmd.getObject(), FIRST_OPERAND);
					
					//updateFirstOperand(firstOperandExpr, negExpr);
				}		
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return (NegationExpression)updateCmd.getObject();
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_NEGATION_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}						
		}else if (expr instanceof NotExpression){
			try{
				//Create
				CreateNotExpressionEXPCmd createCmd = new CreateNotExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				NotExpression notExpr = createCmd.getExpression();
				
				//BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				//Update
				UpdateNotExpressionEXPCmd updateCmd = new UpdateNotExpressionEXPCmd(notExpr);			
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);				
				if (((NotExpression)expr).getExpression()!=null){
					Expression firstOperandExpr = createAndUpdateExpression(((NotExpression)expr).getExpression(), (Expression)updateCmd.getObject(), FIRST_OPERAND);
					
					//updateFirstOperand(firstOperandExpr, notExpr);
				}		
				LoggingUtil.traceExit(this, "createAndUpdateExpression");	
				return (NotExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_NOT_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}	
		/*		
		}else if (expr instanceof RealLiteralExpression){
			try{
				//Create
				CreateRealLiteralExpressionEXPCmd createCmd = new CreateRealLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				RealLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateRealLiteralExpressionEXPCmd updateCmd = new UpdateRealLiteralExpressionEXPCmd(literalExpr);
				wrapperCmd.appendAndExecute(updateCmd);
				updateCmd.setRealSymbol(((RealLiteralExpression)expr).getRealSymbol());
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (RealLiteralExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_REAL_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}	
		*/
		}else if (expr instanceof NumericLiteralExpression){
			try{
				//Create
				CreateNumericLiteralExpressionEXPCmd createCmd = new CreateNumericLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				NumericLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateNumericLiteralExpressionEXPCmd updateCmd = new UpdateNumericLiteralExpressionEXPCmd(literalExpr);				
				updateCmd.setNumericSymbol(((NumericLiteralExpression)expr).getNumericSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (NumericLiteralExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_NUMERIC_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}	
		}else if (expr instanceof TimeLiteralExpression){
			try{
				//Create
				CreateTimeLiteralExpressionEXPCmd createCmd = new CreateTimeLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				TimeLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateTimeLiteralExpressionEXPCmd updateCmd = new UpdateTimeLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setTimeSymbol(((TimeLiteralExpression)expr).getTimeSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (TimeLiteralExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_TIME_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}	
		}else if (expr instanceof DurationLiteralExpression){
			try{
				//Create
				CreateDurationLiteralExpressionEXPCmd createCmd = new CreateDurationLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				DurationLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateDurationLiteralExpressionEXPCmd updateCmd = new UpdateDurationLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setDurationSymbol(((DurationLiteralExpression)expr).getDurationSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (DurationLiteralExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_DURATION_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}					
		}else if (expr instanceof DateLiteralExpression){
			try{
				//Create
				CreateDateLiteralExpressionEXPCmd createCmd = new CreateDateLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				DateLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateDateLiteralExpressionEXPCmd updateCmd = new UpdateDateLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setDateSymbol(((DateLiteralExpression)expr).getDateSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (DateLiteralExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_DATE_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}		
		}else if (expr instanceof DateTimeLiteralExpression){
			try{
				//Create
				CreateDateTimeLiteralExpressionEXPCmd createCmd = new CreateDateTimeLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				DateTimeLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateDateTimeLiteralExpressionEXPCmd updateCmd = new UpdateDateTimeLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setDateTimeSymbol(((DateTimeLiteralExpression)expr).getDateTimeSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (DateTimeLiteralExpression)updateCmd.getObject();	
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_DATETIME_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}											
		}else if (expr instanceof StringLiteralExpression){
			try{
				//Create
				CreateStringLiteralExpressionEXPCmd createCmd = new CreateStringLiteralExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				StringLiteralExpression literalExpr = createCmd.getExpression();
				
				//Update
				UpdateStringLiteralExpressionEXPCmd updateCmd = new UpdateStringLiteralExpressionEXPCmd(literalExpr);
				updateCmd.setStringSymbol(((StringLiteralExpression)expr).getStringSymbol());
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (StringLiteralExpression)updateCmd.getObject();
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_STRING_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}				
		}else if (expr instanceof UnionExpression){
			try{
				CreateUnionExpressionEXPCmd createCmd = new CreateUnionExpressionEXPCmd();
				//createCmd.execute();
				wrapperCmd.appendAndExecute(createCmd);
				UnionExpression unionExpr = createCmd.getExpression();
				
				//BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				//Update
				UpdateUnionExpressionEXPCmd updateCmd = new UpdateUnionExpressionEXPCmd(unionExpr);			
				wrapperCmd.appendAndExecute(updateCmd);
				addExpressionToParent((Expression)updateCmd.getObject(), parentExpr, operandCount);			
				if (((UnionExpression)expr).getFirstOperand()!=null){
					Expression firstOperandExpr = createAndUpdateExpression(((UnionExpression)expr).getFirstOperand(), (Expression)updateCmd.getObject(), FIRST_OPERAND);
							
					//updateFirstOperand(firstOperandExpr, unionExpr);
				}
				if (((UnionExpression)expr).getSecondOperand()!=null){				
					Expression secondOperandExpr = createAndUpdateExpression(((UnionExpression)expr).getSecondOperand(), (Expression)updateCmd.getObject(), SECOND_OPERAND);
					
					//updateSecondOperand(secondOperandExpr, unionExpr);				
				}
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return (UnionExpression)updateCmd.getObject();		
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.CREATE_UNION_LITERAL_EXPR_EXCEPTION, new String[]{expr.getUid()}, ex);
				LoggingUtil.traceExit(this, "createAndUpdateExpression");
				return null;		
			}						
		}else if (expr instanceof VariableExpression){
			//LoggingUtil.logWarning(getImportSession(), IeMessageKeys.VARIABLE_EXPR_NOT_SUPPORTED, new String[]{expr.getUid()}, null);
			
			//Create
			CreateVariableExpressionEXPCmd createCmd = new CreateVariableExpressionEXPCmd();
			wrapperCmd.appendAndExecute(createCmd);
			VariableExpression varExpr = createCmd.getExpression();
			
			VariableExpression srcVarExpr = (VariableExpression) expr;
			
			addExpressionToParent(varExpr, parentExpr, operandCount);
			
			if (srcVarExpr != null) {				
				if (srcVarExpr.getReferredVariable() != null) {			
					//Add & Update
					AddVariableDeclarationToVariableExpressionEXPCmd addCmd = new AddVariableDeclarationToVariableExpressionEXPCmd(varExpr);
					wrapperCmd.appendAndExecute(addCmd);
					VariableDeclaration varDcl = (VariableDeclaration) addCmd.getObject();
					
					UpdateVariableDeclarationEXPCmd updateCmd = new UpdateVariableDeclarationEXPCmd(varDcl);
					updateCmd.setVariableName(srcVarExpr.getReferredVariable().getVariableName());
					updateCmd.setVariableType(srcVarExpr.getReferredVariable().getVariableType()); 					 
					wrapperCmd.appendAndExecute(updateCmd);													
				}	
			}			
			
			//addExpressionToParent(varExpr, parentExpr, operandCount);
			LoggingUtil.traceExit(this, "createAndUpdateExpression");
			return varExpr;
			//LoggingUtil.traceExit(this, "createAndUpdateExpression");
			//return null;		
		}
		return null;
	}
	
	private void updateFirstOperand(Expression workingCopy, EObject parent){
		LoggingUtil.traceEntry(this, "updateFirstOperand");
		UpdateFirstOperandRule firstOperandRule = new UpdateFirstOperandRule();
		firstOperandRule.setWorkingCopy(workingCopy);
		firstOperandRule.setParentExpression(parent);
		firstOperandRule.invoke();		
		LoggingUtil.traceExit(this, "updateFirstOperand");				
	}
	
	private void updateSecondOperand(Expression workingCopy, EObject parent){
		LoggingUtil.traceEntry(this, "updateSecondOperand");
		UpdateSecondOperandRule secondOperandRule = new UpdateSecondOperandRule();
		secondOperandRule.setWorkingCopy(workingCopy);
		secondOperandRule.setParentExpression(parent);
		secondOperandRule.invoke();	
		LoggingUtil.traceExit(this, "updateSecondOperand");	
	}
	
	private void addExpressionToParent (Expression thisExpr, EObject parentExpr, int operandCount){
		LoggingUtil.traceEntry(this, "addExpressionToParent");
		if (parentExpr==null){
			AddExpressionToStructuredOpaqueExpressionBEXCmd addExprCmd = new AddExpressionToStructuredOpaqueExpressionBEXCmd(thisExpr, workingCopy);
			
			try {
				wrapperCmd.appendAndExecute(addExprCmd);				
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.ADD_TO_STRUCTURED_OPAQUE_EXPR_EXCEPTION, new String[]{thisExpr.getUid()}, ex);
			}			
		}else if (operandCount==1){
			updateFirstOperand(thisExpr, parentExpr);
		}else{
			updateSecondOperand(thisExpr, parentExpr);
		}
		LoggingUtil.traceExit(this, "addExpressionToParent");
	}
	
	
}
