package com.ibm.btools.blm.ie.imprt.rule.navigator;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.blm.ie.imprt.rule.AbstractImportRule;
import com.ibm.btools.blm.ui.navigation.model.AbstractNode;

/**
 * Import the process model either form the root or from 
 * another process model
 */
public abstract class CatalogRule extends AbstractImportRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	protected AbstractNode parentNode;
	protected boolean isDefault = false;
		
	/**
	 * Set the parent node. It can be either a project node or a catalog node
	 * @param parentNode
	 */
	public void setParent(final AbstractNode parentNode) {
		this.parentNode = parentNode;
	}
	
	/**
	 * Set true if the Catalog is a default catalog
	 * @param isDefault
	 */
	public void setDefault(final boolean isDefault) {
		this.isDefault = isDefault;
	}
}
