package com.ibm.btools.blm.ie.imprt.rule.processModel;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.blm.ie.imprt.rule.processModel.node.UpdateTopLevelStructureActivityNodeRule;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;

/**
 * Update the Reusable Business Rules Task
 */
public class UpdateReusableBusinessRulesTaskRule extends UpdateReusableProcessRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	/**
	 * Update Implementation
	 */
	protected void updateImplementation() {
		LoggingUtil.traceEntry(this, "updateImplementation");
		StructuredActivityNode implementation = process.getImplementation();
		UpdateTopLevelStructureActivityNodeRule updateToplevelSANRule = new  UpdateTopLevelStructureActivityNodeRule();
		updateToplevelSANRule.setImportSession(getImportSession());
		updateToplevelSANRule.setProjectName(getProjectName());
		updateToplevelSANRule.setSource(implementation);
		updateToplevelSANRule.setWorkingCopy(getImplementationViewModel());
		updateToplevelSANRule.setProcess(process);
		updateToplevelSANRule.invoke();		
		LoggingUtil.traceExit(this, "updateImplementation");		
	}
}
