package com.ibm.btools.blm.ie.imprt.rule.processModel.node;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.command.AbstractCommand;
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.compoundcommand.gef.DomainViewObjectHelper;
import com.ibm.btools.blm.compoundcommand.pe.factory.AbstractAddPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.factory.PeCmdFactory;
import com.ibm.btools.blm.compoundcommand.pe.factory.RemovePeCmd;
import com.ibm.btools.blm.compoundcommand.pe.node.add.AddActionPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.node.add.AddCBAPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.node.add.AddHumanTaskPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.pinset.remove.RemoveInputPinSetPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.pinset.remove.RemoveOutputPinSetPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.pinset.remove.RemovePinSetPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.pinset.update.AssociateInputPinSetWithOutputPinSetPeCmd;
import com.ibm.btools.blm.compoundcommand.process.util.PECommandConstants;
import com.ibm.btools.blm.compoundcommand.process.util.PEDomainViewObjectHelper;
import com.ibm.btools.blm.ie.imprt.IImportFramework;
import com.ibm.btools.blm.ie.imprt.ImportContext;
import com.ibm.btools.blm.ie.imprt.rule.informationModel.UpdateValueSpecificationRule;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdatePinRule;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdatePinSetRule;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdateViewModelRule;
import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.IImportResultMessages;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.NavigatorUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.blm.ui.navigation.model.AbstractLibraryChildNode;
import com.ibm.btools.blm.ui.navigation.model.NavigationProjectNode;
import com.ibm.btools.bom.command.artifacts.AddInstanceValueToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralDurationMaxResourceAwaitingTimeToOperationalTimesBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralDurationProcessingTimeToOperationalTimesBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralNullToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealMaxValueToPUniformDistributionBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealMinValueToPUniformDistributionBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToPListElementBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToResourceQuantityBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralStringToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddOpaqueExpressionToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddStructuredDurationMaxResourceAwaitingTimeToOperationalTimesBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddStructuredDurationProcessingTimeToOperationalTimesBOMCmd;
import com.ibm.btools.bom.command.artifacts.UpdateLiteralRealBOMCmd;
import com.ibm.btools.bom.command.compound.PredefTypesConst;
import com.ibm.btools.bom.command.processes.actions.AddOperationalCostsToActionBOMCmd;
import com.ibm.btools.bom.command.processes.actions.AddOperationalProbabilitiesToActionBOMCmd;
import com.ibm.btools.bom.command.processes.actions.AddOperationalRevenueToActionBOMCmd;
import com.ibm.btools.bom.command.processes.actions.AddOperationalTimesToActionBOMCmd;
import com.ibm.btools.bom.command.processes.actions.AddOutputSetProbabilitiesToOperationalProbabilitiesBOMCmd;
import com.ibm.btools.bom.command.processes.actions.AddOutputSetProbabilityToOutputSetProbabilitiesBOMCmd;
import com.ibm.btools.bom.command.processes.actions.RemoveOperationalProbabilitiesBOMCmd;
import com.ibm.btools.bom.command.processes.activities.UpdateActionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBernoulliDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBernoulliDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBernoulliDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBetaDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBetaDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBetaDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBinomialDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBinomialDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPBinomialDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPContinuousRNDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPContinuousRNDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPContinuousRNDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPErlangRNDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPErlangRNDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPErlangRNDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPExponentialDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPExponentialDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPExponentialDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPGammaDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPGammaDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPGammaDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPJohnsonRNDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPJohnsonRNDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPJohnsonRNDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPListElementToPRandomListBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPLognormalDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPLognormalDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPLognormalDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPNormalDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPNormalDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPNormalDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPPoissonDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPPoissonDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPPoissonDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPRandomListToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPRandomListToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPRandomListToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPTriangularRNDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPTriangularRNDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPTriangularRNDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPUniformDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPUniformDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPUniformDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeibullRNDistributionToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeibullRNDistributionToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeibullRNDistributionToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeightedListElementToPWeightedListBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeightedListToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeightedListToOutputSetProbabilityBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.AddPWeightedListToStructuredDurationBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePBernoulliDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePBetaDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePBinomialDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePContinuousRNDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePErlangRNDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePExponentialDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePGammaDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePJohnsonRNDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePLognormalDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePNormalDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePPoissonDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePRandomListBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePTriangularRNDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePUniformDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePWeibullRNDistributionBOMCmd;
import com.ibm.btools.bom.command.processes.distributions.UpdatePWeightedListBOMCmd;
import com.ibm.btools.bom.command.resources.AddBulkResourceRequirementToActionBOMCmd;
import com.ibm.btools.bom.command.resources.AddCostPerTimeUnitToOperationalCostsBOMCmd;
import com.ibm.btools.bom.command.resources.AddCostValueToTimeDependentCostBOMCmd;
import com.ibm.btools.bom.command.resources.AddIndividualResourceRequirementToActionBOMCmd;
import com.ibm.btools.bom.command.resources.AddMonetaryValueExecutionCostToOperationalCostsBOMCmd;
import com.ibm.btools.bom.command.resources.AddMonetaryValueStartupCostToOperationalCostsBOMCmd;
import com.ibm.btools.bom.command.resources.AddMonetaryValueToCostValueBOMCmd;
import com.ibm.btools.bom.command.resources.AddMonetaryValueToOperationalRevenueBOMCmd;
import com.ibm.btools.bom.command.resources.AddRequiredRoleToActionBOMCmd;
import com.ibm.btools.bom.command.resources.AddResourceQuantityToBulkResourceRequirementBOMCmd;
import com.ibm.btools.bom.command.resources.AddResourceQuantityToRequiredRoleBOMCmd;
import com.ibm.btools.bom.command.resources.AddScopeValueToRequiredRoleBOMCmd;
import com.ibm.btools.bom.command.resources.AddUpdateResourceQuantityBOMCmd;
import com.ibm.btools.bom.command.resources.AddUpdateResourceRequirementBOMCmd;
import com.ibm.btools.bom.model.artifacts.Element;
import com.ibm.btools.bom.model.artifacts.InstanceValue;
import com.ibm.btools.bom.model.artifacts.LiteralDuration;
import com.ibm.btools.bom.model.artifacts.LiteralNull;
import com.ibm.btools.bom.model.artifacts.LiteralReal;
import com.ibm.btools.bom.model.artifacts.LiteralSpecification;
import com.ibm.btools.bom.model.artifacts.OpaqueExpression;
import com.ibm.btools.bom.model.artifacts.StructuredDuration;
import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.bom.model.artifacts.ValueSpecification;
import com.ibm.btools.bom.model.organizationstructures.Location;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnit;
import com.ibm.btools.bom.model.processes.actions.AcceptSignalAction;
import com.ibm.btools.bom.model.processes.actions.BroadcastSignalAction;
import com.ibm.btools.bom.model.processes.actions.CallBehaviorAction;
import com.ibm.btools.bom.model.processes.actions.ControlAction;
import com.ibm.btools.bom.model.processes.actions.Decision;
import com.ibm.btools.bom.model.processes.actions.Fork;
import com.ibm.btools.bom.model.processes.actions.Join;
import com.ibm.btools.bom.model.processes.actions.Map;
import com.ibm.btools.bom.model.processes.actions.Merge;
import com.ibm.btools.bom.model.processes.actions.ObserverAction;
import com.ibm.btools.bom.model.processes.actions.OperationalCosts;
import com.ibm.btools.bom.model.processes.actions.OperationalProbabilities;
import com.ibm.btools.bom.model.processes.actions.OperationalRevenue;
import com.ibm.btools.bom.model.processes.actions.OperationalTimes;
import com.ibm.btools.bom.model.processes.actions.OutputSetProbabilities;
import com.ibm.btools.bom.model.processes.actions.OutputSetProbability;
import com.ibm.btools.bom.model.processes.actions.TimerAction;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.ForLoopNode;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.LoopNode;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.bom.model.processes.activities.Pin;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.processes.distributions.PBernoulliDistribution;
import com.ibm.btools.bom.model.processes.distributions.PBetaDistribution;
import com.ibm.btools.bom.model.processes.distributions.PBinomialDistribution;
import com.ibm.btools.bom.model.processes.distributions.PContinuousRNDistribution;
import com.ibm.btools.bom.model.processes.distributions.PDistribution;
import com.ibm.btools.bom.model.processes.distributions.PErlangRNDistribution;
import com.ibm.btools.bom.model.processes.distributions.PExponentialDistribution;
import com.ibm.btools.bom.model.processes.distributions.PGammaDistribution;
import com.ibm.btools.bom.model.processes.distributions.PJohnsonRNDistribution;
import com.ibm.btools.bom.model.processes.distributions.PJohnsonType;
import com.ibm.btools.bom.model.processes.distributions.PListElement;
import com.ibm.btools.bom.model.processes.distributions.PLognormalDistribution;
import com.ibm.btools.bom.model.processes.distributions.PNormalDistribution;
import com.ibm.btools.bom.model.processes.distributions.PPoissonDistribution;
import com.ibm.btools.bom.model.processes.distributions.PRandomList;
import com.ibm.btools.bom.model.processes.distributions.PTriangularRNDistribution;
import com.ibm.btools.bom.model.processes.distributions.PUniformDistribution;
import com.ibm.btools.bom.model.processes.distributions.PWeibullRNDistribution;
import com.ibm.btools.bom.model.processes.distributions.PWeightedList;
import com.ibm.btools.bom.model.processes.distributions.PWeightedListElement;
import com.ibm.btools.bom.model.resources.BulkResource;
import com.ibm.btools.bom.model.resources.BulkResourceRequirement;
import com.ibm.btools.bom.model.resources.CostPerTimeUnit;
import com.ibm.btools.bom.model.resources.CostValue;
import com.ibm.btools.bom.model.resources.IndividualResource;
import com.ibm.btools.bom.model.resources.IndividualResourceRequirement;
import com.ibm.btools.bom.model.resources.MonetaryValue;
import com.ibm.btools.bom.model.resources.RequiredRole;
import com.ibm.btools.bom.model.resources.ResourceQuantity;
import com.ibm.btools.bom.model.resources.ResourceRequirement;
import com.ibm.btools.bom.model.resources.Role;
import com.ibm.btools.bom.model.resources.ScopeDimension;
import com.ibm.btools.bom.model.resources.ScopeValue;
import com.ibm.btools.bom.model.services.Behavior;
import com.ibm.btools.cef.model.CommonContainerModel;
import com.ibm.btools.cef.model.VisualModelDocument;
import com.ibm.btools.emf.cf.BtCompoundCommand;
import com.ibm.btools.expression.bom.command.AddStructuredOpaqueExpressionToScopeValueBEXCmd;
import com.ibm.btools.expression.bom.model.StructuredOpaqueExpression;
import com.ibm.btools.model.modelmanager.util.AddUpdateObjectCommand;
import com.ibm.btools.model.resourcemanager.util.PredefUtil;

/**
 * Update the Action
 */
public class UpdateActionRule extends UpdateViewModelRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	protected Action action;
	
	/**
	 * Set the action
	 * @param action
	 */
	public void setSource(Object action) {
		if (action instanceof Action) {
			this.action = (Action) action;
		}
	}
	
	/**
	 * Return the action
	 * @return
	 */
	public Object getSource() {
		return action;
	}	
	
	/**
	 * Return the Create command
	 */
	protected AbstractAddPeCmd getCommand() {
		LoggingUtil.traceEntry(this, "getCommand");		
		if (action == null) {
			return null;		
		}
		AddActionPeCmd actionCmd = null;
		
		String aspect = action.getAspect();
		PeCmdFactory cmdFactory = getPeCmdFactory();
		if (action instanceof AcceptSignalAction) {		
			actionCmd = cmdFactory.buildAddAcceptSignalActionPeCmd((EObject) workingCopy);		
		} else if (action instanceof Map) {
			actionCmd = cmdFactory.buildAddMapPeCmd((EObject) workingCopy);
		} else if (action instanceof Decision) {
			//Jie- defect 81536, always create multiple choice decision
			// Jie - 2005.01.31, add support for creating simple decision to support xml import
			//if (action.getOutputPinSet().size() > 2) {
			if (action.getAspect() != null && action.getAspect().equals(IImportFramework.SIMPLE_DECISION_ASPECT)){
				actionCmd = cmdFactory.buildAddDecisionPeCmd((EObject) workingCopy);
			} else {
				actionCmd = cmdFactory.buildAddMultipleChoiceDecisionPeCmd((EObject) workingCopy);
			}			
		} else if (action instanceof Fork) {
			actionCmd = cmdFactory.buildAddForkPeCmd((EObject) workingCopy);
		} else if (action instanceof Join) {
			actionCmd = cmdFactory.buildAddJoinPeCmd((EObject) workingCopy);
		} else if (action instanceof Merge) {
			actionCmd = cmdFactory.buildAddMergePeCmd((EObject) workingCopy);
		} else if (action instanceof ObserverAction) {
			actionCmd = cmdFactory.buildAddObserverActionPeCmd((EObject)workingCopy);
		} else if (action instanceof TimerAction) {		
			actionCmd = cmdFactory.buildAddTimerActionPeCmd((EObject)workingCopy);	
		} else if (action instanceof ForLoopNode) {
			actionCmd = cmdFactory.buildAddForLoopNodePeCmd((EObject)workingCopy);
		} else if (action instanceof LoopNode) {		
			if (((LoopNode)action).getIsTestedFirst().booleanValue()) {
				// While Loop
				actionCmd = cmdFactory.buildAddWhileLoopNodePeCmd((EObject)workingCopy);
			} else {
				// Do While Loop
				actionCmd = cmdFactory.buildAddDoWhileLoopNodePeCmd((EObject)workingCopy);
			}			
		} else if (action instanceof CallBehaviorAction) {
			actionCmd = cmdFactory.buildAddCBAPeCmd((EObject)workingCopy);
			// set Behavior
			Behavior behavior = ((CallBehaviorAction)action).getBehavior();
			Object node = getImportSession().getContext().get(behavior);
			//TODO: jie - add code to resolve reference
			if(node == null){
				node = BOMUtil.getBehaviorFromWorkspace(getImportSession(), getProjectName(), behavior);
			}
			if (node instanceof AbstractLibraryChildNode) {
				Object vmd = BOMUtil.loadViewRootObject((AbstractLibraryChildNode)node);
				if (vmd instanceof VisualModelDocument) {
					CommonContainerModel activityViewModel = 
						(CommonContainerModel)((VisualModelDocument)vmd).getRootContent().getContentChildren().get(0);
					((AddCBAPeCmd)actionCmd).setViewActivity(activityViewModel);			
				}
			}
		} else if (action instanceof BroadcastSignalAction) {
			actionCmd = cmdFactory.buildAddBroadcastSignalActionPeCmd((EObject)workingCopy);
		} else if (action instanceof StructuredActivityNode) {
			if (aspect != null) {
				if (PECommandConstants.TASK_ASPECT.compareTo(aspect) == 0) {
					actionCmd = cmdFactory.buildAddTaskPeCmd((EObject) workingCopy);
				} else if (PECommandConstants.PROCESS_ASPECT.compareTo(aspect) == 0) {
					actionCmd = cmdFactory.buildAddSubProcessPeCmd((EObject) workingCopy);
				} else if (PECommandConstants.HUMAN_TASK_ASPECT.compareTo(aspect) == 0) {
					actionCmd = cmdFactory.buildAddHumanTaskPeCmd((EObject) workingCopy);
					// Ray - d160163
					((AddHumanTaskPeCmd)actionCmd).setCreatePrimaryooleanOwner(false);
				} else if (PECommandConstants.BUSINESS_RULE_TASK_ASPECT.compareTo(aspect) == 0) {
					actionCmd = cmdFactory.buildAddBusinessRuleTaskPeCmd((EObject) workingCopy);
				}
			}
		}
		LoggingUtil.traceExit(this, "getCommand");		
		return actionCmd;		
	}

	/**
	 * Update Model
	 */
	protected void updateModel() {
		LoggingUtil.traceEntry(this, "updateModel");					
		if (domainModel instanceof Action) {
		
			// Update the attribute 
			UpdateActionBOMCmd updateCmd = new UpdateActionBOMCmd((Action)domainModel);	
			String effect = action.getEffect();
			updateCmd.setEffect(effect);	
			
			// Attribute responsibleOrganization
			Iterator orgIterator = action.getResponsibleOrganization().iterator();
			OrganizationUnit unit  = null;		
			Object model = null;	
			while(orgIterator.hasNext()) {
				unit = (OrganizationUnit) orgIterator.next();
				model  = getModelFromContext(unit);
				//TODO: this is to support temprary category solution, should be removed in 6.0
				if(model == null && 
					unit.getOwningPackage() != null && 
						unit.getOwningPackage().getAspect() != null && 
							unit.getOwningPackage().getAspect().equals(PredefTypesConst.CATEGORY_ASPECT)){
								
					//model = BOMUtil.getPredefinedCategoryValueOrganizationUnit(getProjectName(),unit, getImportSession().getContext());
					model = BOMUtil.getPredefinedCategoryValueOrganizationUnit(PredefUtil.getPredefinedProjectName(),unit, getImportSession().getContext());
					
					
				}//<end todo>
				
				if (model != null && model instanceof OrganizationUnit) {
					updateCmd.addResponsibleOrganization((OrganizationUnit)model);
				}else{					
					LoggingUtil.trace(this, "updateModel", "unit " + unit.getName() + " not found or is not a organizationUnit");
				}
			}
			
			// Attribute performAt
			orgIterator = action.getPerformedAt().iterator();
			Location location  = null;			
			while(orgIterator.hasNext()) {
				Location lc = (Location) orgIterator.next();
				model  = getModelFromContext(lc);
				if (model != null && model instanceof Location) {
					updateCmd.addPerformedAt((Location)model);
				}else{
					LoggingUtil.trace(this, "updateModel", "location " + lc.getName() + " not found or is not a Location");
				}
			}			
			
			if (updateCmd.canExecute()) {
				try {
					updateCmd.execute();
				} catch (RuntimeException e) {
					logWarning(getImportSession(), 
						IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 							
						IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
				}
			} else {
				logWarning(getImportSession(), 
					IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
					IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
			}

			// Attribute inputPinSet
			// Attribute outputPinSet
			createPinSet();						
			// Attribute inputControlPin
			// Attribute inputObjectPin		
			// Attribute outputControlPin
			// Attribute outputObjectPin
			createPin();
			
			// Attribute resourceRequirement
			addResourceRequirement();
			
			// Description
			BOMUtil.updateDescription((Element)domainModel, BOMUtil.getDescription((Element)action));
		}
		
		// Attribute aspect - handled
		// Attribute authorizationRequirement - not handled
		// Attribute uid - generated
		// Attribute visibility - Default
		// Attribute ownedConstraint - not handled
		// Attribute performedAt - not handled
		
		
		LoggingUtil.traceExit(this, "updateModel");
	}

	/**
	 * Add resource requirement to Action
	 */	
	public void addResourceRequirement() {
		final Double defaultQuantity = new Double(1);
		final String defaultUnit = BOMUtil.getDefaultUnitOfMeasureName();
		
		LoggingUtil.traceEntry(this, "addResourceRequirement");
		AddUpdateResourceRequirementBOMCmd cmd = null;
		Iterator iterator = action.getResourceRequirement().iterator();
		ResourceRequirement requirement = null;
		Object model = null;
		String unitOfMeasure = null;
		ValueSpecification value = null;
		Double quantityValue = null;
		ResourceQuantity resourceQuantity = null;
		while(iterator.hasNext()) {
			// Default Tool Behavior
			quantityValue = defaultQuantity;
			unitOfMeasure = defaultUnit;
			
			requirement = (ResourceRequirement) iterator.next();
			if (requirement instanceof IndividualResourceRequirement) {
				cmd = new AddIndividualResourceRequirementToActionBOMCmd((Action)domainModel);
				model  = getModelFromContext(((IndividualResourceRequirement)requirement).getIndividualResource());				
				// TN - added to support reusing existing individual resource in the workspace
				if (model == null && ((IndividualResourceRequirement)requirement).getIndividualResource() != null) {
					model = BOMUtil.getResFromWorkspace(getImportSession(), getProjectName(), ((IndividualResourceRequirement)requirement).getIndividualResource());	
				}
				// TN - end of added to support reusing existing individual resource in the workspace
				
				if (model != null && model instanceof IndividualResource) {
					((AddIndividualResourceRequirementToActionBOMCmd)cmd).setIndividualResource((IndividualResource)model);
				}
			} else if (requirement instanceof BulkResourceRequirement) {
				cmd = new AddBulkResourceRequirementToActionBOMCmd((Action)domainModel);
				model  = getModelFromContext(((BulkResourceRequirement)requirement).getBulkResource());				
				// TN - added to support reusing existing individual resource in the workspace
				if (model == null && ((BulkResourceRequirement)requirement).getBulkResource() != null) {
					model = BOMUtil.getResFromWorkspace(getImportSession(), getProjectName(), ((BulkResourceRequirement)requirement).getBulkResource());	
				}
				// TN - end of added to support reusing existing individual resource in the workspace				
				
				if (model != null && model instanceof BulkResource) {
					((AddBulkResourceRequirementToActionBOMCmd)cmd).setBulkResource((BulkResource)model);
				}	
				// Resource Quantiry
				resourceQuantity = ((BulkResourceRequirement)requirement).getRequiredQuantity();
				if (resourceQuantity != null) {		
					unitOfMeasure = resourceQuantity.getUnitOfMeasure();
					if (unitOfMeasure == null || unitOfMeasure.compareTo("") == 0) {
						unitOfMeasure = defaultUnit;
					}
					value = resourceQuantity.getQuantity();
					if (value instanceof LiteralReal) {
						quantityValue = ((LiteralReal)value).getValue();
					}
				}
			} else if (requirement instanceof RequiredRole) {
				cmd = new AddRequiredRoleToActionBOMCmd((Action)domainModel);
				model  = getModelFromContext(((RequiredRole)requirement).getRole());
				// Ray - added to support reusing existing Role in the workspace
				if (model == null) {
					model = BOMUtil.getRoleFromWorkspace(getImportSession(), getProjectName(), ((RequiredRole)requirement).getRole());
				}				
				if (model != null && model instanceof Role) {
					((AddRequiredRoleToActionBOMCmd)cmd).setRole((Role)model);
				}	
				// Resource Quantiry
				resourceQuantity = ((RequiredRole)requirement).getRequiredQuantity();
				if (resourceQuantity != null) {					
					// missing unit of measure - fixes here
					unitOfMeasure = resourceQuantity.getUnitOfMeasure();
					// end of missing unit of measure - fixes here			
					if (unitOfMeasure == null || unitOfMeasure.compareTo("") == 0) {
						unitOfMeasure = defaultUnit;
					}
					value = resourceQuantity.getQuantity();
					if (value instanceof LiteralReal) {
						quantityValue = ((LiteralReal)value).getValue();
					}
				}
			}
			
			Type resourceType = (Type) BOMUtil.getType(getProjectName(), requirement.getResourceType(), getImportSession().getContext());
			cmd.setResourceType(resourceType);
			
			
			cmd.setName(requirement.getName());
			// TODO: [Code] need to check the format of the time required
			String timeRequired = requirement.getTimeRequired();
			if (timeRequired == null) {
				timeRequired = "PT0S";
			}
			cmd.setTimeRequired(timeRequired);
			
			// Create the Requirement
			if (cmd.canExecute()) {
				try {
					cmd.execute();
				} catch (RuntimeException e) {
					logWarning(getImportSession(), 
					IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
						IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
				}
			} else {
				logWarning(getImportSession(), 
				IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
					IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
			}			
			
			// Update the Requirement
			Object newObject = cmd.getObject();
			Object quantity = null;
			AddUpdateResourceQuantityBOMCmd quantityCmd = null;
			if (newObject != null && unitOfMeasure != null) {		
				if (newObject instanceof BulkResourceRequirement) {				
					quantityCmd = new AddResourceQuantityToBulkResourceRequirementBOMCmd((BulkResourceRequirement)newObject);
				} else if (newObject instanceof RequiredRole) {
					quantityCmd = new AddResourceQuantityToRequiredRoleBOMCmd((RequiredRole)newObject);
				}
				if (quantityCmd != null && unitOfMeasure != null) {
					quantityCmd.setUnitOfMeasure(unitOfMeasure);
					if (quantityCmd.canExecute()) {
						try {
							quantityCmd.execute();
						} catch (RuntimeException e) {
							logWarning(getImportSession(), 
								IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
								IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
						}
					} else {
						logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
					}
				}
				if (quantityCmd != null) {
					quantity = quantityCmd.getObject();				
			
				// if (quantity != null && quantity instanceof ResourceQuantity && quantityValue != null) {
					AddLiteralRealToResourceQuantityBOMCmd addRealCmd = new AddLiteralRealToResourceQuantityBOMCmd((ResourceQuantity)quantity);
					addRealCmd.setValue(quantityValue);
					if (addRealCmd.canExecute()) {
						try {
							addRealCmd.execute();
						} catch (RuntimeException e) {
							logWarning(getImportSession(), 
								IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
								IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
						}
					} else {
						logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
					}
				}
			}
			
			// Update RequiredRole			
			if (requirement instanceof RequiredRole && newObject instanceof RequiredRole) {
				ScopeValue scopeValue = null;
				ScopeValue scopeValueWorkingCopy = null;
				Object newScopeDimension = null;
				AddScopeValueToRequiredRoleBOMCmd scopeCmd = null;
				Iterator scopeIterator = ((RequiredRole) requirement).getRequiredScope().iterator();
				List scopeValueList = null;
				ValueSpecification thisValue = null;
				AddUpdateObjectCommand updateValueCmd = null;
				UpdateValueSpecificationRule rule  = null;
				Object newDomainModel = null;
				while (scopeIterator.hasNext()) {
					scopeValue = (ScopeValue) scopeIterator.next();
					scopeCmd = new AddScopeValueToRequiredRoleBOMCmd((RequiredRole)newObject);
					// Set Scope dimension
					ScopeDimension dimension = scopeValue.getScopeDimension();
					newScopeDimension = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_SCOPE_DIMNENSION).get(dimension);
					if (newScopeDimension instanceof ScopeDimension) {
						scopeCmd.setScopeDimension((ScopeDimension)newScopeDimension);	
					}
					if (scopeCmd.canExecute()) {
						try {
							scopeCmd.execute();
							scopeValueWorkingCopy = (ScopeValue)scopeCmd.getObject();
						} catch (RuntimeException e) {
							logWarning(getImportSession(), 
								IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
								IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
						}
					} else {
						logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
					}
					
					// Set Scope Value					
					scopeValueList = scopeValue.getValue();
					if (scopeValueList.size() > 0 && scopeValueWorkingCopy != null) {
						thisValue = (ValueSpecification) scopeValueList.get(0);
						if (thisValue instanceof LiteralNull) {
							updateValueCmd = new AddLiteralNullToScopeValueBOMCmd(scopeValueWorkingCopy); 
						} else if (thisValue instanceof LiteralSpecification) {
							updateValueCmd = new AddLiteralStringToScopeValueBOMCmd(scopeValueWorkingCopy);
						} else if (thisValue instanceof StructuredOpaqueExpression){
							updateValueCmd = new AddStructuredOpaqueExpressionToScopeValueBEXCmd(scopeValueWorkingCopy);	 
						} else if (thisValue instanceof OpaqueExpression) {
							// [Expression] Attrbibute constant value
							updateValueCmd = new AddOpaqueExpressionToScopeValueBOMCmd(scopeValueWorkingCopy);
						} else if (thisValue instanceof InstanceValue) {
							updateValueCmd = new AddInstanceValueToScopeValueBOMCmd(scopeValueWorkingCopy);
						}
						if (updateValueCmd.canExecute()) {
							try {
								updateValueCmd.execute();
							} catch (RuntimeException e) {
								logWarning(getImportSession(), 
									IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
									IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
							}
						} else {
							logWarning(getImportSession(), 
								IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
								IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);				
						}
						//	After creation
						newDomainModel = updateValueCmd.getObject();
						if (newDomainModel != null) {
							rule = new UpdateValueSpecificationRule();
							rule.setSource(value);
							rule.setWorkingCopy(newDomainModel);
							rule.setProjectName(getProjectName());
							rule.setImportSession(getImportSession());
							rule.invoke();
						}						
					}
				}
			}
			
			LoggingUtil.traceExit(this, "addResourceRequirement");			
		}		
	}

	/**
	 * Create pins
	 */
	protected void createPin() {
		LoggingUtil.traceEntry(this, "createPin");
		
		Pin eachPin = null;
		UpdatePinRule inputObjectPinRule = null;
		UpdatePinRule inputControlPinRule = null;
		UpdatePinRule outputObjectPinRule = null;
		UpdatePinRule outputControlPinRule = null;
		
		Iterator pinIterator = action.getInputObjectPin().iterator();
		LoggingUtil.trace(this, "createPin", "Create input object pin");		
		while(pinIterator.hasNext()) {
			eachPin = (Pin) pinIterator.next();
			inputObjectPinRule = new UpdatePinRule();
			inputObjectPinRule.setImportSession(getImportSession());
			inputObjectPinRule.setProjectName(getProjectName());
			inputObjectPinRule.setSource(eachPin);
			inputObjectPinRule.setWorkingCopy(viewModel);
			inputObjectPinRule.setProcess(process);
			inputObjectPinRule.setAction(action);
			inputObjectPinRule.invoke(); 
		}	
		
		pinIterator = action.getInputControlPin().iterator();
		LoggingUtil.trace(this, "createPin", "Create input control pin");		
		while(pinIterator.hasNext()) {
			eachPin = (Pin) pinIterator.next();
			inputControlPinRule = new UpdatePinRule();
			inputControlPinRule.setImportSession(getImportSession());
			inputControlPinRule.setProjectName(getProjectName());
			inputControlPinRule.setSource(eachPin);
			inputControlPinRule.setWorkingCopy(viewModel);
			inputControlPinRule.setProcess(process);
			inputControlPinRule.setAction(action);
			inputControlPinRule.invoke(); 
		}
		
		pinIterator = action.getOutputObjectPin().iterator();
		LoggingUtil.trace(this, "createPin", "Create output object pin");		
		while(pinIterator.hasNext()) {
			eachPin = (Pin) pinIterator.next();
			outputObjectPinRule = new UpdatePinRule();
			outputObjectPinRule.setImportSession(getImportSession());
			outputObjectPinRule.setProjectName(getProjectName());
			outputObjectPinRule.setSource(eachPin);
			outputObjectPinRule.setWorkingCopy(viewModel);
			outputObjectPinRule.setProcess(process);
			outputObjectPinRule.setAction(action);
			outputObjectPinRule.invoke(); 
		}	
		
		pinIterator = action.getOutputControlPin().iterator();
		LoggingUtil.trace(this, "createPin", "Create output control pin");		
		while(pinIterator.hasNext()) {
			eachPin = (Pin) pinIterator.next();
			outputControlPinRule = new UpdatePinRule();
			outputControlPinRule.setImportSession(getImportSession());
			outputControlPinRule.setProjectName(getProjectName());
			outputControlPinRule.setSource(eachPin);
			outputControlPinRule.setWorkingCopy(viewModel);
			outputControlPinRule.setProcess(process);
			outputControlPinRule.setAction(action);
			outputControlPinRule.invoke(); 
		}
		
		LoggingUtil.traceExit(this, "createPin");		
	}	
	
	/**
	 * Remove existing pin sets
	 * @return
	 */
	protected List deletePinSets() {
		LoggingUtil.traceEntry(this, "deletePinSets");
		NavigationProjectNode projectNode = NavigatorUtil.getProjectNode(getProjectName());
		if (projectNode == null) {
			LoggingUtil.traceExit(this, "deletePinSets");											
			return null;
		}		
		PeCmdFactory cmdFactory = getPeCmdFactory();
		RemovePeCmd removeCmd = null;
		RemovePeCmd alreadyRemovedCmd = null;
		List removeCmdList = new ArrayList();
		List removeList = new ArrayList();
		Object removeElement = null;
		if (viewModel instanceof CommonContainerModel) {
			if (action instanceof ControlAction) {
				removeList.addAll(PEDomainViewObjectHelper.getAllInBranch(viewModel));
				removeList.addAll(PEDomainViewObjectHelper.getAllOutBranch(viewModel));
			} else {
				removeList.addAll(PEDomainViewObjectHelper.getAllViewInputPinSetFromViewAction(viewModel));
				removeList.addAll(PEDomainViewObjectHelper.getAllViewOutputPinSetFromViewAction(viewModel));
			}		
			
			Iterator removeIterator = removeList.iterator();				
			while(removeIterator.hasNext()) {
				removeElement = removeIterator.next();
				removeCmd = cmdFactory.buildRemovePeCmd((EObject)removeElement);
				if (removeCmd.canExecute()) {
					try {
						removeCmd.execute();
						removeCmdList.add(removeCmd);
					} catch (RuntimeException e) {
						LoggingUtil.trace(this, "deletePinSets",  IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
						Iterator iterator = removeCmdList.iterator();
						while(iterator.hasNext()) {
							alreadyRemovedCmd = (RemovePinSetPeCmd) iterator.next();
							try {
								alreadyRemovedCmd.undo();
							} catch (RuntimeException re) {
								LoggingUtil.trace(this, "deletePinSets", "Cannot undo remove command.");
								LoggingUtil.traceExit(this, "deletePinSets");
								return null;	
							}
						}
						LoggingUtil.traceExit(this, "deletePinSets");
						return null;							
					}
				} else {
					LoggingUtil.trace(this, "deletePinSets", IImportResultMessages.CANNOT_EXECUTE_REMOVE_CEF_COMMAND);								
					Iterator iterator = removeCmdList.iterator();
					while(iterator.hasNext()) {
						alreadyRemovedCmd = (RemovePinSetPeCmd) iterator.next();
						try {
							alreadyRemovedCmd.undo();
						} catch (RuntimeException re) {
							LoggingUtil.trace(this, "deletePinSets", "Cannot undo remove command.");	
							LoggingUtil.traceExit(this, "deletePinSets");
							return null;	
						}
					}
					LoggingUtil.traceExit(this, "deletePinSets");
					return null;								
				}
			}
		}
		//delete outputSetProbabilities
		deleteOutputSetProbabilities();
				
		LoggingUtil.traceExit(this, "deletePinSets");		
		return removeCmdList;
	}	
	
	/**
	 * Remove default created outputSetProbabilities of the action.
	 *
	 */
	private void deleteOutputSetProbabilities(){
		LoggingUtil.traceEntry(this, "deleteOutputSetProbabilities");
		Action domainAction = (Action)domainModel;
		OperationalProbabilities opProbs = domainAction.getOperationalProbabilities();
		if(opProbs != null){
			RemoveOperationalProbabilitiesBOMCmd cmd = new RemoveOperationalProbabilitiesBOMCmd(opProbs);
			executeCmd(cmd);
		}
		LoggingUtil.traceExit(this,"deleteOutputSetProbabilities");	
	}
	
	/**
	 * Create the pin set
	 */
	protected void createPinSet() {
		LoggingUtil.traceEntry(this, "createPinSet");
		
		List removeCmdList = deletePinSets();
		
		NavigationProjectNode projectNode = NavigatorUtil.getProjectNode(getProjectName());
		if (projectNode == null) {
			LoggingUtil.traceExit(this, "createPinSet");											
			return;
		}		
		PeCmdFactory cmdFactory = getPeCmdFactory();	
		
		LoggingUtil.trace(this, "createPinSet", "Add new pin sets");
		PinSet eachPinSet = null;
		UpdatePinSetRule inputPinSetRule = null;
		UpdatePinSetRule outputPinSetRule = null;
		Iterator pinSetIterator = action.getInputPinSet().iterator();
		LoggingUtil.trace(this, "createPinSet", "Create input pin sets");
		while(pinSetIterator.hasNext()) {
			eachPinSet = (PinSet) pinSetIterator.next();
			inputPinSetRule = new UpdatePinSetRule();
			inputPinSetRule.setImportSession(getImportSession());
			inputPinSetRule.setProjectName(getProjectName());
			inputPinSetRule.setSource(eachPinSet);
			inputPinSetRule.setWorkingCopy(viewModel);
			inputPinSetRule.setProcess(process);
			inputPinSetRule.invoke(); 
		}
		if (domainModel != null && ((Action)domainModel).getInputPinSet().size() == 0) {
			Iterator iterator = removeCmdList.iterator();
			RemovePeCmd alreadyRemovedCmd = null;
			while(iterator.hasNext()) {
				alreadyRemovedCmd = (RemovePeCmd) iterator.next();
				try {
					if (alreadyRemovedCmd instanceof RemoveInputPinSetPeCmd) {
						alreadyRemovedCmd.undo();
					}
				} catch (RuntimeException re) {
					LoggingUtil.trace(this, "updatePinSet", "Cannot undo remove command.");
				}
			}	
			LoggingUtil.traceExit(this, "updatePinSet");
		}				
					
		LoggingUtil.trace(this, "createPinSet", "Create output pin sets");		
		pinSetIterator = action.getOutputPinSet().iterator();
		while(pinSetIterator.hasNext()) {
			eachPinSet = (PinSet) pinSetIterator.next();
			outputPinSetRule = new UpdatePinSetRule();
			outputPinSetRule.setImportSession(getImportSession());
			outputPinSetRule.setProjectName(getProjectName());
			outputPinSetRule.setSource(eachPinSet);
			outputPinSetRule.setWorkingCopy(viewModel);
			outputPinSetRule.setProcess(process);
			outputPinSetRule.invoke(); 
		}
		if (domainModel != null && ((Action)domainModel).getOutputPinSet().size() == 0) {
			Iterator iterator = removeCmdList.iterator();
			RemovePeCmd alreadyRemovedCmd = null;
			while(iterator.hasNext()) {
				alreadyRemovedCmd = (RemovePeCmd) iterator.next();
				try {
					if (alreadyRemovedCmd instanceof RemoveOutputPinSetPeCmd) {
						alreadyRemovedCmd.undo();
					}
				} catch (RuntimeException re) {
					LoggingUtil.trace(this, "updatePinSet", "Cannot undo remove command.");
				}
			}	
			LoggingUtil.traceExit(this, "updatePinSet");
		}		
		
		// Attribute outputPinSet
		// Attribute inputPinSet
		if (action instanceof ControlAction) {
			LoggingUtil.traceExit(this, "updatePinSet");
			return;
		}
		AssociateInputPinSetWithOutputPinSetPeCmd cmd = null;
		ImportContext context = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);
		InputPinSet inputPinSet = null;
		OutputPinSet outputPinSet = null;
		Iterator outputPinSetIterator = null;
		EObject inputViewModel = null;
		EObject outputViewModel = null;
			
		EObject domainModel = null;
		List contents = null;
		pinSetIterator = action.getInputPinSet().iterator();
		while(pinSetIterator.hasNext()) {
			inputPinSet = (InputPinSet) pinSetIterator.next();
			inputViewModel = (EObject) context.get(inputPinSet);
			if (inputViewModel == null) {
				continue;
			}
			outputPinSetIterator = inputPinSet.getOutputPinSet().iterator();
			while(outputPinSetIterator.hasNext()) {
				outputPinSet = (OutputPinSet) outputPinSetIterator.next();
				outputViewModel = (EObject) context.get(outputPinSet);
				if (outputViewModel == null) {
					continue;
				}
				cmd = (AssociateInputPinSetWithOutputPinSetPeCmd) 
					cmdFactory.buildAssociateInputPinSetWithOutputPinSetPeCmd(inputViewModel, outputViewModel);
				if (cmd.canExecute()) {
					try {
						cmd.execute();
					} catch (RuntimeException e) {
						logWarning(getImportSession(), 
							IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
							IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);							
					}
				} else {
					logWarning(getImportSession(), 
						IeMessageKeys.FAIL_TO_UPDATE_ELEMENT, new String[]{getElement(), getName(), getProcessName()}, null, 
						IImportResultMessages.CANNOT_EXECUTE_ASSOCIATE_CEF_COMMAND);
				}
			}
		}
			
		LoggingUtil.traceExit(this, "createPinSet");
	}
	
	/**
	 * Create Action's all operational data
	 */
	protected void createOperationalData() {
		LoggingUtil.traceEntry(this, "createOperationalData");	
		creatOperationalRevenue();
		createOperationalCost();
		createOperationalTimes();
		createOutputPathProbabilities();
		LoggingUtil.traceExit(this, "createOperationalData");		
	}
	
	/**
	 * Creates output path probabilities
	 *
	 */
	protected void createOutputPathProbabilities(){
		LoggingUtil.traceEntry(this, "createOutputPathProbabilities");
		
		OperationalProbabilities opProbs = action.getOperationalProbabilities();
		if(opProbs == null){
			LoggingUtil.traceExit(this, "createOutputPathProbabilities", "OperationalProbabilities is null");
			return;
		}	
		OutputSetProbabilities outputSetProbs = opProbs.getOutputSetProbabilities();
		if(outputSetProbs == null){
			LoggingUtil.traceExit(this, "createOutputPathProbabilities", "OutputSetProbabilities is null");
			return;
		}	

		//get context
		ImportContext context = getImportSession().getContext().getSubContext(IImportFramework.CONTEXT_PROCESS_KEY).getSubContext(process);
		
		AddOperationalProbabilitiesToActionBOMCmd cmd = new AddOperationalProbabilitiesToActionBOMCmd((Action)domainModel);
		executeCmd(cmd);
		OperationalProbabilities newDomainOpProbs = (OperationalProbabilities)cmd.getObject();
		OutputSetProbabilities newDomainOutputSetProbs = null;
		if(newDomainOpProbs != null){				
			AddOutputSetProbabilitiesToOperationalProbabilitiesBOMCmd cmd2 = new AddOutputSetProbabilitiesToOperationalProbabilitiesBOMCmd(newDomainOpProbs);
			executeCmd(cmd2);
			newDomainOutputSetProbs = (OutputSetProbabilities)cmd2.getObject();
		}
		if(newDomainOutputSetProbs != null){				
			for(Iterator it = outputSetProbs.getOutputSetProbability().iterator(); it.hasNext(); ){
				OutputSetProbability outputSetProb = (OutputSetProbability)it.next();
				OutputPinSet outputPinSet = outputSetProb.getOutputPinSet();
				ValueSpecification prob = outputSetProb.getValue();
				if(outputPinSet != null && prob != null){
					EObject outputViewModel = (EObject)context.get(outputPinSet);
					OutputPinSet domainOutputPinSet =(OutputPinSet)DomainViewObjectHelper.getDomainObject(outputViewModel);					
					AddOutputSetProbabilityToOutputSetProbabilitiesBOMCmd cmd3 = new AddOutputSetProbabilityToOutputSetProbabilitiesBOMCmd(newDomainOutputSetProbs);
					cmd3.setOutputPinSet(domainOutputPinSet);
					executeCmd(cmd3);
					OutputSetProbability newDomainOutputSetProb = (OutputSetProbability)cmd3.getObject();				
					if(newDomainOutputSetProb != null){
						addValueToOutputPinSetProbability(newDomainOutputSetProb, prob);
					}					 
				}
			}
		}
		
		LoggingUtil.traceExit(this, "createOutputPathProbabilities");
	}
	
	/**
	 * Creates operational times
	 *
	 */
	protected void createOperationalTimes(){
		LoggingUtil.traceEntry(this, "createOperationalTimes");
		
		OperationalTimes opTimes = action.getOperationalTimes();
		if(opTimes == null){
			LoggingUtil.traceExit(this, "createOperationalTimes", "operational times is null"); 
			return;
		}	
		
		AddOperationalTimesToActionBOMCmd cmd = new AddOperationalTimesToActionBOMCmd((Action)domainModel);
		executeCmd(cmd);
		OperationalTimes newDomainOpTimes =(OperationalTimes)cmd.getObject();
		if(newDomainOpTimes != null){
			
			//processing time
			ValueSpecification processTime = opTimes.getProcessingTime();
			if(processTime != null){				
				updateProcessingTimeToOperationalTimes(newDomainOpTimes, processTime);
			}
			//resourceAwaiting time
			ValueSpecification resWaitTime = opTimes.getMaxResourceAwaitingTime();
			if(resWaitTime != null){
				updateMaxResourceAwaitingTimeToOperationalTimes(newDomainOpTimes, resWaitTime);
			}
		}
		LoggingUtil.traceExit(this, "createOperationalTimes");
	}
	
	/**
	 * Creates operational revenue
	 *
	 */
	protected void creatOperationalRevenue(){
		LoggingUtil.traceEntry(this, "creatOperationalRevenue");
		
		OperationalRevenue opRevenue = action.getOperationalRevenue();
		if(opRevenue == null){
			LoggingUtil.traceExit(this, "creatOperationalRevenue", "operational revenue is null");
			return; 
		}
		
		AddOperationalRevenueToActionBOMCmd cmd = new AddOperationalRevenueToActionBOMCmd((Action)domainModel);
		executeCmd(cmd);

		OperationalRevenue newDomainOpRevenue =(OperationalRevenue)cmd.getObject();
		 if (newDomainOpRevenue != null) {				
			AddMonetaryValueToOperationalRevenueBOMCmd cmd2 = 
				new AddMonetaryValueToOperationalRevenueBOMCmd(newDomainOpRevenue);
			cmd2.setCurrency(opRevenue.getRevenue().getCurrency());
			executeCmd(cmd2);			
			MonetaryValue newDomainMv = (MonetaryValue)cmd2.getObject();
			if(newDomainMv != null){
				ValueSpecification vs = opRevenue.getRevenue().getValue();
				updateMonetaryValue(newDomainMv, vs);
			}
			
		 }	
			
		LoggingUtil.traceExit(this, "creatOperationalRevenue");
	}
	
	/**
	 * Update ouputSet's probability value
	 * @param domainOutputSetProbability
	 * @param vs
	 */
	protected void updateValueToOutputPinSetProbability(OutputSetProbability domainOutputSetProbability, ValueSpecification vs){
		LoggingUtil.traceEntry(this, "updateValueToOutputPinSetProbability");
		ValueSpecification domainVs = domainOutputSetProbability.getValue();
		if(domainVs instanceof LiteralReal && vs instanceof LiteralReal){
			UpdateLiteralRealBOMCmd cmd = 
				new UpdateLiteralRealBOMCmd((LiteralReal)domainVs);							
			cmd.setValue(((LiteralReal)vs).getValue());
			executeCmd(cmd);
		}else if(vs instanceof PDistribution){
						
			if(domainVs instanceof PNormalDistribution && vs instanceof PNormalDistribution){
				UpdatePNormalDistributionBOMCmd cmd = 
					new UpdatePNormalDistributionBOMCmd((PNormalDistribution)domainVs);
				cmd.setMean(((PNormalDistribution)vs).getMean());
				cmd.setStd(((PNormalDistribution)vs).getStd());
				executeCmd(cmd);	
			}	
			else if(domainVs instanceof PLognormalDistribution && vs instanceof PLognormalDistribution){
				UpdatePLognormalDistributionBOMCmd cmd = 
					new UpdatePLognormalDistributionBOMCmd((PLognormalDistribution)domainVs);
				cmd.setMean(((PLognormalDistribution)vs).getMean());
				cmd.setStd(((PLognormalDistribution)vs).getStd());
				executeCmd(cmd);							
			}
			else if(domainVs instanceof PPoissonDistribution && vs instanceof PPoissonDistribution){
				UpdatePPoissonDistributionBOMCmd cmd = 
					new UpdatePPoissonDistributionBOMCmd((PPoissonDistribution)domainVs);
				cmd.setMean(((PPoissonDistribution)vs).getMean());
				executeCmd(cmd);							
			}
			else if(domainVs instanceof PGammaDistribution && vs instanceof PGammaDistribution){
				UpdatePGammaDistributionBOMCmd cmd = 
					new UpdatePGammaDistributionBOMCmd((PGammaDistribution)domainVs);
				cmd.setMean(((PGammaDistribution)vs).getMean());
				cmd.setStd(((PGammaDistribution)vs).getStd());
				executeCmd(cmd);
			}
			else if(domainVs instanceof PExponentialDistribution && vs instanceof PExponentialDistribution){
				UpdatePExponentialDistributionBOMCmd cmd = 
					new UpdatePExponentialDistributionBOMCmd((PExponentialDistribution)domainVs);
				cmd.setMean(((PExponentialDistribution)vs).getMean());
				executeCmd(cmd);			
			}
			else if(domainVs instanceof PUniformDistribution && vs instanceof PUniformDistribution){
				UpdatePUniformDistributionBOMCmd cmd = 
					new UpdatePUniformDistributionBOMCmd((PUniformDistribution)domainVs);
				executeCmd(cmd);
				PUniformDistribution newDomainPDist = (PUniformDistribution)cmd.getObject();
				if(newDomainPDist != null){
					AddLiteralRealMinValueToPUniformDistributionBOMCmd cmd2 = 
						new AddLiteralRealMinValueToPUniformDistributionBOMCmd(newDomainPDist);
					cmd2.setValue(((LiteralReal)((PUniformDistribution)vs).getMinValue()).getValue());
					executeCmd(cmd2);

					AddLiteralRealMaxValueToPUniformDistributionBOMCmd cmd3 = 
						new AddLiteralRealMaxValueToPUniformDistributionBOMCmd(newDomainPDist);
					cmd3.setValue(((LiteralReal)((PUniformDistribution)vs).getMaxValue()).getValue());
					executeCmd(cmd3);			
				}
			}
			else if(domainVs instanceof PBernoulliDistribution && vs instanceof PBernoulliDistribution){
				UpdatePBernoulliDistributionBOMCmd cmd = 
					new UpdatePBernoulliDistributionBOMCmd((PBernoulliDistribution)domainVs);
				cmd.setProbability(((PBernoulliDistribution)vs).getProbability());
				executeCmd(cmd);
			}else if(domainVs instanceof PBinomialDistribution && vs instanceof PBinomialDistribution){
				UpdatePBinomialDistributionBOMCmd cmd = 
					new UpdatePBinomialDistributionBOMCmd((PBinomialDistribution)domainVs);
				cmd.setProbability(((PBinomialDistribution)vs).getProbability());
				executeCmd(cmd);
			}else if(domainVs instanceof PRandomList && vs instanceof PRandomList){
				UpdatePRandomListBOMCmd cmd = 
					new UpdatePRandomListBOMCmd((PRandomList)domainVs);								
				executeCmd(cmd);
				PRandomList newDomainRdmList = (PRandomList)cmd.getObject();
				if(newDomainRdmList != null){
					BtCompoundCommand compoundCmd = new BtCompoundCommand();
					for (Iterator it = ((PRandomList)vs).getListElement().iterator(); it.hasNext();) {
						AddPListElementToPRandomListBOMCmd cmd2 =
							new AddPListElementToPRandomListBOMCmd(newDomainRdmList);
						compoundCmd.append(cmd2);
						PListElement element = (PListElement)cmd2.getObject();
						PListElement nextElement = (PListElement)it.next();									
						LiteralReal literalReal = (LiteralReal)nextElement.getValue();
						AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
						cmd3.setValue(literalReal.getValue());
						compoundCmd.append(cmd3);
					}
					executeCmd(compoundCmd);
				}
						
			}else if(domainVs instanceof PWeightedList && vs instanceof PWeightedList){
				UpdatePWeightedListBOMCmd cmd3 = 
					new UpdatePWeightedListBOMCmd((PWeightedList)domainVs);								
				executeCmd(cmd3);
				PWeightedList newDomainWtList = (PWeightedList)cmd3.getObject();
				if(newDomainWtList != null){
					BtCompoundCommand compoundCmd = new BtCompoundCommand();
					for (Iterator it = ((PWeightedList)vs).getWeightedListElement().iterator(); it.hasNext();) {
						PWeightedListElement nextElement = (PWeightedListElement)it.next();	
						AddPWeightedListElementToPWeightedListBOMCmd cmd4 =
							new AddPWeightedListElementToPWeightedListBOMCmd(newDomainWtList);
						cmd4.setProbability(nextElement.getProbability());										
						compoundCmd.append(cmd4);
						PWeightedListElement element = (PWeightedListElement)cmd4.getObject();																	
						LiteralReal literalRealValue = (LiteralReal)nextElement.getValue();
						AddLiteralRealToPListElementBOMCmd cmd5 = new AddLiteralRealToPListElementBOMCmd(element);
						cmd5.setValue(literalRealValue.getValue());
						compoundCmd.append(cmd5);
					}
					executeCmd(compoundCmd);
				}	
			// support of the new distributions types in L002643				
			} else if (domainVs instanceof PBetaDistribution && vs instanceof PBetaDistribution) {
				UpdatePBetaDistributionBOMCmd cmd = new UpdatePBetaDistributionBOMCmd((PBetaDistribution) domainVs);
				PBetaDistribution betaDist = (PBetaDistribution) vs;				
				cmd.setA(betaDist.getA());
				cmd.setB(betaDist.getB());
				executeCmd(cmd);		
			} else if (domainVs instanceof PErlangRNDistribution && vs instanceof PErlangRNDistribution) {
				UpdatePErlangRNDistributionBOMCmd cmd = new UpdatePErlangRNDistributionBOMCmd((PErlangRNDistribution) domainVs);
				PErlangRNDistribution erlangDist = (PErlangRNDistribution) vs;				
				cmd.setExpmean(erlangDist.getExpmean());
				cmd.setK(erlangDist.getK());
				executeCmd(cmd);				
			} else if (domainVs instanceof PJohnsonRNDistribution && vs instanceof PJohnsonRNDistribution) {
				UpdatePJohnsonRNDistributionBOMCmd cmd = new UpdatePJohnsonRNDistributionBOMCmd((PJohnsonRNDistribution) domainVs);
				PJohnsonRNDistribution johnsonDist = (PJohnsonRNDistribution) vs;				
				cmd.setGamma(johnsonDist.getGamma());
				cmd.setDelta(johnsonDist.getDelta());								
				PJohnsonType pJohnsonType = johnsonDist.getJohnsonType();
				cmd.setJohnsonType(pJohnsonType);
				cmd.setLambda(johnsonDist.getLambda());
				cmd.setXi(johnsonDist.getXi());
				executeCmd(cmd);				
			} else if (domainVs instanceof PTriangularRNDistribution && vs instanceof PTriangularRNDistribution) {
				UpdatePTriangularRNDistributionBOMCmd cmd = new UpdatePTriangularRNDistributionBOMCmd((PTriangularRNDistribution) domainVs);
				PTriangularRNDistribution triangularDist = (PTriangularRNDistribution)vs;
				cmd.setMin(triangularDist.getMin());
				cmd.setMax(triangularDist.getMax());
				cmd.setMode(triangularDist.getMode());
				executeCmd(cmd);
			} else if (domainVs instanceof PWeibullRNDistribution && vs instanceof PWeibullRNDistribution) {
				UpdatePWeibullRNDistributionBOMCmd cmd = new UpdatePWeibullRNDistributionBOMCmd((PWeibullRNDistribution) domainVs);				
				PWeibullRNDistribution weibullDist = (PWeibullRNDistribution)vs;				
				cmd.setAlpha(weibullDist.getAlpha());
				cmd.setBeta(weibullDist.getBeta());
				executeCmd(cmd);
			} else if (domainVs instanceof PContinuousRNDistribution && vs instanceof PContinuousRNDistribution) {
				PContinuousRNDistribution contDist = (PContinuousRNDistribution) vs;
				UpdatePContinuousRNDistributionBOMCmd cmd = new UpdatePContinuousRNDistributionBOMCmd((PContinuousRNDistribution) domainVs);
				executeCmd(cmd);
				PContinuousRNDistribution newDomainContDist = (PContinuousRNDistribution) cmd.getObject();
				UpdatePContinuousRNDistributionBOMCmd cmd2 = new UpdatePContinuousRNDistributionBOMCmd((PContinuousRNDistribution) newDomainContDist);								
				if (newDomainContDist != null) {
					List cs = contDist.getC();
					List vals = contDist.getVal();
					
					if (cs != null && !cs.isEmpty()) {
						for (int i=0; i<cs.size(); i++) {
							cmd2.addC((Double) cs.get(i));
						}				
					}

					if (vals != null && !vals.isEmpty()) {
						for (int i=0; i<vals.size(); i++) {
							cmd2.addVal((Double) vals.get(i));
						}
					}
					executeCmd(cmd);					
				}				
			} else{
				LoggingUtil.trace(this, "updateValueToOutputPinSetProbability", "unknown destribution type");
			}
		}
		LoggingUtil.traceExit(this, "updateValueToOutputPinSetProbability");		
	}
	
	/**
	 * Add value specification to ouputSet's probability
	 * @param domainOutputSetProbability
	 * @param vs
	 */
	protected void addValueToOutputPinSetProbability(OutputSetProbability domainOutputSetProbability, ValueSpecification vs){
		LoggingUtil.traceEntry(this, "addValueToOutputPinSetProbability");
		
		if(vs instanceof LiteralReal){
			AddLiteralRealToOutputSetProbabilityBOMCmd cmd = 
				new AddLiteralRealToOutputSetProbabilityBOMCmd(domainOutputSetProbability);							
			cmd.setValue(((LiteralReal)vs).getValue());
			executeCmd(cmd);
		}else if(vs instanceof PDistribution){
						
			if(vs instanceof PNormalDistribution){
				AddPNormalDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPNormalDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setMean(((PNormalDistribution)vs).getMean());
				cmd.setStd(((PNormalDistribution)vs).getStd());
				executeCmd(cmd);	
			}	
			else if(vs instanceof PLognormalDistribution){
				AddPLognormalDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPLognormalDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setMean(((PLognormalDistribution)vs).getMean());
				cmd.setStd(((PLognormalDistribution)vs).getStd());
				executeCmd(cmd);							
			}
			else if(vs instanceof PPoissonDistribution){
				AddPPoissonDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPPoissonDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setMean(((PPoissonDistribution)vs).getMean());
				executeCmd(cmd);							
			}
			else if(vs instanceof PGammaDistribution){
				AddPGammaDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPGammaDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setMean(((PGammaDistribution)vs).getMean());
				cmd.setStd(((PGammaDistribution)vs).getStd());
				executeCmd(cmd);
			}
			else if(vs instanceof PExponentialDistribution){
				AddPExponentialDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPExponentialDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setMean(((PExponentialDistribution)vs).getMean());
				executeCmd(cmd);			
			}
			else if(vs instanceof PUniformDistribution){
				AddPUniformDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPUniformDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				executeCmd(cmd);
				PUniformDistribution newDomainPDist = (PUniformDistribution)cmd.getObject();
				if(newDomainPDist != null){
					AddLiteralRealMinValueToPUniformDistributionBOMCmd cmd2 = 
						new AddLiteralRealMinValueToPUniformDistributionBOMCmd(newDomainPDist);
					cmd2.setValue(((LiteralReal)((PUniformDistribution)vs).getMinValue()).getValue());
					executeCmd(cmd2);

					AddLiteralRealMaxValueToPUniformDistributionBOMCmd cmd3 = 
						new AddLiteralRealMaxValueToPUniformDistributionBOMCmd(newDomainPDist);
					cmd3.setValue(((LiteralReal)((PUniformDistribution)vs).getMaxValue()).getValue());
					executeCmd(cmd3);			
				}
			}
			else if(vs instanceof PBernoulliDistribution){
				AddPBernoulliDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPBernoulliDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setProbability(((PBernoulliDistribution)vs).getProbability());
				executeCmd(cmd);
			}else if(vs instanceof PBinomialDistribution){
				AddPBinomialDistributionToOutputSetProbabilityBOMCmd cmd = 
					new AddPBinomialDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				cmd.setProbability(((PBinomialDistribution)vs).getProbability());
				executeCmd(cmd);
			}else if(vs instanceof PRandomList){
				AddPRandomListToOutputSetProbabilityBOMCmd cmd = 
					new AddPRandomListToOutputSetProbabilityBOMCmd(domainOutputSetProbability);								
				executeCmd(cmd);
				PRandomList newDomainRdmList = (PRandomList)cmd.getObject();
				if(newDomainRdmList != null){
					BtCompoundCommand compoundCmd = new BtCompoundCommand();
					for (Iterator it = ((PRandomList)vs).getListElement().iterator(); it.hasNext();) {
						AddPListElementToPRandomListBOMCmd cmd2 =
							new AddPListElementToPRandomListBOMCmd(newDomainRdmList);
						compoundCmd.append(cmd2);
						PListElement element = (PListElement)cmd2.getObject();
						PListElement nextElement = (PListElement)it.next();									
						LiteralReal literalReal = (LiteralReal)nextElement.getValue();
						AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
						cmd3.setValue(literalReal.getValue());
						compoundCmd.append(cmd3);
					}
					executeCmd(compoundCmd);
				}
						
			}else if(vs instanceof PWeightedList){
				AddPWeightedListToOutputSetProbabilityBOMCmd cmd3 = 
					new AddPWeightedListToOutputSetProbabilityBOMCmd(domainOutputSetProbability);								
				executeCmd(cmd3);
				PWeightedList newDomainWtList = (PWeightedList)cmd3.getObject();
				if(newDomainWtList != null){
					BtCompoundCommand compoundCmd = new BtCompoundCommand();
					for (Iterator it = ((PWeightedList)vs).getWeightedListElement().iterator(); it.hasNext();) {
						PWeightedListElement nextElement = (PWeightedListElement)it.next();	
						AddPWeightedListElementToPWeightedListBOMCmd cmd4 =
							new AddPWeightedListElementToPWeightedListBOMCmd(newDomainWtList);
						cmd4.setProbability(nextElement.getProbability());										
						compoundCmd.append(cmd4);
						PWeightedListElement element = (PWeightedListElement)cmd4.getObject();																	
						LiteralReal literalRealValue = (LiteralReal)nextElement.getValue();
						AddLiteralRealToPListElementBOMCmd cmd5 = new AddLiteralRealToPListElementBOMCmd(element);
						cmd5.setValue(literalRealValue.getValue());
						compoundCmd.append(cmd5);
					}
					executeCmd(compoundCmd);
				}
		    // support of the new distributions types in L002643
			} else if (vs instanceof PBetaDistribution) {
				AddPBetaDistributionToOutputSetProbabilityBOMCmd cmd = new AddPBetaDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				PBetaDistribution betaDist = (PBetaDistribution) vs;				
				cmd.setA(betaDist.getA());
				cmd.setB(betaDist.getB());
				executeCmd(cmd);		
			} else if (vs instanceof PErlangRNDistribution) {
				AddPErlangRNDistributionToOutputSetProbabilityBOMCmd cmd = new AddPErlangRNDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				PErlangRNDistribution erlangDist = (PErlangRNDistribution) vs;				
				cmd.setExpmean(erlangDist.getExpmean());
				cmd.setK(erlangDist.getK());
				executeCmd(cmd);				
			} else if (vs instanceof PJohnsonRNDistribution) {
				AddPJohnsonRNDistributionToOutputSetProbabilityBOMCmd cmd = new AddPJohnsonRNDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				PJohnsonRNDistribution johnsonDist = (PJohnsonRNDistribution) vs;				
				cmd.setGamma(johnsonDist.getGamma());
				cmd.setDelta(johnsonDist.getDelta());								
				PJohnsonType pJohnsonType = johnsonDist.getJohnsonType();
				cmd.setJohnsonType(pJohnsonType);
				cmd.setLambda(johnsonDist.getLambda());
				cmd.setXi(johnsonDist.getXi());
				executeCmd(cmd);				
			} else if (vs instanceof PTriangularRNDistribution) {
				AddPTriangularRNDistributionToOutputSetProbabilityBOMCmd cmd = new AddPTriangularRNDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);
				PTriangularRNDistribution triangularDist = (PTriangularRNDistribution)vs;
				cmd.setMin(triangularDist.getMin());
				cmd.setMax(triangularDist.getMax());
				cmd.setMode(triangularDist.getMode());
				executeCmd(cmd);
			} else if (vs instanceof PWeibullRNDistribution) {
				AddPWeibullRNDistributionToOutputSetProbabilityBOMCmd cmd = new AddPWeibullRNDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);				
				PWeibullRNDistribution weibullDist = (PWeibullRNDistribution)vs;				
				cmd.setAlpha(weibullDist.getAlpha());
				cmd.setBeta(weibullDist.getBeta());
				executeCmd(cmd);
			} else if (vs instanceof PContinuousRNDistribution) {
				PContinuousRNDistribution contDist = (PContinuousRNDistribution) vs;
				AddPContinuousRNDistributionToOutputSetProbabilityBOMCmd cmd = new AddPContinuousRNDistributionToOutputSetProbabilityBOMCmd(domainOutputSetProbability);			
				List cs = contDist.getC();
				List vals = contDist.getVal();	
				
				if (cs != null && !cs.isEmpty()) {				
					for (int i=0; i<cs.size(); i++) {
						cmd.addC((Double) cs.get(i));
					}
				}
				
				if (vals != null && !vals.isEmpty()) {					
					for (int i=0; i<vals.size(); i++) {
						cmd.addVal((Double) vals.get(i));
					}	
				}
				executeCmd(cmd);		
			} else{
				LoggingUtil.trace(this, "addValueToOutputPinSetProbability", "unknown destribution type");
			}
		}
		LoggingUtil.traceExit(this, "addValueToOutputPinSetProbability");		
	}
	
	/**
	 * Update OperationalTimes' processing times
	 * @param newDomainOpTimes
	 * @param vs
	 */
	private void updateProcessingTimeToOperationalTimes(OperationalTimes newDomainOpTimes, ValueSpecification vs){
		LoggingUtil.traceEntry(this, "updateProcessingTimeToOperationalTimes");
		
		if(vs instanceof LiteralDuration){
			// if the processingTime is a literal duration
			AddLiteralDurationProcessingTimeToOperationalTimesBOMCmd cmd = 
				new AddLiteralDurationProcessingTimeToOperationalTimesBOMCmd(newDomainOpTimes);							
			cmd.setValue(((LiteralDuration)vs).getValue());
			executeCmd(cmd);
		} else if (vs instanceof StructuredDuration) {
			// if the processingTime is a StructuredDuration
			StructuredDuration structDur = (StructuredDuration) vs;
			AddStructuredDurationProcessingTimeToOperationalTimesBOMCmd addSDCmd = 
					new AddStructuredDurationProcessingTimeToOperationalTimesBOMCmd(newDomainOpTimes);
			// set the skew on the structuredDuration
			if (structDur.getSkew() != null) {
				addSDCmd.setSkew(structDur.getSkew());
			} else {
				addSDCmd.setSkew(new Double(0));
			}
			// set the time unit on the structuredDuration
			if (structDur.getTimeUnit() != null) {				
				addSDCmd.setTimeUnit(structDur.getTimeUnit());			
			}
			executeCmd(addSDCmd);
			StructuredDuration newDomainStructDuration = (StructuredDuration) addSDCmd.getObject();
			
			// get the source duration value
			ValueSpecification durationVal = ((StructuredDuration)vs).getDurationValue();
			
			// check the duration value and update the values
			if(durationVal != null && durationVal instanceof PDistribution){
				// Normal Distribution
				if(durationVal instanceof PNormalDistribution){
					AddPNormalDistributionToStructuredDurationBOMCmd cmd = 
						new AddPNormalDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PNormalDistribution)durationVal).getMean());
					cmd.setStd(((PNormalDistribution)durationVal).getStd());
					executeCmd(cmd);	
				}
				// Lognormal Distribution
				else if(durationVal instanceof PLognormalDistribution){
					AddPLognormalDistributionToStructuredDurationBOMCmd cmd = 
						new AddPLognormalDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PLognormalDistribution)durationVal).getMean());
					cmd.setStd(((PLognormalDistribution)durationVal).getStd());
					executeCmd(cmd);							
				}
				// Poisson Distribution
				else if(durationVal instanceof PPoissonDistribution){
					AddPPoissonDistributionToStructuredDurationBOMCmd cmd = 
						new AddPPoissonDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PPoissonDistribution)durationVal).getMean());
					executeCmd(cmd);							
				}
				// Gamma Distribution
				else if(durationVal instanceof PGammaDistribution){
					AddPGammaDistributionToStructuredDurationBOMCmd cmd = 
						new AddPGammaDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PGammaDistribution)durationVal).getMean());
					cmd.setStd(((PGammaDistribution)durationVal).getStd());
					executeCmd(cmd);
				}
				// Exponential Distribution
				else if(durationVal instanceof PExponentialDistribution){
					AddPExponentialDistributionToStructuredDurationBOMCmd cmd = 
						new AddPExponentialDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PExponentialDistribution)durationVal).getMean());
					executeCmd(cmd);			
				}
				// Uniform Distribution
				else if(durationVal instanceof PUniformDistribution){
					AddPUniformDistributionToStructuredDurationBOMCmd cmd = 
						new AddPUniformDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					executeCmd(cmd);
					PUniformDistribution newDomainPDist = (PUniformDistribution)cmd.getObject();
					if(newDomainPDist != null){
						AddLiteralRealMinValueToPUniformDistributionBOMCmd cmd2 = 
							new AddLiteralRealMinValueToPUniformDistributionBOMCmd(newDomainPDist);
						cmd2.setValue(((LiteralReal)((PUniformDistribution)durationVal).getMinValue()).getValue());
						executeCmd(cmd2);
			
						AddLiteralRealMaxValueToPUniformDistributionBOMCmd cmd3 = 
							new AddLiteralRealMaxValueToPUniformDistributionBOMCmd(newDomainPDist);
						cmd3.setValue(((LiteralReal)((PUniformDistribution)durationVal).getMaxValue()).getValue());
						executeCmd(cmd3);			
					}
				}
				// Bernoulli Distribution
				else if(durationVal instanceof PBernoulliDistribution){
					AddPBernoulliDistributionToStructuredDurationBOMCmd cmd = 
						new AddPBernoulliDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setProbability(((PBernoulliDistribution)durationVal).getProbability());
					executeCmd(cmd);
				// Binomial Distribution
				}else if(durationVal instanceof PBinomialDistribution){
					AddPBinomialDistributionToStructuredDurationBOMCmd cmd = 
						new AddPBinomialDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setProbability(((PBinomialDistribution)durationVal).getProbability());
					executeCmd(cmd);
				// Random List
				}else if(durationVal instanceof PRandomList){
					AddPRandomListToStructuredDurationBOMCmd cmd = 
						new AddPRandomListToStructuredDurationBOMCmd(newDomainStructDuration);								
					executeCmd(cmd);
					PRandomList newDomainRdmList = (PRandomList)cmd.getObject();
					if(newDomainRdmList != null){
						BtCompoundCommand compoundCmd = new BtCompoundCommand();
						for (Iterator it = ((PRandomList)durationVal).getListElement().iterator(); it.hasNext();) {
							AddPListElementToPRandomListBOMCmd cmd2 =
								new AddPListElementToPRandomListBOMCmd(newDomainRdmList);
							compoundCmd.append(cmd2);
							PListElement element = (PListElement)cmd2.getObject();
							PListElement nextElement = (PListElement)it.next();									
							LiteralReal literalReal = (LiteralReal)nextElement.getValue();
							AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
							cmd3.setValue(literalReal.getValue());
							compoundCmd.append(cmd3);
						}
						executeCmd(compoundCmd);
					}
				// Weighted List			
				}else if(durationVal instanceof PWeightedList){
					AddPWeightedListToStructuredDurationBOMCmd cmd3 = 
						new AddPWeightedListToStructuredDurationBOMCmd(newDomainStructDuration);								
					executeCmd(cmd3);
					PWeightedList newDomainWtList = (PWeightedList)cmd3.getObject();
					if(newDomainWtList != null){
						BtCompoundCommand compoundCmd = new BtCompoundCommand();
						for (Iterator it = ((PWeightedList)durationVal).getWeightedListElement().iterator(); it.hasNext();) {
							PWeightedListElement nextElement = (PWeightedListElement)it.next();	
							AddPWeightedListElementToPWeightedListBOMCmd cmd4 =
								new AddPWeightedListElementToPWeightedListBOMCmd(newDomainWtList);
							cmd4.setProbability(nextElement.getProbability());										
							compoundCmd.append(cmd4);
							PWeightedListElement element = (PWeightedListElement)cmd4.getObject();																	
							LiteralReal literalRealValue = (LiteralReal)nextElement.getValue();
							AddLiteralRealToPListElementBOMCmd cmd5 = new AddLiteralRealToPListElementBOMCmd(element);
							cmd5.setValue(literalRealValue.getValue());
							compoundCmd.append(cmd5);
						}
						executeCmd(compoundCmd);
					}
			    // support of the new distributions types in L002643				
				} else if (durationVal instanceof PBetaDistribution) {
					AddPBetaDistributionToStructuredDurationBOMCmd cmd = new AddPBetaDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PBetaDistribution betaDist = (PBetaDistribution) durationVal;				
					cmd.setA(betaDist.getA());
					cmd.setB(betaDist.getB());
					executeCmd(cmd);		
				} else if (durationVal instanceof PErlangRNDistribution) {
					AddPErlangRNDistributionToStructuredDurationBOMCmd cmd = new AddPErlangRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PErlangRNDistribution erlangDist = (PErlangRNDistribution) durationVal;				
					cmd.setExpmean(erlangDist.getExpmean());
					cmd.setK(erlangDist.getK());
					executeCmd(cmd);				
				} else if (durationVal instanceof PJohnsonRNDistribution) {
					AddPJohnsonRNDistributionToStructuredDurationBOMCmd cmd = new AddPJohnsonRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PJohnsonRNDistribution johnsonDist = (PJohnsonRNDistribution) durationVal;				
					cmd.setGamma(johnsonDist.getGamma());
					cmd.setDelta(johnsonDist.getDelta());								
					PJohnsonType pJohnsonType = johnsonDist.getJohnsonType();
					cmd.setJohnsonType(pJohnsonType);
					cmd.setLambda(johnsonDist.getLambda());
					cmd.setXi(johnsonDist.getXi());
					executeCmd(cmd);				
				} else if (durationVal instanceof PTriangularRNDistribution) {
					AddPTriangularRNDistributionToStructuredDurationBOMCmd cmd = new AddPTriangularRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PTriangularRNDistribution triangularDist = (PTriangularRNDistribution) durationVal;
					cmd.setMin(triangularDist.getMin());
					cmd.setMax(triangularDist.getMax());
					cmd.setMode(triangularDist.getMode());
					executeCmd(cmd);
				} else if (durationVal instanceof PWeibullRNDistribution) {
					AddPWeibullRNDistributionToStructuredDurationBOMCmd cmd = new AddPWeibullRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);				
					PWeibullRNDistribution weibullDist = (PWeibullRNDistribution) durationVal;				
					cmd.setAlpha(weibullDist.getAlpha());
					cmd.setBeta(weibullDist.getBeta());
					executeCmd(cmd);
				} else if (durationVal instanceof PContinuousRNDistribution) {
					PContinuousRNDistribution contDist = (PContinuousRNDistribution) durationVal;
					AddPContinuousRNDistributionToStructuredDurationBOMCmd cmd = new AddPContinuousRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);			
					List cs = contDist.getC();
					List vals = contDist.getVal();	
					
					if (cs != null && !cs.isEmpty()) {
						for (int i=0; i<cs.size(); i++) {
							cmd.addC((Double) cs.get(i));
						}
					}
					
					if (vals != null && !vals.isEmpty()) {						
						for (int i=0; i<vals.size(); i++) {
							cmd.addVal((Double) vals.get(i));
						}				
					}
					executeCmd(cmd);		
				} else{
					LoggingUtil.trace(this,"updateProcessingTimeToOperationalTimes", "unknown destribution type");				
				}
			}	// end else-if for PDistribution			
		} else {
			LoggingUtil.trace(this,"updateProcessingTimeToOperationalTimes", "unknown data type for processingTime");			
		}		
		LoggingUtil.traceExit(this, "updateProcessingTimeToOperationalTimes");	
	}
	
	/**
	 * Updat operationalTimes' maxResourceAwaitingTime with the value specification
	 * @param newDomainOpTimes
	 * @param vs
	 */
	private void updateMaxResourceAwaitingTimeToOperationalTimes(OperationalTimes newDomainOpTimes, ValueSpecification vs){
		LoggingUtil.traceEntry(this, "updateMaxResourceAwaitingTimeToOperationalTimes");
		if(vs instanceof LiteralDuration){
			// if the max resource awaiting time is a literalDuration
			AddLiteralDurationMaxResourceAwaitingTimeToOperationalTimesBOMCmd cmd = 
				new AddLiteralDurationMaxResourceAwaitingTimeToOperationalTimesBOMCmd(newDomainOpTimes);							
			cmd.setValue(((LiteralDuration)vs).getValue());
			executeCmd(cmd);
		} else if (vs instanceof StructuredDuration) {
			// if the max resource awaiting time is a structured duration
			StructuredDuration structDur = (StructuredDuration) vs;
			AddStructuredDurationMaxResourceAwaitingTimeToOperationalTimesBOMCmd addSDCmd = 
				new AddStructuredDurationMaxResourceAwaitingTimeToOperationalTimesBOMCmd(newDomainOpTimes);
			if (structDur.getSkew() != null) {
				// set the skew in the structured duration
				addSDCmd.setSkew(structDur.getSkew());
			} else {
				addSDCmd.setSkew(new Double(0));
			}
			if (structDur.getTimeUnit() != null) {
				// set the time unit in the structured duration
				addSDCmd.setTimeUnit(structDur.getTimeUnit());			
			}
			executeCmd(addSDCmd);
			StructuredDuration newDomainStructDuration = (StructuredDuration) addSDCmd.getObject();
		
			// get the source duration value
			ValueSpecification durationVal = ((StructuredDuration)vs).getDurationValue();			
			
			if(durationVal != null && durationVal instanceof PDistribution){
				// Normal Distribution
				if(durationVal instanceof PNormalDistribution){
					AddPNormalDistributionToStructuredDurationBOMCmd cmd = 
						new AddPNormalDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PNormalDistribution)durationVal).getMean());
					cmd.setStd(((PNormalDistribution)durationVal).getStd());
					executeCmd(cmd);	
				}
				// Lognormal Distribution
				else if(durationVal instanceof PLognormalDistribution){
					AddPLognormalDistributionToStructuredDurationBOMCmd cmd = 
						new AddPLognormalDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PLognormalDistribution)durationVal).getMean());
					cmd.setStd(((PLognormalDistribution)durationVal).getStd());
					executeCmd(cmd);							
				}
				// Poisson Distribution
				else if(durationVal instanceof PPoissonDistribution){
					AddPPoissonDistributionToStructuredDurationBOMCmd cmd = 
						new AddPPoissonDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PPoissonDistribution)durationVal).getMean());
					executeCmd(cmd);							
				}
				// Gamma Distribution
				else if(durationVal instanceof PGammaDistribution){
					AddPGammaDistributionToStructuredDurationBOMCmd cmd = 
						new AddPGammaDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PGammaDistribution)durationVal).getMean());
					cmd.setStd(((PGammaDistribution)durationVal).getStd());
					executeCmd(cmd);
				}
				// Exponential Distribution
				else if(durationVal instanceof PExponentialDistribution){
					AddPExponentialDistributionToStructuredDurationBOMCmd cmd = 
						new AddPExponentialDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setMean(((PExponentialDistribution)durationVal).getMean());
					executeCmd(cmd);			
				}
				// Uniform Distribution
				else if(durationVal instanceof PUniformDistribution){
					AddPUniformDistributionToStructuredDurationBOMCmd cmd = 
						new AddPUniformDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					executeCmd(cmd);
					PUniformDistribution newDomainPDist = (PUniformDistribution)cmd.getObject();
					if(newDomainPDist != null){
						AddLiteralRealMinValueToPUniformDistributionBOMCmd cmd2 = 
							new AddLiteralRealMinValueToPUniformDistributionBOMCmd(newDomainPDist);
						cmd2.setValue(((LiteralReal)((PUniformDistribution)durationVal).getMinValue()).getValue());
						executeCmd(cmd2);
			
						AddLiteralRealMaxValueToPUniformDistributionBOMCmd cmd3 = 
							new AddLiteralRealMaxValueToPUniformDistributionBOMCmd(newDomainPDist);
						cmd3.setValue(((LiteralReal)((PUniformDistribution)durationVal).getMaxValue()).getValue());
						executeCmd(cmd3);			
					}
				} // Bernoulli Distribution
				else if(durationVal instanceof PBernoulliDistribution){
					AddPBernoulliDistributionToStructuredDurationBOMCmd cmd = 
						new AddPBernoulliDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setProbability(((PBernoulliDistribution)durationVal).getProbability());
					executeCmd(cmd);					
				} // Binomial Distribution
				else if(durationVal instanceof PBinomialDistribution){
					AddPBinomialDistributionToStructuredDurationBOMCmd cmd = 
						new AddPBinomialDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					cmd.setProbability(((PBinomialDistribution)durationVal).getProbability());
					executeCmd(cmd);
				} // Random List
				else if(durationVal instanceof PRandomList){
					AddPRandomListToStructuredDurationBOMCmd cmd = 
						new AddPRandomListToStructuredDurationBOMCmd(newDomainStructDuration);								
					executeCmd(cmd);
					PRandomList newDomainRdmList = (PRandomList)cmd.getObject();
					if(newDomainRdmList != null){
						BtCompoundCommand compoundCmd = new BtCompoundCommand();
						for (Iterator it = ((PRandomList)durationVal).getListElement().iterator(); it.hasNext();) {
							AddPListElementToPRandomListBOMCmd cmd2 =
								new AddPListElementToPRandomListBOMCmd(newDomainRdmList);
							compoundCmd.append(cmd2);
							PListElement element = (PListElement)cmd2.getObject();
							PListElement nextElement = (PListElement)it.next();									
							LiteralReal literalReal = (LiteralReal)nextElement.getValue();
							AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
							cmd3.setValue(literalReal.getValue());
							compoundCmd.append(cmd3);
						}
						executeCmd(compoundCmd);
					}
							
				} // Weighted List
				else if(durationVal instanceof PWeightedList){
					AddPWeightedListToStructuredDurationBOMCmd cmd = 
						new AddPWeightedListToStructuredDurationBOMCmd(newDomainStructDuration);								
					executeCmd(cmd);
					PWeightedList newDomainWtList = (PWeightedList)cmd.getObject();
					if(newDomainWtList != null){
						BtCompoundCommand compoundCmd = new BtCompoundCommand();
						for (Iterator it = ((PWeightedList)durationVal).getWeightedListElement().iterator(); it.hasNext();) {
							PWeightedListElement nextElement = (PWeightedListElement)it.next();	
							AddPWeightedListElementToPWeightedListBOMCmd cmd2 =
								new AddPWeightedListElementToPWeightedListBOMCmd(newDomainWtList);
							cmd2.setProbability(nextElement.getProbability());										
							compoundCmd.append(cmd2);
							PWeightedListElement element = (PWeightedListElement)cmd2.getObject();																	
							LiteralReal literalRealValue = (LiteralReal)nextElement.getValue();
							AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
							cmd3.setValue(literalRealValue.getValue());
							compoundCmd.append(cmd3);
						}
						executeCmd(compoundCmd);
					}
				// support of the new distributions types in L002643
				} else if (durationVal instanceof PBetaDistribution) {
					AddPBetaDistributionToStructuredDurationBOMCmd cmd = new AddPBetaDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PBetaDistribution betaDist = (PBetaDistribution) durationVal;				
					cmd.setA(betaDist.getA());
					cmd.setB(betaDist.getB());
					executeCmd(cmd);		
				} else if (durationVal instanceof PErlangRNDistribution) {
					AddPErlangRNDistributionToStructuredDurationBOMCmd cmd = new AddPErlangRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PErlangRNDistribution erlangDist = (PErlangRNDistribution) durationVal;				
					cmd.setExpmean(erlangDist.getExpmean());
					cmd.setK(erlangDist.getK());
					executeCmd(cmd);				
				} else if (durationVal instanceof PJohnsonRNDistribution) {
					AddPJohnsonRNDistributionToStructuredDurationBOMCmd cmd = new AddPJohnsonRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PJohnsonRNDistribution johnsonDist = (PJohnsonRNDistribution) durationVal;				
					cmd.setGamma(johnsonDist.getGamma());
					cmd.setDelta(johnsonDist.getDelta());								
					PJohnsonType pJohnsonType = johnsonDist.getJohnsonType();
					cmd.setJohnsonType(pJohnsonType);
					cmd.setLambda(johnsonDist.getLambda());
					cmd.setXi(johnsonDist.getXi());
					executeCmd(cmd);				
				} else if (durationVal instanceof PTriangularRNDistribution) {
					AddPTriangularRNDistributionToStructuredDurationBOMCmd cmd = new AddPTriangularRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);
					PTriangularRNDistribution triangularDist = (PTriangularRNDistribution) durationVal;
					cmd.setMin(triangularDist.getMin());
					cmd.setMax(triangularDist.getMax());
					cmd.setMode(triangularDist.getMode());
					executeCmd(cmd);
				} else if (durationVal instanceof PWeibullRNDistribution) {
					AddPWeibullRNDistributionToStructuredDurationBOMCmd cmd = new AddPWeibullRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);				
					PWeibullRNDistribution weibullDist = (PWeibullRNDistribution) durationVal;				
					cmd.setAlpha(weibullDist.getAlpha());
					cmd.setBeta(weibullDist.getBeta());
					executeCmd(cmd);
				} else if (durationVal instanceof PContinuousRNDistribution) {
					PContinuousRNDistribution contDist = (PContinuousRNDistribution) durationVal;
					AddPContinuousRNDistributionToStructuredDurationBOMCmd cmd = new AddPContinuousRNDistributionToStructuredDurationBOMCmd(newDomainStructDuration);			
					List cs = contDist.getC();
					List vals = contDist.getVal();	
					
					if (cs != null && !cs.isEmpty()) {
						for (int i=0; i<cs.size(); i++) {
							cmd.addC((Double) cs.get(i));
						}						
					}
					
					if (vals != null && !vals.isEmpty()) {
						for (int i=0; i<vals.size(); i++) {
							cmd.addVal((Double) vals.get(i));
						}						
					}
					executeCmd(cmd);				
				} else{
					LoggingUtil.trace(this,"updateMaxResourceAwaitingTimeToOperationalTimes", "unknown destribution type");
				}
			}	// end of else-if PDistribution			
		} else {
			LoggingUtil.trace(this,"updateMaxResourceAwaitingTimeToOperationalTimes", "unknown data type for max resource awaiting times");
		}		
		LoggingUtil.traceExit(this,"updateMaxResourceAwaitingTimeToOperationalTimes"); 	
	}
	
	/**
	 * Updates MonetaryValue with the value specification
	 * @param newDomainMv
	 * @param vs
	 */
	private void updateMonetaryValue(MonetaryValue newDomainMv, ValueSpecification vs){
		LoggingUtil.traceEntry(this,"updateMonetaryValue");
		
		if(vs instanceof LiteralReal){
			AddLiteralRealToMonetaryValueBOMCmd cmd =
				new AddLiteralRealToMonetaryValueBOMCmd(newDomainMv);
			cmd.setValue(((LiteralReal)vs).getValue());
			executeCmd(cmd);
		}
		else if(vs instanceof PDistribution){
						
			if(vs instanceof PNormalDistribution){
				AddPNormalDistributionToMonetaryValueBOMCmd cmd = 
					new AddPNormalDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setMean(((PNormalDistribution)vs).getMean());
				cmd.setStd(((PNormalDistribution)vs).getStd());
				executeCmd(cmd);	
			}	
			else if(vs instanceof PLognormalDistribution){
				AddPLognormalDistributionToMonetaryValueBOMCmd cmd = 
					new AddPLognormalDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setMean(((PLognormalDistribution)vs).getMean());
				cmd.setStd(((PLognormalDistribution)vs).getStd());
				executeCmd(cmd);							
			}
			else if(vs instanceof PPoissonDistribution){
				AddPPoissonDistributionToMonetaryValueBOMCmd cmd = 
					new AddPPoissonDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setMean(((PPoissonDistribution)vs).getMean());
				executeCmd(cmd);							
			}
			else if(vs instanceof PGammaDistribution){
				AddPGammaDistributionToMonetaryValueBOMCmd cmd = 
					new AddPGammaDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setMean(((PGammaDistribution)vs).getMean());
				cmd.setStd(((PGammaDistribution)vs).getStd());
				executeCmd(cmd);
			}
			else if(vs instanceof PExponentialDistribution){
				AddPExponentialDistributionToMonetaryValueBOMCmd cmd = 
					new AddPExponentialDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setMean(((PExponentialDistribution)vs).getMean());
				executeCmd(cmd);			
			}
			else if(vs instanceof PUniformDistribution){
				AddPUniformDistributionToMonetaryValueBOMCmd cmd = 
					new AddPUniformDistributionToMonetaryValueBOMCmd(newDomainMv);
				executeCmd(cmd);
				PUniformDistribution newDomainPDist = (PUniformDistribution)cmd.getObject();
				if(newDomainPDist != null){
					AddLiteralRealMinValueToPUniformDistributionBOMCmd cmd2 = 
						new AddLiteralRealMinValueToPUniformDistributionBOMCmd(newDomainPDist);
					cmd2.setValue(((LiteralReal)((PUniformDistribution)vs).getMinValue()).getValue());
					executeCmd(cmd2);

					// TN - fixes on the max value (it used min value before)
					AddLiteralRealMaxValueToPUniformDistributionBOMCmd cmd3 = 
						new AddLiteralRealMaxValueToPUniformDistributionBOMCmd(newDomainPDist);
					cmd3.setValue(((LiteralReal)((PUniformDistribution)vs).getMaxValue()).getValue());
					// end of TN - fixes on the max value (it used min value before)
					executeCmd(cmd3);			
				}
			}
			else if(vs instanceof PBernoulliDistribution){
				AddPBernoulliDistributionToMonetaryValueBOMCmd cmd = 
					new AddPBernoulliDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setProbability(((PBernoulliDistribution)vs).getProbability());
				executeCmd(cmd);
			}else if(vs instanceof PBinomialDistribution){
				AddPBinomialDistributionToMonetaryValueBOMCmd cmd = 
					new AddPBinomialDistributionToMonetaryValueBOMCmd(newDomainMv);
				cmd.setProbability(((PBinomialDistribution)vs).getProbability());
				executeCmd(cmd);
			}else if(vs instanceof PRandomList){
				AddPRandomListToMonetaryValueBOMCmd cmd = 
					new AddPRandomListToMonetaryValueBOMCmd(newDomainMv);								
				executeCmd(cmd);
				PRandomList newDomainRdmList = (PRandomList)cmd.getObject();
				if(newDomainRdmList != null){
					BtCompoundCommand compoundCmd = new BtCompoundCommand();
					for (Iterator it = ((PRandomList)vs).getListElement().iterator(); it.hasNext();) {
						AddPListElementToPRandomListBOMCmd cmd2 =
							new AddPListElementToPRandomListBOMCmd(newDomainRdmList);
						compoundCmd.append(cmd2);
						PListElement element = (PListElement)cmd2.getObject();
						PListElement nextElement = (PListElement)it.next();									
						LiteralReal literalReal = (LiteralReal)nextElement.getValue();
						AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
						cmd3.setValue(literalReal.getValue());
						compoundCmd.append(cmd3);
					}
					executeCmd(compoundCmd);
				}
						
			}else if(vs instanceof PWeightedList){
				AddPWeightedListToMonetaryValueBOMCmd cmd = 
					new AddPWeightedListToMonetaryValueBOMCmd(newDomainMv);								
				executeCmd(cmd);
				PWeightedList newDomainWtList = (PWeightedList)cmd.getObject();
				if(newDomainWtList != null){
					BtCompoundCommand compoundCmd = new BtCompoundCommand();
					for (Iterator it = ((PWeightedList)vs).getWeightedListElement().iterator(); it.hasNext();) {
						PWeightedListElement nextElement = (PWeightedListElement)it.next();	
						AddPWeightedListElementToPWeightedListBOMCmd cmd2 =
							new AddPWeightedListElementToPWeightedListBOMCmd(newDomainWtList);
						cmd2.setProbability(nextElement.getProbability());										
						compoundCmd.append(cmd2);
						PWeightedListElement element = (PWeightedListElement)cmd2.getObject();																	
						LiteralReal literalRealValue = (LiteralReal)nextElement.getValue();
						AddLiteralRealToPListElementBOMCmd cmd3 = new AddLiteralRealToPListElementBOMCmd(element);
						cmd3.setValue(literalRealValue.getValue());
						compoundCmd.append(cmd3);
					}
					executeCmd(compoundCmd);
				}
			 // support of the new distributions types in L002643				
			} else if (vs instanceof PBetaDistribution) {
				AddPBetaDistributionToMonetaryValueBOMCmd cmd = new AddPBetaDistributionToMonetaryValueBOMCmd(newDomainMv);
				PBetaDistribution betaDist = (PBetaDistribution) vs;				
				cmd.setA(betaDist.getA());
				cmd.setB(betaDist.getB());
				executeCmd(cmd);		
			} else if (vs instanceof PErlangRNDistribution) {
				AddPErlangRNDistributionToMonetaryValueBOMCmd cmd = new AddPErlangRNDistributionToMonetaryValueBOMCmd(newDomainMv);
				PErlangRNDistribution erlangDist = (PErlangRNDistribution) vs;				
				cmd.setExpmean(erlangDist.getExpmean());
				cmd.setK(erlangDist.getK());
				executeCmd(cmd);				
			} else if (vs instanceof PJohnsonRNDistribution) {
				AddPJohnsonRNDistributionToMonetaryValueBOMCmd cmd = new AddPJohnsonRNDistributionToMonetaryValueBOMCmd(newDomainMv);
				PJohnsonRNDistribution johnsonDist = (PJohnsonRNDistribution) vs;				
				cmd.setGamma(johnsonDist.getGamma());
				cmd.setDelta(johnsonDist.getDelta());								
				PJohnsonType pJohnsonType = johnsonDist.getJohnsonType();
				cmd.setJohnsonType(pJohnsonType);
				cmd.setLambda(johnsonDist.getLambda());
				cmd.setXi(johnsonDist.getXi());
				executeCmd(cmd);				
			} else if (vs instanceof PTriangularRNDistribution) {
				AddPTriangularRNDistributionToMonetaryValueBOMCmd cmd = new AddPTriangularRNDistributionToMonetaryValueBOMCmd(newDomainMv);
				PTriangularRNDistribution triangularDist = (PTriangularRNDistribution)vs;
				cmd.setMin(triangularDist.getMin());
				cmd.setMax(triangularDist.getMax());
				cmd.setMode(triangularDist.getMode());
				executeCmd(cmd);
			} else if (vs instanceof PWeibullRNDistribution) {
				AddPWeibullRNDistributionToMonetaryValueBOMCmd cmd = new AddPWeibullRNDistributionToMonetaryValueBOMCmd(newDomainMv);				
				PWeibullRNDistribution weibullDist = (PWeibullRNDistribution)vs;				
				cmd.setAlpha(weibullDist.getAlpha());
				cmd.setBeta(weibullDist.getBeta());
				executeCmd(cmd);
			} else if (vs instanceof PContinuousRNDistribution) {
				PContinuousRNDistribution contDist = (PContinuousRNDistribution) vs;
				AddPContinuousRNDistributionToMonetaryValueBOMCmd cmd = new AddPContinuousRNDistributionToMonetaryValueBOMCmd(newDomainMv);			
				List cs = contDist.getC();
				List vals = contDist.getVal();
				
				if (cs != null && !cs.isEmpty()) {
					for (int i=0; i<cs.size(); i++) {
						cmd.addC((Double) cs.get(i));
					}
				}
				
				if (vals != null && !vals.isEmpty()) {
					for (int i=0; i<vals.size(); i++) {
						cmd.addVal((Double) vals.get(i));
					}				
				}
				executeCmd(cmd);		
			}
			else{
				LoggingUtil.trace(this, "updateMonetaryValue", "unknown destribution type");
			}
		}	
		LoggingUtil.traceExit(this, "updateMonetaryValue");	
	}
	
	/**
	 * Creates operationalCost for action
	 *
	 */
	protected void createOperationalCost(){
		LoggingUtil.traceEntry(this, "createOperationalCost");
		
		OperationalCosts opCosts = action.getOperationalCosts();
		if(opCosts == null){
			LoggingUtil.traceEntry(this, "createOperationalCost", "Operational costs is null");	
			return; 
		}
					
		AddOperationalCostsToActionBOMCmd cmd = new AddOperationalCostsToActionBOMCmd((Action)domainModel);
		executeCmd(cmd);
		OperationalCosts newDomainOpCosts =(OperationalCosts)cmd.getObject();
		if(newDomainOpCosts != null){
			//executionCost	
			MonetaryValue exeCost = opCosts.getExecutionCost();
			if(exeCost != null){					
				AddMonetaryValueExecutionCostToOperationalCostsBOMCmd cmd2 
					= new AddMonetaryValueExecutionCostToOperationalCostsBOMCmd(newDomainOpCosts);
				cmd2.setCurrency(exeCost.getCurrency());
				executeCmd(cmd2);
				MonetaryValue newDomainMv = (MonetaryValue)cmd2.getObject();
				if(newDomainMv != null && exeCost.getValue() != null){
					updateMonetaryValue(newDomainMv, exeCost.getValue());
				}
			}		

			//startupcost
			MonetaryValue startupCost = opCosts.getStartupCost();
			if(startupCost != null){					
				AddMonetaryValueStartupCostToOperationalCostsBOMCmd cmd2 
					= new AddMonetaryValueStartupCostToOperationalCostsBOMCmd(newDomainOpCosts);
				cmd2.setCurrency(startupCost.getCurrency());
				executeCmd(cmd2);
				MonetaryValue newDomainMv = (MonetaryValue)cmd2.getObject();
				if(newDomainMv != null && startupCost.getValue() != null){
					updateMonetaryValue(newDomainMv, startupCost.getValue());
				}
			}
			//resourceAwaitingcost
			CostPerTimeUnit resWaitingCost = opCosts.getResourceAwaitingCost();
			if(resWaitingCost != null){					
				AddCostPerTimeUnitToOperationalCostsBOMCmd cmd2 
					= new AddCostPerTimeUnitToOperationalCostsBOMCmd(newDomainOpCosts);
				cmd2.setTimeUnit(resWaitingCost.getTimeUnit());
				executeCmd(cmd2);
				CostPerTimeUnit newDomainCostPerTimeUnit =(CostPerTimeUnit)cmd2.getObject();
				if(newDomainCostPerTimeUnit != null && !resWaitingCost.getCostValue().isEmpty()){
					AddCostValueToTimeDependentCostBOMCmd cmd3 = new AddCostValueToTimeDependentCostBOMCmd(newDomainCostPerTimeUnit);
					executeCmd(cmd3);
					CostValue newDomainCostValue = (CostValue)cmd3.getObject();
					if(newDomainCostValue != null){
						AddMonetaryValueToCostValueBOMCmd cmd4 = new AddMonetaryValueToCostValueBOMCmd(newDomainCostValue);
						//tool only support one value
						CostValue costValue = (CostValue)resWaitingCost.getCostValue().get(0);							
						cmd4.setCurrency(costValue.getAmount().getCurrency());
						executeCmd(cmd4);
						MonetaryValue newDomainMv = (MonetaryValue)cmd4.getObject();
						if(newDomainMv != null && costValue.getAmount().getValue() != null){
							updateMonetaryValue(newDomainMv, costValue.getAmount().getValue());
						}
					}
				}		
			}		
		
		}
		LoggingUtil.traceExit(this, "createOperationalCost");
	}
	
	
	/**
	 * Execute the given command
	 * @param cmd
	 */
	protected void executeCmd(AbstractCommand cmd){
		LoggingUtil.traceEntry(this, "executeCmd");
		if(cmd.canExecute()) {
			try {
				cmd.execute();
			} catch (RuntimeException e) {
				LoggingUtil.trace(this, "executeCmd", IImportResultMessages.COMMAND_RUNTIME_EXCEPTION);
				LoggingUtil.traceExit(this, "executeCmd");
				return;
			}
		} else {
			LoggingUtil.trace(this, "executeCmd", IImportResultMessages.CANNOT_EXECUTE_BOM_COMMAND);	
			LoggingUtil.traceExit(this, "executeCmd");
			return;			
		}
		LoggingUtil.traceExit(this, "executeCmd");
	}
}
