package com.ibm.btools.blm.ie.imprt.rule.processModel.node;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.compoundcommand.pe.factory.AbstractAddPeCmd;
import com.ibm.btools.blm.compoundcommand.pe.factory.PeCmdFactory;
import com.ibm.btools.blm.compoundcommand.pe.node.add.AddControlNodePeCmd;
import com.ibm.btools.blm.ie.imprt.rule.processModel.UpdateViewModelRule;
import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.bom.model.artifacts.Element;
import com.ibm.btools.bom.model.processes.activities.ControlNode;
import com.ibm.btools.bom.model.processes.activities.FlowFinalNode;
import com.ibm.btools.bom.model.processes.activities.InitialNode;
import com.ibm.btools.bom.model.processes.activities.TerminationNode;

/**
 * Update the ControlNode
 */
public class UpdateControlNodeRule extends UpdateViewModelRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	protected ControlNode node;
	
	/**
	 * Return the node
	 * @return
	 */
	public Object getSource() {
		return node;
	}	
	
	/**
	 * Set Original node
	 * @param node
	 */
	public void setSource(final Object node) {
		if (node instanceof ControlNode) {
			this.node = (ControlNode) node;
		}
	}

	/**
	 * Return the Create command
	 */
	protected AbstractAddPeCmd getCommand() {
		LoggingUtil.traceEntry(this, "getCommand");	
	
		AddControlNodePeCmd cmd = null;
		PeCmdFactory cmdFactory = getPeCmdFactory();
		if (node instanceof FlowFinalNode) {
			cmd = cmdFactory.buildAddFlowFinalNodePeCmd((EObject) workingCopy);
		} else if (node instanceof TerminationNode) {
			cmd = cmdFactory.buildAddTerminationNodePeCmd((EObject) workingCopy);
		} else if (node instanceof InitialNode) {
			cmd = cmdFactory.buildAddInitialNodePeCmd((EObject) workingCopy);
		}
		LoggingUtil.traceExit(this, "getCommand");			
		return cmd;		
	}
		
	/**
	 * Update Model
	 */
	protected void updateModel() {		
		LoggingUtil.traceEntry(this, "updateModel");
		
		// Attribute comment
		BOMUtil.updateDescription((Element)domainModel, BOMUtil.getDescription((Element)node));	
		
		
		// Attribute outgoing - handled by command		
		// Attribute incoming - handled by command		
		// Attribute ownedConstraint -  no supported
		// Attribute uid - generated
		// Attribute visibility - handled by command
					
		LoggingUtil.traceExit(this, "updateModel");
	}	
}
