package com.ibm.btools.blm.ie.imprt.rule.processModel.node;

import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.bom.command.processes.humantasks.UpdateHumanTaskBOMCmd;
import com.ibm.btools.bom.model.processes.humantasks.HumanTask;
import com.ibm.btools.bom.model.resources.ResourceRequirement;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * Update the Human Task
 */
public class UpdateHumanTaskRule extends UpdateStructuredActivityNodeRule {
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	protected void createNodeContents() {		
		// Attribute nodeContents - not handled
	}
	protected void createEdgeContents() {	
		// Attribute edgeContents - not handled		
	}
	/**
	 * Update Model
	 */
	protected void updateModel() {
		LoggingUtil.traceEntry(this, "updateModel");
		super.updateModel();
		ResourceRequirement resReq = ((HumanTask)domainModel).getPotentialOwner();
		if(resReq == null) {
			UpdateHumanTaskBOMCmd cmd0 = new UpdateHumanTaskBOMCmd((HumanTask)domainModel);
			UpdateHumanTaskBOMCmd cmd = new UpdateHumanTaskBOMCmd((HumanTask)domainModel);
			cmd.setPotentialOwner((ResourceRequirement)((HumanTask)domainModel).getResourceRequirement().get(0));
			cmd0.appendAndExecute(cmd);
		}
	}
}
