package com.ibm.btools.blm.ie.imprt.rule.resourceModel;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.blm.ie.imprt.rule.informationModel.UpdateInstanceSpecificationRule;
import com.ibm.btools.blm.ie.imprt.rule.informationModel.UpdateValueSpecificationRule;
import com.ibm.btools.blm.ie.imprt.rule.util.BOMUtil;
import com.ibm.btools.blm.ie.imprt.rule.util.LoggingUtil;
import com.ibm.btools.blm.ie.resource.IeMessageKeys;
import com.ibm.btools.blm.ui.navigation.model.AbstractChildContainerNode;
import com.ibm.btools.blm.ui.navigation.model.AbstractLibraryChildNode;
import com.ibm.btools.bom.command.artifacts.AddInstanceValueToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralBooleanToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralDurationToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralIntegerToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralNullToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToMonetaryValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToResourceQuantityBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralRealToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralStringToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralTimeToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddLiteralUnlimitedNaturalToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddOpaqueExpressionToScopeValueBOMCmd;
import com.ibm.btools.bom.command.artifacts.AddUpdateValueSpecificationBOMCmd;
import com.ibm.btools.bom.command.compound.CreateTimeIntervalsBOMCmd;
import com.ibm.btools.bom.command.compound.OpenRootObjectForUpdateBOMCmd;
import com.ibm.btools.bom.command.resources.AddCostPerQuantityAndTimeUnitToResourceBOMCmd;
import com.ibm.btools.bom.command.resources.AddCostPerQuantityToResourceBOMCmd;
import com.ibm.btools.bom.command.resources.AddCostPerTimeUnitToResourceBOMCmd;
import com.ibm.btools.bom.command.resources.AddCostValueToTimeDependentCostBOMCmd;
import com.ibm.btools.bom.command.resources.AddMonetaryValueToCostValueBOMCmd;
import com.ibm.btools.bom.command.resources.AddOneTimeCostToResourceBOMCmd;
import com.ibm.btools.bom.command.resources.AddQualificationToResourceBOMCmd;
import com.ibm.btools.bom.command.resources.AddResourceQuantityToBulkResourceBOMCmd;
import com.ibm.btools.bom.command.resources.AddScopeValueToQualificationBOMCmd;
import com.ibm.btools.bom.command.resources.AddUpdateTimeDependentCostBOMCmd;
import com.ibm.btools.bom.command.resources.UpdateBulkResourceBOMCmd;
import com.ibm.btools.bom.command.resources.UpdateCostValueBOMCmd;
import com.ibm.btools.bom.command.resources.UpdateResourceBOMCmd;
import com.ibm.btools.bom.command.resources.UpdateScopeValueBOMCmd;
import com.ibm.btools.bom.command.time.UpdateTimeIntervalsBOMCmd;
import com.ibm.btools.bom.model.artifacts.InstanceValue;
import com.ibm.btools.bom.model.artifacts.LiteralBoolean;
import com.ibm.btools.bom.model.artifacts.LiteralDuration;
import com.ibm.btools.bom.model.artifacts.LiteralInteger;
import com.ibm.btools.bom.model.artifacts.LiteralNull;
import com.ibm.btools.bom.model.artifacts.LiteralReal;
import com.ibm.btools.bom.model.artifacts.LiteralSpecification;
import com.ibm.btools.bom.model.artifacts.LiteralString;
import com.ibm.btools.bom.model.artifacts.LiteralTime;
import com.ibm.btools.bom.model.artifacts.LiteralUnlimitedNatural;
import com.ibm.btools.bom.model.artifacts.OpaqueExpression;
import com.ibm.btools.bom.model.artifacts.PackageableElement;
import com.ibm.btools.bom.model.artifacts.ValueSpecification;
import com.ibm.btools.bom.model.resources.BulkResource;
import com.ibm.btools.bom.model.resources.CostPerQuantity;
import com.ibm.btools.bom.model.resources.CostPerQuantityAndTimeUnit;
import com.ibm.btools.bom.model.resources.CostPerTimeUnit;
import com.ibm.btools.bom.model.resources.CostValue;
import com.ibm.btools.bom.model.resources.IndividualResource;
import com.ibm.btools.bom.model.resources.MonetaryValue;
import com.ibm.btools.bom.model.resources.OneTimeCost;
import com.ibm.btools.bom.model.resources.Qualification;
import com.ibm.btools.bom.model.resources.Resource;
import com.ibm.btools.bom.model.resources.ResourceQuantity;
import com.ibm.btools.bom.model.resources.Role;
import com.ibm.btools.bom.model.resources.ScopeDimension;
import com.ibm.btools.bom.model.resources.ScopeValue;
import com.ibm.btools.bom.model.resources.TimeDependentCost;
import com.ibm.btools.bom.model.time.RecurringTimeIntervals;
import com.ibm.btools.bom.model.time.TimeIntervals;
import com.ibm.btools.emf.cf.BtCompoundCommand;
import com.ibm.btools.expression.bom.command.AddStructuredOpaqueExpressionToScopeValueBEXCmd;
import com.ibm.btools.expression.bom.model.StructuredOpaqueExpression;
import com.ibm.btools.model.filemanager.FileMGR;
import com.ibm.btools.model.modelmanager.CloseWorkingSetCmd;
import com.ibm.btools.model.modelmanager.SaveWorkingSetCmd;
import com.ibm.btools.model.modelmanager.copyregistry.CopyRegistry;


public class UpdateResourceRule extends UpdateInstanceSpecificationRule {
	
	//copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	

	/**
	 * Invokes the rule.
	 */
	public void invoke() {
		LoggingUtil.traceEntry(this, "invoke");
		super.invoke();
		updateProperties();
		LoggingUtil.traceEntry(this, "invoke");

	}
	/**
	 * Updates the BOM Resource with Properties.
	 */
	private void updateProperties(){
		LoggingUtil.traceEntry(this, "updateProperties");
		Resource resource = null;
		Resource workingResource = null;
		if(instanceSample instanceof IndividualResource){
			resource = (IndividualResource)instanceSample;
			workingResource = (IndividualResource)workingCopy;
		}else{
			resource = (BulkResource)instanceSample;
			workingResource = (BulkResource)workingCopy;
			updateResourceQuantity((BulkResource)resource, (BulkResource)workingResource);
		}
		updateAvailability(resource, workingResource);
		updateQualification(resource, workingResource);
		updateTimeDependentCost(resource, workingResource);
		LoggingUtil.traceExit(this, "updateProperties");
		
	}
	
	/**
	 * Updates the <code>workingResource</code> with BOM ResourceQuantity as per the 
	 * source <code>resource</code>
	 * @param resource source BOM Resource
	 * @param workingResource BOM Resource
	 */
	private void updateResourceQuantity(BulkResource resource, BulkResource workingResource){
		LoggingUtil.traceEntry(this, "updateResourceQuantity");
		UpdateBulkResourceBOMCmd updateCmd = new UpdateBulkResourceBOMCmd(workingResource);
		if(resource.getIsConsumable() != null){
			updateCmd.setIsConsumable(resource.getIsConsumable().booleanValue());
		}else{
			updateCmd.setIsConsumable(false);
		}
		if(!updateCmd.canExecute()){
			LoggingUtil.logWarning(getImportSession(), IeMessageKeys.BULK_RESOURCE_CONSUMABLE_UPDATE_EXCEPTION, new String[]{resource.getName()}, null);
		}else{
			try{
				updateCmd.execute();
			}catch(RuntimeException ex){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.BULK_RESOURCE_CONSUMABLE_UPDATE_EXCEPTION, new String[]{resource.getName()}, ex);
			}
		}
		//updates the BulkResource with the available quantity. Will create a ResourceQuantity only if
		// the quantity is not null and is a LiteralReal.
		if(resource.getAvailableQuantity() != null){
			ResourceQuantity resQuantity = resource.getAvailableQuantity();
			ValueSpecification quantity = resQuantity.getQuantity();
			if(quantity == null || !(quantity instanceof LiteralReal)){
				LoggingUtil.trace(this, "updateResourceQuantity", IeMessageKeys.BULK_RESOURCE_AVAILABLE_QUANTITY_UPDATE_EXCEPTION);
				
			}else{
				BtCompoundCommand wrapperCmd = new BtCompoundCommand();
				AddResourceQuantityToBulkResourceBOMCmd addResQuantCmd = new AddResourceQuantityToBulkResourceBOMCmd(workingResource);
				addResQuantCmd.setUnitOfMeasure(resQuantity.getUnitOfMeasure());
				if(!wrapperCmd.appendAndExecute(addResQuantCmd)){
					LoggingUtil.logWarning(getImportSession(), IeMessageKeys.BULK_RESOURCE_AVAILABLE_QUANTITY_UPDATE_EXCEPTION, new String[]{resource.getName()}, null);
				}else{
					ResourceQuantity workingResQuantity = (ResourceQuantity)addResQuantCmd.getObject();
					AddLiteralRealToResourceQuantityBOMCmd addQuantityCmd = new AddLiteralRealToResourceQuantityBOMCmd(workingResQuantity);
					addQuantityCmd.setValue(((LiteralReal)quantity).getValue());
					if(!wrapperCmd.appendAndExecute(addQuantityCmd)){
						wrapperCmd.undo();
						LoggingUtil.logWarning(getImportSession(), IeMessageKeys.BULK_RESOURCE_AVAILABLE_QUANTITY_UPDATE_EXCEPTION, new String[]{resource.getName()}, null);
					}
				}
			}
		}
		LoggingUtil.traceExit(this, "updateResourceQuantity");
	}


	/**
	 * Updates the <code>workingResource</code> with BOM Resource availability as per the 
	 * source <code>resource</code>
	 * @param resource source BOM Resource
	 * @param workingResource BOM Resource
	 *
	 */
	private void updateAvailability(Resource resource, Resource workingResource){
		LoggingUtil.traceEntry(this, "updateAvailability");
		//TODO change when the model will change.. should be follow cost profile example...
		if(resource.getAvailability() != null){
			//if(resource.getOwnedAvailability() != null){
			//TimeIntervals availability = resource.getOwnedAvailability();
			TimeIntervals availability = resource.getAvailability();
			//AddTimeIntervalsToPackageBOMCmd addTimeIntervalsCmd = new AddTimeIntervalsToPackageBOMCmd(workingResource.getOwningPackage());
			BtCompoundCommand wrapperCmd = new BtCompoundCommand();
			
			AbstractChildContainerNode resCatalogNode = (AbstractChildContainerNode)getImportSession().getContext().get(resource.getOwningPackage());
			String intervalsURI = createTimeIntervals(resource, resCatalogNode, wrapperCmd);
			//TODO check for null
			OpenRootObjectForUpdateBOMCmd openCmd = new OpenRootObjectForUpdateBOMCmd();
			openCmd.setProjectName(getProjectName());
			openCmd.setROBLM_URI(intervalsURI);
			if(!wrapperCmd.appendAndExecute(openCmd)){
						wrapperCmd.undo();
			}else{
				// need to get copy id for saving
				String copyID = openCmd.getCopyID();
				
				TimeIntervals workingTimeIntervals = (TimeIntervals)openCmd.getROCopy();
				
				if(availability.getRecurringTimeIntervals() != null && !availability.getRecurringTimeIntervals().isEmpty()){
					Iterator it = availability.getRecurringTimeIntervals().iterator();
					
					UpdateTimeIntervalsBOMCmd updateTI = new UpdateTimeIntervalsBOMCmd(workingTimeIntervals);
					
					while(it.hasNext()){
						RecurringTimeIntervals recurringTimeInterval = (RecurringTimeIntervals)it.next();
						RecurringTimeIntervals workingRecInterval = (RecurringTimeIntervals) BOMUtil.loadRootObject((AbstractLibraryChildNode) getImportSession().getContext().get(recurringTimeInterval));
						updateTI.addRecurringTimeIntervals(workingRecInterval);
					}
					wrapperCmd.appendAndExecute(updateTI);
				}
				
				SaveWorkingSetCmd saveCmd = new SaveWorkingSetCmd();
				saveCmd.setProjectName(getProjectName());
				String projectPath = FileMGR.getProjectPath(getProjectName());
				saveCmd.setProjectPath(projectPath);
				saveCmd.setWorkingSetID(copyID);
				
				if(!wrapperCmd.appendAndExecute(saveCmd)){
					wrapperCmd.undo();
				}else{
					TimeIntervals masterIntervals = (TimeIntervals)BOMUtil.loadRootObject(intervalsURI, getProjectName());
					UpdateResourceBOMCmd updateResource = new UpdateResourceBOMCmd(workingResource);
					updateResource.setAvailability(masterIntervals);
					wrapperCmd.appendAndExecute(updateResource);
				}
				closeWorkingCopy(copyID);
			}
		}
		
		LoggingUtil.traceExit(this, "updateAvailability");
	}

	/**
	 * Creates a list that will consolidate the a resource availability recurring intervals and a resource owned Availability
	 * recurring intervals into a single list. 
	 * Note: tool limitation : the tool does not expose the reusable costProfile. In the tool, the user will always
	 * assign cost to a resource => create an ownedCostProfile (owned TimeDependedCost instance), while the Resource 
	 * costProfile association will point to the ownedCostProfile instance.
	 * On the import, if both costProfile and ownedCostProfile are specified, the list of timeDependentCosts will be 
	 * consolidated in an unique list.
	 * @param resource a BOM Resource
	 * @return list - a List containing all the <code>resource</code> cost profiles.
	 */
	private List consolidateAvailabilityList(Resource resource){
		
		List intervals = new LinkedList();
		if(resource.getAvailability() != null){
			List availabilityIntervals = resource.getAvailability().getRecurringTimeIntervals();
			if(availabilityIntervals != null && !availabilityIntervals.isEmpty()){
				intervals.addAll(availabilityIntervals);
			}
			/*
			//if(resource.getAvailability() != null){
			if(resource.getOwnedAvailability() != null){
				List ownedAvailabilityIntervals = resource.getOwnedAvailability().getRecurringTimeIntervals();
				//List ownedAvailabilityIntervals = resource.getAvailability().getRecurringTimeIntervals();
				if(ownedAvailabilityIntervals != null && !ownedAvailabilityIntervals.isEmpty()){
					Iterator it = ownedAvailabilityIntervals.iterator();
					while(it.hasNext()){
						RecurringTimeIntervals inOwned = (RecurringTimeIntervals)it.next();
						if(!intervals.contains(inOwned)){
							intervals.add(inOwned);
						}
					}
				}
			}
		//}else if(resource.getAvailability() != null){
		}else if(resource.getOwnedAvailability() != null){
			List ownedAvailabilityIntervals = resource.getOwnedAvailability().getRecurringTimeIntervals();
			//List ownedAvailabilityIntervals = resource.getAvailability().getRecurringTimeIntervals();
			if(ownedAvailabilityIntervals != null && !ownedAvailabilityIntervals.isEmpty()){
				intervals.add(ownedAvailabilityIntervals);
			}
			*/
		}
		return intervals;
	}



	//TODO will dissapear when move to new ResourceModel
	protected String createTimeIntervals(Resource resource, AbstractChildContainerNode node, BtCompoundCommand wrapperCmd) {

		CreateTimeIntervalsBOMCmd createCmd = new CreateTimeIntervalsBOMCmd();
		createCmd.setParentModelBLM_URI((String)node.getEntityReference());
		createCmd.setProjectName(node.getProjectNode().getLabel());
		createCmd.setName("$" + resource.getName() + "_availability");
		//create an unique name for the exempt period.. unique exempt period/recurringInterval...
		//TODO !!!!!!! add precondition for interval name and not execute the command otherwise !!!!!
		if(!wrapperCmd.appendAndExecute(createCmd)){
			wrapperCmd.undo();
		}
		
		
		return createCmd.getROBLM_URI();
	}
	/**
	 * Creates a list that will consolidate the a resource costProfile and a resource owned CostProfile into 
	 * a single list. 
	 * Note: tool limitation : the tool does not expose the reusable costProfile. In the tool, the user will always
	 * assign cost to a resource => create an ownedCostProfile (owned TimeDependedCost instance), while the Resource 
	 * costProfile association will point to the ownedCostProfile instance.
	 * On the import, if both costProfile and ownedCostProfile are specified, the list of timeDependentCosts will be 
	 * consolidated in an unique list.
	 * @param resource a BOM Resource
	 * @return list - a List containing all the <code>resource</code> cost profiles.
	 */
	private List consolidateCostProfileList(Resource resource){
		
		List costProfile = new LinkedList();
		if(resource.getOwnedCostProfile() != null && !resource.getOwnedCostProfile().isEmpty()){
			 costProfile.addAll(resource.getOwnedCostProfile());
			 if(resource.getCostProfile() != null && !resource.getCostProfile().isEmpty()){
			 	List costProfiles = resource.getCostProfile();
			 	Iterator costIt = costProfiles.iterator();
			 	while(costIt.hasNext()){
			 		TimeDependentCost tempCost = (TimeDependentCost)costIt.next();
			 		if(!costProfile.contains(tempCost)){
			 			costProfile.add(tempCost);
			 		}
			 	}
			}
		}else{
			if(resource.getCostProfile()!= null && !resource.getCostProfile().isEmpty()){
				costProfile.addAll(resource.getCostProfile());
			}
		}
		
		return costProfile;
	}
	/**
	 * Updates the <code>workingResource</code> with BOM Resource cost Profile as per the 
	 * source <code>resource</code>
	 * @param resource source BOM Resource
	 * @param workingResource BOM Resource
	 */		
	private void updateTimeDependentCost(Resource resource, Resource workingResource){
		LoggingUtil.traceEntry(this, "updateTimeDependentCost");
		//TODO check with latest commands.. use CompoundCommands that should update the ownedCostProfile
		//toghether with the referenced CostProfile
		List costProfiles = consolidateCostProfileList(resource);
		//if(resource.getOwnedCostProfile() != null && !resource.getOwnedCostProfile().isEmpty()){
		if(costProfiles != null && !costProfiles.isEmpty()){
			//List ownedCosts = resource.getOwnedCostProfile();
			//Iterator it = resource.getOwnedCostProfile().iterator();
			Iterator it = costProfiles.iterator();
			TimeDependentCost timeCost = null;
			TimeDependentCost workingTimeCost = null;
			AddUpdateTimeDependentCostBOMCmd addTimeCmd = null;
			while(it.hasNext()){
				timeCost = (TimeDependentCost)it.next();
				
				if (timeCost instanceof CostPerQuantityAndTimeUnit){
					addTimeCmd = new AddCostPerQuantityAndTimeUnitToResourceBOMCmd(workingResource);
					((AddCostPerQuantityAndTimeUnitToResourceBOMCmd)addTimeCmd).setUnitOfMeasure(((CostPerQuantityAndTimeUnit)timeCost).getUnitOfMeasure());
					((AddCostPerQuantityAndTimeUnitToResourceBOMCmd)addTimeCmd).setTimeUnit(((CostPerQuantityAndTimeUnit)timeCost).getTimeUnit());
				} else if(timeCost instanceof CostPerQuantity){
					addTimeCmd = new AddCostPerQuantityToResourceBOMCmd(workingResource);
					((AddCostPerQuantityToResourceBOMCmd)addTimeCmd).setUnitOfMeasure(((CostPerQuantity)timeCost).getUnitOfMeasure());
				} else if(timeCost instanceof CostPerTimeUnit){
					addTimeCmd = new AddCostPerTimeUnitToResourceBOMCmd(workingResource);
					((AddCostPerTimeUnitToResourceBOMCmd)addTimeCmd).setTimeUnit(((CostPerTimeUnit)timeCost).getTimeUnit());
				} else if (timeCost instanceof OneTimeCost){
					addTimeCmd = new AddOneTimeCostToResourceBOMCmd(workingResource);
				}
								
				addTimeCmd.setName(timeCost.getName());
				if(addTimeCmd != null && !addTimeCmd.canExecute()){
					LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
				}else{
					try{
						addTimeCmd.execute();
						workingTimeCost = (TimeDependentCost)addTimeCmd.getObject();
						List costValues = timeCost.getCostValue();
						if(costValues != null && ! costValues.isEmpty()){
							CostValue costValue = null;
							CostValue workingCostValue = null;
							AddCostValueToTimeDependentCostBOMCmd addCostValueCmd = null;
							Iterator costIt = costValues.iterator();
							while(costIt.hasNext()){
								costValue = (CostValue)costIt.next();
								addCostValueCmd = new AddCostValueToTimeDependentCostBOMCmd(workingTimeCost);
								if(!addCostValueCmd.canExecute()){
									LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
								}else{
									try{								
										addCostValueCmd.execute();
										workingCostValue = (CostValue)addCostValueCmd.getObject();
										if(costValue.getAmount()!= null){
											MonetaryValue amount = costValue.getAmount();
											AddMonetaryValueToCostValueBOMCmd addMonetaryCmd = new AddMonetaryValueToCostValueBOMCmd(workingCostValue);
											addMonetaryCmd.setCurrency(amount.getCurrency());
											if(!addMonetaryCmd.canExecute()){
												LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
											}else{
												try{
													addMonetaryCmd.execute();
													MonetaryValue workingMonetary = (MonetaryValue)addMonetaryCmd.getObject();
													if(amount.getValue() != null && amount.getValue() instanceof LiteralReal){
														AddLiteralRealToMonetaryValueBOMCmd addValueCmd = new AddLiteralRealToMonetaryValueBOMCmd(workingMonetary);
														addValueCmd.setValue(((LiteralReal)amount.getValue()).getValue());
														if(!addValueCmd.canExecute()){
															LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
														}else{
															try{
																addValueCmd.execute();
															}catch(RuntimeException ex){
																LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
															}
														}
													}
												}catch(RuntimeException ex){
													LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, ex);
												}
											}
										}
										updateCostValueAvailability(resource, costValue, workingCostValue);
									}catch(RuntimeException ex){
										LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, ex);
									}
								}
							}
						}
//						TODO uncomment when the model is updated
						//the referenced cost profile should be set updated with the ownedCostProfile.
						 UpdateResourceBOMCmd updateCmd = new UpdateResourceBOMCmd(workingResource);
						 updateCmd.addCostProfile(workingTimeCost);
						 if(updateCmd.canExecute()){
						 		updateCmd.execute();
						 }
						 
					}catch(RuntimeException ex){
						LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, ex);
					}

				}
			}
		}
		LoggingUtil.traceExit(this, "updateTimeDependentCost");
	}
	
		


	/**
	 * Updates the <code>workingCostValue</code> availability as per the <code>costValue</code>
	 * NOTE: will follow the tool mechanism of managing costAvailability TimeIntervals. All the available intervals
	 * of a CostValue are wrapped in a TimeIntervals object (top level BOM Packageable element)
	 * of the ResourceModel that is not shareable, as it is not visible in the BOM navigator.
	 * There is only one TimeIntervals for a CostValue. 
	 * The name of the TimeIntervals is unique as build from the name of the resource, and the unique ID of the CostValue.
	 * The management of this TimeIntervals is linked with the CostValue (Resource). 
	 * Upon the deletion of the Resource, the TimeIntervals corresponding to the
	 * CostAvailability should be also deleted.
	 * NOTE: Although this code will create top level BOM Packageable elements (TimeIntervals)
	 * it will not handle name colision for the above mentioned reason.  
	 * TODO check the method commands and errors
	 * @param resource BOM Resource
	 * @param costValue BOM CostValue
	 * @param workingCostValue 
	 * TODO error log
	 */
	private void updateCostValueAvailability(Resource resource, CostValue costValue, CostValue workingCostValue){
		LoggingUtil.traceEntry(this, "updateCostValueAvailability");
		if(costValue.getWhen() != null && workingCostValue != null){
			TimeIntervals when = costValue.getWhen();
			BtCompoundCommand wrapperCmd = new BtCompoundCommand();
			AbstractChildContainerNode resCatalogNode = (AbstractChildContainerNode)getImportSession().getContext().get(resource.getOwningPackage());
			if(resCatalogNode == null){
				//can not find the resource model, can not create the TimeIntervals
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.OBJECT_REFERENCE_NOT_FOUND_EXCEPTION, new String[]{"Resource Catalog", resource.getOwningPackage().getName()}, null);
				//can not create the TimeIntervals that will contain all the RecurringTimeInterval ExemptPeriods, return 
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.COST_AVAILABILITY_TIME_INTERVALS_CREATION_EXCEPTION, new String[]{resource.getName()}, null, "Can not retrieve the resourceCatalog");
				LoggingUtil.traceExit(this, "updateCostValueAvailability");
				return;
			}
			String intervalsURI = createTimeIntervalsForCostValue(resource, resCatalogNode, wrapperCmd, workingCostValue);
			if(intervalsURI == null){
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.COST_AVAILABILITY_TIME_INTERVALS_CREATION_EXCEPTION, new String[]{resource.getName()}, null, "IntervalsURI is null");
				LoggingUtil.traceExit(this, "updateCostValueAvailability");
				return;
			}
			OpenRootObjectForUpdateBOMCmd openCmd = new OpenRootObjectForUpdateBOMCmd();
			openCmd.setProjectName(getProjectName());
			openCmd.setROBLM_URI(intervalsURI);
			if(!wrapperCmd.appendAndExecute(openCmd)){
				wrapperCmd.undo();
			}else{
			
				// need to get copy id for saving
				String copyID = openCmd.getCopyID();
				
				TimeIntervals workingTimeIntervals = (TimeIntervals)openCmd.getROCopy();
				
				if(when.getRecurringTimeIntervals() != null && !when.getRecurringTimeIntervals().isEmpty()){
					Iterator it = when.getRecurringTimeIntervals().iterator();
					
					UpdateTimeIntervalsBOMCmd updateTI = new UpdateTimeIntervalsBOMCmd(workingTimeIntervals);
					while(it.hasNext()){
						RecurringTimeIntervals recurringTimeInterval = (RecurringTimeIntervals)it.next();
						RecurringTimeIntervals workingRecInterval = (RecurringTimeIntervals) BOMUtil.loadRootObject((AbstractLibraryChildNode) getImportSession().getContext().get(recurringTimeInterval));
						updateTI.addRecurringTimeIntervals(workingRecInterval);
					}
					wrapperCmd.appendAndExecute(updateTI);
				}
				
				SaveWorkingSetCmd saveCmd = new SaveWorkingSetCmd();
				saveCmd.setProjectName(getProjectName());
				String projectPath = FileMGR.getProjectPath(getProjectName());
				saveCmd.setProjectPath(projectPath);
				saveCmd.setWorkingSetID(copyID);
				if(!wrapperCmd.appendAndExecute(saveCmd)){
					wrapperCmd.undo();
				}else{
					TimeIntervals masterIntervals = (TimeIntervals)BOMUtil.loadRootObject(intervalsURI, getProjectName());
					UpdateCostValueBOMCmd updateCostValue = new UpdateCostValueBOMCmd(workingCostValue);
					updateCostValue.setWhen(masterIntervals);
					wrapperCmd.appendAndExecute(updateCostValue);
				}
				closeWorkingCopy(copyID);
				
			}
		}
		LoggingUtil.traceExit(this, "updateCostValueAvailability");
		return;
	}
	/**
	* Creates a hidden (tool hidden) TimeInterval that will contain all cost available RecurringTimeIntervals.
	* The name of the TimeIntervals is created from the name of the Reosurce and the ID of the CostValue and should be unique.
	* Life cycle of this object is managed by the Resource that reference it.
	* @param resource 
	* @param node
	* @param wrapperCmd
	* @return the TimeIntervals root object BML URI. 
	* TODO error log
	*/
	protected String createTimeIntervalsForCostValue(Resource resource, AbstractChildContainerNode node, BtCompoundCommand wrapperCmd, CostValue workingCostValue) {
		
		CreateTimeIntervalsBOMCmd createCmd = new CreateTimeIntervalsBOMCmd();
		createCmd.setParentModelBLM_URI((String)node.getEntityReference());
		createCmd.setProjectName(node.getProjectNode().getLabel());
		String workingSetID = CopyRegistry.instance().getCopyID(workingCostValue);
		EObject master = CopyRegistry.instance().getMaster(workingSetID, workingCostValue);
		createCmd.setName("$" + resource.getName() + "_"+ ((CostValue)master).getUid()+"_when");
		//create an unique name for the exempt period.. unique exempt period/recurringInterval...
			//TODO !!!!!!! add precondition for interval name and not execute the command otherwise !!!!!	
		if(!wrapperCmd.appendAndExecute(createCmd)){
			wrapperCmd.undo();
		}
		
		return createCmd.getROBLM_URI();
	}
	/**
	 * Updates the qualification of the <code>workingResource</code> as per the qualification of 
	 * the <code>resource</code>
	 * @param resource source BOM Resource
	 * @param workingResource target BOM Resource
	 */
	private void updateQualification(Resource resource, Resource workingResource){
		LoggingUtil.traceEntry(this, "updateQualification");
		if(resource.getQualification() != null && !resource.getQualification().isEmpty()){
			EList qualifications = resource.getQualification();
			Qualification qualification = null;
			Qualification workingQualification = null;
			AddQualificationToResourceBOMCmd addQualificationCmd = null;
			Role workingRole = null;
			Iterator it = qualifications.iterator();
			while(it.hasNext()){
				qualification = (Qualification)it.next();
				addQualificationCmd = new AddQualificationToResourceBOMCmd(workingResource);
				if(qualification.getRole()!= null){
					//workingRole = (Role) BOMUtil.loadRootObject((AbstractLibraryChildNode) getImportSession().getContext().get(qualification.getRole()));
					workingRole = (Role)BOMUtil.getType(getProjectName(), qualification.getRole(), getImportSession().getContext());
					if(workingRole == null){
						LoggingUtil.logWarning(getImportSession(), IeMessageKeys.OBJECT_REFERENCE_NOT_FOUND_EXCEPTION, new String[]{"Role", qualification.getRole().getName()}, null);
					}
					addQualificationCmd.setRole(workingRole);
				}
				if(!addQualificationCmd.canExecute()){
					LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_QUALIFICATION_CREATION_EXCEPTION, new String[]{resource.getName()}, null);
				}else{
					try{
						addQualificationCmd.execute();
						workingQualification = (Qualification)addQualificationCmd.getObject();
						if(qualification.getProvidedScope() != null && !qualification.getProvidedScope().isEmpty()){
							EList providedScope = qualification.getProvidedScope();
							Iterator itScope = providedScope.iterator();
							ScopeValue scopeValue = null;
							ScopeValue workingScopeValue = null;
							AddScopeValueToQualificationBOMCmd addScopeCmd = null;
							while(itScope.hasNext()){
								scopeValue = (ScopeValue)itScope.next();
								addScopeCmd = new  AddScopeValueToQualificationBOMCmd(workingQualification);
								if(addScopeCmd.canExecute()){
									try {
										addScopeCmd.execute();
										workingScopeValue = (ScopeValue)addScopeCmd.getObject();
										updateQualificationScopeValue(scopeValue, workingScopeValue);
									} catch (RuntimeException ex) {
										LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_SCOPE_QUALIFICATION_CREATION_EXCEPTION, new String[]{resource.getName()}, ex);
									}
								}else{
									LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_SCOPE_QUALIFICATION_CREATION_EXCEPTION, new String[]{resource.getName()}, null);
								}
							}
						}
					}catch(RuntimeException ex){
						LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_QUALIFICATION_CREATION_EXCEPTION, new String[]{resource.getName()}, ex);
					}
				}
			}
		}
		LoggingUtil.traceExit(this, "updateQualification");
	}
	/**
	 * Updates the <code>workingScopeValue</code> Qualification based on the <code> scopeValue</code>
	 * @param scopeValue BOM source ScopeValue
	 * @param workingScopeValue BOM target ScopeValue
	 */
	private void updateQualificationScopeValue(ScopeValue scopeValue, ScopeValue workingScopeValue){
		LoggingUtil.traceEntry(this, "updateQualificationScopeValue");
		if(scopeValue.getValue() != null && !scopeValue.getValue().isEmpty()){
			EList values = scopeValue.getValue();
			Iterator valuesIt = values.iterator();
			ValueSpecification valueSpec = null;
			AddUpdateValueSpecificationBOMCmd addValueSpecCmd = null;
			ValueSpecification workingValueSpecification = null;
			UpdateValueSpecificationRule updateValueRule = null;
			while(valuesIt.hasNext()){
				valueSpec = (ValueSpecification)valuesIt.next();
				addValueSpecCmd = createScopeValueValueSpec(valueSpec, workingScopeValue);
				if(addValueSpecCmd.canExecute()){
					try {
						addValueSpecCmd.execute();
						workingValueSpecification = (ValueSpecification)addValueSpecCmd.getObject();
						updateValueRule = new UpdateValueSpecificationRule();
						updateValueRule.setProjectName(getProjectName());
						updateValueRule.setImportSession(getImportSession());
						updateValueRule.setSource(valueSpec);
						updateValueRule.setWorkingCopy(workingValueSpecification);
						updateValueRule.invoke();
					} catch (RuntimeException e) {
						LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_SCOPE_VALUE_SPECIFICATION_CREATION_EXCEPTION, null, e);
					}
				}else{
					LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_SCOPE_VALUE_SPECIFICATION_CREATION_EXCEPTION, null, null);
				}
			}
		}
		//this assumes that the Role was updated the first
		ScopeDimension workingScopeDimension = findReferencedScopeDimension(scopeValue.getScopeDimension());
		if(workingScopeDimension != null){
			UpdateScopeValueBOMCmd updateScopeCmd = new UpdateScopeValueBOMCmd(workingScopeValue);
			updateScopeCmd.setScopeDimension(workingScopeDimension);
			if(updateScopeCmd.canExecute()){
				try {
					updateScopeCmd.execute();
				} catch (RuntimeException e) {
					LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_SCOPE_VALUE_SPECIFICATION_CREATION_EXCEPTION, null, e);
				}
			}else{
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_SCOPE_VALUE_SPECIFICATION_CREATION_EXCEPTION, null, null);
			}
		}
		LoggingUtil.traceExit(this, "updateQualificationScopeValue");
	}
	/**
	 * Returns the target scopeDimension.
	 * @param scopeDimension the source BOM ScopeDimension
	 * @return target scopeDimension
	 */
	private ScopeDimension findReferencedScopeDimension(ScopeDimension scopeDimension){
		LoggingUtil.traceEntry(this, "findReferencedScopeDimension");
		ScopeDimension workingScopeDimension = null;
		if(scopeDimension == null){
			return null;
		}
		Role role = (Role)scopeDimension.eContainer();
		if(role != null){
			Role workingRole = (Role)BOMUtil.getType(getProjectName(), (PackageableElement)scopeDimension.eContainer(), getImportSession().getContext());
			if(workingRole != null){
				EList scopeDimensions = workingRole.getScopeDimension();
				if(scopeDimensions != null && !scopeDimensions.isEmpty()){
					Iterator it = scopeDimensions.iterator();
					ScopeDimension thisScope = null;
					while(it.hasNext()){
						thisScope = (ScopeDimension)it.next();
						if(thisScope.getName().equals(scopeDimension.getName())){
							workingScopeDimension = thisScope;
							break;
						}
					}
				}
			}else{
				LoggingUtil.logWarning(getImportSession(), IeMessageKeys.OBJECT_REFERENCE_NOT_FOUND_EXCEPTION, new String[]{"Role", role.getName()}, null);
			}
		}
		LoggingUtil.traceEntry(this, "findReferencedScopeDimension");
		return workingScopeDimension;
	}
	/**
	 * Returns the command for updating the <code>workingScopeValue</code> with the <code>valueSpec</code>
	 * @param valueSpecification BOM ValueSpecification
	 * @param workingScopeValue BOM ScopeValue
	 * @return AddUpdateValuespecificationBOMCmd - an implementation of this command
	 */
	private AddUpdateValueSpecificationBOMCmd createScopeValueValueSpec(ValueSpecification valueSpecification, ScopeValue workingScopeValue){
		
		AddUpdateValueSpecificationBOMCmd addValueSpecCmd = null;
		if(valueSpecification instanceof LiteralSpecification){
			LiteralSpecification literalSpec = (LiteralSpecification)valueSpecification;
			if(literalSpec instanceof LiteralString){
				addValueSpecCmd = new AddLiteralStringToScopeValueBOMCmd(workingScopeValue);
			}else if (literalSpec instanceof LiteralUnlimitedNatural){
				addValueSpecCmd = new AddLiteralUnlimitedNaturalToScopeValueBOMCmd(workingScopeValue);
			}else if(literalSpec instanceof LiteralNull){
				addValueSpecCmd = new AddLiteralNullToScopeValueBOMCmd(workingScopeValue);
			}else if (literalSpec instanceof LiteralInteger){
				addValueSpecCmd = new AddLiteralIntegerToScopeValueBOMCmd(workingScopeValue);
			}else if (literalSpec instanceof LiteralBoolean){
				addValueSpecCmd = new AddLiteralBooleanToScopeValueBOMCmd(workingScopeValue);
			}else if (literalSpec instanceof LiteralTime){
				addValueSpecCmd = new AddLiteralTimeToScopeValueBOMCmd(workingScopeValue);
			}else if (literalSpec instanceof LiteralDuration){
				addValueSpecCmd = new AddLiteralDurationToScopeValueBOMCmd(workingScopeValue);
			}else if (literalSpec instanceof LiteralReal){
				addValueSpecCmd = new AddLiteralRealToScopeValueBOMCmd(workingScopeValue);
			}else if(literalSpec instanceof LiteralNull){
				addValueSpecCmd = new AddLiteralNullToScopeValueBOMCmd(workingScopeValue);
			}
				
		}else if (valueSpecification instanceof InstanceValue){
			addValueSpecCmd = new AddInstanceValueToScopeValueBOMCmd(workingScopeValue);
			
		}else if (valueSpecification instanceof StructuredOpaqueExpression){
			addValueSpecCmd = new AddStructuredOpaqueExpressionToScopeValueBEXCmd(workingScopeValue);
			
		}else if (valueSpecification instanceof OpaqueExpression){
			addValueSpecCmd = new AddOpaqueExpressionToScopeValueBOMCmd(workingScopeValue);
		}
		return addValueSpecCmd;
		 
	}
//	/**
//	 * Updates the <code>workingResource</code> with BOM Resource cost Profile as per the 
//	 * source <code>resource</code>
//	 * @param resource source BOM Resource
//	 * @param workingResource BOM Resource
//	 */		
//	private void updateTimeDependentCost(Resource resource, Resource workingResource){
//		LoggingUtil.traceEntry(this, "updateTimeDependentCost");
//	//TODO check with latest commands.. use CompoundCommands that should update the ownedCostProfile
//	//toghether with the referenced CostProfile
//		if(resource.getOwnedCostProfile() != null && !resource.getOwnedCostProfile().isEmpty()){
//			List ownedCosts = resource.getOwnedCostProfile();
//			Iterator it = resource.getOwnedCostProfile().iterator();
//			TimeDependentCost timeCost = null;
//			TimeDependentCost workingTimeCost = null;
//			AddUpdateTimeDependentCostBOMCmd addTimeCmd = null;
//			while(it.hasNext()){
//				timeCost = (TimeDependentCost)it.next();
//				if(timeCost instanceof CostPerTimeUnit){
//					addTimeCmd = new AddCostPerTimeUnitToResourceBOMCmd(workingResource);
//					((AddCostPerTimeUnitToResourceBOMCmd)addTimeCmd).setTimeUnit(((CostPerTimeUnit)timeCost).getTimeUnit());
//				}else if(timeCost instanceof CostPerQuantity){
//					addTimeCmd = new AddCostPerQuantityToResourceBOMCmd(workingResource);
//					((AddCostPerQuantityToResourceBOMCmd)addTimeCmd).setUnitOfMeasure(((CostPerQuantity)timeCost).getUnitOfMeasure());
//				}else if (timeCost instanceof OneTimeCost){
//					addTimeCmd = new AddOneTimeCostToResourceBOMCmd(workingResource);
//				}else if (timeCost instanceof CostPerQuantityAndTimeUnit){
//					addTimeCmd = new AddCostPerQuantityAndTimeUnitToResourceBOMCmd(workingResource);
//					((AddCostPerQuantityAndTimeUnitToResourceBOMCmd)addTimeCmd).setUnitOfMeasure(((CostPerQuantityAndTimeUnit)timeCost).getUnitOfMeasure());
//					((AddCostPerQuantityAndTimeUnitToResourceBOMCmd)addTimeCmd).setTimeUnit(((CostPerQuantityAndTimeUnit)timeCost).getTimeUnit());
//				}
//				if(addTimeCmd != null && addTimeCmd.canExecute()){
//					addTimeCmd.setName(timeCost.getName());
//					try{
//						addTimeCmd.execute();
//						workingTimeCost = (TimeDependentCost)addTimeCmd.getObject();
//						List costValues = timeCost.getCostValue();
//						if(costValues != null && ! costValues.isEmpty()){
//							CostValue costValue = null;
//							CostValue workingCostValue = null;
//							Iterator costIt = costValues.iterator();
//							while(costIt.hasNext()){
//								costValue = (CostValue)costIt.next();
//								AddCostValueToTimeDependentCostBOMCmd addCostValueCmd = new AddCostValueToTimeDependentCostBOMCmd(workingTimeCost);
//								if(addCostValueCmd.canExecute()){
//									try{								
//										addCostValueCmd.execute();
//										workingCostValue = (CostValue)addCostValueCmd.getObject();
//										if(costValue.getAmount()!= null){
//											MonetaryValue amount = costValue.getAmount();
//											AddMonetaryValueToCostValueBOMCmd addMonetaryCmd = new AddMonetaryValueToCostValueBOMCmd(workingCostValue);
//											addMonetaryCmd.setCurrency(amount.getCurrency());
//											if(addMonetaryCmd.canExecute()){
//												try{
//													addMonetaryCmd.execute();
//													MonetaryValue workingMonetary = (MonetaryValue)addMonetaryCmd.getObject();
//													if(amount.getValue() != null && amount.getValue() instanceof LiteralReal){
//														AddLiteralRealToMonetaryValueBOMCmd addValueCmd = new AddLiteralRealToMonetaryValueBOMCmd(workingMonetary);
//														addValueCmd.setValue(((LiteralReal)amount.getValue()).getValue());
//														if(addValueCmd.canExecute()){
//															try{
//																addValueCmd.execute();
//															}catch(RuntimeException ex){
//																LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_VALUE_AMOUNT_UPDATE_EXCEPTION, new String[]{resource.getName()}, null);
//															}
//														}else{
//															LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_VALUE_AMOUNT_UPDATE_EXCEPTION, new String[]{resource.getName()}, null); 
//														}
//													}
//												}catch(RuntimeException ex){
//													LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_VALUE_AMOUNT_UPDATE_EXCEPTION, new String[]{resource.getName()}, ex);
//												}
//											}else{
//												LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_VALUE_AMOUNT_UPDATE_EXCEPTION, new String[]{resource.getName()}, null); 
//											}
//										}
//										updateCostValueAvailability(resource, costValue, workingCostValue);
//									}catch(RuntimeException ex){
//										LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_VALUE_CREATE_EXCEPTION, new String[]{resource.getName()}, ex);
//									}
//								}else{
//									LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_VALUE_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
//								}
//							}
//						}
//					}catch(RuntimeException ex){
//						LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, ex);
//					}
//				}else{
//					LoggingUtil.logWarning(getImportSession(), IeMessageKeys.RESOURCE_COST_CREATE_EXCEPTION, new String[]{resource.getName()}, null);
//				}
//			}
//		}
//		LoggingUtil.traceExit(this, "updateResourceQuantity");
//	}


//	/**
//	 * Updates the <code>workingResource</code> with BOM Resource availability as per the 
//	 * source <code>resource</code>
//	 * @param resource source BOM Resource
//	 * @param workingResource BOM Resource
//	 *
//	 */
//	private void updateAvailability(Resource resource, Resource workingResource){
//		LoggingUtil.traceEntry(this, "updateAvailability");
//		//TODO change when the model will change.. should be like costProfile...
//		if(resource.getAvailability() != null){
//			TimeIntervals availability = resource.getAvailability();
//			//AddTimeIntervalsToPackageBOMCmd addTimeIntervalsCmd = new AddTimeIntervalsToPackageBOMCmd(workingResource.getOwningPackage());
//			BtCompoundCommand wrapperCmd = new BtCompoundCommand();
//			AbstractChildContainerNode resCatalogNode = (AbstractChildContainerNode)getImportSession().getContext().get(resource.getOwningPackage());
//			String intervalsURI = createTimeIntervals(resource, resCatalogNode, wrapperCmd);
//			//TODO check for null
//			OpenRootObjectForUpdateBOMCmd openCmd = new OpenRootObjectForUpdateBOMCmd();
//			openCmd.setProjectName(getProjectName());
//			openCmd.setROBLM_URI(intervalsURI);
//			if (openCmd.canExecute()) {
//				openCmd.execute();
//			}
//			// need to get copy id for saving
//			String copyID = openCmd.getCopyID();
//			
//			TimeIntervals workingTimeIntervals = (TimeIntervals)openCmd.getROCopy();
//			
//			if(availability.getRecurringTimeIntervals() != null && !availability.getRecurringTimeIntervals().isEmpty()){
//				Iterator it = availability.getRecurringTimeIntervals().iterator();
//				
//				UpdateTimeIntervalsBOMCmd updateTI = new UpdateTimeIntervalsBOMCmd(workingTimeIntervals);
//				
//				while(it.hasNext()){
//					RecurringTimeIntervals recurringTimeInterval = (RecurringTimeIntervals)it.next();
//					RecurringTimeIntervals workingRecInterval = (RecurringTimeIntervals) BOMUtil.loadRootObject((AbstractLibraryChildNode) getImportSession().getContext().get(recurringTimeInterval));
//					updateTI.addRecurringTimeIntervals(workingRecInterval);
//				}
//				wrapperCmd.appendAndExecute(updateTI);
//			}
//			
//			SaveWorkingSetCmd saveCmd = new SaveWorkingSetCmd();
//			saveCmd.setProjectName(getProjectName());
//			String projectPath = FileMGR.getProjectPath(getProjectName());
//			saveCmd.setProjectPath(projectPath);
//			saveCmd.setWorkingSetID(copyID);
//			if(saveCmd.canExecute()) {
//				saveCmd.execute();
//			} else {
//				//TODO: log error to error log
//				
//			}
//			
//			TimeIntervals masterIntervals = (TimeIntervals)BOMUtil.loadRootObject(intervalsURI, getProjectName());
//			UpdateResourceBOMCmd updateResource = new UpdateResourceBOMCmd(workingResource);
//			updateResource.setAvailability(masterIntervals);
//			wrapperCmd.appendAndExecute(updateResource);
//		}
//		LoggingUtil.traceExit(this, "updateAvailability");
//	}
	
	/**
	 * Close the workingcopy by id
	 * @param copyID
	 */
	protected void closeWorkingCopy(final String copyID) {
		LoggingUtil.traceEntry(this, "closeWorkingCopy");		
		if (copyID == null) {
			LoggingUtil.trace(this, "closeWorkingCopy", "The copyID should not be null.");
			LoggingUtil.traceExit(this, "closeWorkingCopy");			
			return;
		}
		CloseWorkingSetCmd closeCmd = new CloseWorkingSetCmd();
		closeCmd.setWorkingSetID(copyID);
		if(closeCmd.canExecute()) {
			try {			
				closeCmd.execute();
			} catch (RuntimeException e) {
				LoggingUtil.trace(this, "closeWorkingCopy", "The close command throws a RuntimeException.");
				LoggingUtil.traceExit(this, "closeWorkingCopy");
				return;
			}
		} else {
			LoggingUtil.trace(this, "closeWorkingCopy", "The close command cannot be executed.");
			LoggingUtil.traceExit(this, "closeWorkingCopy");
			return;
		}
		LoggingUtil.traceExit(this, "closeWorkingCopy");		
	}

}
