package com.ibm.btools.blm.ie.resource;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2004, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.util.resource.CommonMessageKeys;

/**
 * The MessageKeys interface holds the keys used within the resource bundle.
 */
public interface IeMessageKeys extends CommonMessageKeys {

	public final static String RESOURCE_PROPERTY_FILE = "com.ibm.btools.blm.ie.resource.messages";	
	public final static String PLUGIN_ID = "com.ibm.btools.blm.ie";
	
	// copyright	
	static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2004, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$	
	
	// --- Import Engine and Import Framework
	public final static String GENERIC_ERROR 											= "IEF00010E";		// {}
	public final static String CANCEL_THE_OPERATION 									= "IEF00020W";		// {}
	
	public final static String FILE_LENGTH_EXCEEDED_GENERIC								= "IEF01010W";
	public final static String FILE_LENGTH_EXCEEDED_APPROX								= "IEF01020W";
	public final static String FILE_LENGTH_EXCEEDED_EXACT								= "IEF01030W";		
	
	public final static String CANNOT_CREATE_BULK_RESOURCE_DEFINITION_CATEGORY			= "IEF02010W";		// {name}
	public final static String CANNOT_CREATE_BULK_RESOURCE_DEFINITION		  			= "IEF02020W";		// {name}
	public final static String CANNOT_CREATE_BULK_RESOURCE							  	= "IEF02030W";		// {name}
	public final static String CANNOT_CREATE_BUSINESS_ITEM							  	= "IEF02040W";		// {name}
	public final static String CANNOT_CREATE_BUSINESS_ITEM_SAMPLE					  	= "IEF02050W";		// {name}
	public final static String CANNOT_CREATE_CALENDAR								  	= "IEF02060W";		// {name}
	public final static String CANNOT_CREATE_CATEGORY								  	= "IEF02070W";		// {name}
	public final static String CANNOT_CREATE_DATA_CATALOG							  	= "IEF02080W";		// {name}
	public final static String CANNOT_CREATE_DATASTORE						  		 	= "IEF02090W";		// {name}
	public final static String CANNOT_CREATE_HIERARCHY									= "IEF02100W";		// {name}
	public final static String CANNOT_CREATE_HIERARCHY_STRUCTURE_DEFINITION				= "IEF02110W";		// {name}
	public final static String CANNOT_CREATE_INDIVIDUAL_RESOURCE_DEFINITION_CATEGORY	= "IEF02120W";		// {name}
	public final static String CANNOT_CREATE_INDIVIDUAL_RESOURCE_DEFINITION				= "IEF02130W";		// {name}
	public final static String CANNOT_CREATE_INDIVIDUAL_RESOURCE						= "IEF02140W";		// {name}
	public final static String CANNOT_CREATE_LOCATION_DEFINITION_CATEGORY				= "IEF02150W";		// {name}
	public final static String CANNOT_CREATE_LOCATION_DEFINITION						= "IEF02160W";		// {name}
	public final static String CANNOT_CREATE_LOCATION									= "IEF02170W";		// {name}
	public final static String CANNOT_CREATE_ORGANIZATON_DEFINITION_CATEGORY			= "IEF02180W";		// {name}
	public final static String CANNOT_CREATE_ORGANIZATON_DEFINITION						= "IEF02190W";		// {name}
	public final static String CANNOT_CREATE_ORGANIZATON_UNIT							= "IEF02200W";		// {name}
	public final static String CANNOT_CREATE_ORGANIZATON_CATALOG						= "IEF02210W";		// {name}
	public final static String CANNOT_CREATE_PROCESS_CATALOG							= "IEF02220W";		// {name}
	public final static String CANNOT_CREATE_PROCESS									= "IEF02230W";		// {name}
	public final static String CANNOT_CREATE_RESOURCE_CATALOG							= "IEF02240W";		// {name}
	public final static String CANNOT_CREATE_ROLE										= "IEF02250W";		// {name}
	public final static String CANNOT_CREATE_SERVICE									= "IEF02260W";		// {name}
	public final static String CANNOT_CREATE_SIGNAL_CATEGORY							= "IEF02270W";		// {name}
	public final static String CANNOT_CREATE_SIGNAL										= "IEF02280W";		// {name}
	public final static String CANNOT_CREATE_TASK										= "IEF02290W";		// {name}
	public final static String CANNOT_CREATE_CATEGORY_CATALOG							= "IEF02291W";		// {name}
	public final static String CANNOT_CREATE_CATEGORY_INSTANCE							= "IEF02292W";		// {name}
	public final static String CANNOT_CREATE_CATEGORY_VALUE_INSTANCE					= "IEF02293W";		// {name}
	public final static String CANNOT_CREATE_PROCESS_OBSERVATION						= "IEF02294W";
	public final static String CANNOT_CREATE_FORM										= "IEF02295W";
	
	//Added for new model support by Andy.X.Z	
	public final static String CANNOT_CREATE_EXTERNAL_SERVICE							= "IEF02282W";
	public final static String CANNOT_CREATE_SERVICE_INTERFACE							= "IEF02283W";
	public final static String CANNOT_CREATE_OPERATION									= "IEF02284W";
	public final static String CANNOT_CREATE_EXTERNAL_SCHEMA							= "IEF02285W";
	public final static String CANNOT_CREATE_COMPLEX_TYPE								= "IEF02286W";
	public final static String CANNOT_CREATE_COMPLEX_TYPE_TEMPLATE						= "IEF02287W";
	public final static String NAME_NOT_UNIQUE_DIFFERENT_CASES							= "IEF02288W";
	public final static String CANNOT_CREATE_EXTERNAL_MODEL								= "IEF02289W";
	
	public final static String CREATE_BULK_RESOURCE_DEFINITION_CATEGORY_DIFF_NAME		= "IEF02300W";		// {old, new}
	public final static String CREATE_BULK_RESOURCE_DEFINITION_DIFF_NAME		  		= "IEF02310W";		// {old, new}
	public final static String CREATE_BULK_RESOURCE_DIFF_NAME							= "IEF02320W";		// {old, new}
	public final static String CREATE_BUSINESS_ITEM_DIFF_NAME							= "IEF02330W";		// {old, new}
	public final static String CREATE_BUSINESS_ITEM_SAMPLE_DIFF_NAME					= "IEF02340W";		// {old, new}
	public final static String CREATE_CALENDAR_DIFF_NAME								= "IEF02350W";		// {old, new}
	public final static String CREATE_CATEGORY_DIFF_NAME								= "IEF02360W";		// {old, new}
	public final static String CREATE_DATA_CATALOG_DIFF_NAME						  	= "IEF02370W";		// {old, new}
	public final static String CREATE_DATASTORE_DIFF_NAME						  	 	= "IEF02380W";		// {old, new}
	public final static String CREATE_HIERARCHY_DIFF_NAME								= "IEF02390W";		// {old, new}
	public final static String CREATE_HIERARCHY_STRUCTURE_DEFINITION_DIFF_NAME			= "IEF02400W";		// {old, new}
	public final static String CREATE_INDIVIDUAL_RESOURCE_DEFINITION_CATEGORY_DIFF_NAME	= "IEF02410W";		// {old, new}
	public final static String CREATE_INDIVIDUAL_RESOURCE_DEFINITION_DIFF_NAME			= "IEF02420W";		// {old, new}
	public final static String CREATE_INDIVIDUAL_RESOURCE_DIFF_NAME						= "IEF02430W";		// {old, new}
	public final static String CREATE_LOCATION_DEFINITION_CATEGORY_DIFF_NAME			= "IEF02440W";		// {old, new}
	public final static String CREATE_LOCATION_DEFINITION_DIFF_NAME						= "IEF02450W";		// {old, new}
	public final static String CREATE_LOCATION_DIFF_NAME								= "IEF02460W";		// {old, new}
	public final static String CREATE_ORGANIZATON_DEFINITION_CATEGORY_DIFF_NAME			= "IEF02470W";		// {old, new}
	public final static String CREATE_ORGANIZATON_DEFINITION_DIFF_NAME					= "IEF02480W";		// {old, new}
	public final static String CREATE_ORGANIZATON_UNIT_DIFF_NAME						= "IEF02490W";		// {old, new}
	public final static String CREATE_ORGANIZATON_CATALO_DIFF_NAME						= "IEF02500W";		// {old, new}
	public final static String CREATE_PROCESS_CATALOG_DIFF_NAME							= "IEF02510W";		// {old, new}
	public final static String CREATE_PROCESS_DIFF_NAME									= "IEF02520W";		// {old, new}
	public final static String CREATE_RESOURCE_CATALOG_DIFF_NAME						= "IEF02530W";		// {old, new}
	public final static String CREATE_ROLE_DIFF_NAME									= "IEF02540W";		// {old, new}
	public final static String CREATE_SERVICE_DIFF_NAME									= "IEF02550W";		// {old, new}
	public final static String CREATE_SIGNAL_CATEGORY_DIFF_NAME							= "IEF02560W";		// {old, new}
	public final static String CREATE_SIGNAL_DIFF_NAME									= "IEF02570W";		// {old, new}
	public final static String CREATE_TASK_DIFF_NAME									= "IEF02580W";		// {old, new}
	public final static String CREATE_FORM_DIFF_NAME									= "IEF02581W";		// {old, new}
		
	// --- Update Process
	public final static String FAIL_TO_CREATE_ELEMENT									= "IEF03010W";		// {element, name, process}
	public final static String FAIL_TO_UPDATE_ELEMENT									= "IEF03020W";		// {element, name, process}		
	public final static String FLOW_FINAL_NODE											= "IEF03110W";		// {}
	public final static String TERMINATION_NODE											= "IEF03120W";		// {}
	public final static String INITIAL_NODE												= "IEF03130W";		// {}
	public final static String ACCEPT_SIGNAL_ACTION										= "IEF03140W";		// {}
	public final static String MAP														= "IEF03150W";		// {}
	public final static String DECISION													= "IEF03160W";		// {}
	public final static String FORK														= "IEF03170W";		// {}
	public final static String JOIN														= "IEF03180W";		// {}
	public final static String MERGE													= "IEF03190W";		// {}				
	public final static String OBSERVATION_ACTION										= "IEF03200W";		// {}
	public final static String TIMER_ACTION												= "IEF03210W";		// {}	
	public final static String FOR_LOOP_NODE											= "IEF03220W";		// {}		
	public final static String LOOP_NODE												= "IEF03230W";		// {}
	public final static String CBA_TASK													= "IEF03240W";		// {}
	public final static String BROADCAST_SIGNAL_ACTION									= "IEF03250W";		// {}
	public final static String TASK														= "IEF03260W";		// {}	
	public final static String HUMAN_TASK												= "IEF03261W";		// {}	
	public final static String BUSINESS_RULES_TASK										= "IEF03262W";		// {}	
	public final static String SUBPROCESS												= "IEF03270W";		// {}				
	public final static String PROCESS													= "IEF03280W";		// {}		
	public final static String CBA_PROCESS												= "IEF03290W";		// {}				
	public final static String CBA_SERVICE												= "IEF03300W";		// {}
	public final static String ELEMENT													= "IEF03310W";		// {}
	
	// -------
	//----- Import Information Model and Generic Artifacts
	
	public final static String BUSINESS_ITEM_PROPERTY_EXCEPTION				 			= "IEF05010W";
	public final static String CLASSIFIER_SUPER_CLASSIFIER_EXCEPTION			 		= "IEF05020W";
	public final static String PROPERTY_DEFAULT_VALUE_EXCEPTION				 			= "IEF05030W";
	public final static String INSTANCE_SUPER_CLASSIFIER_EXCEPTION 						= "IEF05050W"; 
	public final static String INSTANCE_SLOT_CREATION_EXCEPTION 						= "IEF05060W"; 
	public final static String PROPERTY_PROPERTY_EXCEPTION 								= "IEF05080W";
	public final static String PROPERTY_LOWER_BOUND_NAMED_EXCEPTION 					= "IEF05090W";
	public final static String PROPERTY_LOWER_BOUND_EXCEPTION 							= "IEF05095W";
	public final static String PROPERTY_UPPER_BOUND_NAMED_EXCEPTION 					= "IEF05100W";
	public final static String PROPERTY_UPPER_BOUND_EXCEPTION 							= "IEF05105W";
	public final static String PROPERTY_COMMENT_CREATE_EXCEPTION						= "IEF05110W";
	public final static String PROPERTY_COMMENT_UPDATE_EXCEPTION			 			= "IEF05120W";
	public final static String INSTANCE_UPDATE_EXCEPTION								= "IEF05140W";
	public final static String OBJECT_REFERENCE_NOT_FOUND_EXCEPTION 					= "IEF05150W";
	public final static String UNSUPPORTED_CONSTAINT_SPECIFICATION_EXCEPTION			= "IEF05160W";
	public final static String PROPERTY_FORMDATA_UPDATE_EXCEPTION						= "IEF05161W";
	public final static String INVALID_VALUE_FOR_PROPERTY_TYPE  						= "IEF05162W";

	//-------- Resource Model and Time 
	public final static String RESOURCE_PROPERTY_EXCEPTION 								= "IEF06010W";   
    public final static String ROLE_SCOPE_DIMENSION_CREATE_EXCEPTION 					= "IEF06030W";
	public final static String CALENDAR_UPDATE_EXCEPTION 								= "IEF06040W";   
   	public final static String BULK_RESOURCE_CONSUMABLE_UPDATE_EXCEPTION			 	= "IEF06090W";  
   	public final static String BULK_RESOURCE_AVAILABLE_QUANTITY_UPDATE_EXCEPTION 		= "IEF06100W";    
	public final static String RESOURCE_COST_CREATE_EXCEPTION 							= "IEF06130W"; 
	public final static String EXEMPT_PERIOD_TIME_INTERVALS_CREATION_EXCEPTION			= "IEF06160W";       
	public final static String RESOURCE_QUALIFICATION_CREATION_EXCEPTION				= "IEF06170W";        
	public final static String RESOURCE_SCOPE_QUALIFICATION_CREATION_EXCEPTION			= "IEF06180W";        
	public final static String RESOURCE_SCOPE_VALUE_SPECIFICATION_CREATION_EXCEPTION	= "IEF06190W";                          
	public final static String COST_AVAILABILITY_TIME_INTERVALS_CREATION_EXCEPTION		= "IEF06200W";       
	public final static String UNSUPPORTED_RECURRING_INTERVAL_VALIDITY_PERIOD			= "IEF06210W";
	
	//------- Expression Model
	public final static String ADD_SECOND_OPERAND_EXCEPTION 							= "IEF07010W";   
	public final static String SET_REFERENCE_OBJECT_EXCEPTION		 					= "IEF07020W";  
	public final static String ADD_STEP_TO_MPE_EXCEPTION 								= "IEF07030W";  
	public final static String STATIC_STEP_NOT_SUPPORTED 								= "IEF07040W";  
	public final static String ADD_FUNCTION_ARG_EXPR_EXCEPTION 							= "IEF07050W";  
	public final static String UPDATE_FUNCTION_ARG_EXPR_EXCEPTION 						= "IEF07060W";  
	public final static String UPDATE_FUNCTION_EXPR_EXCEPTION 							= "IEF07070W";  
	public final static String UPDATE_FIRST_OPRERAND_EXCEPTION 							= "IEF07080W";  
	public final static String CREATE_BINARY_LOGICAL_BOOLEAN_EXPR_EXCEPTION			 	= "IEF07090W";  
	public final static String CREATE_BOOLEAN_LITERAL_EXPR_EXCEPTION		 			= "IEF07110W";  
	public final static String CREATE_BINARY_NUMERIC_EXPR_EXCEPTION			 			= "IEF07120W";  
	public final static String CREATE_COMPARISON_EXPR_EXCEPTION			 				= "IEF07130W";  
	public final static String CREATE_FUNCTION_EXPR_EXCEPTION 							= "IEF07140W";  
	public final static String CREATE_INTEGER_LITERAL_EXPR_EXCEPTION		 			= "IEF07150W";  
	public final static String CREATE_MODEL_PATH_EXPR_EXCEPTION 						= "IEF07160W";  
	public final static String CREATE_NEGATION_EXPR_EXCEPTION 							= "IEF07170W";  
	public final static String CREATE_NOT_EXPR_EXCEPTION 								= "IEF07180W";  
	public final static String CREATE_REAL_LITERAL_EXPR_EXCEPTION 						= "IEF07190W";
	public final static String CREATE_STRING_LITERAL_EXPR_EXCEPTION 					= "IEF07200W";
	public final static String CREATE_UNION_LITERAL_EXPR_EXCEPTION 						= "IEF07210W";
	public final static String VARIABLE_EXPR_NOT_SUPPORTED 								= "IEF07220W";
	public final static String ADD_TO_STRUCTURED_OPAQUE_EXPR_EXCEPTION 					= "IEF07230W";
	public final static String CREATE_TIME_LITERAL_EXPR_EXCEPTION 						= "IEF07240W";
	public final static String CREATE_DURATION_LITERAL_EXPR_EXCEPTION					= "IEF07250W";
	public final static String CREATE_DATE_LITERAL_EXPR_EXCEPTION 						= "IEF07260W";
	public final static String CREATE_DATETIME_LITERAL_EXPR_EXCEPTION					= "IEF07270W";
	public final static String CREATE_NUMERIC_LITERAL_EXPR_EXCEPTION 					= "IEF07280W";

	//------- SimulationProcessor
	public final static String SIMULATION_COMMAND_NOT_AVAILABLE 						= "IEF08010W";
	public final static String VALIDATION_ERROR_ON_PROCESS		 						= "IEF08020W";
	public final static String SIMULATOR_PROCESS_PROFILE_UPDATE_EXCEPTION 				= "IEF08500W";
	public final static String SIMULATION_PROFILE_NOT_FOUND_EXCEPTION					= "IEF08510W";
	public final static String SIMULATOR_TASK_PROFILE_CREATE_EXCEPTION					= "IEF08520W";
	public final static String SIMULATOR_TASK_PROFILE_UPDATE_EXCEPTION					= "IEF08530W";
	public final static String SIMULATOR_TRANSITION_EXCEPTION							= "IEF08540W";
	public final static String SIMULATOR_GENERATED_ROLE_PROFILE_UPDATE_EXCEPTION		= "IEF08630W";
	public final static String SIMULATOR_GENERATED_ROLE_OVERRIDE_EXCEPTION				= "IEF08650E";	
		
	//-------- Progress Monitor's Task
	public final static String TASK_STARTING_IMPORT										= "IEF10000I";
	public final static String TASK_READING_FILE										= "IEF10010I";
	public final static String TASK_PROCESS_INPUT										= "IEF10020I";
	public final static String TASK_CREATING_PROCESS_CATALOG							= "IEF10030I";
	public final static String TASK_CREATING_PROCESS									= "IEF10040I";
	public final static String TASK_CREATING_TASK										= "IEF10050I";
	public final static String TASK_CREATING_BUSINESS_RULES_TASK						= "IEF10051I";
	public final static String TASK_CREATING_HUMAN_TASK									= "IEF10052I";
	public final static String TASK_CREATING_REPOSITORY									= "IEF10060I";
	public final static String TASK_CREATING_SERVICE									= "IEF10070I";
	public final static String TASK_CREATING_DATA_CATALOG								= "IEF10080I";
	public final static String TASK_CREATING_BUSINESS_ITEM								= "IEF10090I";
	public final static String TASK_CREATING_BUSINESS_ITEM_TEMPLATE						= "IEF10100I";
	public final static String TASK_CREATING_BUSINESS_ITEM_INSTANCE						= "IEF10110I";
	public final static String TASK_CREATING_NOTIFICATION								= "IEF10120I";
	public final static String TASK_CREATING_NOTIFICATION_TEMPLATE						= "IEF10130I";
	public final static String TASK_CREATING_RESOURCE_CATALOG							= "IEF10140I";
	public final static String TASK_CREATING_ROLE										= "IEF10150I";
	public final static String TASK_CREATING_BULK_RESOURCE_DEFINITION_TEMPLATE			= "IEF10160I";
	public final static String TASK_CREATING_BULK_RESOURCE_DEFINITION					= "IEF10170I";
	public final static String TASK_CREATING_BULK_RESOURCE								= "IEF10180I";
	public final static String TASK_CREATING_INDIVIDUAL_RESOURCE_DEFINITION_TEMPLATE	= "IEF10190I";
	public final static String TASK_CREATING_INDIVIDUAL_RESOURCE_DEFINITION				= "IEF10200I";
	public final static String TASK_CREATING_INDIVIDUAL_RESOURCE						= "IEF10210I";
	public final static String TASK_CREATING_TIMETABLE									= "IEF10220I";
	public final static String TASK_CREATING_ORGANIZATION_CATALOG						= "IEF10230I";
	public final static String TASK_CREATING_ORGANIZATION_DEFINITION_TEMPLATE			= "IEF10240I";
	public final static String TASK_CREATING_ORGANIZATION_DEFINITION					= "IEF10250I";
	public final static String TASK_CREATING_ORGANIZATION_UNIT							= "IEF10260I";
	public final static String TASK_CREATING_LOCATION_DEFINITION_TEMPLATE				= "IEF10270I";
	public final static String TASK_CREATING_LOCATION_DEFINITION						= "IEF10280I";
	public final static String TASK_CREATING_LOCATION									= "IEF10290I";
	public final static String TASK_CREATING_HIERARCHY_STRUCTURE_DEFINITION				= "IEF10300I";	
	public final static String TASK_CREATING_HIERARCHY									= "IEF10310I";
	public final static String TASK_CREATING_FORM										= "IEF10311I";
	public final static String TASK_UPDATING_PROCESS_CATALOG							= "IEF10320I";
	public final static String TASK_UPDATING_PROCESS									= "IEF10330I";
	public final static String TASK_UPDATING_TASK										= "IEF10340I";
	public final static String TASK_UPDATING_HUMAN_TASK									= "IEF10341I";
	public final static String TASK_UPDATING_BUSINESS_RULES_TASK						= "IEF10342I";
	public final static String TASK_UPDATING_REPOSITORY									= "IEF10350I";
	public final static String TASK_UPDATING_SERVICE									= "IEF10360I";
	public final static String TASK_UPDATING_DATA_CATALOG								= "IEF10370I";
	public final static String TASK_UPDATING_BUSINESS_ITEM								= "IEF10380I";
	public final static String TASK_UPDATING_BUSINESS_ITEM_TEMPLATE						= "IEF10390I";
	public final static String TASK_UPDATING_BUSINESS_ITEM_INSTANCE						= "IEF10400I";
	public final static String TASK_UPDATING_NOTIFICATION								= "IEF10410I";
	public final static String TASK_UPDATING_NOTIFICATION_TEMPLATE						= "IEF10420I";
	public final static String TASK_UPDATING_RESOURCE_CATALOG							= "IEF10430I";
	public final static String TASK_UPDATING_ROLE										= "IEF10440I";
	public final static String TASK_UPDATING_BULK_RESOURCE_DEFINITION_TEMPLATE			= "IEF10450I";
	public final static String TASK_UPDATING_BULK_RESOURCE_DEFINITION					= "IEF10460I";
	public final static String TASK_UPDATING_BULK_RESOURCE								= "IEF10470I";
	public final static String TASK_UPDATING_INDIVIDUAL_RESOURCE_DEFINITION_TEMPLATE	= "IEF10480I";
	public final static String TASK_UPDATING_INDIVIDUAL_RESOURCE_DEFINITION				= "IEF10490I";
	public final static String TASK_UPDATING_INDIVIDUAL_RESOURCE						= "IEF10500I";
	public final static String TASK_UPDATING_TIMETABLE									= "IEF10510I";
	public final static String TASK_UPDATING_ORGANIZATION_CATALOG						= "IEF10520I";
	public final static String TASK_UPDATING_ORGANIZATION_DEFINITION_TEMPLATE			= "IEF10530I";
	public final static String TASK_UPDATING_ORGANIZATION_DEFINITION					= "IEF10540I";
	public final static String TASK_UPDATING_ORGANIZATION_UNIT							= "IEF10550I";
	public final static String TASK_UPDATING_LOCATION_DEFINITION_TEMPLATE				= "IEF10560I";
	public final static String TASK_UPDATING_LOCATION_DEFINITION						= "IEF10570I";
	public final static String TASK_UPDATING_LOCATION									= "IEF10580I";
	public final static String TASK_UPDATING_HIERARCHY_STRUCTURE_DEFINITION				= "IEF10590I";	
	public final static String TASK_UPDATING_HIERARCHY									= "IEF10600I";	
	public final static String TASK_VALIDATING_PROJECT									= "IEF11010I";
	public final static String TASK_CREATING_SIMULATION_PROFILES						= "IEF11020I";
	public final static String TASK_CREATING_PROCESS_OBSERVATION						= "IEF11030I";
	public final static String TASK_UPDATING_PROCESS_OBSERVATION						= "IEF11040I";
	public final static String TASK_UPDATING_FORM										= "IEF11041I";
	//Add information to support external model import
	
	public final static String TASK_CREATING_COMPLEX_TYPE_TEMPLATE						= "IEF12000I";
	public final static String TASK_CREATING_COMPLEX_TYPE								= "IEF12001I";
	public final static String TASK_CREATING_SERVICE_OPERATION							= "IEF12002I";
	
	public final static String TASK_CREATING_EXTERNAL_SERVICE							= "IEF12003I";
	public final static String TASK_CREATING_EXTERNAL_SCHEMA							= "IEF12004I";
	public final static String TASK_CREATING_SERVICE_INTERFACE							= "IEF12005I";
	
	public final static String TASK_UPDATING_COMPLEX_TYPE_TEMPLATE						= "IEF12006I";
	public final static String TASK_UPDATING_COMPLEX_TYPE								= "IEF12007I";
	public final static String TASK_UPDATING_SERVICE_OPERATION							= "IEF12008I";	
	
	public final static String COMPLEX_TYPE_DESCRIPTION 								= "IEF12009I";
	public final static String COMPLEX_TYPE_TEMPLATE_DESCRIPTION 						= "IEF12010I";
	public final static String SERVICE_OPERATION_DESCRIPTION							= "IEF12011I"; 
	
	public static final String TEMP_FILE_DELETE_ERROR 									= "IEF12012I";
	
	//AZ added for creating external model catalog during xml import
	public static final String TASK_CREATING_EXTERNAL_MODEL                             = "IEF12013I";
	public static final String NO_CATALOG_DEFINED                             			= "IEF12014I";
	
	public static final String _UI_Path_Length_Error									= "IEF00011E";
	public static final String ERROR													= "IEF00012E";
	public static final String NAME_TOO_LONG											= "IEF00013E";
	
	//JR 31715 Add info for template business object creation
	public static final String TEMPLATE_CREATION_INFO 									= "IEF12015I";
}
