package com.ibm.btools.te.ilm;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.OperationCanceledException;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceFactoryImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.wst.wsdl.Definition;
import org.eclipse.wst.wsdl.ExtensibilityElement;
import org.eclipse.wst.wsdl.ExtensibleElement;
import org.eclipse.wst.wsdl.Import;
import org.eclipse.wst.wsdl.Namespace;
import org.eclipse.wst.wsdl.PortType;
import org.eclipse.wst.wsdl.WSDLFactory;
import org.eclipse.wst.wsdl.internal.impl.DefinitionImpl;
import org.eclipse.wst.wsdl.internal.util.WSDLResourceFactoryImpl;
import org.eclipse.wst.wsdl.util.WSDLResourceImpl;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.util.XSDConstants;
import org.eclipse.xsd.util.XSDResourceFactoryImpl;
import org.eclipse.xsd.util.XSDResourceImpl;
import org.osgi.framework.Bundle;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.ibm.btools.blm.ie.exprt.AbstractExportOperation;
import com.ibm.btools.blm.ie.exprt.ExportResult;
import com.ibm.btools.blm.ie.exprt.ExportSession;
import com.ibm.btools.blm.ie.exprt.IExportOperation;
import com.ibm.btools.blm.ie.exprt.IExportQuery;
import com.ibm.btools.blm.ie.exprt.option.BpelOptions;
import com.ibm.btools.blm.ie.exprt.option.WpsExportOptionsBean;
import com.ibm.btools.blm.ie.imprt.engine.ProgressCalculator;
import com.ibm.btools.blm.ie.imprt.rule.navigator.factory.ResourceCatalogFactory;
import com.ibm.btools.bom.model.artifacts.NamedElement;
import com.ibm.btools.bom.model.externalmodels.ExternalService;
import com.ibm.btools.bom.model.models.Model;
import com.ibm.btools.bom.model.models.OrganizationModel;
import com.ibm.btools.bom.model.models.ResourceModel;
import com.ibm.btools.bom.model.organizationstructures.OrganizationUnit;
import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.ActivitiesPackage;
import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.processes.activities.impl.ActivityImpl;
import com.ibm.btools.bom.model.processes.humantasks.Form;
import com.ibm.btools.fdl.model.DataStructure;
import com.ibm.btools.fdl.model.ModelFactory;
import com.ibm.btools.fdl.model.Organization;
import com.ibm.btools.fdl.model.Person;
import com.ibm.btools.fdl.model.ProcessCategory;
import com.ibm.btools.fdl.model.ProcessModel;
import com.ibm.btools.fdl.model.Program;
import com.ibm.btools.fdl.model.Role;
import com.ibm.btools.fdl.model.Staff;
import com.ibm.btools.fdl.model.resource.FDLProcessModelResourceFactoryImpl;
import com.ibm.btools.model.filemanager.FileMGR;
import com.ibm.btools.model.resourcemanager.ResourceMGR;
import com.ibm.btools.te.framework.rulehandler.RuleHandlerRegistry;
import com.ibm.btools.te.ilm.heuristics.helper.AbstractbpelConstants;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptimizationUtil;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.btools.te.ilm.heuristics.helper.FabricIntegrationUtil;
import com.ibm.btools.te.ilm.heuristics.helper.HumanTaskUtil;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;
import com.ibm.btools.te.ilm.heuristics.helper.SAUtil;
import com.ibm.btools.te.ilm.heuristics.helper.StaffUtil;
import com.ibm.btools.te.ilm.heuristics.helper.TransformationSessionKeyConstants;
import com.ibm.btools.te.ilm.heuristics.helper.TransformationSessionUtil;
import com.ibm.btools.te.ilm.heuristics.scdl.util.JavaImplementation;
import com.ibm.btools.te.ilm.heuristics.scdl.util.ScdlUtil;
import com.ibm.btools.te.ilm.heuristics.wsdl.util.OriginalWsdlUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;
import com.ibm.btools.te.ilm.model.sa.ComposedArtifact;
import com.ibm.btools.te.ilm.model.sa.HumanTask;
import com.ibm.btools.te.ilm.model.sa.ProcessFlow;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.btools.te.ilm.model.sa.SAType;
import com.ibm.btools.te.ilm.model.sa.ScdlArtifact;
import com.ibm.btools.te.ilm.model.sa.SolutionArtifact;
import com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact;
import com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType;
import com.ibm.btools.te.ilm.resource.MessageKeys;
import com.ibm.btools.te.ilm.resource.TEResourceBundleSingleton;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingUtil;
import com.ibm.btools.te.ilm.rulehandler.mapping.wps.WpsRuleHandlerFactory;
import com.ibm.btools.util.exception.BTRuntimeException;
import com.ibm.wbiservers.businessrule.model.brg.BusinessRuleGroup;
import com.ibm.wbiservers.businessrule.model.brg.util.BrgResourceFactoryImpl;
import com.ibm.wbiservers.businessrule.model.brgt.BusinessRuleGroupTable;
import com.ibm.wbit.ae.sacl.SACLRoot;
import com.ibm.wbit.ae.sacl.StateMachineDefinition;
import com.ibm.wbit.ae.sacl.util.SACLResourceFactoryImpl;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpel.Process;
import com.ibm.wbit.bpel.resource.BPELResourceFactoryImpl;
import com.ibm.wbit.bpel.services.partnerlinktype.PartnerLinkType;
import com.ibm.wbit.bpelpp.Id;
import com.ibm.wbit.bpelpp.JavaScriptActivity;
import com.ibm.wbit.bpelpp.Task;
import com.ibm.wbit.bpelpp.impl.IdImpl;
import com.ibm.wbit.bpelpp.impl.JavaScriptActivityImpl;
import com.ibm.wbit.bpelpp.impl.TaskImpl;
import com.ibm.wbit.br.core.model.RuleSet;
import com.ibm.wbit.br.core.model.util.ModelResourceFactoryImpl;
import com.ibm.wbit.businesscalendar.ICalendar;
import com.ibm.wbit.businesscalendar.util.CalResourceFactoryImpl;
import com.ibm.wbit.cei.model.mon.AssociationType;
import com.ibm.wbit.cei.model.mon.EventSourceType;
import com.ibm.wbit.cei.model.mon.EventType;
import com.ibm.wbit.cei.model.mon.MapType;
import com.ibm.wbit.cei.model.mon.MonitorType;
import com.ibm.wbit.cei.model.mon.PropertyType;
import com.ibm.wbit.cei.model.mon.TXType;
import com.ibm.wbit.cei.model.mon.VersionType;
import com.ibm.wbit.cei.model.mon.impl.MonFactoryImpl;
import com.ibm.wbit.cei.model.mon.util.MonResourceFactoryImpl;
import com.ibm.wbit.cei.model.mon.util.MonResourceImpl;
import com.ibm.wbit.extension.model.ExtensionMap;
import com.ibm.wbit.extension.model.ExtensionmodelFactory;
import com.ibm.wbit.lineage.XMLStamper;
import com.ibm.wbit.model.utils.NamespaceUtils;
import com.ibm.wbit.sib.mediation.operation.model.InterfaceMediationFlow;
import com.ibm.wbit.tel.TCustomClientSettings;
import com.ibm.wbit.tel.TCustomSetting;
import com.ibm.wbit.tel.TImport;
import com.ibm.wbit.tel.TTask;
import com.ibm.wbit.tel.TUISettings;
import com.ibm.wbit.tel.util.TaskResourceFactoryImpl;
import com.ibm.wbit.tel.util.TaskResourceImpl;
import com.ibm.wbit.wiring.ui.ext.model.GraphicalExtensionFactory;
import com.ibm.wbit.wiring.ui.ext.model.ModuleExtension;
import com.ibm.wbit.wpc.Script;
import com.ibm.ws.fabric.da.scdl.DAFactory;
import com.ibm.ws.fabric.da.scdl.DynamicAssembler;
import com.ibm.ws.fabric.da.scdl.DynamicAssemblyConfiguration;
import com.ibm.ws.fabric.da.scdl.util.DAResourceFactoryImpl;
import com.ibm.wsspi.sca.scdl.Component;
import com.ibm.wsspi.sca.scdl.DocumentRoot;
import com.ibm.wsspi.sca.scdl.Implementation;
import com.ibm.wsspi.sca.scdl.Module;
import com.ibm.wsspi.sca.scdl.SCDLPackage;
import com.ibm.wsspi.sca.scdl.mfc.MediationFlowFactory;
import com.ibm.wsspi.sca.scdl.mfc.impl.MediationFlowFactoryImpl;
import com.ibm.wsspi.sca.scdl.mfc.util.MediationFlowResourceFactoryImpl;
import com.ibm.wsspi.sca.scdl.process.ProcessImplementation;
import com.ibm.wsspi.sca.scdl.process.TProcess;
import com.ibm.wsspi.sca.scdl.task.TaskImplementation;
import com.ibm.wsspi.sca.scdl.util.SCDLResourceFactoryImpl;
import com.ibm.wsspi.sca.scdl.webservice.WebServiceImportBinding;

public class ExportOperation extends AbstractExportOperation implements ExportOperationConstants {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	private WSDLResourceFactoryImpl wsdlResourceFactory=null;
	private BPELResourceFactoryImpl bpelResourceFactory=null;
	//private BPELPlusResourceFactoryImpl bpelpResourceFactory=null;
	private TaskResourceFactoryImpl telResourceFactory =null;
	private XSDResourceFactoryImpl xsdResourceFactory=null;
	private FDLProcessModelResourceFactoryImpl fdlResourceFactory=null;
	private SCDLResourceFactoryImpl scdlResourceFactory=null;
	//private SCDLExtensionResourceFactoryImpl scdlResourceFactory=null;
	private XMIResourceFactoryImpl extModelResourceFactory=null;
	private MonResourceFactoryImpl monResourceFactory=null;
	private TransformationSession session = null;
	
	private ProcessModel commonFDLModel=null;
	private Resource commonFdlResource=null;
	private IProgressMonitor monitor=null;
	private String absPathPrefix;
	private FilePathManager filePathManager=null;
	
	//public static final boolean bUseWSDLSuffix=true;
	public static final boolean bUseWSDLSuffix=false;
	public static final boolean bInterfaceWISCompliant=true;
	public static final boolean bUseSinglePartWSDL=true;
	private String fdlCommonDefFileName = "model";
	
	/* Flag to indicate whether the exporter has opted not to save the output */
	private Boolean saveOutput = null;
	
	//Registry to keep WSDL/XSD EMF objects to FileName mapping
	Map obj2FileNameRegistry = null;
	private Set<Object> saveWSDLRegistry = null;  
	private HashMap<XSDSchema, String> savedSchemas = null;	// schema with target file location
	private String projectDirectory = null;
	//Constants for the external model root

	// map used for resolving the wsdl and xsd imports
	// key:
	//	A) internal (Modeler created) = namespace + fileName
	//	B) external (imported) = resource absolute path in Modeler	
	// value = List of: resource target absolute path, Resource (WSDL or XSD)
	private Map<String, List<Object>> sourcePathToTargetPathAbsoluteRegistry = null;
	
	//AZ Move the SA collection as global variable
	Collection<SolutionArtifact> transformedCollection = null;
	
	//AZ 0110 add record for artifact definitions
	private Set<Object> artifactsDefinitionRegistry = null;
	
	//AZ 0111 add registry for the SCDL component resource path;
	private List<String> scdlComponentPathRegistry = null;
	
	//AZ WMT 20070322 add to hold the top level document root
	private Set topLevelDocumentRoot = null;

	// GJD 20080422
	private Set timetableRegistry = null;
	
	private HashMap<Object, String> objectFilePathMap = null;//new HashMap<Object, String>();
	
	private Map<String,Resource> importResourceMap = null;
	//the Project name of the single element for transformation in the d2d case
	private String d2dtargetProjectName = null;
	
	//JR33669 Collection for checking multiple import fix
	private List<Definition> resolvedDefinition = null;


	private void initialize() {
		wsdlResourceFactory=null;
		bpelResourceFactory=null;
		//bpelpResourceFactory=null;
		xsdResourceFactory=null;
		fdlResourceFactory=null;
		scdlResourceFactory=null;
		extModelResourceFactory=null;
		monResourceFactory=null;
		
		commonFDLModel=null;
		commonFdlResource=null;
		
		absPathPrefix=null;
		monitor=null;
		
		
		if (getSourcePathToTargetPathAbsoluteRegistry() != null) {
			getSourcePathToTargetPathAbsoluteRegistry().clear();
		}
		setSourcePathToTargetPathAbsoluteRegistry(null);
		//AZ 0110 registry to hold the artifact definition created from the process
		//flow SA
		if (getArtifatcsDefinitionRegistry() != null) {
			getArtifatcsDefinitionRegistry().clear();
		}
		setArtifatcsDefinitionRegistry(null);
		
		if (getScdlComponentPathRegistry() != null) {
			getScdlComponentPathRegistry().clear();
		}
		setScdlComponentPathRegistry(null);
		//AZ WMT 20070322
		setTopLevelDocumentRoot(null); 
		setTimetableRegistry(null);
		
		if(getImportResourceMap() != null) {
			getImportResourceMap().clear();
		}
		setImportResourceMap(null);
		if (obj2FileNameRegistry != null) {
			obj2FileNameRegistry.clear();
		}
		obj2FileNameRegistry = null;
		if (saveWSDLRegistry != null) {
			saveWSDLRegistry.clear();
		}
		saveWSDLRegistry = null;
		if (savedSchemas != null) {
			savedSchemas.clear();
		}
		savedSchemas = null;
		projectDirectory = null;
		
		if (objectFilePathMap != null) {
			objectFilePathMap.clear();
		}
		objectFilePathMap = null;
		
		ExportOperationUtil.resetUidList();
		WIDProjectUtil.singleModuleAndLibraryAttributes = null;
		
		if(resolvedDefinition != null){
			resolvedDefinition.clear();
		}
		resolvedDefinition = null;
		//make sure we initialize the constants for 6.0 BPEL 
		//		BPELPlusConstants.NAMESPACE = BPELPlusConstants.NAMESPACE_60;
		//		MessagepropertiesConstants.NAMESPACE = MessagepropertiesConstants.NAMESPACE_2004;
		//		PartnerlinktypeConstants.NAMESPACE = PartnerlinktypeConstants.NAMESPACE_2004;

	}
	
	/* (non-Javadoc)
	 * @see com.ibm.btools.blm.ie.exprt.IExportOperation#export()
	 */
	public void export() {
		LoggingUtil.traceEntry(this, "export");
		
		initialize();
		TransformationEngine aTransformationEngine = new TransformationEngine();
        
		resolvedDefinition = new ArrayList<Definition>();
		objectFilePathMap = new HashMap<Object, String>();
		obj2FileNameRegistry = new HashMap();
		saveWSDLRegistry = new HashSet<Object>();  
		savedSchemas = new HashMap<XSDSchema, String>();
		setSourcePathToTargetPathAbsoluteRegistry(new HashMap<String, List<Object>>());
		setArtifatcsDefinitionRegistry(new HashSet<Object>());
		setScdlComponentPathRegistry(new ArrayList<String>());
		//AZ WMT 20070322
		setTopLevelDocumentRoot(new HashSet());
		setTimetableRegistry(new HashSet());
		
		setImportResourceMap(new HashMap<String,Resource>());

		ExportResult exportResult = new ExportResult();
		
		ExportSession exportSession=getExportSession();
		//exportSession.setExportResult(exportResult);	
		//put the project name into the export options hashmap
		//TODO AZ This should be revisted for cross project reference case
		exportSession.getExportOptions().getAdditionalOptions().put(TransformationSessionKeyConstants.PROJECT_NAME,getProjectName());	
		
		//AZ WMT 20070322 set the top level document root set in the export session
		exportSession.getExportOptions().getAdditionalOptions().put(TransformationSessionKeyConstants.TOP_LEVEL_DOCUMENT_ROOT,getTopLevelDocumentRoot());
		
		//GJD 20080422 set the registry for timetables in the export session
		exportSession.getExportOptions().getAdditionalOptions().put(TransformationSessionKeyConstants.TIMETABLE_NAME_REGISTRY, getTimetableRegistry());		
		
		//defect 165690 record the use import flag
		exportSession.getExportOptions().getAdditionalOptions().put(TransformationSessionKeyConstants.TASK_RESOURCE_USE_IMPORT_FLAG,new Boolean(TaskResourceImpl.getUseImports()));
		
		session = new TransformationSession();
		TransformationSessionUtil.setExportSession(session,exportSession);
		TransformationSessionUtil.setExportResult(session, exportResult);
		HashMap overrides = (HashMap)exportSession.getExportOptions().getAdditionalOption("VALID_FROM_OVERRIDE");
		TransformationSessionUtil.setValidFromOverride(session, overrides);
		aTransformationEngine.registerTransformationSession(session);
		
		//	aTransformationEngine.registerExportSession(exportSession);
		// TESetting teSetting = (TESetting)exportSession.getExportOptions().getAdditionalOption("TE_SETTING");
		WpsRuleHandlerFactory wpsRuleHandlerFactory = null;
		//AZ WMT 20070323 register rule handler factory
		if(BpelOptionsUtil.isMapModelGenerationEnabled()){
			wpsRuleHandlerFactory = new WpsRuleHandlerFactory();
			RuleHandlerRegistry.getInstance().registerHandlerFactory(wpsRuleHandlerFactory);			
		}		
		/* Are there any instructions as to whether we should save the outputs? */
		saveOutput = (Boolean)exportSession.getExportOptions().getAdditionalOption("SAVE_OUTPUT");
		if (saveOutput == null){
			saveOutput = Boolean.TRUE;
		}
		
		//Collection transformedCollection = null;
		
		exportSession.getExportOptions().setAdditionalOption("SELECTED_ELEMENTS", getModelElements());
		
		//transformedCollection = aTransformationEngine.execute(getModelElements(), teSetting);
		//Initialize the hashmap for object to file name registry		
		exportSession.getExportOptions().setAdditionalOption(TransformationSessionKeyConstants.OBJECT_TO_FILE_NAME_REGISTRY,obj2FileNameRegistry);		
		try{
			List modelElements = computeModelElements(exportSession);
			//in case we generate for d2d there will be only one Module for the Project that the element resides in. Caching the Project info is necessary for
			// the calculation of dependencies
			if(BpelOptionsUtil.isGenerateForDeployPatternEnabled()){
				if(modelElements.size() == 1){
					EObject toTransform = (EObject)modelElements.get(0);
					d2dtargetProjectName = CrossProjectReferenceUtil.getProjectNameForBOMElement(toTransform);
				}
			}
			if(modelElements != null && !modelElements.isEmpty()) transformedCollection = aTransformationEngine.execute(modelElements, exportSession);
		}catch(Exception e){
			//AZ 20070528 We have to clean up the rule handler factory in case of any failure
			//This is to avoid the default attribute value generation action to create map model
			if(wpsRuleHandlerFactory != null){
				RuleHandlerRegistry.getInstance().unregisterHandlerFactory(wpsRuleHandlerFactory);
			}		
			LoggingUtil.logError(MessageKeys.ERROR_IN_TRANSFORMATION, null, e);
			BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.ERROR_IN_TRANSFORMATION));
			throw runtimeEx;
		}
		monitor = exportSession.getProgressMonitor();
		if(monitor != null){
			monitor.worked(ProgressCalculator.getComplexTask());
		}
		
		if(monitor != null && monitor.isCanceled()){
			throw new OperationCanceledException();
		}
		
		fdlCommonDefFileName = getProjectName();
		
		persistTargets(transformedCollection);
						
		exportSession.setExportResult(exportResult);	
		exportResult.setErrorCount(LoggingUtil.getErrorCount());
		exportResult.setWarningCount(LoggingUtil.getWarningCount());
		
		//defect 165690 set the use import flag back to its original
		if(exportSession != null){
			Object useImportFlag = exportSession.getExportOptions().getAdditionalOptions().get(TransformationSessionKeyConstants.TASK_RESOURCE_USE_IMPORT_FLAG);
			if(useImportFlag instanceof Boolean){
				Boolean flagBoolean = (Boolean)useImportFlag;
				TaskResourceImpl.setUseImports(flagBoolean.booleanValue());
			}
		}
		
		//aTransformationEngine.deregisterExportSession();
		aTransformationEngine.deregisterTransformationSession();
		//AZ 20070511 unregister the rule handler factory
		if(wpsRuleHandlerFactory != null){
			RuleHandlerRegistry.getInstance().unregisterHandlerFactory(wpsRuleHandlerFactory);
		}		
		if(monitor != null){
			monitor.worked(ProgressCalculator.getSimpleTask());
		}	
		//defect 157473
		initialize();
		LoggingUtil.traceEntry(this, "exit");		
	}	
	/**
	 * Will add the Resources and Organization units to the list of selected elements.
	 * Currently the wizard is passing as additional elements all the Resurce and Org catalogs that are included in 
	 * all the Projects in the Project group. As there is no explicit reference between the Staff Query and  the Resources/Orh
	 * we need to process ALL the resources and Organization in the project group
	 * @param additionalElements
	 * @return
	 */
	private List computeModelElements(ExportSession exportSession) {
		//add additional resources and organizations for 
		List requiredElements = new LinkedList();
		requiredElements.addAll(getModelElements());
		if(exportSession != null && exportSession.getExportOptions() != null){
			Map options = exportSession.getExportOptions().getAdditionalOptions();
			if(options != null){
				Object registry = options.get(TransformationSessionKeyConstants.MODEL_ELEMENTS_PER_SESSION);
				if(!(registry instanceof List)){
					List<EObject> modelElements = new ArrayList<EObject>(getModelElements());
					options.put(TransformationSessionKeyConstants.MODEL_ELEMENTS_PER_SESSION, modelElements);
				}
			}			
		}		
		WpsExportOptionsBean exportBean = BpelOptions.getWpsOptions(exportSession);
		//defect 76466, the wps options is not available for the fdl export, so just return the original collection
		if(exportBean == null) return requiredElements;
		List additionalElements = exportBean.getExtraReferencedObjects();
		List extraElements = computeAdditionalModelElement(additionalElements);
		if(!extraElements.isEmpty()){
			requiredElements.addAll(extraElements);
		}
		return requiredElements;
	}
	
	/**
	 * Filters the list of additionalElements and retain only the Resources and Organizations.

	 * @param additionalElements
	 * @return
	 */
	private List computeAdditionalModelElement(List<Object> additionalElements){
		List<Object> requiredElements = new LinkedList();
		for(Object modelElement: additionalElements){
			if(modelElement instanceof ResourceModel || modelElement instanceof ResourceModel){
				requiredElements.addAll(computeAdditionalModelElement(((Model)modelElement).getOwnedMember()));
				//defect 75299
			}else if(modelElement instanceof com.ibm.btools.bom.model.resources.Resource || modelElement instanceof com.ibm.btools.bom.model.resources.Role){
				requiredElements.add(modelElement);
			}else if(modelElement instanceof OrganizationUnit){
				requiredElements.add(modelElement);
			}
		}
		return requiredElements;
	}

	/**
	 * Return true if there are additional export operations.
	 * Now assume only MM needs it.
	 * @return boolean
	 */
	private boolean hasAdditionExportOperations() {
		//	call BmMADExportOperation
		IExtensionPoint addiExpOpPoint = Platform.getExtensionRegistry().getExtensionPoint("com.ibm.btools.te.ilm.additionalExportOperations");
		IExtension[] extensions = addiExpOpPoint.getExtensions();
		if (extensions.length>0) {
			if (getExportSession().getExportOptions().getAdditionalOption(BpelOptions.BM_MM_OPTIONS)!=null) {
				return true;
			}
		}
		return false;
	}	
	
	/**
	 * invoke addtional export operations 
	 */ 
	private void invokeAdditionalExportOperations() {
		//	call BmMADExportOperation
		IExtensionPoint addiExpOpPoint = Platform.getExtensionRegistry().getExtensionPoint("com.ibm.btools.te.ilm.additionalExportOperations");
		IExtension[] extensions = addiExpOpPoint.getExtensions();
		for (IExtension extension : extensions) {
			IConfigurationElement[] elements = extension.getConfigurationElements();
			String className = null;
			for (IConfigurationElement element : elements) {
				className = element.getAttribute("class");
				//	Load the class
				Bundle plugin = Platform.getBundle(extension.getNamespace());
				try {						
					Class exportOperationClass = plugin.loadClass(className);
					IExportOperation exportOperation = (IExportOperation) exportOperationClass.newInstance();
					exportOperation.setName(element.getAttribute("name"));
					exportOperation.setModelElements(getModelElements());
					exportOperation.setOutputDir(getOutputDir());
					getExportSession().getExportOptions().getAdditionalOptions().put("WID_ABS_PATH_PREFIX", getAbsPathPrefix());
					getExportSession().getExportOptions().getAdditionalOptions().put("SRC_TO_TARGET_OBJ_MAP", getSourcePathToTargetPathAbsoluteRegistry());
					exportOperation.setExportSession(getExportSession());
					exportOperation.export();
				} catch (Exception e) {
					// skip
					e.printStackTrace();
					LoggingUtil.trace(this, "readExportOperations", "Cannot load the element class.");
					break;						
				}
			}
		}
	}
	
	private ProcessModel getCommonFdlModel() {
		if (commonFDLModel == null) {
			commonFDLModel= (ProcessModel)com.ibm.btools.fdl.model.ModelFactory.eINSTANCE.createProcessModel();
		}
		return commonFDLModel;			
	}
	
	private Resource getCommonFdlResource() {	
		if (commonFdlResource == null) {
//			d140334	String filePath = getAbsPathPrefix()+FDL_FILE_FOLDER + FILE_SEPARATOR + fdlCommonDefFileName + FDL_FILE_EXT;
			String filePath = getAbsPathPrefix();
			if (filePath.endsWith("\\/")) {		// root, e.g. "E:\\/"
				filePath = filePath.substring(0, filePath.length() - 1);
			}
			if (FDL_FILE_FOLDER == null || FDL_FILE_FOLDER == "") {
				filePath = filePath + fdlCommonDefFileName + FDL_FILE_EXT;
			} else {
				filePath = filePath + FDL_FILE_FOLDER + FILE_SEPARATOR + fdlCommonDefFileName + FDL_FILE_EXT;
			}
			URI fileURI = URI.createFileURI(filePath);
			commonFdlResource = getFdlResourceFactory().createResource(fileURI);
		}
		return commonFdlResource;
	}
	
	/**
	 * Need to update the path of the BPEL file.  The component file will be sitting in the root directory thus
	 * separate from the implementation file.
	 * @param component
	 * @param implPath
	 */
	private void fixImplementationPath(Component component, String implPath) {
		if (implPath!=null && implPath.trim().length()>0) {
			Implementation impl = component.getImplementation();
			if (impl instanceof ProcessImplementation) {
				TProcess tProc = ((ProcessImplementation)impl).getProcess();
				if (tProc!=null) {
					String bpelFileName = tProc.getBpel();
					bpelFileName = FILE_SEPARATOR+implPath+bpelFileName;
					bpelFileName=bpelFileName.replace(File.separatorChar,FILE_SEPARATOR.charAt(0));
					tProc.setBpel(bpelFileName);					
				}
			} else if (impl instanceof TaskImplementation) {
				com.ibm.wsspi.sca.scdl.task.TTask tTask = ((TaskImplementation)impl).getTask();
				if (tTask!=null) {
					String fileName = tTask.getTel();
					fileName = FILE_SEPARATOR+implPath+fileName;
					fileName=fileName.replace(File.separatorChar,FILE_SEPARATOR.charAt(0));
					tTask.setTel(fileName);					
				}
			}
		}
		
	}
	
	/** Add the location to the WSDL imports. 
	 *
	 * @param process
	 */
	private void fixImport(Process process, String absolutePath) {
		String relativePath = filePathManager.getPath(process);
		Iterator<com.ibm.wbit.bpel.Import> it = process.getImports().iterator();
		
		int count=0;
		count = ExportOperationUtil.countFileSegment(relativePath)-1;
		String backwardPath = ExportOperationUtil.buildBackwardPath(count);
		String importNamespace = null;
		com.ibm.wbit.bpel.Import importObj = null;
		String fileExt = null;
		String fixedLocation = null;
		String importLocation = null;
		String fullLocation = null;
		String fixedURILocation = null;
		List<com.ibm.wbit.bpel.Import> duplicateImports = null;
		Set bpelImports = new HashSet();  
		boolean oneTimeChange = true;
		
		while (it.hasNext()) {
			fullLocation = null;
			Object obj = it.next();
			if(obj instanceof com.ibm.wbit.bpel.Import){ 
				importObj = (com.ibm.wbit.bpel.Import)obj;
				String key = ExportOperationUtil.createKeyForProcessImport(importObj);
				String encodedFixedURILocation = null;
				
				List values = this.sourcePathToTargetPathAbsoluteRegistry.get(key);
				//AZ 06/21/07 Fix the duplicate tns+name
//				if(values == null){
//					//try to find the case we append "#projectName" to identify					
//					values=CrossProjectReferenceUtil.searchForBusinessObjectValuesByDependency(key,sourcePathToTargetPathAbsoluteRegistry, process);
//				}
				if (values != null && values.size() > 1) {
					fullLocation = (String)values.get(1);
				}
				if (fullLocation != null) {
					fullLocation = ExportOperationUtil.replaceConvertedSpaces(fullLocation);
					if (fullLocation.startsWith(URI_FILE)) {
						fixedURILocation = ExportOperationUtil.reconcilePaths(fullLocation.substring(6), absolutePath,getAbsPathPrefix().length());
					} else {
						fixedURILocation = ExportOperationUtil.reconcilePaths(fullLocation, absolutePath,getAbsPathPrefix().length());
					}
				if (fixedURILocation != null) {
//						try {
//							encodedFixedURILocation = URIEncoder.encode(fixedURILocation, "UTF-8");
//						} catch (Exception e) {
//							String params[] = {fixedURILocation};
//							LoggingUtil.logError(MessageKeys.ERROR_ENCODING_SCHEMA_LOCATION, params, null);
//							BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.ERROR_ENCODING_SCHEMA_LOCATION));
//							throw runtimeEx;
//						}
						//AZ defect 149073
					    encodedFixedURILocation = fixedURILocation;
						encodedFixedURILocation = ExportOperationUtil.flatenRelativePath(encodedFixedURILocation);
						importObj.setLocation(encodedFixedURILocation);
						if(bpelImports.contains(importObj.getNamespace() + importObj.getLocation())) {
							if (duplicateImports == null) {
								duplicateImports = new ArrayList<com.ibm.wbit.bpel.Import>();
							}
							duplicateImports.add(importObj);
						} else {
							bpelImports.add(importObj.getNamespace() + importObj.getLocation());
						}
						continue;
					}   
				}
				importLocation = importObj.getLocation();
				if(importLocation.indexOf("/") != -1){
					importLocation = importLocation.substring(importLocation.lastIndexOf("/") + 1);
				}
				fixedLocation = importLocation;
				importNamespace = importObj.getNamespace();
				fileExt = ExportOperationUtil.extractFileExtension(importLocation);
				
				if (fileExt.equals(importLocation)) {
					continue;
				}
				
				if (fileExt == null || fileExt.length()==0) {
					// Assume it is an WSDL file by default
					fileExt = WSDL_FILE_EXT;
				}
				if (fileExt.equals(WSDL_FILE_EXT)) {
					String WSDLName = ExportOperationUtil.stripFileExtension(importLocation,fileExt);					
					fixedLocation=filePathManager.getPath(Definition.class,importNamespace,WSDLName);
					if (count > 0 && fixedLocation.indexOf(File.separatorChar) != -1 && backwardPath.length() > 3 && oneTimeChange) {
						backwardPath = backwardPath.substring(3);
						fixedLocation = fixedLocation.substring(fixedLocation.indexOf(File.separatorChar) + 1);
						oneTimeChange = false;
					}
				}else if (fileExt.equals(XSD_FILE_EXT)){
					fixedLocation=filePathManager.getPath(XSDSchema.class,importNamespace,null);
				}else if(fileExt.equals(WSDL_FILE_EXT) && PROCESS_SCHEMA_IMPORT.equals(importObj.getImportType())){
					String WSDLName = ExportOperationUtil.stripFileExtension(importLocation,fileExt);				
				}else if (fileExt.equals(ITEL_FILE_EXT) || fileExt.equals(TEL_FILE_EXT)){
					String telFileName = ExportOperationUtil.stripFileExtension(importLocation, fileExt);
					fixedLocation=filePathManager.getPath(TTask.class, importNamespace, telFileName);
				}
				relativePath = relativePath.replace('\\', '/');
				if (!fixedLocation.equals(relativePath)) {
					if (fileExt.equals(XSD_FILE_EXT)) {
						fullLocation = absolutePath.substring(0, absolutePath.indexOf(relativePath)) +
						fixedLocation.substring(0, fixedLocation.length() - 1) +
						fileExt;
						if (fullLocation != null) {
							fullLocation = ExportOperationUtil.replaceConvertedSpaces(fullLocation);
							fixedURILocation = ExportOperationUtil.reconcilePaths(fullLocation, absolutePath,getAbsPathPrefix().length());
							if (fixedURILocation != null) {
//								try {
//									encodedFixedURILocation = URIEncoder.encode(fixedURILocation, "UTF-8");
//								} catch (Exception e) {
//									String params[] = {fixedURILocation};
//									LoggingUtil.logError(MessageKeys.ERROR_ENCODING_SCHEMA_LOCATION, params, null);
//									BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.ERROR_ENCODING_SCHEMA_LOCATION));
//									throw runtimeEx;
//								}
								encodedFixedURILocation = fixedURILocation;
								importObj.setLocation(encodedFixedURILocation);
								if(bpelImports.contains(importObj.getNamespace() + importObj.getLocation())) {
									if (duplicateImports == null) {
										duplicateImports = new ArrayList<com.ibm.wbit.bpel.Import>();
									}
									duplicateImports.add(importObj);
								} else {
									bpelImports.add(importObj.getNamespace() + importObj.getLocation());
								}
								continue;
							}   
						}
					} else {	// existing code - prior to 20061118
						fixedLocation = backwardPath+fixedLocation+importLocation;
						fixedLocation=fixedLocation.replace(File.separatorChar,FILE_SEPARATOR.charAt(0));
						if(isInBpelNamespace(importObj,process.getTargetNamespace())){
							importObj.setLocation(fixedLocation.substring(fixedLocation.lastIndexOf("/")+1));
						}else{
							importObj.setLocation(fixedLocation);
						}
					}
				} 
			}			
		}
		// remove duplicate imports
		if (duplicateImports != null && !duplicateImports.isEmpty()) {
			Iterator<com.ibm.wbit.bpel.Import> duplicateIt = duplicateImports.iterator();
			while (duplicateIt.hasNext()) {
				importObj = duplicateIt.next();
				process.getImports().remove(importObj);
			}
		}
	}
	
	private boolean isInBpelNamespace(com.ibm.wbit.bpel.Import importObject, String bpelNamespace){
		String importNamespace = importObject.getNamespace();
		if (importNamespace.indexOf("/") > -1) {
			importNamespace = importNamespace.substring(0,importNamespace.lastIndexOf("/"));
		}
		if(importNamespace.equals(bpelNamespace)){
			return true;
		}
		return false;
	}
	
	private boolean isInWsdlNamespace(Import importObject,String wsdlNamespace){
		String importNamespace = importObject.getNamespaceURI();
		if (importNamespace.indexOf("/") > -1) {
			importNamespace = importNamespace.substring(0,importNamespace.lastIndexOf("/"));
		}
		wsdlNamespace = wsdlNamespace.substring(0,wsdlNamespace.indexOf(ARTIFACTS_SUFFIX));
		if(importNamespace.equals(wsdlNamespace)){
			return true;
		}		
		return false;		
	}
	
	private void fixFormPath(TTask task) {
		TUISettings uiSettings = task.getUiSettings();
		if (uiSettings!=null) {
			if (!uiSettings.getCustomClientSettings().isEmpty()) {
				for (Iterator it = uiSettings.getCustomClientSettings().iterator();it.hasNext();) {
					TCustomClientSettings customClientSettings = (TCustomClientSettings)it.next();
					if (customClientSettings.getClientType().equals(HumanTaskUtil.CLIENT_SETTING_TYPE_LOTUS_FORMS)) {
						for (Iterator it2=customClientSettings.getCustomSetting().iterator(); it2.hasNext();) {
							TCustomSetting customSetting = (TCustomSetting)it2.next();
							//defect 81750:-)
							if(!HumanTaskUtil.CLIENT_SETTING_LOTUS_FORMS_INPUT_PARAMETER.equals(customSetting.getName()) &&  !HumanTaskUtil.CLIENT_SETTING_LOTUS_FORMS_OUTPUT_PARAMETER.equals(customSetting.getName())){
							String uid = customSetting.getValue();
							//defect 85458
							if(uid == null) return;
							uid = uid.substring(0,uid.indexOf("/"));
							String path = filePathManager.getPath(uid);
							//could not find the path in the pathManager based on the returned uid.
							if(path == null){
								//use the Task path in this case TODO verify the path manager registry
								path = filePathManager.getPath(task);
								path=path.replace('\\', '/');
								path="/"+path;
								String tempPath = customSetting.getValue();
								tempPath = tempPath.substring(tempPath.lastIndexOf(HumanTaskUtil.CUSTOM_SETTING_DELIMITER)+3,tempPath.length());
								String updatedPath = path+tempPath;
								//get the Form content saved as customSetting value
								String value = customSetting.getValue().substring(0,customSetting.getValue().indexOf(HumanTaskUtil.CUSTOM_SETTING_DELIMITER));
								//udpate the customSettingValue
								customSetting.setValue(updatedPath);
								try{
									String absPathPrefix = getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar);
						    		// Compose the absolute target path and save the Form
						    		tempPath=absPathPrefix+updatedPath;
									File formFile = new File(tempPath);
									if(!formFile.exists()){
										FileOutputStream fos = new FileOutputStream(new File(tempPath));
										BufferedWriter out = new BufferedWriter(new OutputStreamWriter(fos, "UTF8"));
										out.write(value);
								        out.close();
									}
								}catch(IOException ioEx){
						  			String [] params = new String[1];
					    			params[0]=tempPath;
					    			//do not raise the error if this is Lib only defect 842028.
					    			if(!BpelOptionsUtil.isLibraryOnly()){
					    				LoggingUtil.logError(MessageKeys.FAILED_TO_PERSIST_XFDL_FILE, params, ioEx);
					    				BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.FAILED_TO_PERSIST_XFDL_FILE));
//										AR failed to serialize the Form is not serious enough to fail the transformation, rather will log an error.					    				
//					    				runtimeEx.setChainedException(ioEx);
//					    				throw runtimeEx;
					    			}
								}
							}else{
								path=path.replace('\\', '/');
								path="/"+path;
	//							String tempPath = path.substring(0,path.length()-1);
	//							tempPath=tempPath.substring(tempPath.lastIndexOf("/")+1,tempPath.length());
	//							path = path+tempPath+LOTUS_FORM_EXT;
								String tempPath = customSetting.getValue();
								tempPath = tempPath.substring(tempPath.lastIndexOf("/")+1,tempPath.length());
								customSetting.setValue(path+tempPath);
							}
						}
						}
					}
				}
			}
		}
	}
	/** Add the location to the WSDL imports. 
	 * @param telPath the path of TTask that encloses the import
	 * @param process
	 */
	private void fixImport(TTask task, String telPath) {
		//String relativePath = filePathManager.getPath(task);
//		String relativePath = filePathManager.getProjectRelativePath(task);
		String fixedLocation = null;
		TImport importObj = task.getImport();
		if(importObj == null)
			return;
		
//		int count = (ExportOperationUtil.countFileSegment(relativePath))-1;
//		String backwardPath = ExportOperationUtil.buildBackwardPath(count);
//		String importNamespace;
//		String fileExt;	
//		
//		importNamespace = importObj.getNamespace().toString();
//		fileExt = ExportOperationUtil.extractFileExtension(importObj.getLocation().toString());
//		if (fileExt == null || fileExt.length()==0) {
//			// Assume it is an WSDL file by default
//			fileExt = WSDL_FILE_EXT;
//		}
//		String importLocation = importObj.getLocation().toString();
//		String WSDLName = ExportOperationUtil.stripFileExtension(importLocation,fileExt);	
		//fixedLocation=filePathManager.getPath(Definition.class,importNamespace,WSDLName);
//		fixedLocation=filePathManager.getProjectRelativePath(Definition.class,importNamespace,WSDLName);
		String key = ExportOperationUtil.createKeyForTTaskImport(importObj);
		List values = this.sourcePathToTargetPathAbsoluteRegistry.get(key);
		if(values != null && values.size()> 1){
			String wsdlAbsPath = (String)values.get(1);
			if (wsdlAbsPath != null) {
				wsdlAbsPath = ExportOperationUtil.replaceConvertedSpaces(wsdlAbsPath);
				if (wsdlAbsPath.startsWith(URI_FILE)) {
					fixedLocation = ExportOperationUtil.reconcilePaths(wsdlAbsPath.substring(6), (getAbsPathPrefix()+telPath),getAbsPathPrefix().length());
				} else {
					fixedLocation = ExportOperationUtil.reconcilePaths(wsdlAbsPath, (getAbsPathPrefix()+telPath),getAbsPathPrefix().length());
				}
			if (fixedLocation != null) {//					
					fixedLocation = ExportOperationUtil.flatenRelativePath(fixedLocation);
					importObj.setLocation(URI.createURI(fixedLocation));					
				}   
			}
		}
//		if (!fixedLocation.equals(relativePath)) {
//			fixedLocation = backwardPath+fixedLocation+importLocation;
//			fixedLocation=fixedLocation.replace(File.separatorChar,FILE_SEPARATOR.charAt(0));
//			importObj.setLocation(URI.createURI(fixedLocation));
//		}
	}	
	
	private Definition createArtifactsDefinition(List definitions,Process process){
		List<Object> partnerLinks = new LinkedList<Object>();
		Definition wsdlArtifactsDefinition=null;
		Definition definition = null;		
		if(definitions != null && !definitions.isEmpty()){
			for(int i=0; i<definitions.size(); i++){
				definition = (Definition)definitions.get(i);
				if(definition.getExtensibilityElements() != null && !definition.getExtensibilityElements().isEmpty()){
					List<Object> extElem = definition.getExtensibilityElements();
					List<Object> defPartnerLinks = new ArrayList<Object>();
					Iterator<Object> it = extElem.iterator();
					while(it.hasNext()){
						Object obj =it.next();
						if( obj instanceof PartnerLinkType){							
							defPartnerLinks.add(obj);
						}
					}
					// remove PartnerLinkType from the Definitions						
					extElem.removeAll(defPartnerLinks);					
					partnerLinks.addAll(defPartnerLinks);
				}
			}
		}
		if(!partnerLinks.isEmpty()){			
			
			wsdlArtifactsDefinition = WSDLFactory.eINSTANCE.createDefinition();
			String relativePath;
			relativePath = filePathManager.getPath(process);	
			String projectRelativePath = filePathManager.getProjectRelativePath(process);
			//name of the artifacts definition is based on the name of the Process + Artifacts
			String wsdlArtifactsName = process.getName() + ExportOperation.ARTIFACTS_SUFFIX;
			
			String fileName = wsdlArtifactsName + WSDL_FILE_EXT;
			
			String relativeFilePath = relativePath+fileName;		
			String filePath = getAbsPathPrefix()+relativeFilePath;
			if(filePath.indexOf(FILE_SEPARATOR) != -1){
				filePath = filePath.replace(FILE_SEPARATOR_CHAR,File.separatorChar);
			}
			
			//Artifacts namespace same as the Process namespace
			String encodedNamespace = process.getTargetNamespace() + ExportOperation.ARTIFACTS_SUFFIX;
			wsdlArtifactsDefinition.setTargetNamespace(encodedNamespace);
			
			javax.xml.namespace.QName qname = new javax.xml.namespace.QName(encodedNamespace,wsdlArtifactsName);
			wsdlArtifactsDefinition.setQName(qname);		
			//add traditional namespaces
			wsdlArtifactsDefinition.addNamespace("tns", encodedNamespace);
			wsdlArtifactsDefinition.addNamespace("xsd", XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001);
			wsdlArtifactsDefinition.addNamespace("wsdl", "http://schemas.xmlsoap.org/wsdl/");
			
			//add first the import of the Definition as that one is not in the list of the Definition import
			for(int i=0; i<definitions.size(); i++){
				definition = (Definition)definitions.get(i);
				Import wsdlImport = WSDLFactory.eINSTANCE.createImport();
				//Handle business service interface import
				if(definition.getLocation()!= null && ExportOperationUtil.isExternalFile(definition.getLocation())){
					wsdlImport.setLocationURI(definition.getLocation());
				}else{
					wsdlImport.setLocationURI(definition.getQName().getLocalPart()+ExportOperation.WSDL_FILE_EXT);
				}
				wsdlImport.setDefinition(definition);
				wsdlImport.setNamespaceURI(definition.getTargetNamespace());
				if(!wsdlArtifactsDefinition.getImports().containsKey(definition.getTargetNamespace())){
					wsdlArtifactsDefinition.addImport(wsdlImport);	
				}
				String prefix = DataDefinitionUtil.getPrefixFromNamespaceURI(definition.getTargetNamespace());
				if(definition.getLocation()!= null && ExportOperationUtil.isExternalFile(definition.getLocation())){
					prefix = definition.getPrefix(definition.getTargetNamespace());
				}
				if (wsdlArtifactsDefinition.getNamespace(prefix) == null){
					//register the prefix for the namespace
					wsdlArtifactsDefinition.addNamespace( prefix, definition.getTargetNamespace());
				}
				List imports = definition.getEImports();
				List tempImports = new LinkedList(imports);
				
				if(tempImports != null && !tempImports.isEmpty()){
					for(int j=0; j<tempImports.size(); j++){
						Import thisImport = (Import)tempImports.get(j);
						//GJD200701	if(wsdlArtifactsDefinition.getNamespace(thisImport.getNamespaceURI()) == null){
						if(!ExportOperationUtil.wsdlContainsImport(wsdlArtifactsDefinition, thisImport)){
							//Make sure the import's enclosing definition has been changed, otherwise, DOM Exception when saving						
							thisImport.setEnclosingDefinition(wsdlArtifactsDefinition);
							wsdlArtifactsDefinition.addImport(thisImport);							
							prefix = definition.getPrefix(thisImport.getNamespaceURI());
							wsdlArtifactsDefinition.addNamespace(prefix, thisImport.getNamespaceURI());
							//we can now remove the namespace declaration from the "cleaned" of PartnerLinks definition. 
							//it is safe to assume that the namespaces will not be used, they correspond to the namespaces 
							//of imported WSDL definitions. 
							definition.getNamespaces().remove(prefix);								
						}
					}
				}			
				filePathManager.setPath(wsdlArtifactsDefinition,relativePath); // the WSDLArtifactsDefinition sits in the relativePath
				filePathManager.setProjectRelativePath(wsdlArtifactsDefinition,projectRelativePath);
				//fixImport(wsdlArtifactsDefinition, filePath);
			}
			
			  
			//Due to the model persistence issue, we create a fresh copy of the partner link types	
			wsdlArtifactsDefinition.getExtensibilityElements().addAll(FabricIntegrationUtil.clonePartnerLink(partnerLinks,wsdlArtifactsDefinition,process));
         		
			//wsdlArtifactsDefinition.getExtensibilityElements().addAll(partnerLinks);			
//			
//			// NOTE: namespaces and prefixes are generated in the Transformation	
//			
//			Iterator<Object> it = partnerLinks.iterator();
//			PartnerLinkType link = null;
//			while (it.hasNext()) {
//				link = (PartnerLinkType)it.next();
//				link.setEnclosingDefinition(wsdlArtifactsDefinition);				
//				if (link.getRole() != null && !link.getRole().isEmpty()){
//					Iterator roleIt = link.getRole().iterator();
//					com.ibm.wbit.bpel.services.partnerlinktype.Role role = null;
//					while (roleIt.hasNext()) {
//						role = (com.ibm.wbit.bpel.services.partnerlinktype.Role)roleIt.next();
//						role.setEnclosingDefinition(wsdlArtifactsDefinition);						
//						if (role.getPortType() != null) {
//							role.getPortType().setEnclosingDefinition(wsdlArtifactsDefinition);								
//						}
//					}
//				}
//			}	
//			
//			wsdlArtifactsDefinition.updateElement(true);
			
			//AZ 20070131 explicitly add artifacts definition import into the process
			com.ibm.wbit.bpel.Import artifactsImport = BPELFactory.eINSTANCE.createImport();
			artifactsImport.setLocation(fileName);
			artifactsImport.setImportType(AbstractbpelConstants.WSDL_IMPORT_TYPE);
			artifactsImport.setNamespace(encodedNamespace);
			if(process != null){
				process.getImports().add(artifactsImport);
			}
		}		
		return wsdlArtifactsDefinition;
	}
	
	private void fixArtifactsImportsSave(Definition wsdlArtifactsDefinition,Process process,ResourceSet resourceSet){
		String relativePath = null;
		relativePath = filePathManager.getPath(process);	
		String projectRelativePath = filePathManager.getProjectRelativePath(process);
		//name of the artifacts definition is based on the name of the Process + Artifacts
		String wsdlArtifactsName = process.getName() + ExportOperation.ARTIFACTS_SUFFIX;
		
		String fileName = wsdlArtifactsName + WSDL_FILE_EXT;
		
		String relativeFilePath = relativePath+fileName;		
		String filePath = getAbsPathPrefix()+relativeFilePath;
		if(filePath.indexOf(FILE_SEPARATOR) != -1){
			filePath = filePath.replace(FILE_SEPARATOR_CHAR,File.separatorChar);
		}
		
		ResourceFactoryImpl resourceFactory = getWsdlResourceFactory();	
		
		//AZ Add registry for the artifacts definition 
		ExportOperationUtil.createRegistryForResource(resourceFactory,resourceSet,
				getSourcePathToTargetPathAbsoluteRegistry(),
				wsdlArtifactsDefinition, 
				getAbsPathPrefix(),
				relativePath,
				obj2FileNameRegistry, null);
		
//		Retrieve the resource for the artifacts definition
		String key = wsdlArtifactsDefinition.getTargetNamespace()+ fileName;
		Object artifactValueListObj = getSourcePathToTargetPathAbsoluteRegistry().get(key);
		if(artifactValueListObj instanceof List){
			List  values = (List)artifactValueListObj;
			if(values.size() > 1){
				Object resourceObj = values.get(0);
				Object targetPathObj = values.get(1);

				//AZ 06/20/2007 Add to support WID compare/merge functionality
				if(BpelOptionsUtil.isMapModelGenerationEnabled()){
					if(CrossProjectReferenceUtil.getSourceForTarget(process)!=null){
						EObject processSource = CrossProjectReferenceUtil.getSourceForTarget(process);
						//d83889.2 - MappingManager.addMapDefinition has a check that will only allow one Definition to be associated with an activity, 
						//to establish a mapping for the bpel artifacts file, we need to bypass this check by calling createMapDefinition directly
						CrossProjectReferenceUtil.registerTranformTargetWithProjectName(processSource, wsdlArtifactsDefinition);
						MappingManager.getInstance().createMapDefinition(processSource, wsdlArtifactsDefinition);
						if(targetPathObj != null){
							objectFilePathMap.put(wsdlArtifactsDefinition,(String)targetPathObj);
						}
					}
				}				
				//AZ 0110 We should save the artifacts definition in the last step in case that
				//the referenced artifacts are not saved yet
				if(resourceObj instanceof WSDLResourceImpl && targetPathObj instanceof String){
					if(!getArtifatcsDefinitionRegistry().contains(resourceObj)){
						getArtifatcsDefinitionRegistry().add(resourceObj);
					}
				}
			}
		}
	}
	
	private Resource createResource(Object element, ResourceSet resourceSet) {
		Resource resource = null;
		if (BpelOptionsUtil.isExportSCDLArtifactsOnly()) {
			if (!(element instanceof DocumentRoot)) {
				return null;
			} 
		}
		String relativeFilePath=null;
		String relativePath = filePathManager.getPath(element);
		ResourceFactoryImpl resourceFactory=null;
		String namespace = TransformationSessionUtil.getProcessedElementNamespace(TransformationEngine.getTransformationSession(), (EObject)element);		
		String fileName = null;


		String namespaceWithFileName = null;
		String externalElementSourceLocation = null;
		Definition inlineDefinition = null;
		String filePath = getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar);
		String scdlImportFilePath = filePath;

		if (element instanceof XSDSchema && !((XSDSchema)element).getContents().isEmpty()) {
			//defect 78712, do not save the schema is namespace is part if the Schema namespace, will be imported from net location
			if (savedSchemas.containsKey(element) || org.eclipse.xsd.util.XSDUtil.isSchemaForSchemaNamespace(((XSDSchema)element).getTargetNamespace())
					|| org.eclipse.xsd.util.XSDUtil.isSchemaInstanceNamespace(((XSDSchema)element).getTargetNamespace())
							|| org.eclipse.xsd.util.XSDUtil.isXMLNamespace(((XSDSchema)element).getTargetNamespace()) 
							|| org.eclipse.xsd.util.XSDUtil.isXMLNSNamespace(((XSDSchema)element).getTargetNamespace())){
				return null;
			}
			XSDSchema xsd = (XSDSchema)element;
			resourceFactory = getXsdResourceFactory();
			if (relativePath==null ||relativePath.length() == 0 ) {
				relativePath = createFilePathFromNamespace(xsd.getTargetNamespace());
			}
			
			if (xsd.getTargetNamespace() != null && this.obj2FileNameRegistry.containsKey(xsd.getSchemaLocation() + xsd.getTargetNamespace())) {
				inlineDefinition = (Definition)this.obj2FileNameRegistry.get(xsd.getSchemaLocation() + xsd.getTargetNamespace()); //if inline schema, try to get the path for the Definition
			}
			
			String originalSchemaLocation = null;
			if(xsd.getSchemaLocation() != null){
				originalSchemaLocation = (ExportOperationUtil.replaceConvertedSpaces(xsd.getSchemaLocation())).replace(FILE_SEPARATOR.charAt(0), File.separatorChar);  
			}
			
			if (ExportOperationUtil.isExternalFile(originalSchemaLocation)) {
				externalElementSourceLocation = ExportOperationUtil.replaceConvertedSpaces(xsd.getSchemaLocation());
				fileName = originalSchemaLocation.substring(originalSchemaLocation.lastIndexOf(File.separator) + 1);
				if (fileName == null) {
					String params[] = {xsd.getTargetNamespace()};
					LoggingUtil.logError(MessageKeys.ERROR_COPYING_ORIGINAL_XSD_DEFINITION, params, null);
					BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.ERROR_COPYING_ORIGINAL_XSD_DEFINITION));
					throw runtimeEx;
				}
				relativeFilePath = (ExportOperationUtil.calculateRelativeTargetLocation(externalElementSourceLocation, relativePath)).replace(FILE_SEPARATOR_CHAR, File.separatorChar);
				if (inlineDefinition != null) {	// inline schema
					this.saveWSDLRegistry.add(relativeFilePath);
				} else if (fileName.endsWith(XSD_FILE_EXT)) {					
					//process the xsd imports, include, and redefine
					if (xsd.getSchemaLocation() != null) {
						ExportOperationUtil.processXSDImportIncludeRedefine(xsd, getSourcePathToTargetPathAbsoluteRegistry(), filePath, relativePath);
					}
				}
			} else {	//GJD 20060817: code prior to reuse xsd
				relativeFilePath = relativePath+createFileNameFromNamespace(xsd.getTargetNamespace())+XSD_FILE_EXT;
				//process the xsd imports, include, and redefine
				if (xsd.getSchemaLocation() != null) {
					ExportOperationUtil.processXSDImportIncludeRedefine(xsd, getSourcePathToTargetPathAbsoluteRegistry(), filePath, relativePath);
				}
				namespaceWithFileName = xsd.getTargetNamespace();
				fileName = relativeFilePath.substring(relativeFilePath.lastIndexOf(File.separatorChar) + 1);
			}
//GJD20070925			savedSchemas.add(xsd);
		} else if (element instanceof Definition) {
			Definition definition  = (Definition)element;
			resourceFactory = getWsdlResourceFactory();
			//AZ d142188 Add registry to handle multiple operation external service export,
			//in which overwrite option will be prompted, There still a overwrite prompt
			//we only save registry for external file
			String defLocation = definition.getLocation(); 
			if(defLocation != null &&
					ExportOperationUtil.isExternalFile(defLocation)&&
					defLocation.indexOf(FILE_SEPARATOR) != -1){
				relativeFilePath = relativePath + defLocation.substring(defLocation.lastIndexOf(FILE_SEPARATOR)+1);
				if(relativeFilePath != null && !saveWSDLRegistry.contains(relativeFilePath)){
					this.saveWSDLRegistry.add(relativeFilePath); 
				}
			}
		} else if (element instanceof Process) {			
			resourceFactory = getBpelResourceFactory();
			if (relativePath == null) {
				relativePath = createFilePathFromNamespace(namespace)+FILE_SEPARATOR;				
			}
			relativeFilePath = relativePath+((Process)element).getName()+BPEL_FILE_EXT;
			fixImport((Process)element, (getAbsPathPrefix() + relativeFilePath).replace(File.separatorChar, FILE_SEPARATOR_CHAR));
			fileName = ((Process)element).getName()+BPEL_FILE_EXT;
		} else if (element instanceof ProcessModel) {
			resourceFactory = getFdlResourceFactory();
			relativeFilePath = FDL_FILE_FOLDER + FILE_SEPARATOR + fdlCommonDefFileName + FDL_FILE_EXT;
		} else if (element instanceof com.ibm.btools.fdl.model.Process) {
			resourceFactory = getFdlResourceFactory();
			relativeFilePath = ((com.ibm.btools.fdl.model.Process)element).getName();
		}else if(element instanceof HumanTask){
			//}else if(element instanceof TTask){
			HumanTask ht =(HumanTask)element;
			com.ibm.wbit.tel.DocumentRoot dr = ((com.ibm.wbit.tel.DocumentRoot)((HumanTask)ht).getHumanTask());
			boolean isInline = ht.isInline();
			TTask task = dr.getTask();
			resourceFactory = getTELResourceFactory();
			fileName = "";
			if(isInline){
				fileName = task.getName() + ITEL_FILE_EXT;
			}else{
				fileName = task.getName() + TEL_FILE_EXT;
			}
			namespace = task.getTargetNamespace().toString();
			relativePath = filePathManager.getPath(task);
			relativeFilePath = relativePath + fileName;
			fixImport(task, relativeFilePath);
			fixFormPath(task);
			element = dr;
		} else if (element instanceof DocumentRoot) {
			resourceFactory = getSCDLResourceFactory();
			DocumentRoot dr = (DocumentRoot)element;
			if (dr.getComponent()!=null) {
				fileName = dr.getComponent().getName()+ SCA_COMPONENT_FILE_EXT;	
				if (BpelOptionsUtil.isPersistSCDLComponentToRootFolder()) {
					fixImplementationPath(dr.getComponent(),relativePath);					
				}
				//fixReferencedComponentPath(dr.getComponent());
			} else if (dr.getExport() != null) { 
				fileName = dr.getExport().getName()+ SCA_EXPORT_FILE_EXT;		
			} else if (dr.getImport() !=null) {
				fileName = dr.getImport().getName()+ SCA_IMPORT_FILE_EXT;		
			} else if (dr.getModule()!=null) {
				fileName = SCA_MODULE_FILENAME+ SCA_MODULE_FILE_EXT;
			}
			fileName=createFileNameFromNamespace(fileName);			
			relativeFilePath = relativePath + fileName;
			//AZ Persist DA configuration file if applicable L015750
			persistDynamicAssemblerConfiguration(resourceSet, relativePath, filePath, dr);	
		}else if(element instanceof SACLRoot){
			SACLRoot saclRoot = (SACLRoot)element;
			StateMachineDefinition smdef = saclRoot.getStateMachineDefinition();
			resourceFactory = new SACLResourceFactoryImpl();
			fileName = smdef.getName() + ExportOperation.SACL_FILE_EXT;
			fileName=createFileNameFromNamespace(fileName);		
			namespace = smdef.getTargetNamespace().toString();
			relativeFilePath = relativePath + fileName;
			element = saclRoot;
		}else if (element instanceof com.ibm.wbit.sib.mediation.operation.model.DocumentRoot) {
			//resourceFactory = getMFCResourceFactory();
			com.ibm.wbit.sib.mediation.operation.model.DocumentRoot dr = (com.ibm.wbit.sib.mediation.operation.model.DocumentRoot)element;
			resourceFactory = new MediationFlowResourceFactoryImpl();
			InterfaceMediationFlow imf = dr.getInterfaceMediationFlow();
			if(imf != null){
				fileName = imf.getName();
				fileName=createFileNameFromNamespace(fileName)+ ".mfc";			
				relativeFilePath = relativePath + fileName;
				
			}
			
		}else if (element instanceof EPackage) {
			//resourceFactory = getMFCResourceFactory();
			resource = ((EPackage)element).eResource();
			fileName = createFileNameFromNamespace(resource.getURI().toString());
			relativeFilePath = relativePath + fileName;
			filePath = filePath + relativeFilePath;			
			resource.setURI(URI.createFileURI(filePath));
			return resource;
			
		}else if(element instanceof BusinessRuleGroup){
			BusinessRuleGroup brg = (BusinessRuleGroup)element;
			resourceFactory = new BrgResourceFactoryImpl();
			fileName = brg.getName() + ExportOperation.BRG_FILE_EXT;
			fileName = createFileNameFromNamespace(fileName);	
			namespace = brg.getTargetNameSpace().toString();
			relativeFilePath = relativePath + fileName;
		}else if(element instanceof BusinessRuleGroupTable){
			BusinessRuleGroupTable brgt = (BusinessRuleGroupTable)element;
			resourceFactory = new BrgResourceFactoryImpl();
			fileName = brgt.getName() + ExportOperation.BRGT_FILE_EXT;
			fileName = createFileNameFromNamespace(fileName);	
			namespace = brgt.getTargetNameSpace().toString();
			relativeFilePath = relativePath + fileName;
		}else if(element instanceof RuleSet){
			RuleSet rSet = (RuleSet)element;
			resourceFactory = new ModelResourceFactoryImpl();
			fileName = rSet.getName() + ExportOperation.RULESET_FILE_EXT;
			fileName = createFileNameFromNamespace(fileName);
			//TODO can this be null?: namespace = rSet.getTargetNamespace().toString();
			relativeFilePath = relativePath + fileName;
		}else if(element instanceof com.ibm.wbit.br.core.model.DocumentRoot 
				&& ((com.ibm.wbit.br.core.model.DocumentRoot)element).getRuleSet() != null){
			RuleSet rSet = ((com.ibm.wbit.br.core.model.DocumentRoot)element).getRuleSet();
			resourceFactory = new ModelResourceFactoryImpl();
			fileName = rSet.getName() + ExportOperation.RULESET_FILE_EXT;
			fileName = createFileNameFromNamespace(fileName);
			//TODO can this be null?: namespace = rSet.getTargetNamespace().toString();
			relativeFilePath = relativePath + fileName;			
		}else if(element instanceof JavaImplementation){
			if(!isLibraryProjectOnly()){
				Component component = ((JavaImplementation)element).getComponent();
				String javaImplementation = ((JavaImplementation)element).getJavaImplementation();
				String javaFileName = ScdlUtil.getTargetSimpleTypeName(component) + ExportOperation.JAVA_FILE_EXT;
				javaFileName = createFileNameFromNamespace(javaFileName);
				relativeFilePath = relativePath + javaFileName;	
				String javaFilePath = getAbsPathPrefix()+relativeFilePath;
				fileName = javaFileName;
				//now save the file
				FileWriter out = null;
				try{
					File javaImplFile = new File(javaFilePath);
					javaImplFile.createNewFile();
					out = new FileWriter(javaImplFile);
					out.write(javaImplementation);
				}catch(IOException ex){
					//log exception.. 
					BTRuntimeException e = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.TE_FAILED_TO_CREATE_JAVA_IMPLEMENTATION));
					e.setChainedException(ex);
					LoggingUtil.logError(MessageKeys.TE_FAILED_TO_CREATE_JAVA_IMPLEMENTATION);
				}finally{
					if(out != null){
						try{
							out.close();
						}catch(Exception ex){
							LoggingUtil.logError(MessageKeys.UNABLE_WRITE_TO_FILE, new String[]{javaFileName}, null);
						}
					}
				}
			}
			return null;
		} else if(element instanceof ICalendar){
			ICalendar iCal = (ICalendar)element;
			resourceFactory = new CalResourceFactoryImpl();
			fileName = iCal.getName() + ExportOperation.CAL_FILE_EXT;
			relativeFilePath = relativePath + fileName;
		}
		
		
		if(element instanceof Definition){		
			//AZ put the source and target path in the registry
			Definition elementDef = (Definition)element;
			String originalPath = (elementDef).getLocation();
			String registryKey = null;
			if(originalPath == null){
				registryKey = ExportOperationUtil.getAbsolutePathForSource(element,getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar),relativePath,elementDef.getTargetNamespace());
			}else{
				registryKey = ExportOperationUtil.normalizeImportLocation(originalPath);
			}			

			if (originalPath == null && getSourcePathToTargetPathAbsoluteRegistry().containsKey(registryKey)) {
				Object value = getSourcePathToTargetPathAbsoluteRegistry().get(registryKey);
				if(value instanceof List){
					List valueList = (List)value;
					if(valueList.size() > 1){
						Object targetFilePath = valueList.get(1);
						this.saveWSDLRegistry.add(targetFilePath);						
					}
				}
				return null;
			}

			ExportOperationUtil.createRegistryForResource(resourceFactory,
					resourceSet,
					getSourcePathToTargetPathAbsoluteRegistry(),
					element,
					getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar),
					relativePath,
					obj2FileNameRegistry, 
					objectFilePathMap
			);
			Object value = getSourcePathToTargetPathAbsoluteRegistry().get(registryKey);
			if(value instanceof List){
				List valueList = (List)value;
				if(valueList.size() > 0){
					Object resourceObj = valueList.get(0);
					this.saveWSDLRegistry.add(valueList.get(1));
					if(resourceObj instanceof Resource){
						//AZ WMT 20070323 
						String objFilePath = relativePath+ExportOperationUtil.computeNameFromDefinitionObject((Definition)element);
						objectFilePathMap.put(element,objFilePath);
						return (Resource)resourceObj;				
					}
				}				
			}
			return null;
		} else if (inlineDefinition != null) {
			//AZ put the source and target path in the registry
			ExportOperationUtil.createRegistryForResource(getWsdlResourceFactory(),
					resourceSet,
					getSourcePathToTargetPathAbsoluteRegistry(),
					inlineDefinition,
					getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar),
					null,
					obj2FileNameRegistry,
					objectFilePathMap
			);
			Definition elementDef = inlineDefinition;
			String originalPath = elementDef.getLocation();
			String registryKey = null;
			if(originalPath == null){
				registryKey = ExportOperationUtil.getAbsolutePathForSource(elementDef,getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar),relativePath,elementDef.getTargetNamespace());
			}else{
				registryKey = ExportOperationUtil.normalizeImportLocation(originalPath);
			}			
			Object value = getSourcePathToTargetPathAbsoluteRegistry().get(registryKey);
			if(value instanceof List){
				List valueList = (List)value;
				if(valueList.size() > 0){
					Object resourceObj = valueList.get(0);
					if(resourceObj instanceof Resource){
					//PMR 17765,999,000
					//defect 167662					
						String projectOrModule = "";
						String pathNoProject = null;
						if (relativeFilePath.indexOf(File.separatorChar) != -1) {
							projectOrModule = relativeFilePath.substring(0, relativeFilePath.indexOf(File.separatorChar) + 1);
							pathNoProject = relativeFilePath.substring(relativeFilePath.indexOf(File.separatorChar) + 1);
						} else {
							pathNoProject = relativeFilePath;
						}
						if (savedSchemas.containsValue(pathNoProject.toLowerCase())) {
							pathNoProject = ExportOperationUtil.generateUniqueXSDPath(pathNoProject, savedSchemas.values());
							relativeFilePath = projectOrModule + pathNoProject;
						}
						this.savedSchemas.put((XSDSchema)element, pathNoProject.toLowerCase());
						return (Resource)resourceObj;				
					}
				}				
			}
			return null;			
		}

		// d128635			
		// create a unique name based on relative path - make folder unique; e.g. "businessitem2\businessitem.xsd"
		if (element instanceof XSDSchema) {
			XSDSchema xsd = (XSDSchema)element;
			String pathNoProject = null;
			String projectOrModule = "";
			if (!ExportOperationUtil.isExternalFile(xsd.getSchemaLocation())) {
				if (relativePath.indexOf(File.separatorChar) != -1) {
					projectOrModule = relativePath.substring(0, relativePath.indexOf(File.separatorChar) + 1);
					pathNoProject = relativePath.substring(relativePath.indexOf(File.separatorChar) + 1);
				} else {
					pathNoProject = relativePath;
				}
//				String fName = ExportOperationUtil.calculateFileNameFromCatalogue(relativePath);
				//defect 92443 compute from the targetnamespace to be symmetrical to the datadefinitionrule look up
				//mechanism, which is based on the targetnamespace
				String fName = createFileNameFromNamespace(xsd.getTargetNamespace());
				
				//defect 92880 decode the encoded name to its original form
				fName = NamespaceUtils.convertUriToNamespace(fName);
				
				//JR32289 We mangle the schema name by prefixing the library project name in the existing schema name
				//The schema folder name will no longer be mangled. However, this rule is only applicable to library 
				//involved export context
				
				fName = ExportOperationUtil.generateUniqueSchemaName(xsd,fName);
				
//				if (savedSchemas.containsValue((pathNoProject + fName + XSD_FILE_EXT).toLowerCase())) {
//					pathNoProject = ExportOperationUtil.generateUniqueXSDPath(pathNoProject + fName + XSD_FILE_EXT, savedSchemas.values());
//					relativeFilePath = projectOrModule + pathNoProject;
//					savedSchemas.put(xsd, pathNoProject.toLowerCase());
//				} else {
					relativeFilePath = relativePath+fName + XSD_FILE_EXT;
					savedSchemas.put(xsd, (pathNoProject + fName + XSD_FILE_EXT).toLowerCase());
//				}
			} else {
				if (relativeFilePath.indexOf(File.separatorChar) != -1) {
					projectOrModule = relativeFilePath.substring(0, relativeFilePath.indexOf(File.separatorChar) + 1);
					pathNoProject = relativeFilePath.substring(relativeFilePath.indexOf(File.separatorChar) + 1);
				} else {
					pathNoProject = relativeFilePath;
				}
				if (savedSchemas.containsValue(pathNoProject.toLowerCase())) {
					pathNoProject = ExportOperationUtil.generateUniqueXSDPath(pathNoProject, savedSchemas.values());
					relativeFilePath = projectOrModule + pathNoProject;
				}
				savedSchemas.put(xsd, pathNoProject.toLowerCase());
			}
		}

		filePath = filePath + relativeFilePath;		
		URI fileURI = URI.createFileURI(filePath);
		//AZ WMT 20070323 		
		objectFilePathMap.put(element,relativeFilePath);

		//AZ 0111 This assertion is to ensure the component name uniqueness
		if(element instanceof DocumentRoot && ((DocumentRoot)element).getComponent() != null){
			if(getScdlComponentPathRegistry() != null){
				if(getScdlComponentPathRegistry().contains(filePath)){
					//This case means that there are duplication of component name in the same folder
					String params[]={((DocumentRoot)element).getComponent().getName()};
					LoggingUtil.logError(MessageKeys.TE_ATTRIBUTES_DUPLICATE_NAME, params, null);
				}else{
					getScdlComponentPathRegistry().add(filePath);
				}
			}
		}

		if (resourceFactory != null) {
			
			//AR directToDeploy enhancement. This path calculates the imports to be generated based on the Project group references. 
			//For directToDeploy we can rely on the imports created during transformation due to the fact that all the referenced elements
			//are in separate modules, so the import should be generated
			if(CrossProjectReferenceUtil.isImportDocumentRoot(element) && !BpelOptionsUtil.isNoneOption() && !BpelOptionsUtil.isGenerateForDeployPatternEnabled() && !CrossProjectReferenceUtil.isSCABindingImport(element) && !ScdlUtil.isCallbackImport(element)){
				CrossProjectReferenceUtil.createResourceForSCDLImport(getSCDLResourceFactory(), resourceSet, element, scdlImportFilePath, relativeFilePath, getImportResourceMap(), objectFilePathMap);
				return null;
			}else{
				resource = resourceFactory.createResource(fileURI);
				if(resource instanceof TaskResourceImpl){
					TaskResourceImpl.setUseImports(true);
				}
				resourceSet.getResources().add(resource);
				resource.getContents().add((EObject)element);
			}
			//store the element in the registry
			//resource is created in the target location.
			if (element instanceof XSDSchema) {
				if (externalElementSourceLocation != null) {
					List<Object> value = new ArrayList<Object>(2);
					//target resource (XSD)
					value.add(0, resource);
					value.add(1, fileURI.toString());
					getSourcePathToTargetPathAbsoluteRegistry().put(externalElementSourceLocation, value);
				} else {	// key = tns + fileName (resource created in Modeler)
					if (namespaceWithFileName == null) {
						namespaceWithFileName = fileName;
					} else {
						namespaceWithFileName = namespaceWithFileName + fileName;
					}
					// Ray Fix for Share Across Project - for persisting mutliple XSDSchemas with same namespace
					// Ensure the SourcePathToTargetPathAbsoluteRegistry uses unique key in the case
					// where more than one schemas has the same namespace and filename.  Also ensure
					// the key matches to the <include> location created earlier (See ClassRuleImpl's OrganizeImports method)
//					if (getSourcePathToTargetPathAbsoluteRegistry().get(namespaceWithFileName)!=null) {
//					// all schemas are registered based on its tns and only include the hashcode in the key when there is a conflict in the registry
//					namespaceWithFileName = element.hashCode()+namespaceWithFileName;						
//					}
					//AZ Fix the registry by appending the project name of the artifatcs, which will be unique
					//in identifying the key for the fact that BOs with same name and targetnamespace can
					//reside in different projects
//					String projectName = CrossProjectReferenceUtil.getProjectNameForTargetObject(element);
//					if(projectName != null){
//						namespaceWithFileName = namespaceWithFileName+"#"+projectName;
//					}
					List<Object> value = new ArrayList<Object>(2);
					value.add(0, resource);
					value.add(1, fileURI.toString());
					getSourcePathToTargetPathAbsoluteRegistry().put(namespaceWithFileName, value);
				}
			}
			return resource;
		}
		return null;
	}

	private void processUnClassifiedSA(SolutionArtifact sa, ResourceSet resourceSet){
		List artifacts = (List) sa.getComposedArtifacts();
		Iterator caIt = artifacts.iterator();
		Iterator ucaIt;
		UnclassifiedArtifact uca;
		List ucaArtifacts;
		Resource resource=null;
		while (caIt.hasNext())
		{
			uca = (UnclassifiedArtifact)caIt.next();
			ucaArtifacts = uca.getArtifacts();
			ucaIt = ucaArtifacts.iterator();
			if (uca.getType()==UnclassifiedArtifactType.WORKFLOW_DEFINITION_LITERAL)
			{

				while (ucaIt.hasNext())
				{
					Object obj = ucaIt.next();
					if (obj instanceof Program) {
						getCommonFdlModel().getPrograms().add(obj);
					}else if(obj instanceof ProcessCategory){
						getCommonFdlModel().getProcessCategories().add(obj);
					}else if(obj instanceof DataStructure){
						getCommonFdlModel().getDataStructures().add(obj);

					}else if(obj instanceof Person){
						Staff staff = getCommonFdlModel().getStaff();
						if(staff == null){
							staff = ModelFactory.eINSTANCE.createStaff();
							getCommonFdlModel().setStaff(staff);
						}
						staff.getPerson().add(obj);

					}else if(obj instanceof Organization){
						Staff staff = getCommonFdlModel().getStaff();
						if(staff == null){
							staff = ModelFactory.eINSTANCE.createStaff();
							getCommonFdlModel().setStaff(staff);
						}
						staff.getOrganization().add(obj);
					}else if(obj instanceof Role){
						Staff staff = getCommonFdlModel().getStaff();
						if(staff == null){
							staff = ModelFactory.eINSTANCE.createStaff();
							getCommonFdlModel().setStaff(staff);
						}
						staff.getRole().add(obj);
					}
				}
				getCommonFdlResource().getContents().add(getCommonFdlModel());
				resourceSet.getResources().add(getCommonFdlResource());
			} else {
				while (ucaIt.hasNext()) {
					Object obj = ucaIt.next();
					if (obj instanceof Form) {
						persistForm((Form)obj);
					} else if (obj instanceof ICalendar) {
						resource = createResource(obj, resourceSet);
						if (resource != null) {
//							doSave(resource, null);						
							Map<String, String> options = new HashMap<String, String>();
							options.put(XMLResource.OPTION_ENCODING, "UTF-8");
							doSave(resource, options);
						}
					} else {
						resource = createResource(obj, resourceSet);						
					}
				}			
			}

		}			
	}

	/**
	 * Persist Form to file system
	 * @param form
	 */
	private void persistForm (Form form) {
		// Obtain project info from the Form
        String projectName = ResourceMGR.getResourceManger().getProjectName(form);
        // Object the attached Form information
        String projectPath = FileMGR.getProjectPath(projectName);
        String xfdlFilename = HumanTaskUtil.getAttachedFormFilename(form);
        if (xfdlFilename!=null) {
        	String bomRelURI = ResourceMGR.getResourceManger().getRelativeURI(form);
        	String originalLocation = projectPath + 
										File.separator + 
										bomRelURI.substring(0,bomRelURI.lastIndexOf(File.separator)+1);
    		// Get the registered relative target path from the FilePathManager
            String outputPath=filePathManager.getPath(form);
    		// Get the target directory set by user
    		String absPathPrefix = getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar);
    		// Compose the absolute target path
    		outputPath=absPathPrefix+outputPath;
    		try {
    			copyFile(originalLocation,xfdlFilename,outputPath,xfdlFilename);
    		} catch (IOException ioEx) {
    			String [] params = new String[1];
    			params[0]=outputPath+xfdlFilename;
    			LoggingUtil.logError(MessageKeys.FAILED_TO_PERSIST_XFDL_FILE, params, ioEx);
    			BTRuntimeException runtimeEx = new BTRuntimeException(TEResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.FAILED_TO_PERSIST_XFDL_FILE));
    			runtimeEx.setChainedException(ioEx);
    			throw runtimeEx;			
    		}
        }
        
	}
	
	/**
	 * Copy files from one location to another
	 * @param sourceFilePath
	 * @param sourceFileName
	 * @param targetDirectoryPath
	 * @param targetFileName
	 * @throws IOException
	 */
	private void copyFile (String sourceFilePath, String sourceFileName, String targetDirectoryPath, String targetFileName) throws IOException {
		File inputFile = new File(sourceFilePath+sourceFileName);
		// Creates the directories 
		File file = new File(targetDirectoryPath);
		file.mkdirs();
		// Add the file name to the path
		targetFileName=targetDirectoryPath+targetFileName;	
		File outputFile = new File(targetFileName);
		// Copy the file to target path
		FileInputStream reader = new FileInputStream(inputFile);
		FileOutputStream writer = new FileOutputStream(outputFile);		
	    int ch;
	    while ((ch = reader.read()) != -1) {
	    	writer.write(ch);
	    }
	    reader.close();
	    writer.close();		
	}
	
	private void processHumanTaskSA(SolutionArtifact sa, ResourceSet resourceSet){
		List artifacts = (List) sa.getComposedArtifacts();
		Iterator caIt = artifacts.iterator();
		Iterator ucaIt;
		HumanTask humanTaskSa;
		List ucaArtifacts;
		Resource resource=null;

		for(int i=0; i<artifacts.size(); i++){
			humanTaskSa = (HumanTask)artifacts.get(i);
			resource = createResource(humanTaskSa, resourceSet);
			if (resource != null) {
				resourceSet.getResources().add(resource);						
				doSave(resource, null);
			}		
			if (!humanTaskSa.isInline()){
				TTask task = ((com.ibm.wbit.tel.DocumentRoot)humanTaskSa.getHumanTask()).getTask();
				// d139598 check the flag				
				// Map teOptions = (Map)getExportSession().getExportOptions().getAdditionalOption(BpelOptions.WPS_OPTIONS);
				WpsExportOptionsBean teOptions = (WpsExportOptionsBean)getExportSession().getExportOptions().getAdditionalOption(BpelOptions.WPS_OPTIONS);
				if (teOptions != null) {
					//Boolean defaultEvent = (Boolean)teOptions.get(BpelOptions.WPS_ENABLE_DEFAULT_EVENTS);
//					boolean defaultEvent = teOptions.getWpsEnableDefaultEvents();
					//if (defaultEvent != null && defaultEvent.booleanValue()) {
//					if(defaultEvent){  // enable events based on business measures specified
						Resource monResource = createMonResource(task, resource);
						resourceSet.getResources().add(monResource);
						Map<String, String> options = new HashMap<String, String>();
						options.put(MonResourceImpl.OPTION_MONITOR_TYPE, MonResourceImpl.OPTION_TYPE_TASK);
						doSave(monResource, options);
//					}
				}
			} else {
				URI uri = resource.getURI();
				String fileURI = uri.toFileString();
				File itelFile = new File(fileURI);
				XMLStamper xmlStamper = new XMLStamper();
				String path = uri.path();
				// get the filename
				String fileName=uri.segment(uri.segmentCount()-1);
				// convert the itel filename to the process filename, base on the assumption that
				// it is prepended with the process name (required by WID)
				int indexOfUnderscoreInFileName = fileName.indexOf("_");
				int indexOfFileName = fileURI.indexOf(fileName);
				int indexOfUnderscoreInPath = indexOfFileName+indexOfUnderscoreInFileName;
				fileURI = fileURI.substring(0, indexOfUnderscoreInPath)+".bpel";
				// Now fix the path so that is only includes the path starting from the Module/Library name
				String pathPrefix = getAbsPathPrefix().replace(FILE_SEPARATOR.charAt(0), File.separatorChar);
				path = fileURI.substring(pathPrefix.length()-1, fileURI.length());
				xmlStamper.stamp(itelFile, "UTF-8", new String[] {path}, null);
			}
		}
	}

	
	private List<SolutionArtifact> processScdlSA(SolutionArtifact sa, ResourceSet resourceSet){
		List artifacts = (List) sa.getComposedArtifacts();
		Iterator caIt = artifacts.iterator();
		Iterator ucaIt;
		com.ibm.btools.te.ilm.model.sa.ScdlArtifact cSA;
		Resource resource=null;

		List<SolutionArtifact> processAfterSchemas = null;

		while (caIt.hasNext()){
			cSA = (com.ibm.btools.te.ilm.model.sa.ScdlArtifact)caIt.next();

			// process PROCESS after schemas are created 
			if(cSA.getArtifact() instanceof Process){
				if (processAfterSchemas == null) {
					processAfterSchemas = new ArrayList<SolutionArtifact>();
				}
				processAfterSchemas.add(sa);
				continue;
			}
			//AZ Skip save the interface which is referenced within processflow	
			if(cSA.getArtifact() instanceof Definition){
				if(isInterfaceInProcessFlow((Definition)cSA.getArtifact(),transformedCollection))
					continue;
			}			
			resource = createResource(cSA.getArtifact(), resourceSet);			
			//AZ WMT 20070326 skip save for the artifacts definition
			if(ExportOperationUtil.isArtifactsDefinition(cSA.getArtifact())){
				if(!getArtifatcsDefinitionRegistry().contains(resource)){
					getArtifatcsDefinitionRegistry().add(resource);
				}
				continue;
			}
			if (resource != null) {
				resourceSet.getResources().add(resource);	
				//defect 116657
				Map<String, String> options = new HashMap<String, String>();
				options.put(XMLResource.OPTION_ENCODING, "UTF-8");
				doSave(resource, options);
			}	
		}

		return processAfterSchemas;
	}

	// copied from processSCDLSA above
	private void processDeferredScdlSA(List<SolutionArtifact> saList, ResourceSet resourceSet){

		if (saList == null || saList.isEmpty()) {
			return;
		}

		Iterator<SolutionArtifact> it = saList.iterator();
		SolutionArtifact sa = null;

		while (it.hasNext()) {
			sa = it.next();
			List artifacts = (List) sa.getComposedArtifacts();

			if (artifacts == null || artifacts.isEmpty()) {
				continue;
			}

			Iterator caIt = artifacts.iterator();
			Iterator ucaIt;
			com.ibm.btools.te.ilm.model.sa.ScdlArtifact cSA;
			Resource resource=null;

			List processAfterSchemas = null;

			while (caIt.hasNext()){
				cSA = (com.ibm.btools.te.ilm.model.sa.ScdlArtifact)caIt.next();		
				EObject procObject = cSA.getArtifact();
				if(procObject instanceof Process){
					if(isProcessDefInProcessFlow((Process)procObject,transformedCollection))
						continue;
				}
				resource = createResource(cSA.getArtifact(), resourceSet);
				//AZ WMT 20070326 skip creation of artifacts definition, the regsitry will create the resource
				//later, otherwise, they overwrite each other
				if(ExportOperationUtil.isArtifactsDefinition(cSA.getArtifact())){
					continue;
				}
				if (resource != null) {
					resourceSet.getResources().add(resource);	
					//defect 116657
					Map<String, String> options = new HashMap<String, String>();
					options.put(XMLResource.OPTION_ENCODING, "UTF-8");
					doSave(resource, options);
				}	
			}
		}
	}

	private void processProcessFlowSA(SolutionArtifact sa, ResourceSet resourceSet) {
		List artifacts = (List) sa.getComposedArtifacts();		
		Iterator caIt = artifacts.iterator();		
		Resource resource=null;
		ProcessFlow pf;
		while (caIt.hasNext())
		{
			pf = (ProcessFlow)caIt.next();
			if (pf.getType()==ProcessFlowType.BPEL_LITERAL || pf.getType()==ProcessFlowType.BPELPP_LITERAL)
			{
				Process processImpl = (Process) pf.getProcessDefinition();
				
//				if(FabricIntegrationUtil.shouldSkipProcessFlow(pf)){			
//					continue;
//				}
				List defs = pf.getProcessInterface();			
				if (defs != null && !defs.isEmpty()) {
					Definition artifactsDefinition = createArtifactsDefinition(defs,processImpl);
					Iterator it = defs.iterator();
					while(it.hasNext()){
						Definition def = (Definition)it.next();						
						
						//Due to the WSDL EMF limitation, we need to load the original WSDL definition in case
						//that the process refers to a business service as interface
						boolean isProcessInterfaceDef = false;
						EObject ne = null;
						//Load the original WSDL to persist because it's polluted						
						if(FabricIntegrationUtil.isProcessInterfaceDefinition(def) && FabricIntegrationUtil.isBusinessServiceInterface(def)){
							ne = CrossProjectReferenceUtil.getSourceForTarget(def);
							def  = OriginalWsdlUtil.getCachedOriginalWSDL((NamedElement)CrossProjectReferenceUtil.getSourceForTarget(def));
							obj2FileNameRegistry.put(def,def.getLocation());
							isProcessInterfaceDef = true;
						}
						
						resource = createResource(def, resourceSet);
						
						//Add mapping for the original WSDL definition which is the interface of the process
						if(isProcessInterfaceDef && BpelOptionsUtil.isMapModelGenerationEnabled()&& ne != null){
							MappingManager mappingMgr = MappingManager.getInstance();
							mappingMgr.addMapDefinition(ne, def);
							List<Object> targetDefPath = (getSourcePathToTargetPathAbsoluteRegistry().get(ExportOperationUtil.normalizeImportLocation(def.getLocation())));	
							if(targetDefPath != null){
								objectFilePathMap.put(def,(String)targetDefPath.get(1));
							}													
						}	
						//PMR the same definition processed multiple times which screw up the import locations, bypass the import location fix
						if(!resolvedDefinition.contains(def)){
							ExportOperationUtil.fixImport(def,getSourcePathToTargetPathAbsoluteRegistry(), false,getAbsPathPrefix().length());
						}
						if (resource != null) {
							doSave(resource,null);
						}
					}
					//To avoid exception while updating element for the defintion, the import
					//will be fixed and saved after all the referenced partner interfaces were created
					//and saved
					if(artifactsDefinition != null){
						fixArtifactsImportsSave(artifactsDefinition,processImpl,resourceSet);
					}
				}
				if (processImpl != null) {
					resource = createResource(processImpl, resourceSet);
					if (resource != null) {
						resourceSet.getResources().add(resource);
						doSave(resource, null);
						if (BpelOptionsUtil.isTargetDiamondCompatible()){
							//  d139598: check the flag
							//Map teOptions = (Map)getExportSession().getExportOptions().getAdditionalOption(BpelOptions.WPS_OPTIONS);
							WpsExportOptionsBean teOptions = (WpsExportOptionsBean)getExportSession().getExportOptions().getAdditionalOption(BpelOptions.WPS_OPTIONS);
							if (teOptions != null) {
//								boolean defaultEvent = teOptions.getWpsEnableDefaultEvents();//.get(BpelOptions.WPS_ENABLE_DEFAULT_EVENTS);
								// if (defaultEvent != null && defaultEvent.booleanValue()) {
//								if(defaultEvent){   // enable events based on business measures specified
									Resource monResource = createMonResource(processImpl, resource);
									resourceSet.getResources().add(monResource);
									Map<String, String> options = new HashMap<String, String>();
									options.put(MonResourceImpl.OPTION_MONITOR_TYPE, MonResourceImpl.OPTION_TYPE_BPEL);
									doSave(monResource, options);
//								}
							}
						}
					}
				}	

			} else if (pf.getType()==ProcessFlowType.FDL_LITERAL) {
				com.ibm.btools.fdl.model.Process processImpl = (com.ibm.btools.fdl.model.Process) pf.getProcessDefinition();
				getCommonFdlModel().getProcesses().add(processImpl);
				getCommonFdlResource().getContents().add(getCommonFdlModel());
				resourceSet.getResources().add(getCommonFdlResource());
			}
		}

	}


//	/**
//	 * Returns the ExtensibilityElement attached to e that has the Class c
//	 * 
//	 * @param haystack The ExtensibleElement to search through 
//	 * @param needle The Class of ExtensibilityElement to look for
//	 * @return The ExtensibilityElement whose class matches c;
//	 */
//	public ExtensibilityElement getExtensibilityElement(ExtensibleElement haystack, Class needle){
//		ExtensibilityElement e = null;
//		for (Iterator it = haystack.getEExtensibilityElements().iterator(); it.hasNext(); ){
//			e = (ExtensibilityElement)it.next();
//			if (e.getClass() == needle){
//				return e;
//			}
//		}
//
//		return null;            
//	}

	/**
	 * Configures an EMF Resource for the .mon file created for each .tel file
	 * @param humanTask The TTask that is represented in the .tel file
	 * @param htResource The Resource to configure 
	 * @return htResource for convenience
	 */
	private Resource createMonResource(TTask humanTask, Resource htResource){
		/* This is a diamond-compatible process flow, so create the .mon file */
		com.ibm.wbit.cei.model.mon.DocumentRoot monDocRoot = MonFactoryImpl.eINSTANCE.createDocumentRoot();

		MonitorType monType = MonFactoryImpl.eINSTANCE.createMonitorType();
		monDocRoot.setMonitor(monType);

		MapType configurationMapType = MonFactoryImpl.eINSTANCE.createMapType();
		AssociationType configAssocType = MonFactoryImpl.eINSTANCE.createAssociationType();
		configAssocType.setKey("FULL_MODE");
		configAssocType.setValue("FIELDS");
		configurationMapType.getEntry().add(configAssocType);
		monType.setConfiguration(configurationMapType);
		// defect 160462
		monType.setVersion(VersionType._61_LITERAL);
		
		// TODO: Is there somewhere that I can access these strings as constants?
		monType.setKind("http://www.ibm.com/xmlns/prod/websphere/scdl/human-task/6.0.0");
		monType.setName(humanTask.getName());
		monType.setTargetName(humanTask.getName());
		monType.setTargetNamespace(humanTask.getTargetNamespace() + ":" + humanTask.getName());
		monType.getEventSource().add(createEventSourceType("Task:/" + humanTask.getName(), "FULL"));  // End-to-end monitoring
//		monType.getEventSource().add(createEventSourceType("Task:/" + humanTask.getName(), "EMPTY"));

		monResourceFactory = new MonResourceFactoryImpl();
		Resource resource = monResourceFactory.createResource(null);

		/* The standard is for the .mon file to have the same name as the human task, with '_tel.mon' added */
		URI uri = htResource.getURI().trimSegments(1).appendSegment(humanTask.getName() + "_tel.mon");
		resource.setURI(uri);
		resource.getContents().add(monDocRoot);
		return resource;

	}


	/**
	 * Created the extension model (.modulex) for the module and sets the display name.
	 * @param rs ResourceSet
	 * @param extensionModelURI URI 
	 * @return module for Module
	 */
	public void createExtensionModel(ResourceSet rs, URI extensionModelURI, Module module) throws IOException {
		
		// Create a new extension model
		Resource extensionModel = rs.createResource(extensionModelURI);
		
		// Create extension map
		ExtensionMap extensionMap = ExtensionmodelFactory.eINSTANCE.createExtensionMap(SCDLPackage.eNS_URI);
		extensionMap.initializeAdapter();
		
		extensionModel.getContents().add(extensionMap);

		// Create module extension and set DisplayNameShown to true
		ModuleExtension moduleExtension = GraphicalExtensionFactory.eINSTANCE.createModuleExtension();
		moduleExtension.setShowDisplayName(true);
		
		//defect 89958 reference to 89897
		moduleExtension.setAutoLayout(true);
		
		extensionMap.put(module, moduleExtension);
		//defect 90562
		Map<String, String> options = new HashMap<String, String>();
		options.put(XMLResource.OPTION_ENCODING, "UTF-8");
		extensionModel.save(options);
		
		//extensionModel.save(Collections.EMPTY_MAP);
	}

	
	/**
	 * Configures an EMF Resource for the .mon file created for a .bpel file
	 * @param process The top-level BPEL process
	 * @param processResource The Resource to configure 
	 * @return processResource for convenience
	 */
	private Resource createMonResource(Process process, Resource processResource){
		/* This is a diamond-compatible process flow, so create the .mon file */
		com.ibm.wbit.cei.model.mon.DocumentRoot monDocRoot = MonFactoryImpl.eINSTANCE.createDocumentRoot();
		
		MonitorType monType = MonFactoryImpl.eINSTANCE.createMonitorType();
		monDocRoot.setMonitor(monType);
		
		// TODO: Is there somewhere that I can access these strings as constants?
		monType.setKind("http://www.ibm.com/xmlns/prod/websphere/scdl/business-process/6.0.0");
		monType.setName(process.getName());
		monType.setTargetName(process.getName());
		monType.setTargetNamespace(process.getTargetNamespace() + ":" + process.getName());
		// defect 160462
		monType.setVersion(VersionType._61_LITERAL);
		
		// assume no default events
		monType.setEnableDefaultEvents(false);
		
		MapType configurationMapType = MonFactoryImpl.eINSTANCE.createMapType();
		AssociationType configAssocType = MonFactoryImpl.eINSTANCE.createAssociationType();
		configAssocType.setKey("FULL_MODE");
		configAssocType.setValue("FIELDS");
		configurationMapType.getEntry().add(configAssocType);
		monType.setConfiguration(configurationMapType);
		
		MapType attributesMapType = MonFactoryImpl.eINSTANCE.createMapType();
		AssociationType associationType = MonFactoryImpl.eINSTANCE.createAssociationType();
		associationType.setKey("IdentifyingAttribute");
		associationType.setValue("wpc:id");
		attributesMapType.getEntry().add(associationType);
		monType.setAttributes(attributesMapType);
		
		// Grace: enable events based on business measures specified
//		List<Process> elementsToMonitorList = new ArrayList<Process>();
//		extractMonitoredElements(process, elementsToMonitorList);
//		
//		while (!elementsToMonitorList.isEmpty()){
//			ExtensibleElement element = elementsToMonitorList.remove(0);
//			String id = ((Id)getExtensibilityElement(element, IdImpl.class)).getId().toString();
//			Task staffTask = (Task)getExtensibilityElement(element, TaskImpl.class);
//			Script javaScript = (JavaScriptActivity)getExtensibilityElement(element, JavaScriptActivityImpl.class);
//			String payload = "FULL"; // "EMPTY";   // End-to-end monitoring
//			String typeName = element.eClass().getInstanceClassName();
//			typeName = typeName.substring(typeName.lastIndexOf('.')+1);
//			if (typeName.equals("BPELVariable")){
//				typeName = "Variable";
//				/* The variable updated events are the only events that require payload data */
//				payload = "FULL";
//			} else if (staffTask != null){
//				/* Special settings for a staff activity */
//				typeName = "Staff";
//			} else if (javaScript != null){
//				/* Special settings for a java snippet */
//				typeName = "Script";
//			}
//			typeName += (":/" + id);
//			monType.getEventSource().add(createEventSourceType(typeName, payload));
//		}
		
		monResourceFactory = new MonResourceFactoryImpl();
		Resource resource = monResourceFactory.createResource(null);
		
		/* The standard is for the .mon file to have the same name as the process, with '_bpel.mon' added */
		URI uri = processResource.getURI().trimSegments(1).appendSegment(process.getName() + "_bpel.mon");
		resource.setURI(uri);
		resource.getContents().add(monDocRoot);
		return resource;
		
	}
	
	/**
	 * Creates and EventSourceType object with all monitoring enabled.  This is the default
	 * EventSourceType object used for monitoring.
	 * 
	 * @param typeName The name to assign to the EventSourceType created
	 * @return The EventSourceType created
	 */
	private EventSourceType createEventSourceType(String typeName, String payload){
		EventSourceType eventSourceType = MonFactoryImpl.eINSTANCE.createEventSourceType();
		eventSourceType.setName(typeName);
		eventSourceType.getProperty().add(PropertyType.CEI_LITERAL);
		
		/* NOTE: Turning on all events for the BPEL Activities will automatically turn
		 * on the 'link evaluated to true' events, since they are on the <flow> activities */
		EventType eventType = MonFactoryImpl.eINSTANCE.createEventType();
		eventType.setActive(true);
		eventType.setName("ALL");
		eventType.setPayload(payload);
		eventType.setLabel("");
		eventType.setTx(TXType.SAME_LITERAL);
		
		eventSourceType.getEvent().add(eventType);
		
		return eventSourceType;
	}
	
	private List<Process> extractMonitoredElements(Process process, List<Process> elementsToMonitorList){
		elementsToMonitorList.add(process);
		BpelOptimizationUtil.getAllActivities(process, elementsToMonitorList);
		BpelOptimizationUtil.getAllVariables(process, elementsToMonitorList);
		return elementsToMonitorList;
	}
	
	private boolean isLibraryProjectOnly(){
//		return (BpelOptionsUtil.isWPSCreateLibrary() && 
//		!BpelOptionsUtil.isWPSCreateModule());
		return BpelOptionsUtil.isLibraryOnly();
	}
	
	private void doSave(Resource res, Map<String, String> options){
		LoggingUtil.traceEntry(this, "doSave");
		
		/* If the requestor has opted not to save, return immediately.
		 * TODO: Will XSLT tranformation fail (in 5.1 case) if we don't save output? */
		if (!saveOutput.booleanValue()){
			return;
		}
		//		feature 117494
		if(res instanceof WSDLResourceImpl){
			if(res.getContents().get(0) instanceof Definition){
				Definition wsdlDefinition = (Definition)res.getContents().get(0);	
				if(resolvedDefinition == null){
					resolvedDefinition = new ArrayList<Definition>();
				}
				if(!resolvedDefinition.contains(wsdlDefinition)){
					resolvedDefinition.add(wsdlDefinition);
				}
				if(!obj2FileNameRegistry.containsKey(wsdlDefinition)){						
					updateDefinitionDocumentation(wsdlDefinition);
				}
			}
		}
		/*
		 * For library project export only, disable process directory save
		 * This is for the WPS export options
		 */
		if(isLibraryProjectOnly()){
			List<Object> libraryArtifacts = this.filePathManager.getLibraryArtifacts();
			EList contents = res.getContents();
			if(!libraryArtifacts.contains(contents.get(0))&& 
					!ExportOperationUtil.isFileAttachment(options)){
				return;
			}			
		}
		
		if(monitor != null && monitor.isCanceled()){
			throw new OperationCanceledException();
		}
		
		URI uri = res.getURI();
		String fileFullName = uri.toFileString();
		boolean fileExist = isFileExist(fileFullName);
		boolean overwrite = true;
		if(fileExist && !getExportSession().getExportOptions().isAlwaysOverwrite())
		{
			//callback to the UI to ask user
			//If the WSDL referenced by an inline schema, skip saving the file
			if(ExportOperationUtil.savedWSDL(fileFullName,this.saveWSDLRegistry)){
				overwrite = false;
			}else{
				IExportQuery query = getExportSession().getOverwriteQuery();
				if( query != null){
					
					int answer = query.queryExportOption(fileFullName);
					if(answer == IExportQuery.CANCEL){
						LoggingUtil.logWarning(MessageKeys.FILE_NOT_OVERWRITTEN, new String[]{fileFullName}, null);
						overwrite = false;
					}
				}else{
					overwrite = false;
				}
			}		
		}
		
		if(overwrite){	
			try{				
				res.save(options);
			}catch(IOException ex){
				ex.printStackTrace();
				LoggingUtil.logError(MessageKeys.UNABLE_WRITE_TO_FILE, new String[]{fileFullName}, ex);
			}catch(Exception e){
				e.printStackTrace();
			}				
		}	
		res = null;
		LoggingUtil.traceExit(this, "doSave");
		
	}
	
	private boolean isFileExist(String fileFullName){	
		
		File file = new File(fileFullName);
		return file.exists();
	}
	
	public void persistTargets(Collection<SolutionArtifact> target){
		//defect 111153
		LoggingUtil.traceEntry(this, "persistTargets");
		if (getOutputDir()!=null) {
			persistTargets(getOutputDir(),target);
		} else if (BpelOptionsUtil.getWPSModuleDirectory()!=null) {
			persistTargets(BpelOptionsUtil.getWPSModuleDirectory(),target);
		}
		TransformationSession session = TransformationEngine.getTransformationSession();
		//disable the generation of the VMM scripts for the d2d scenario.
		if( TransformationSessionUtil.hasHumanTask(session) && !BpelOptionsUtil.isGenerateForDeployPatternEnabled())
			generateVMMScripts();
		
		
		//feature 120168
		//if(BpelOptionsUtil.getWPSProjectInterchangeName() != null && !BpelOptionsUtil.getWPSProjectInterchangeName().trim().equals("")){
		if(BpelOptionsUtil.isProjectInterchangeEnabled()){
			generateProjectInterchange();
		}
		LoggingUtil.traceExit(this, "persistTargets");
	}
	
	/**
	 * Create StringBuffers containing code for vmm entry creation and cleanup scripts
	 *
	 */
	private void generateVMMScripts(){
		
		//String timestamp = ExportOperationUtil.getTimeStamp();
		String timestamp = null;
		if(getExportSession().getExportOptions().getAdditionalOption("TEST_SUPPORT") != null){
			timestamp = "2008-05-01T00.00.00";
		}else{
			timestamp = ExportOperationUtil.getTimeStamp();	
		}
		StringBuffer vmmContent = generateVMMScriptContent(timestamp);
		StringBuffer vmmCleanupContent = generateVMMCleanupScriptContent(timestamp);
		StringBuffer vmmSessionCleanupContent = generateVMMSessionCleanupScriptContent(timestamp);
		List projectNameList = CrossProjectReferenceUtil.getProjectNameListForExportSession();
		if(projectNameList != null && !projectNameList.isEmpty()){
			for(Iterator it = projectNameList.iterator();it.hasNext();){
				String projectName = (String)it.next();					
				if(BpelOptionsUtil.getWPSModuleName(projectName) != null){
					String wpsModuleDir = getAbsPathPrefix()+ BpelOptionsUtil.getWPSModuleName(projectName);
					File moduleDir = new File(wpsModuleDir);
					if(moduleDir.exists() && vmmContent != null && !(vmmContent.length() == 0)){	
						String createScriptPath = wpsModuleDir + "\\" + StaffUtil.VMMConstants.VMM_SCRIPT_FILENAME + timestamp + StaffUtil.VMMConstants.VMM_SCRIPT_EXTENSION;
						try {
							//System.out.println(vmmContent.toString());
							//defect 73470
							FileOutputStream fos = new FileOutputStream(new File(createScriptPath));
							BufferedWriter out = new BufferedWriter(new OutputStreamWriter(fos, "UTF8"));
							out.write(vmmContent.toString());
					        out.close();
					    } catch (IOException e) {
					    	//log warning .. cannot save vmm file.. 
					    	String param [] = new String[1];
							param [0]= (createScriptPath);
					    	LoggingUtil.logWarning(MessageKeys.VMM_SAVE_VMM_SCRIPT_FAILED, param, null);
					    }
					}
					if(moduleDir.exists() && vmmCleanupContent != null && !(vmmCleanupContent.length() == 0)){	
						String createScriptPath = wpsModuleDir + "\\" + StaffUtil.VMMConstants.VMM_SCRIPT_CLEANUP_FILENAME + StaffUtil.VMMConstants.VMM_SCRIPT_EXTENSION;
						try {
							//System.out.println(vmmCleanupContent.toString());
							FileOutputStream fos = new FileOutputStream(new File(createScriptPath));
							BufferedWriter out = new BufferedWriter(new OutputStreamWriter(fos, "UTF8"));
						    out.write(vmmCleanupContent.toString());
					        out.close();
					    } catch (IOException e) {
					    	//log warning .. cannot save vmm file..
					    	String param [] = new String[1];
							param [0]= (createScriptPath);
					    	LoggingUtil.logWarning(MessageKeys.VMM_SAVE_VMM_SCRIPT_FAILED, param, null);
					    }
					}
					
					if(moduleDir.exists() && vmmSessionCleanupContent != null && !(vmmSessionCleanupContent.length() == 0)){	
						String createScriptPath = wpsModuleDir + "\\" + StaffUtil.VMMConstants.VMM_SCRIPT_SESSION_CLEANUP_FILENAME + timestamp + StaffUtil.VMMConstants.VMM_SCRIPT_EXTENSION;
						try {
							//System.out.println(vmmSessionCleanupContent.toString());
							FileOutputStream fos = new FileOutputStream(new File(createScriptPath));
							BufferedWriter out = new BufferedWriter(new OutputStreamWriter(fos, "UTF8"));
						    out.write(vmmSessionCleanupContent.toString());
					        out.close();
					    } catch (IOException e) {
					    	//log warning .. cannot save vmm file..
					    	String param [] = new String[1];
							param [0]= (createScriptPath);
					    	LoggingUtil.logWarning(MessageKeys.VMM_SAVE_VMM_SCRIPT_FAILED, param, null);
					    }
					}
				}
			}
		}
	}
	
	/**
	 * Generates VMM entry creationJython script file.
	 * @param timestamp 
	 *
	 */
	private StringBuffer generateVMMScriptContent(String timestamp) {
		StringBuffer sb = new StringBuffer();
		List groupEntries =TransformationSessionUtil.getVMMGroupsFromRole(session);
		List personEntries = TransformationSessionUtil.getVMMPersons(session);
		List groupEntriesOrg = TransformationSessionUtil.getVMMGroupsFromOrg(session);
		sb = StaffUtil.generateVMMJythonScript(groupEntries, personEntries, groupEntriesOrg, timestamp);
		return sb;
	}
	
	/**
	 * Generates VMM session cleanup Jython script file.
	 * @param timestamp 
	 *
	 */
	private StringBuffer generateVMMSessionCleanupScriptContent(String timestamp) {
		List groupEntries =TransformationSessionUtil.getVMMGroupsFromRole(session);
		List personEntries = TransformationSessionUtil.getVMMPersons(session);
		List groupEntriesOrg = TransformationSessionUtil.getVMMGroupsFromOrg(session);
		StringBuffer sessionCleanupSb = new StringBuffer();
		sessionCleanupSb = StaffUtil.generateSessionCleanupVMMJythonScript(groupEntries, personEntries, groupEntriesOrg, timestamp);
	    return sessionCleanupSb;
	}
	
	/**
	 * Generates VMM cleanup Jython script file.
	 * @param timestamp 
	 *
	 */
	private StringBuffer generateVMMCleanupScriptContent(String timestamp) {
		List groupEntries =TransformationSessionUtil.getVMMGroupsFromRole(session);
		List personEntries = TransformationSessionUtil.getVMMPersons(session);
		List groupEntriesOrg = TransformationSessionUtil.getVMMGroupsFromOrg(session);
		StringBuffer cleanupSb = new StringBuffer();
		cleanupSb = StaffUtil.generateCleanupVMMJythonScript(groupEntries, personEntries, groupEntriesOrg, timestamp);
	    return cleanupSb;
	}
	
	
	/**
	 * Generates a ProjectInterchange.
	 *
	 */
	private void generateProjectInterchange(){
		String projectInterchangeName = null;
		//File vmmScript = new File(getAbsPathPrefix()+ StaffUtil.VMMConstants.VMM_SCRIPT_FILENAME);
		if(BpelOptionsUtil.isProjectInterchangeTimeStampEnabled()){
			projectInterchangeName = getOutputDir() + 
			FILE_SEPARATOR + 
			BpelOptionsUtil.getWPSProjectInterchangeName() + 
			UNDER_SCORE + 
			//String.valueOf(System.currentTimeMillis()) + 
			ExportOperationUtil.getTimeStamp()+
			ZIP_FILE_EXT;
		}else{
			projectInterchangeName = getOutputDir() + 
			FILE_SEPARATOR + 
			BpelOptionsUtil.getWPSProjectInterchangeName()+ZIP_FILE_EXT;
		}
		boolean fileExist = isFileExist(projectInterchangeName);
		boolean overwrite = true;
		//defect 120719
		if(fileExist && !getExportSession().getExportOptions().isAlwaysOverwrite())
		{
			//callback to the UI to ask user
			IExportQuery query = getExportSession().getOverwriteQuery();
			if( query != null){
				
				int answer = query.queryExportOption(projectInterchangeName);
				if(answer == IExportQuery.CANCEL){
					LoggingUtil.logWarning(MessageKeys.FILE_NOT_OVERWRITTEN, new String[]{projectInterchangeName}, null);
					overwrite = false;
				}
			}else{
				overwrite = false;
			}
			
		}
		
		if(overwrite){	
			TEZipFileExporter fileExporter = null;
			try{
//GJD				fileExporter = new TEZipFileExporter(projectInterchangeName, false, false);
				ArrayList<String> allFiles = new ArrayList<String>();
				File moduleFolder = null;
				File libFolder = null;
				File implFolder = null;
				List projectNameList = CrossProjectReferenceUtil.getProjectNameListForExportSession();
				List tempFolderList = new LinkedList();				
				if(projectNameList != null && !projectNameList.isEmpty()){
					for(Iterator it = projectNameList.iterator();it.hasNext();){
						String projectName = (String)it.next();					
						if(BpelOptionsUtil.getWPSModuleName(projectName) != null){
							//String wpsModuleDir = getOutputDir() + FILE_SEPARATOR +String.valueOf(System.currentTimeMillis())+File.separator+ BpelOptionsUtil.getWPSModuleName(projectName);
							String wpsModuleDir = getAbsPathPrefix()+ BpelOptionsUtil.getWPSModuleName(projectName);
							moduleFolder = new File(wpsModuleDir);
							getAllFilesinFolder(moduleFolder, allFiles);
							//tempFolderList.add(moduleFolder);
						}
						if(BpelOptionsUtil.getWPSLibraryName(projectName) != null){
							//String wpsLibDir = getOutputDir() + FILE_SEPARATOR + String.valueOf(System.currentTimeMillis())+File.separator+ BpelOptionsUtil.getWPSLibraryName(projectName);
							String wpsLibDir = getAbsPathPrefix()+ BpelOptionsUtil.getWPSLibraryName(projectName);
							libFolder = new File(wpsLibDir);
							getAllFilesinFolder(libFolder, allFiles);
							//tempFolderList.add(libFolder);
						}

						//AZ WBT 20070322 Create folder for implementation module
						if(BpelOptions.isBestPracticePatternEnabed(getExportSession())){
							//String wpsImplDir = getOutputDir() + FILE_SEPARATOR +String.valueOf(System.currentTimeMillis())+File.separator+ BpelOptionsUtil.getImplementationModuleName(projectName);
							String wpsImplDir = getAbsPathPrefix()+ BpelOptionsUtil.getImplementationModuleName(projectName);
							implFolder = new File(wpsImplDir);
							getAllFilesinFolder(implFolder, allFiles);
							//tempFolderList.add(implFolder);
						}
					}
				}
				//add the absolute path to the list of files to be zipped
//				if(createScriptPath != null){
//					if(isFileExist(createScriptPath)){
//						allFiles.add(createScriptPath);
//					}
//				}
//				if(cleanupScriptPath != null){
//					if(isFileExist(cleanupScriptPath)){
//						allFiles.add(cleanupScriptPath);
//					}
//				}
				
				tempFolderList.add(new File(getAbsPathPrefix()));

				if(!allFiles.isEmpty()){
					fileExporter = new TEZipFileExporter(projectInterchangeName, false, false);
					Iterator<String> it = allFiles.iterator();
					while(it.hasNext()){
						String fileFullName = it.next();
						InputStream is = new FileInputStream(fileFullName);
						String destinationPath = fileFullName.substring(fileFullName.indexOf(getOutputDir())+getOutputDir().length());
						destinationPath = destinationPath.substring(1);
						destinationPath = destinationPath.substring(destinationPath.indexOf(File.separator)+1);
						fileExporter.write(is,destinationPath);
						is.close();
					}
				}
				if (fileExporter != null)
					fileExporter.finished();
				else {
					//TODO log warning - no contents in zip?
				}
				if(tempFolderList != null && !tempFolderList.isEmpty()){
					for(Iterator it = tempFolderList.iterator();it.hasNext();){
						File theFolder = (File)it.next();
						deleteDeep(theFolder);
					}
				}				
			}catch(Exception ex){
				try{
					if(fileExporter != null)
						fileExporter.finished();
				}catch(Exception ex1){
					//log error, unable to zip 
					LoggingUtil.logError(MessageKeys.UNABLE_WRITE_TO_FILE, new String[]{projectInterchangeName}, ex);
				}
				//log error, unable to zip 
				LoggingUtil.logError(MessageKeys.UNABLE_WRITE_TO_FILE, new String[]{projectInterchangeName}, ex);
			}
		}



	}
	/**
	 * Recursively collects all files in the <code>baseFolder</code>
	 * @param baseFolder
	 * @param files
	 */
	private void getAllFilesinFolder(File baseFolder, ArrayList<String> files) {
		File[] children = baseFolder.listFiles();
		if(children != null){
			for(int i=0; i < children.length; i++) {
				if(children[i] != null){
					if(children[i].isDirectory()) getAllFilesinFolder(children[i], files); 
					if(children[i].isFile()) files.add(children[i].getAbsolutePath());
				}
			}
		}
	}
	/**
	 * Recursively deletes all files in the <code>baseFolder</code>
	 * @param baseFolder
	 */
	private void deleteDeep(File baseFolder) {
		File[] children = baseFolder.listFiles();
		if(children != null){
			for(int i=0; i < children.length; i++) {
				if(children[i].isFile()) children[i].delete();
				if(children[i].isDirectory()) deleteDeep(children[i]); 
			}
			baseFolder.delete();
		}
	}

	private List<SolutionArtifact> sortProcessFlow(Collection<SolutionArtifact> target){
		List<SolutionArtifact> processFlowSa = new ArrayList<SolutionArtifact>();
		if(target == null){
			return processFlowSa;
		}		
		List sortedTarget = new ArrayList();
		Iterator<SolutionArtifact> it = target.iterator();		
		while(it.hasNext()){
			SolutionArtifact sa = it.next();
			if(sa.getType()==SAType.PROCESS_FLOW_LITERAL){
				if (((ProcessFlow)sa.getComposedArtifacts().get(0)).getType() == ProcessFlowType.BPELPP_LITERAL){
					processFlowSa.add(sa);
				}else{
					processFlowSa.add(0,sa);	
				}
			}			
		}		
		return processFlowSa;
	}
	
	/**
	 * This method is to look up the interface definition, if the process flow refers to the same
	 * interface definition in the SCDL SA, we skip the process of the SCDL SA 
	 * @param interDef
	 * @return
	 */
	private boolean isInterfaceInProcessFlow(Definition interDef,Collection<SolutionArtifact> targets){
		List<SolutionArtifact> procFlows = this.sortProcessFlow(targets);
		if(procFlows != null && !procFlows.isEmpty()){
			Iterator<SolutionArtifact> flowIt = procFlows.iterator();
			while(flowIt.hasNext()){
				Object saObject = flowIt.next();
				if(saObject instanceof SolutionArtifact){
					SolutionArtifact sa = (SolutionArtifact)saObject;
					Object interObject = ((ProcessFlow)sa.getComposedArtifacts().get(0)).getProcessInterface().get(0);
					if(interObject instanceof Definition && interDef == interObject ){
						return true;
					}
				}
			}
		}
		return false;
	}
	
	private boolean isProcessDefInProcessFlow(Process process,Collection<SolutionArtifact> targets){
		List<SolutionArtifact> procFlows = this.sortProcessFlow(targets);
		if(procFlows != null && !procFlows.isEmpty()){
			Iterator<SolutionArtifact> flowIt = procFlows.iterator();
			while(flowIt.hasNext()){
				Object saObject = flowIt.next();
				if(saObject instanceof SolutionArtifact){
					SolutionArtifact sa = (SolutionArtifact)saObject;
					Object procObject = ((ProcessFlow)sa.getComposedArtifacts().get(0)).getProcessDefinition();
					if(procObject instanceof Process && procObject == process ){
						return true;
					}
				}
			}
		}
		return false;
	}
	
	public void persistTargets(String project, Collection<SolutionArtifact> target) {
		LoggingUtil.traceEntry(this, "persistTargets");
		if(target == null){
			return;
		}
		// Create filePathManager
		filePathManager = new FilePathManager(target);
		// set the absolute path info
		//defect 155836
		//setAbsPathPrefix(project + FILE_SEPARATOR);		
		setAbsPathPrefix(project);		
		ResourceSet resourceSet = new ResourceSetImpl();
		List artifacts;
		SolutionArtifact sa;
		Iterator<SolutionArtifact> targetIt;		
		targetIt = target.iterator();		
		List<SolutionArtifact> ht = new LinkedList<SolutionArtifact>();
		
		List<SolutionArtifact> deferredComponents = new ArrayList<SolutionArtifact>();
		
		//defect 111153
		// we have to make sure while processing the targets that the HumanTask SA is processed after it's 
		//corresponding WSDL SA. For that, processed the HT SA last.		
		while (targetIt.hasNext()) {
			sa = targetIt.next();
			if (sa.getType()==SAType.UNCLASSIFIED_LITERAL) {				
				processUnClassifiedSA(sa,resourceSet);//wsdl sa belongs to unclassified SA
			} else if (sa.getType()==SAType.PROCESS_FLOW_LITERAL){
				continue;
				//processProcessFlowSA(sa,resourceSet);
			}
			else if(sa.getType()== SAType.HUMAN_TASK_LITERAL){
				ht.add(sa);
				//processHumanTaskSA(sa, resourceSet);
			}
			else if (sa.getType()==SAType.SCDL_LITERAL) {
				List<SolutionArtifact> components = processScdlSA(sa,resourceSet);		// this is invoked for BPEL process generated for component
				if (components != null && !components.isEmpty()) {
					deferredComponents.addAll(components);
				}
			}
		}
		//AZ fix the import resource after .export and .component are saved
		ExportOperationUtil.persistImportResources(getImportResourceMap());
		
		ExportOperationUtil.fixXSDImports(getSourcePathToTargetPathAbsoluteRegistry(), resourceSet, getXsdResourceFactory(), getWsdlResourceFactory(),getAbsPathPrefix().length());
//		AZ Iterate through the registry fix import and create/save resource 
		processResourceRegistry(getSourcePathToTargetPathAbsoluteRegistry(), resourceSet);
		
		List<SolutionArtifact> processFlowSa = sortProcessFlow(target);
		if(processFlowSa.size()> 0){
			Iterator<SolutionArtifact> pfIt = processFlowSa.iterator();
			while(pfIt.hasNext()){
				processProcessFlowSA(pfIt.next(),resourceSet);
			}
		}
				
		if (deferredComponents != null && !deferredComponents.isEmpty()) {
			processDeferredScdlSA(deferredComponents ,resourceSet);
		}
		
		if(getArtifatcsDefinitionRegistry() != null && !getArtifatcsDefinitionRegistry().isEmpty() ){
			Iterator<Object> artifactsIterator = getArtifatcsDefinitionRegistry().iterator();
			while(artifactsIterator.hasNext()){
				Object artObject = artifactsIterator.next();
				if(artObject instanceof WSDLResourceImpl){		
					WSDLResourceImpl wsdlResource = (WSDLResourceImpl)artObject;
					Definition artifatcsDef = (Definition)wsdlResource.getContents().get(0);
					ExportOperationUtil.fixImport(artifatcsDef,getSourcePathToTargetPathAbsoluteRegistry(), true,getAbsPathPrefix().length());
					doSave(wsdlResource,null);
				}
			}
		}
		
		//now process the HumanTask SAs.
		targetIt = ht.iterator();
		while(targetIt.hasNext()){
			sa = targetIt.next();
			processHumanTaskSA(sa, resourceSet);
		}
		
		// Handle the FDL file persistence
		if (commonFdlResource != null) {
			doSave(commonFdlResource, null);
		} else {
			//defect 114380
			// If we detect we are in WID we should create the Module and Library in the same time.. x
			//AZ 20071005 ensure project interchange option not calling wid plugin, which cause
			//failure if the specific WID plugin presented in the WBM platform 
			//TODO handle WID project creation in shell sharing case defect 158785
			
     		Bundle bundle = null;
			boolean isShellShared = false;
			boolean isAdditionOperDone = false;
			if(!BpelOptionsUtil.isProjectInterchangeEnabled()){
				isShellShared = WIDProjectUtil.isShellShared();
				bundle = WIDProjectUtil.getWidPlugin();
			}
			//defect161899, defect 80626, do not generate Project for D2D
			if(isShellShared && bundle != null && !BpelOptionsUtil.isGenerateForDeployPatternEnabled()){
				if(!BpelOptionsUtil.isNoneOption()){
					MappingManager.postProcessObjectDefinitions();
					if (hasAdditionExportOperations()){
//						//Invoke addtionalExportOperations
						invokeAdditionalExportOperations();
						isAdditionOperDone = true;
//						//end of call invoke addtionalExportOperations
					}
					MappingManager.save(getAbsPathPrefix(),objectFilePathMap,getSourcePathToTargetPathAbsoluteRegistry());
				}
				WIDProjectUtil.createProjectsInWIDXP(getAbsPathPrefix(), bundle); // 86622 - call this after the map artifacts are created.
			}else{
				List projectNameList = CrossProjectReferenceUtil.getProjectNameListForExportSession();
				if(projectNameList != null && !projectNameList.isEmpty()){
					for(Iterator projectNameIt=projectNameList.iterator();projectNameIt.hasNext();){
						String projectName = (String)projectNameIt.next();
						// Handle Module and Library project generation
						if (BpelOptionsUtil.getWPSLibraryName(projectName)!=null) {
							//AZ WMT 20070328 To generate empty class path file for lib project
							//AZ 06/22/07 add support for cross project reference
							String[] projectReference = CrossProjectReferenceUtil.getProjectReferencesForLib(projectName, getAbsPathPrefix());
							WIDProjectUtil.createLibraryProject(BpelOptionsUtil.getWPSLibraryName(projectName),getAbsPathPrefix(),projectReference);//new String[]{""});
						}
						if (BpelOptionsUtil.getWPSModuleName(projectName)!=null &&
								CrossProjectReferenceUtil.existProjectDirectory(getAbsPathPrefix(), BpelOptionsUtil.getWPSModuleName(projectName))) {
							//				if (BpelOptionsUtil.getWPSLibraryName()==null) {
							DocumentRoot module = ScdlUtil.createScdlModule(BpelOptionsUtil.getWPSModuleName(projectName));
							filePathManager.setPath(module,BpelOptionsUtil.getWPSModuleName(projectName)+File.separator);
							Resource resource = createResource(module,resourceSet);
							if (resource != null) {
								resourceSet.getResources().add(resource);	
								// defect 121288
								Map<String, String> options = new HashMap<String, String>();
								options.put(XMLResource.OPTION_ENCODING, "UTF-8");
								doSave(resource,options);
								// add saving of extension model
								if (resource.getURI().fileExtension().equals(SCA_MODULE_FILE_EXT.substring(1))) {		//skip the "."
									URI extensionModuleURI = URI.createFileURI(
											resource.getURI().toFileString().substring(0, resource.getURI().toFileString().length() - SCA_MODULE_FILE_EXT.length()) +
											SCA_MODULE_EX_FILE_EXT);
									try {
										createExtensionModel(resourceSet, extensionModuleURI, module.getModule());
									} catch (IOException io) {
										io.printStackTrace();
										LoggingUtil.logError(MessageKeys.UNABLE_WRITE_TO_FILE, new String[]{extensionModuleURI.fileExtension()}, io);
									}
								}
							}
						}
						if (BpelOptions.isBestPracticePatternEnabed(getExportSession())&&
								CrossProjectReferenceUtil.existProjectDirectory(getAbsPathPrefix(), BpelOptionsUtil.getImplementationModuleName(projectName))){					
							DocumentRoot module = ScdlUtil.createScdlModule(BpelOptionsUtil.getImplementationModuleName(projectName));
							filePathManager.setPath(module,BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator);
							Resource resource = createResource(module,resourceSet);
							if (resource != null) {
								resourceSet.getResources().add(resource);	
								// defect 121288
								Map<String, String> options = new HashMap<String, String>();
								options.put(XMLResource.OPTION_ENCODING, "UTF-8");
								doSave(resource,options);
								// add saving of extension model
								if (resource.getURI().fileExtension().equals(SCA_MODULE_FILE_EXT.substring(1))) {		//skip the "."
									URI extensionModuleURI = URI.createFileURI(
											resource.getURI().toFileString().substring(0, resource.getURI().toFileString().length() - SCA_MODULE_FILE_EXT.length()) +
											SCA_MODULE_EX_FILE_EXT);
									try {
										createExtensionModel(resourceSet, extensionModuleURI, module.getModule());
									} catch (IOException io) {
										io.printStackTrace();
										LoggingUtil.logError(MessageKeys.UNABLE_WRITE_TO_FILE, new String[]{extensionModuleURI.fileExtension()}, io);
									}
								}
							}
						}

						if (BpelOptionsUtil.getWPSLibraryName(projectName)!=null && BpelOptionsUtil.isModuleEnabledWithLib()){
//							String [] referencedProjects = new String[1];
//							referencedProjects[0]=BpelOptionsUtil.getWPSLibraryName(projectName);
							if(CrossProjectReferenceUtil.existProjectDirectory(getAbsPathPrefix(), BpelOptionsUtil.getWPSModuleName(projectName))){
								if(BpelOptionsUtil.isGenerateForDeployPatternEnabled()){
									// defect 90791 we only need to generate the Module once, for the main Project. We don't need to generate for the dependencies.
									if(projectName.equals(d2dtargetProjectName)){
										String [] referencedProjects = CrossProjectReferenceUtil.getProjectReferences(projectName,getAbsPathPrefix());
										WIDProjectUtil.createModuleProject(BpelOptionsUtil.getWPSModuleName(projectName),getAbsPathPrefix(),referencedProjects);
									}
								}else{
									String [] referencedProjects = CrossProjectReferenceUtil.getProjectReferences(projectName,getAbsPathPrefix());
									WIDProjectUtil.createModuleProject(BpelOptionsUtil.getWPSModuleName(projectName),getAbsPathPrefix(),referencedProjects);
								}
							}
						}
						//AZ WMT 20070322 support pattern
						else if(BpelOptions.isBestPracticePatternEnabed(getExportSession())) {
//							String [] referencedProjects = new String[1];					
//							referencedProjects[0]=BpelOptionsUtil.getWPSLibraryName(projectName);	
							String [] referencedProjects = CrossProjectReferenceUtil.getProjectReferences(projectName,getAbsPathPrefix());
							//Create implementation module
							if(CrossProjectReferenceUtil.existProjectDirectory(getAbsPathPrefix(), BpelOptionsUtil.getImplementationModuleName(projectName))){
								WIDProjectUtil.createModuleProject(BpelOptionsUtil.getImplementationModuleName(projectName),getAbsPathPrefix(),referencedProjects);
							}
							if(CrossProjectReferenceUtil.existProjectDirectory(getAbsPathPrefix(), BpelOptionsUtil.getWPSModuleName(projectName))){
								//Create top level module 
								WIDProjectUtil.createModuleProject(BpelOptionsUtil.getWPSModuleName(projectName),getAbsPathPrefix(),referencedProjects);
							}
						}			
						else if(BpelOptionsUtil.getWPSModuleName(projectName) != null) {
							if(CrossProjectReferenceUtil.existSharedLib()){
								String predefinedProjectLib = CrossProjectReferenceUtil.getSharedLibProjectName();
								WIDProjectUtil.createModuleProject(BpelOptionsUtil.getWPSModuleName(projectName),getAbsPathPrefix(),new String[]{predefinedProjectLib});
							}else{
								WIDProjectUtil.createModuleProject(BpelOptionsUtil.getWPSModuleName(projectName),getAbsPathPrefix(),new String[]{""});
							}
						}
					}
				}
			}			
			//}
			boolean isPostProcessed = false;
			if (!isAdditionOperDone && hasAdditionExportOperations()){		
				//Move objectdefinition pre-save processing into mapping manager
				MappingManager.postProcessObjectDefinitions();
				isPostProcessed = true;
//				//Invoke addtionalExportOperations
				invokeAdditionalExportOperations();
//				//end of call invoke addtionalExportOperations
			}

			//AZ WMT 20070323 
			if(BpelOptionsUtil.isProjectInterchangeEnabled() || BpelOptionsUtil.isGenerateForDeployPatternEnabled()){	
				if (!isPostProcessed) {
					//Move objectdefinition pre-save processing into mapping manager
					MappingManager.postProcessObjectDefinitions();
				}
				MappingManager.save(getAbsPathPrefix(),objectFilePathMap,getSourcePathToTargetPathAbsoluteRegistry());
			}
		}
		//AZ 20070506 we are done, clean up all the global registries		
		//initialize();
		resourceSet = null;
		LoggingUtil.traceExit(this, "persistTargets");
	}
	
	private String createFilePathFromNamespace(String namespace) {
		if(namespace == null || namespace.length() == 0){
			return "";
		}
		//We need to decode the namespace in case that it's encoded
		//namespace = URI.decode(namespace);
		//Use the same decoding method as WID does
		namespace = NamespaceUtils.convertUriToNamespace(namespace);
		String path = namespace.substring(namespace.indexOf(":")+ 1,namespace.length());
		String fileSeparator = FILE_SEPARATOR;
		path = path.replace('/',fileSeparator.charAt(0));
		path = path.replace('\\',fileSeparator.charAt(0));
		while (path.startsWith(fileSeparator)) {
			path = path.substring(1);
		}
		return path;
	}
	
	private String createFileNameFromNamespace(String namespace) {
		String filename=namespace;
		int lastSeparator = namespace.lastIndexOf("/");
		if (lastSeparator == -1) {
			lastSeparator = namespace.lastIndexOf("\\");
		}
		if (lastSeparator != -1) {
			filename = namespace.substring(lastSeparator+ 1,namespace.length());
		} else if (namespace.indexOf(":") != -1){
			filename = namespace.substring(namespace.indexOf(":")+ 1,namespace.length());
		}
		return filename;
	}
	
	/**
	 * @return
	 */
	public BPELResourceFactoryImpl getBpelResourceFactory() {
		if (bpelResourceFactory == null) {
			bpelResourceFactory = new BPELResourceFactoryImpl();
		}
		return bpelResourceFactory;
	}
	/**
	 * @return
	 */
	public SCDLResourceFactoryImpl getSCDLResourceFactory() {
		if (scdlResourceFactory == null) {
			scdlResourceFactory = new SCDLResourceFactoryImpl();
		}
		return scdlResourceFactory;
	}
	
	/**
	 * @return
	 */
	public TaskResourceFactoryImpl getTELResourceFactory() {
		if (telResourceFactory == null) {
			telResourceFactory = new TaskResourceFactoryImpl();
		}
		return telResourceFactory;
	}
	/**
	 * @return
	 */
	public FDLProcessModelResourceFactoryImpl getFdlResourceFactory() {
		if (fdlResourceFactory == null) {
			fdlResourceFactory = new FDLProcessModelResourceFactoryImpl();
		}
		return fdlResourceFactory;
	}
	
	/**
	 * @return
	 */
	public WSDLResourceFactoryImpl getWsdlResourceFactory() {
		if (wsdlResourceFactory == null) {
			wsdlResourceFactory = new WSDLResourceFactoryImpl();
		}
		return wsdlResourceFactory;
	}
	
	/**
	 * @return
	 */
	public XSDResourceFactoryImpl getXsdResourceFactory() {
		if (xsdResourceFactory == null) {
			xsdResourceFactory = new XSDResourceFactoryImpl();
		}
		return xsdResourceFactory;
	}
	
	
	public XMIResourceFactoryImpl getExtensionmodelResourceFactory() {
		if (extModelResourceFactory == null) {
			extModelResourceFactory = new XMIResourceFactoryImpl();
		}
		return extModelResourceFactory;
	}
	
	/**
	 * @return
	 */
	public String getAbsPathPrefix() {
		return absPathPrefix;
	}
	
	/**
	 * @param string
	 */
	public void setAbsPathPrefix(String string) {
		// defect 128424
		if(string == null){
			return;
		}
		//defect 155836
		if(string.endsWith("\\")){
			string = string.substring(0,string.length()-1);
		}
		string = string+FILE_SEPARATOR;
		
		File file = new File(string);
		boolean bAbs = file.isAbsolute();
		String absPath=string;
		if (!bAbs) {
			absPath=file.getAbsolutePath()+File.separator;
		}
		if(BpelOptionsUtil.isProjectInterchangeEnabled()){
			absPathPrefix = absPath+String.valueOf(System.currentTimeMillis())+File.separator;
		}else{
			absPathPrefix = absPath;
		}
	}
	
	/**
	 * Creates a custom documentation for the WSDL Interface that will allow us to determine this interface was
	 * generated with Modeler. /Note: As WID does not support documentation at the WSDL Interface level, we will 
	 * attach the documentation at the PortType level/
	 * @param wsdlDefinition
	 * @param activity
	 */
	private void updateDefinitionDocumentation(Definition wsdlDefinition){
		//feature 117494
		((DefinitionImpl)wsdlDefinition).updateElement();
		List portTypes = wsdlDefinition.getEPortTypes();
		if(portTypes != null && !portTypes.isEmpty()){
			Iterator it = portTypes.iterator();
			while(it.hasNext()){
				PortType portType = (PortType)it.next();
				Element element = portType.getElement();
				Node firstChild = element.getFirstChild();
				
				Document portTypeDoc = portType.getElement().getOwnerDocument();
				//Element doc = wsdlDefinition.getDocument().createElementNS(AttributeNameConstants.WSDL_TARGET_NAMESPACE, "documentation");
				Element modelerDocumentation = portTypeDoc.createElementNS("http://schemas.xmlsoap.org/wsdl/" , "wsdl:documentation");
				StringBuffer serviceComment = new StringBuffer();
				serviceComment.append(AbstractbpelConstants.MODELER_VERSION_TAG);
				Node modelerText = portTypeDoc.createTextNode(serviceComment.toString());
				modelerDocumentation.appendChild(modelerText);
				if(firstChild != null){
					element.insertBefore(modelerDocumentation, firstChild);
				}else{
					element.appendChild(modelerDocumentation);
				}
				
			}
		}
		
		
	}
	//	public static IFile getIFileForURI(URI uri) throws IOException{
	//		
	//		String filePath = null;
	//		String scheme = uri.scheme(); 
	//		
	//		if ("file".equals(scheme)) { //$NON-NLS-1$
	//			filePath = uri.toFileString();
	//		} else if ("platform".equals(scheme) && uri.segmentCount() > 1 && "resource".equals(uri.segment(0))) { //$NON-NLS-1$ //$NON-NLS-2$
	//			StringBuffer platformResourcePath = new StringBuffer();
	//			for (int i = 1, size = uri.segmentCount(); i < size; ++i) {
	//				platformResourcePath.append('/');
	//				platformResourcePath.append(uri.segment(i));
	//			}
	//			filePath = URI.decode(platformResourcePath.toString());
	//		}
	//		
	//		if (filePath == null) return null;
	//		
	//		IFile file = null;
	//		
	//		if(scheme.equals("file")){ //$NON-NLS-1$
	//		    String newPath = filePath.substring(filePath.indexOf(uri.device()),filePath.length());
	//		    file = ResourcesPlugin.getWorkspace().getRoot().getFile(new Path(filePath));
	//			//file = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(new Path(newPath));
	//		}else
	//			file = ResourcesPlugin.getWorkspace().getRoot().getFile(new Path(filePath));
	//		
	//		try {
	//		    if(file == null) return null;
	//			if (file.exists() && (!file.isLocal(IResource.DEPTH_ONE) || !file.isSynchronized(IResource.DEPTH_ONE))) {
	//				file.refreshLocal(IResource.DEPTH_ONE, null);
	//			}
	//			return file;
	//		} catch (CoreException exception) {
	//			throw new Resource.IOWrappedException(exception);
	//		}
	//	}
	
	/**
	 * FilePathManager is responsible for maintaining the registry of relative path for the artifacts
	 * contained in as SolutionArtifact object
	 * @author raykong
	 *
	 * TODO To change the template for this generated type comment go to
	 * Window - Preferences - Java - Code Style - Code Templates
	 */
	private class FilePathManager {
		private HashMap<Object, String> pathRegistry = new HashMap<Object, String>(); // this registry store path include Module or Library name
		private HashMap<Object, String> projectRelativePathRegistry = new HashMap<Object, String>(); // this registry stores path without Module or Library project name in the path. hence relative within the project
		private List<Object> libraryArtifacts = new ArrayList<Object>();
		private List<Object> moduleArtifacts = new ArrayList<Object>();
		
		public FilePathManager(Collection<SolutionArtifact> saList) {
			createPathRegistry(saList);
		}
		
		public String getProjectRelativePath (Class type, String namespace, String name) {
			return getPath(type,namespace,name,true);			
		}
		
		public String getPath (Class type, String namespace, String name) {
			return getPath(type,namespace,name,false);			
		}
		
		/**
		 * Get the relative file path for the element that matches the type, namespace, and optionally the name
		 * Search the Path registry by find the key element in the registry that matches the object type, the namespace, 
		 * the name of the object (if presented)
		 * @param type
		 * @param namespace
		 * @param name - Optional for XSDSchema element
		 * @return
		 */
		public String getPath (Class type, String namespace, String name, boolean bProjectRelativePath) {
			for (Iterator<Object> it = pathRegistry.keySet().iterator();it.hasNext();){
				Object obj = it.next();
				if (type==Process.class && obj instanceof Process) {
					Process proc=(Process)obj;
					if (proc.getTargetNamespace().equals(namespace) && proc.getName().equals(name)) {
						if (!bProjectRelativePath) {
							return pathRegistry.get(obj);							
						} else {
							return projectRelativePathRegistry.get(obj);														
						}
					}
				} 
				if (type==Definition.class && obj instanceof Definition) {
					Definition def=(Definition)obj;
					String origFileName = (String)obj2FileNameRegistry.get(def);
					if(origFileName != null && origFileName.length() > 0){
						return pathRegistry.get(obj);
					}
					if (def.getQName()!=null) {
						if (def.getQName().getNamespaceURI().equals(namespace)&&def.getQName().getLocalPart().equals(name)) {
							if (!bProjectRelativePath) {
								return pathRegistry.get(obj);								
							} else {								
								return projectRelativePathRegistry.get(obj);
							}
						}
					}
				} 
				if (type==XSDSchema.class && obj instanceof XSDSchema) {
					XSDSchema schema=(XSDSchema)obj;
					if (schema.getTargetNamespace().equals(namespace)) {
						if (!bProjectRelativePath) {
							return pathRegistry.get(obj);							
						} else {
							return projectRelativePathRegistry.get(obj);
						}
					}
				}
				if(type == TTask.class && obj instanceof TTask){
					TTask task = (TTask)obj;
					if (task.getTargetNamespace().toString().equals(namespace) && task.getName().equals(name)) {
						if (!bProjectRelativePath) {
							return pathRegistry.get(obj);							
						} else {
							return projectRelativePathRegistry.get(obj);
						}
					}
				}
				
				
				
			}
			return "";
		}
		
		/**
		 * Get the relative file path for persisting the element
		 * @param element
		 * @return
		 */
		public String getPath(Object element) {
			return pathRegistry.get(element);
		}
		
		public String getProjectRelativePath(Object element) {
			return projectRelativePathRegistry.get(element);
		}
		
		/**
		 * Manually set the path for the element
		 * @param element
		 * @param path
		 */
		public void setPath(Object element, String path) {
			pathRegistry.put(element,path);
		}
		
		public void setProjectRelativePath(Object element, String path) {
			projectRelativePathRegistry.put(element,path);
		}
		
		/**
		 * Register all the SA elements into the registry.
		 * The Key of the registry will be the element contained in the SA/CA
		 * @param saList
		 */
		private void createPathRegistry(Collection<SolutionArtifact> saList) {
			
			SolutionArtifact sa;
			ComposedArtifact ca;
			if(saList == null){
				return;
			}
			for (Iterator<SolutionArtifact> it=saList.iterator();it.hasNext();) {
				sa = it.next();	
				for (Iterator it2=sa.getComposedArtifacts().iterator();it2.hasNext();) {
					ca = (ComposedArtifact)it2.next();
					if (sa.getType()==SAType.UNCLASSIFIED_LITERAL) {
						List ucas = ((UnclassifiedArtifact)ca).getArtifacts();
						for (Iterator it3=ucas.iterator();it3.hasNext();) {
							Object uca = it3.next();
							if (uca instanceof ICalendar) {
								if(BpelOptions.isBestPracticePatternEnabed(getExportSession())|| 
										BpelOptionsUtil.isLibraryEnabledWithModuleProject() ||
										BpelOptionsUtil.isLibraryOnly()){
									pathRegistry.put(uca, getRelativePath(sa,uca));
								} else {
									pathRegistry.put(uca, getRelativePath(sa,uca));
								}
								projectRelativePathRegistry.put(uca, getRelativePath(sa,null,true));								
							} else {
								String path = getRelativePath(sa,uca);
								pathRegistry.put(uca,path);
								String projectRelativePath = getRelativePath(sa,uca,true);
								projectRelativePathRegistry.put(uca,projectRelativePath);
								// Ray - Form Support
								// If the uca is a Form, then register the path based on the UID.  This is 
								// needed for updating the HumanTask's form path
								if (uca instanceof Form) {
									pathRegistry.put(((Form)uca).getUid(),path);
									projectRelativePathRegistry.put(((Form)uca).getUid(),projectRelativePath);
								}
							}
						}
					} else if (sa.getType()==SAType.PROCESS_FLOW_LITERAL){
						ProcessFlow pf = (ProcessFlow)ca;
						if (pf.getProcessDefinition()!=null) {
							pathRegistry.put(pf.getProcessDefinition(),getRelativePath(sa,pf.getProcessDefinition()));							
							projectRelativePathRegistry.put(pf.getProcessDefinition(),getRelativePath(sa,null,true));
						}
						if (pf.getProcessInterface()!=null) {
							//	pathRegistry.put(pf.getProcessInterface(),getRelativePath(sa,pf.getProcessInterface()));
							
							Iterator it1 = pf.getProcessInterface().iterator();
							while(it1.hasNext()){
								Object def = it1.next();
								pathRegistry.put(def ,getRelativePath(sa,def));
								projectRelativePathRegistry.put(def,getRelativePath(sa,def,true));
							}
							
						}
					} else if(sa.getType()== SAType.HUMAN_TASK_LITERAL){
						if(BpelOptions.isBestPracticePatternEnabed(getExportSession())){
							pathRegistry.put(((com.ibm.wbit.tel.DocumentRoot)((HumanTask)ca).getHumanTask()).getTask(), getRelativePath(sa,((HumanTask)ca).getHumanTask()));
							
						} else {
							pathRegistry.put(((com.ibm.wbit.tel.DocumentRoot)((HumanTask)ca).getHumanTask()).getTask(), getRelativePath(sa,((HumanTask)ca).getHumanTask()));							
						}
						projectRelativePathRegistry.put(((com.ibm.wbit.tel.DocumentRoot)((HumanTask)ca).getHumanTask()).getTask(), getRelativePath(sa,null,true));
					} else if (sa.getType()==SAType.SCDL_LITERAL) {
						//AZ WMT 20070322 support pattern 
						if(BpelOptions.isBestPracticePatternEnabed(getExportSession())){
							pathRegistry.put(((ScdlArtifact)ca).getArtifact(),getRelativePath(sa,((ScdlArtifact)ca).getArtifact()));						
						}else{
							pathRegistry.put(((ScdlArtifact)ca).getArtifact(),getRelativePath(sa,((ScdlArtifact)ca).getArtifact()));
						}
						projectRelativePathRegistry.put(((ScdlArtifact)ca).getArtifact(),getRelativePath(sa,null,true));
					}		
					
				}
			}
		}
		
		/**
		 * Internal method that calls getRelativePath(SolutionArtifact sa, Object obj)
		 * @param sa
		 * @return
		 */
		private String getRelativePath(SolutionArtifact sa) {
			return getRelativePath(sa,null);
		}
		
		private void addObject(List<Object> ObjList,Object objectToAdd){
			if(ObjList == null){
				ObjList = new ArrayList<Object>();
			}
			if(objectToAdd != null){
				ObjList.add(objectToAdd);
			}
		}
		
		private List<Object> getLibraryArtifacts(){
			return this.libraryArtifacts;
		}
		
		private List<Object> getModuleArtifacts(){
			return this.moduleArtifacts;
		}
		
		private String fixRelativePath(String relPath,Object obj) {
			if (obj==null) {
				return relPath;
			}
			String projectName = (String)CrossProjectReferenceUtil.getProjectNameForTargetObject(obj);
			List<Object> libraryArtifacts = getLibraryArtifacts();
			List<Object> moduleArtifacts = getModuleArtifacts();
			String topPackage=null;
			if (libraryArtifacts!=null) {
				if (libraryArtifacts.contains(obj)) {
					if (relPath.startsWith(BpelOptionsUtil.getWPSLibraryName(projectName))) {
						topPackage=BpelOptionsUtil.getWPSLibraryName(projectName)+File.separator;
					}
				}
			}
			if (topPackage==null && moduleArtifacts!=null) {
				if (moduleArtifacts.contains(obj)) {
					if (relPath.startsWith(BpelOptionsUtil.getWPSModuleName(projectName))) {
						topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
					}
				}
			}
			if (topPackage != null) {
				return relPath.substring(topPackage.length());
			}
			return relPath;
		}
		
		private String getRelativePath(SolutionArtifact sa, Object obj) {
			return getRelativePath(sa,obj,false);
		}
		
		/**
		 * Internal method that calculates the relative file path of the element contianed in the solution artifact
		 * @param sa
		 * @param obj - Optional, it is the specific object inside the sa
		 * @return
		 */
		private String getRelativePath(SolutionArtifact sa, Object obj,boolean ignoreTopPackage) {		
			String topPackage="";		
			String projectName = (String)CrossProjectReferenceUtil.getProjectNameForTargetObject(obj);
			if (sa.getType()==SAType.UNCLASSIFIED_LITERAL) {
				if (obj!=null && obj instanceof Definition) {
					Set keys = obj2FileNameRegistry.keySet();
					if(keys.contains(obj) && BpelOptionsUtil.getWPSLibraryName(projectName)!=null){						
						topPackage=BpelOptionsUtil.getWPSLibraryName(projectName)+File.separator;
						this.addObject(libraryArtifacts,obj);					
					}else{
						//AZ WMT 20070322 
						//AZ 20070315 support pattern
						boolean isArtifacts = ExportOperationUtil.isArtifactsDefinition(obj);
						//AZ defect 148942
						if((BpelOptionsUtil.isLibraryEnabledWithModuleProject()||BpelOptionsUtil.isLibraryOnly())&&
								!isArtifacts){
							//local interface should go lib too
							//AZ 20070427 add object as libraryArtifacts
							if (BpelOptionsUtil.getWPSLibraryName(projectName)!=null) {
								topPackage=BpelOptionsUtil.getWPSLibraryName(projectName)+File.separator;
								this.addObject(libraryArtifacts,obj);
							}							
							
						}else{						
							if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
								topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
								this.addObject(moduleArtifacts,obj);
							}	
						}
					}
				} else if (obj != null && obj instanceof ICalendar) {
					if(BpelOptions.isBestPracticePatternEnabed(getExportSession()) || 
							BpelOptionsUtil.isLibraryEnabledWithModuleProject() ||
							BpelOptionsUtil.isLibraryOnly()){
						if(topLevelDocumentRoot.contains(obj)){
							topPackage = BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						} else if (timetableRegistry.contains(obj)){
							topPackage = BpelOptionsUtil.getWPSLibraryName(projectName)+File.separator;
							this.addObject(libraryArtifacts,obj);
						} else {
							topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;						
						}
					} else {
						if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
							topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
							this.addObject(moduleArtifacts,obj);
						}					
					}					
				} else {
					if (BpelOptionsUtil.getWPSLibraryName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSLibraryName(projectName)+File.separator;						
						this.addObject(libraryArtifacts,obj);
					} else if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						this.addObject(moduleArtifacts,obj);
					}	
					if(obj instanceof XSDSchema){
						XSDSchema schema = (XSDSchema)obj;
						if(!ExportOperationUtil.isExternalFile(schema.getSchemaLocation())){
							//AZ take the first segment which is the project name							
//							String tnsProjectName = null;
//							String catalogPath = createFilePathFromNamespace(schema.getTargetNamespace());
//							if(catalogPath.indexOf(FILE_SEPARATOR) != -1 &&
//									!CrossProjectReferenceUtil.isArtificialListSchema(obj)){
//								tnsProjectName = catalogPath.substring(0,catalogPath.indexOf(FILE_SEPARATOR));								
//							}else{
//								tnsProjectName = catalogPath;
//							}
//							topPackage =topPackage+tnsProjectName+File.separator;
//GJD20070925							topPackage =topPackage+projectName+File.separator;
						}
					}
				}				
			} else if (sa.getType()==SAType.PROCESS_FLOW_LITERAL){
				if (obj!=null && obj instanceof Definition) {
					if (BpelOptionsUtil.getWPSLibraryName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSLibraryName(projectName)+File.separator;
						this.addObject(libraryArtifacts,obj);
					} else if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						this.addObject(moduleArtifacts,obj);
					}
					//we need more logic to determine the package
					if(FabricIntegrationUtil.isProcessInterfaceDefinition((Definition)obj)){
						EObject es = CrossProjectReferenceUtil.getSourceForTarget((EObject)obj);
						String packageStr = SAUtil.createPackage(es);
						sa.setPackage(packageStr);
					}			
					
				} else {
					if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						this.addObject(moduleArtifacts,obj);
						//					} else if (BpelOptionsUtil.getWPSLibraryName()!=null) {
						//						topPackage=BpelOptionsUtil.getWPSLibraryName()+File.separator;
					}					
				}
			} else if(sa.getType()== SAType.HUMAN_TASK_LITERAL){
				if(BpelOptions.isBestPracticePatternEnabed(getExportSession())){
					if(topLevelDocumentRoot.contains(obj)){
						topPackage = BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
					} else {
						topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;						
					}
				} else {
					if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						this.addObject(moduleArtifacts,obj);
						//				} else if (BpelOptionsUtil.getWPSLibraryName()!=null) {
						//					topPackage=BpelOptionsUtil.getWPSLibraryName()+File.separator;
					}					
				}
			}
			else if (sa.getType()==SAType.SCDL_LITERAL) {
				//AZ WMT 20070322 
				if(BpelOptions.isBestPracticePatternEnabed(getExportSession())){
					topPackage = ExportOperationUtil.getTopPackageName(obj) + File.separator;
//					if(obj instanceof Definition){
//						if(ExportOperationUtil.isArtifactsDefinition(obj)){
//							topPackage = BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
//						}
//					}
					if(obj instanceof DocumentRoot){
						DocumentRoot docRoot = (DocumentRoot)obj;
						boolean isInTopLevelModel = false;
						//AR enable MFC for WID defect 82758
						//if(BpelOptionsUtil.isGenerateForDeployPatternEnabled() && docRoot.getImport() != null){
						if(docRoot.getImport() != null){
							com.ibm.wsspi.sca.scdl.Import thisImport = docRoot.getImport();
							if(thisImport.getBinding() != null && thisImport.getBinding() instanceof WebServiceImportBinding){
								topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;
							}
						}

//						if(docRoot.getComponent().getImplementation() instanceof TaskImplementation ||									
//						docRoot.getComponent().getImplementation() instanceof BusinessRuleGroupImplementation){
//						isInTopLevelModel = true;
//						}							
//						}
						//TODO
						if(topLevelDocumentRoot.contains(obj) || isInTopLevelModel){
							topPackage = BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						}
					} else if(obj instanceof BusinessRuleGroup || 
							obj instanceof BusinessRuleGroupTable ||
							obj instanceof RuleSet ||
							obj instanceof com.ibm.wbit.br.core.model.DocumentRoot){			
						//topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;
						//Business rule artifacts should go into top level module
//						if(topLevelDocumentRoot.contains(obj)){
						if(topLevelDocumentRoot.contains(obj)){
							topPackage = BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						} else{
							topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;						
						}
					} else if(obj instanceof JavaImplementation){
						JavaImplementation javaImpl = (JavaImplementation)obj;
						Component component = javaImpl.getComponent();
						if(component != null && component.eContainer()instanceof DocumentRoot){
							DocumentRoot root = (DocumentRoot)component.eContainer();
							String eContainerProjectName = CrossProjectReferenceUtil.getProjectNameForTargetObject(root);
							topPackage = BpelOptionsUtil.getImplementationModuleName(eContainerProjectName)+File.separator;
						}
					} else if (obj instanceof Process || obj instanceof com.ibm.wbit.sib.mediation.operation.model.DocumentRoot || obj instanceof EPackage){
						topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;
					} else if (obj instanceof Definition) {
						if ( ExportOperationUtil.isArtifactsDefinition(obj)) {
							topPackage = BpelOptionsUtil.getImplementationModuleName(projectName)+File.separator;
						}
					}
				}else{
					if (BpelOptionsUtil.getWPSModuleName(projectName)!=null) {
						topPackage=BpelOptionsUtil.getWPSModuleName(projectName)+File.separator;
						this.addObject(moduleArtifacts,obj);
						//				} else if (BpelOptionsUtil.getWPSLibraryName()!=null) {
						//					topPackage=BpelOptionsUtil.getWPSLibraryName()+File.separator;
					}else if(obj instanceof JavaImplementation){
						JavaImplementation javaImpl = (JavaImplementation)obj;
						Component component = javaImpl.getComponent();
						if(component != null && component.eContainer()instanceof DocumentRoot){
							DocumentRoot root = (DocumentRoot)component.eContainer();
							String eContainerProjectName = CrossProjectReferenceUtil.getProjectNameForTargetObject(root);
							String moduleName = BpelOptionsUtil.getWPSModuleName(eContainerProjectName);
							if (moduleName != null) {
								topPackage = moduleName + File.separator;
							} else if (projectName == null){	//d164171 - use project name when exporting with "None" option
								projectName = eContainerProjectName;
							}
							//d164171 topPackage = BpelOptionsUtil.getWPSModuleName(eContainerProjectName) + File.separator;
						}
					} 
					if (BpelOptionsUtil.isPersistSCDLComponentToRootFolder()) {
						sa.setPackage(null);
					}
				}
			}
			if(BpelOptionsUtil.isNoneOption()){
				topPackage = projectName+File.separator;;
			}
			if (!ignoreTopPackage) {					
				return topPackage+(sa.getPackage()==null?"":sa.getPackage());				
			} else {
				return (sa.getPackage()==null?"":sa.getPackage());
			}
		}
	}
	/**
	 * @return Returns the sourcePathToTargetPathAbsoluteRegistry.
	 */
	private Map<String, List<Object>> getSourcePathToTargetPathAbsoluteRegistry() {
		return sourcePathToTargetPathAbsoluteRegistry;
	}
	/**
	 * @param sourcePathToTargetPathAbsoluteRegistry The sourcePathToTargetPathAbsoluteRegistry to set.
	 */
	private void setSourcePathToTargetPathAbsoluteRegistry(Map<String, List<Object>> sourcePathToTargetPathAbsoluteRegistry) {
		this.sourcePathToTargetPathAbsoluteRegistry = sourcePathToTargetPathAbsoluteRegistry;
	}
	
	private void setArtifatcsDefinitionRegistry(Set<Object> artifatcsDefinitionRegistry){
		this.artifactsDefinitionRegistry = artifatcsDefinitionRegistry;
	}
	
	private Set<Object> getArtifatcsDefinitionRegistry(){
		return this.artifactsDefinitionRegistry;
	}
	
	private void setScdlComponentPathRegistry(List<String> scdlComponentPathRegistry){
		this.scdlComponentPathRegistry = scdlComponentPathRegistry;
	}
	
	private List<String> getScdlComponentPathRegistry(){
		return scdlComponentPathRegistry;
	}
	
	/**
	 * This method is to process WSDL/XSD instances registered, the registry will
	 * be processed based on the contents of the value:
	 * 1. SA resource - read resource, update imports, and save
	 * 2. WSDL/XSD instances, which are imported but unreferenced resources
	 * 	   - create Resource in ResourceSet based on target path, update 
	 *    	imports, save resource.
	 * @param registry
	 */
	private void processResourceRegistry(Map<String, List<Object>> registry,ResourceSet resourceSet){		
		Map<String, String> options = new HashMap<String, String>();
		if(registry == null ||registry.size()== 0){
			return;			
		}

		Collection<List<Object>> values = registry.values();
		Iterator<List<Object>> valueIt = values.iterator();
		while(valueIt.hasNext()){
			Object eachValue = valueIt.next();
			if(eachValue instanceof List){
				List valueList = (List)eachValue;
				if(valueList.size() > 1){
					// 0 index is the Resource or WSDL/XSD instance
					Object resource = valueList.get(0);
					// 1 index is the target path for the resource
					String targetPath = ExportOperationUtil.replaceConvertedSpaces((String)valueList.get(1));
					if(resource instanceof WSDLResourceImpl){
						WSDLResourceImpl wsdlResource = (WSDLResourceImpl)resource;
						if(getArtifatcsDefinitionRegistry().contains(wsdlResource)){
							continue;
						}
						Definition definition = (Definition)wsdlResource.getContents().get(0);
						ExportOperationUtil.fixImport(definition,registry, false,getAbsPathPrefix().length());
						doSave(wsdlResource,options);
					}else if(resource instanceof XSDResourceImpl){
						XSDResourceImpl xsdResource = (XSDResourceImpl)resource;
						Object content = xsdResource.getContents().get(0);
						if(content instanceof Definition){							
							Resource wsdlResource = ExportOperationUtil.createResource(content,getWsdlResourceFactory(),resourceSet,targetPath);
							ExportOperationUtil.fixImport((Definition)content,registry, false,getAbsPathPrefix().length());
							doSave(wsdlResource,options);
						}else{
							XSDSchema xsdContent = (XSDSchema)xsdResource.getContents().get(0);
							doSave((XSDResourceImpl)resource,options);
						}
						
					}else if(resource instanceof Definition){
						//process unreferenced definition
						Definition definition = (Definition)resource;	
						ExportOperationUtil.addToExtDocumentWithArtCatList(MappingUtil.resolveUnreferencedService(definition.getLocation()));
						ExportOperationUtil.fixImport(definition,registry, false,getAbsPathPrefix().length());
						Resource wsdlResource = ExportOperationUtil.createResource(resource,getWsdlResourceFactory(),resourceSet,targetPath);
						if(BpelOptionsUtil.isMapModelGenerationEnabled()){
							MappingUtil.addMapForUnTransformedService(objectFilePathMap, definition, targetPath, definition.getLocation());
						}
						//force saving
						options.put(FILE_ATTACHMENT, TRUE_LIETRAL);
						doSave(wsdlResource,options);
					}else if(resource instanceof XSDSchema){
						//process unreferenced schema
						Resource xsdResource = null;
						String absolutePath = (String)MappingUtil.resolveRegistryPathKey(registry, eachValue);
						ExportOperationUtil.addToExtDocumentWithArtCatList(MappingUtil.resolveUnreferencedSchema(absolutePath));
						if (targetPath.startsWith(URI_FILE)) {
							xsdResource = ExportOperationUtil.createResource(resource,getXsdResourceFactory(),resourceSet,targetPath.substring(6));
						} else {
							xsdResource = ExportOperationUtil.createResource(resource,getXsdResourceFactory(),resourceSet,targetPath);
						}
						if(BpelOptionsUtil.isMapModelGenerationEnabled()){
							MappingUtil.addMapForUnTransformedSchema(objectFilePathMap, (XSDSchema)resource, targetPath, (String)MappingUtil.resolveRegistryPathKey(registry, eachValue));
						}
						//we may make use of the options to pass external schema information to make sure it's saved
						options.put(FILE_ATTACHMENT, TRUE_LIETRAL);
						doSave(xsdResource,options);
					}
				}
			}			
		}
	}

	protected Set getTopLevelDocumentRoot() {
		return topLevelDocumentRoot;
	}

	protected void setTopLevelDocumentRoot(Set topLevelDocumentRoot) {
		this.topLevelDocumentRoot = topLevelDocumentRoot;
	}

	protected Set getTimetableRegistry() {
		return timetableRegistry;
	}

	protected void setTimetableRegistry(Set newTimetableRegistry) {
		this.timetableRegistry = newTimetableRegistry;
	}
	
	public Map<String, Resource> getImportResourceMap() {
		return importResourceMap;
	}

	public void setImportResourceMap(Map<String, Resource> importResourceMap) {
		this.importResourceMap = importResourceMap;
	}
	   /**
	     * Create the dyanamic assembler configuration file along with the component
	   * @param resourceSet
	   * @param relativePath
       * @param filePath
	   * @param dr 
	   */
	private void persistDynamicAssemblerConfiguration(ResourceSet resourceSet, String relativePath, String filePath, DocumentRoot dr) {
		if(filePath == null || relativePath == null || dr == null || resourceSet == null){
			return;
		}
		if(dr.getComponent() != null && dr.getComponent().getImplementation() instanceof DynamicAssembler){					
			DynamicAssemblyConfiguration config = DAFactory.eINSTANCE.createDynamicAssemblyConfiguration();
			//Default settings for the DA configration file
			config.setFireInvocationEvents(true);
			config.setResultCaching(true);
			config.setVerboseLogging(false);	
				//Create resource for the configuration file
				DAResourceFactoryImpl daResourceFactory = new DAResourceFactoryImpl();
				String componentName = dr.getComponent().getName();
				String configFileName = null;
				if(componentName != null && componentName.indexOf(FILE_SEPARATOR) != -1){
				configFileName = componentName.substring(componentName.lastIndexOf(FILE_SEPARATOR)+1)+DA_CONFIGURATION_EXT;
				}
				if(configFileName != null && config != null){
					URI daConfigFileURI = URI.createFileURI(filePath+relativePath+configFileName);
					Resource daConfigResource = daResourceFactory.createResource(daConfigFileURI);
					daConfigResource.getContents().add(config);
					if(daConfigResource != null){
						resourceSet.getResources().add(daConfigResource);
						Map<String, String> options = new HashMap<String, String>();
						options.put(XMLResource.OPTION_ENCODING, "UTF-8");
						doSave(daConfigResource, options);
				}					
			}
		}
	}
}
