package com.ibm.btools.te.ilm;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import org.eclipse.core.internal.resources.ModelObjectWriter;
import org.eclipse.core.internal.resources.ProjectDescription;

/**
 * TEModelObjectWrite overrides the ModelObjectWriter to specify the referencedProjects based on names and not 
 * the actual IProject object.
 */
public class TEModelObjectWriter extends ModelObjectWriter {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	private String[] referencedProjects=null;
	
	protected String[] getReferencedProjects(ProjectDescription description) {
		if (referencedProjects!=null) {
			return getReferencedProjects();			
		} else {
			return super.getReferencedProjects(description);
		}
	}	
	/**
	 * @return Returns the referencedProjects.
	 */
	public String[] getReferencedProjects() {
		return referencedProjects;
	}
	/**
	 * @param referencedProjects The referencedProjects to set.
	 */
	public void setReferencedProjects(String[] referencedProjects) {
		this.referencedProjects = referencedProjects;
	}
}
