package com.ibm.btools.te.ilm.attribute;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.te.attributes.helper.AttributeNameConstants;
import com.ibm.btools.te.ilm.attribute.wps.BpelAttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.wps.BusinessRuleValueProvider;
import com.ibm.btools.te.ilm.attribute.wps.ServiceComponentProvider;
import com.ibm.btools.te.ilm.attribute.wps.SpecificationAttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.wps.TELAttributeValueProvider;
import com.ibm.btools.te.ilm.attribute.wps.WSDLAttributeValueProvider;

/**
* Factory class responsible for creating an AttributeValueProvider. 
*/
public class AttributeValueProviderFactory {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/**
	 * Returns a specific AttributeValueProvider based on the property<code>propertyName</code> 
	 * @param propertyName a technical property
	 * @return AttribuetValueProvider
	 */
	public static AttributeValueProvider createAttributeValueProvider(String propertyName){
		
		if(propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME) || propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_NAME)
				|| propertyName.equals(AttributeNameConstants.BPEL_PROCESS_DISPLAY_NAME) || propertyName.equals(AttributeNameConstants.BPEL_PROCESS_NAME)
						|| propertyName.equals(AttributeNameConstants.BPEL_PROCESS_TARGET_NAMESPACE) || propertyName.equals(AttributeNameConstants.BPEL_VARIABLE_NAME) 
						|| propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME_SWITCH) || propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME_WHILE)
						|| propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_DISPLAY_NAME_SCOPE) || propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_NAME_SWITCH) || propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_NAME_WHILE) 
						|| propertyName.equals(AttributeNameConstants.BPEL_ACTIVITY_NAME_SCOPE)|| propertyName.equals(AttributeNameConstants.BPEL_VARIABLE_NAME_VARIABLE)){
			return new BpelAttributeValueProvider();
		}else if(propertyName.equals(AttributeNameConstants.WSDL_CALLBACK_PORT_TYPE_NAME) || propertyName.equals(AttributeNameConstants.WSDL_MESSAGE_NAME)
				||  propertyName.equals(AttributeNameConstants.WSDL_OPERATION_NAME) ||  propertyName.equals(AttributeNameConstants.WSDL_PART_NAME)
				||  propertyName.equals(AttributeNameConstants.WSDL_PART_NAME) ||  propertyName.equals(AttributeNameConstants.WSDL_PORT_TYPE_NAME)
						||  propertyName.equals(AttributeNameConstants.WSDL_TARGET_NAMESPACE) ||  propertyName.equals(AttributeNameConstants.WSDL_CALLBACK_PORT_TYPE_TARGET_NAMESPACE)){
			return new WSDLAttributeValueProvider();
		}else if(  propertyName.equals(AttributeNameConstants.BPEL_PROCESS_IS_LONG_RUNNING) ||  propertyName.equals(AttributeNameConstants.BPEL_PROCESS_VALID_FROM)
				 ||  propertyName.equals(AttributeNameConstants.BPEL_PROCESS_RUN_AS_CHILD) ||  propertyName.equals(AttributeNameConstants.GENERATE_SWITCH)
				 || propertyName.equals(AttributeNameConstants.IS_ONE_WAY_OPERATION)){
			return new SpecificationAttributeValueProvider();
		}else if(propertyName.equals(AttributeNameConstants.BUSINESS_RULE_NAME)) {			
			return new BusinessRuleValueProvider();
		}else if (propertyName.equals(AttributeNameConstants.TEL_TASK_NAME)||propertyName.equals(AttributeNameConstants.TEL_TASK_DISPLAY_NAME)||
				propertyName.equals(AttributeNameConstants.TEL_EMAIL_NAME) || propertyName.equals(AttributeNameConstants.TEL_ESCALATION_NAME) ||
				propertyName.equals(AttributeNameConstants.TEL_ESCALATION_DISPLAY_NAME)) {
			return new TELAttributeValueProvider();
		}else {
			return new ServiceComponentProvider();
			
		}
	}
}
