/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.graphs.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;

import com.ibm.btools.te.ilm.graphs.BPGraph;
import com.ibm.btools.te.ilm.graphs.GraphsFactory;
import com.ibm.btools.te.ilm.graphs.GraphsPackage;
import com.ibm.btools.te.ilm.graphs.ProcessFlowGraph;
import com.ibm.btools.te.ilm.graphs.SAGraph;
import com.ibm.btools.te.ilm.graphs.SolutionGraph;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class GraphsFactoryImpl extends EFactoryImpl implements GraphsFactory {
	
	// copyright   
	  public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$  
	  
	/**
	 * Creates and instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GraphsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case GraphsPackage.BP_GRAPH: return createBPGraph();
			case GraphsPackage.PROCESS_FLOW_GRAPH: return createProcessFlowGraph();
			case GraphsPackage.SA_GRAPH: return createSAGraph();
			case GraphsPackage.SOLUTION_GRAPH: return createSolutionGraph();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BPGraph createBPGraph() {
		BPGraphImpl bpGraph = new BPGraphImpl();
		return bpGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessFlowGraph createProcessFlowGraph() {
		ProcessFlowGraphImpl processFlowGraph = new ProcessFlowGraphImpl();
		return processFlowGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SAGraph createSAGraph() {
		SAGraphImpl saGraph = new SAGraphImpl();
		return saGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SolutionGraph createSolutionGraph() {
		SolutionGraphImpl solutionGraph = new SolutionGraphImpl();
		return solutionGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GraphsPackage getGraphsPackage() {
		return (GraphsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static GraphsPackage getPackage() {
		return GraphsPackage.eINSTANCE;
	}

} //GraphsFactoryImpl
