/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.graphs.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import com.ibm.btools.te.ilm.graphs.GraphsPackage;
import com.ibm.btools.te.ilm.graphs.SAGraph;

/**
 * A Solution Artifact Graph that captures a solution artifact interface
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.btools.te.graphs.impl.SAGraphImpl#getArtifactInterface <em>Artifact Interface</em>}</li>
 * </ul>
 * </p>
 *
 */
public class SAGraphImpl extends EObjectImpl implements SAGraph {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached value of the '{@link #getArtifactInterface() <em>Artifact Interface</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArtifactInterface()
	 * @generated
	 * @ordered
	 */
	protected EObject artifactInterface = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SAGraphImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return GraphsPackage.eINSTANCE.getSAGraph();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject getArtifactInterface() {
		if (artifactInterface != null && artifactInterface.eIsProxy()) {
			EObject oldArtifactInterface = artifactInterface;
			artifactInterface = (EObject)eResolveProxy((InternalEObject)artifactInterface);
			if (artifactInterface != oldArtifactInterface) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, GraphsPackage.SA_GRAPH__ARTIFACT_INTERFACE, oldArtifactInterface, artifactInterface));
			}
		}
		return artifactInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject basicGetArtifactInterface() {
		return artifactInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setArtifactInterface(EObject newArtifactInterface) {
		EObject oldArtifactInterface = artifactInterface;
		artifactInterface = newArtifactInterface;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GraphsPackage.SA_GRAPH__ARTIFACT_INTERFACE, oldArtifactInterface, artifactInterface));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SA_GRAPH__ARTIFACT_INTERFACE:
				if (resolve) return getArtifactInterface();
				return basicGetArtifactInterface();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SA_GRAPH__ARTIFACT_INTERFACE:
				setArtifactInterface((EObject)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SA_GRAPH__ARTIFACT_INTERFACE:
				setArtifactInterface((EObject)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SA_GRAPH__ARTIFACT_INTERFACE:
				return artifactInterface != null;
		}
		return eDynamicIsSet(eFeature);
	}

} //SAGraphImpl
