/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.graphs.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.te.ilm.graphs.GraphsPackage;
import com.ibm.btools.te.ilm.graphs.SolutionGraph;

/**
 * Solution Graph representation that captures a let of links between
 * Solution Artifacts
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.btools.te.graphs.impl.SolutionGraphImpl#getDirectLinks <em>Direct Links</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SolutionGraphImpl extends SAGraphImpl implements SolutionGraph {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached value of the '{@link #getDirectLinks() <em>Direct Links</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDirectLinks()
	 * @generated
	 * @ordered
	 */
	protected EList directLinks = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SolutionGraphImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return GraphsPackage.eINSTANCE.getSolutionGraph();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getDirectLinks() {
		if (directLinks == null) {
			directLinks = new EObjectContainmentEList(EObject.class, this, GraphsPackage.SOLUTION_GRAPH__DIRECT_LINKS);
		}
		return directLinks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case GraphsPackage.SOLUTION_GRAPH__DIRECT_LINKS:
					return ((InternalEList)getDirectLinks()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SOLUTION_GRAPH__ARTIFACT_INTERFACE:
				if (resolve) return getArtifactInterface();
				return basicGetArtifactInterface();
			case GraphsPackage.SOLUTION_GRAPH__DIRECT_LINKS:
				return getDirectLinks();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SOLUTION_GRAPH__ARTIFACT_INTERFACE:
				setArtifactInterface((EObject)newValue);
				return;
			case GraphsPackage.SOLUTION_GRAPH__DIRECT_LINKS:
				getDirectLinks().clear();
				getDirectLinks().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SOLUTION_GRAPH__ARTIFACT_INTERFACE:
				setArtifactInterface((EObject)null);
				return;
			case GraphsPackage.SOLUTION_GRAPH__DIRECT_LINKS:
				getDirectLinks().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case GraphsPackage.SOLUTION_GRAPH__ARTIFACT_INTERFACE:
				return artifactInterface != null;
			case GraphsPackage.SOLUTION_GRAPH__DIRECT_LINKS:
				return directLinks != null && !directLinks.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} //SolutionGraphImpl
