/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.TransformationRoot;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Transformation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Source = BPGraph
 * Target = a set of generic IT graphs and Data definitions
 * Rule =
 * 1.Go through the BPGraph and extract all top level processes
 * 2. For each top level process, it creates a PatternRule based on user preference (or user interaction)
 * 3. Creates a Solution rule and set the generic graphs created from the PatternRule as the source.
 * 4. Extracts the data definition in the dataDefRegistry and collects the data definition targets
 * 
 * 
 * 
 * <!-- end-model-doc -->
 *
 *
 * @see com.ibm.btools.te.ilm.heuristics.HeuristicsPackage#getHeuristicsTransformation()
 * @model
 * @generated
 */
public interface HeuristicsTransformation extends TransformationRoot {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * isFirstClassArtifact checks if the artifact is a top level participant that the HeuristicsTransformation need to process
	 * <!-- end-model-doc -->
	 * @model
	 * @generated
	 */
	boolean isFirstClassArtifact(EObject artifact);

} // HeuristicsTransformation
