/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.abstractbpel.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/



import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractProcDefRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ActivityRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AssignRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BRTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.BpelOptimizationRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.CallBehaviorActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.CallOperationActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ConcurrentBranchRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ConnectableRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ContainerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreAccessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DatastoreRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.DecisionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ExclusiveBranchRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ExpressionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ForkRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.FormRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.GenericActionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTBusinessCalendarRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HTTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.HumanTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InputRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InputValuePinRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.InvokeWithCallbackRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.JoinRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.LinkRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.LoopNodeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.MapRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.MergeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.OneWayInvokeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.OutputRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.PartnerRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessInterfaceRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.ProcessWalkingRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANNestedProcessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableProcessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANReusableTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.SANTaskRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.StaffActivityRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.TerminationNodeRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableAccessRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.VariableRule;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage
 * @generated
 */
public class AbstractbpelSwitch {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static AbstractbpelPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AbstractbpelSwitch() {
		if (modelPackage == null) {
			modelPackage = AbstractbpelPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case AbstractbpelPackage.ABSTRACT_PROC_DEF_RULE: {
				AbstractProcDefRule abstractProcDefRule = (AbstractProcDefRule)theEObject;
				Object result = caseAbstractProcDefRule(abstractProcDefRule);
				if (result == null) result = caseTransformationRule(abstractProcDefRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.ACTION_RULE: {
				ActionRule actionRule = (ActionRule)theEObject;
				Object result = caseActionRule(actionRule);
				if (result == null) result = caseConnectableRule(actionRule);
				if (result == null) result = caseAbstractProcDefRule(actionRule);
				if (result == null) result = caseTransformationRule(actionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.ACTIVITY_RULE: {
				ActivityRule activityRule = (ActivityRule)theEObject;
				Object result = caseActivityRule(activityRule);
				if (result == null) result = caseAbstractProcDefRule(activityRule);
				if (result == null) result = caseTransformationRule(activityRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.SAN_REUSABLE_PROCESS_RULE: {
				SANReusableProcessRule sanReusableProcessRule = (SANReusableProcessRule)theEObject;
				Object result = caseSANReusableProcessRule(sanReusableProcessRule);
				if (result == null) result = caseActionRule(sanReusableProcessRule);
				if (result == null) result = caseConnectableRule(sanReusableProcessRule);
				if (result == null) result = caseAbstractProcDefRule(sanReusableProcessRule);
				if (result == null) result = caseTransformationRule(sanReusableProcessRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.SAN_NESTED_PROCESS_RULE: {
				SANNestedProcessRule sanNestedProcessRule = (SANNestedProcessRule)theEObject;
				Object result = caseSANNestedProcessRule(sanNestedProcessRule);
				if (result == null) result = caseConnectableRule(sanNestedProcessRule);
				if (result == null) result = caseAbstractProcDefRule(sanNestedProcessRule);
				if (result == null) result = caseTransformationRule(sanNestedProcessRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.SAN_TASK_RULE: {
				SANTaskRule sanTaskRule = (SANTaskRule)theEObject;
				Object result = caseSANTaskRule(sanTaskRule);
				if (result == null) result = caseActionRule(sanTaskRule);
				if (result == null) result = caseConnectableRule(sanTaskRule);
				if (result == null) result = caseAbstractProcDefRule(sanTaskRule);
				if (result == null) result = caseTransformationRule(sanTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.PROCESS_RULE: {
				ProcessRule processRule = (ProcessRule)theEObject;
				Object result = caseProcessRule(processRule);
				if (result == null) result = caseProcessWalkingRule(processRule);
				if (result == null) result = caseConnectableRule(processRule);
				if (result == null) result = caseAbstractProcDefRule(processRule);
				if (result == null) result = caseTransformationRule(processRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.CONTAINER_RULE: {
				ContainerRule containerRule = (ContainerRule)theEObject;
				Object result = caseContainerRule(containerRule);
				if (result == null) result = caseAbstractProcDefRule(containerRule);
				if (result == null) result = caseTransformationRule(containerRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.CALL_BEHAVIOR_ACTION_RULE: {
				CallBehaviorActionRule callBehaviorActionRule = (CallBehaviorActionRule)theEObject;
				Object result = caseCallBehaviorActionRule(callBehaviorActionRule);
				if (result == null) result = caseActionRule(callBehaviorActionRule);
				if (result == null) result = caseConnectableRule(callBehaviorActionRule);
				if (result == null) result = caseAbstractProcDefRule(callBehaviorActionRule);
				if (result == null) result = caseTransformationRule(callBehaviorActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.SAN_REUSABLE_TASK_RULE: {
				SANReusableTaskRule sanReusableTaskRule = (SANReusableTaskRule)theEObject;
				Object result = caseSANReusableTaskRule(sanReusableTaskRule);
				if (result == null) result = caseActionRule(sanReusableTaskRule);
				if (result == null) result = caseConnectableRule(sanReusableTaskRule);
				if (result == null) result = caseAbstractProcDefRule(sanReusableTaskRule);
				if (result == null) result = caseTransformationRule(sanReusableTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.CONNECTABLE_RULE: {
				ConnectableRule connectableRule = (ConnectableRule)theEObject;
				Object result = caseConnectableRule(connectableRule);
				if (result == null) result = caseAbstractProcDefRule(connectableRule);
				if (result == null) result = caseTransformationRule(connectableRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.PROCESS_WALKING_RULE: {
				ProcessWalkingRule processWalkingRule = (ProcessWalkingRule)theEObject;
				Object result = caseProcessWalkingRule(processWalkingRule);
				if (result == null) result = caseConnectableRule(processWalkingRule);
				if (result == null) result = caseAbstractProcDefRule(processWalkingRule);
				if (result == null) result = caseTransformationRule(processWalkingRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.EXCLUSIVE_BRANCH_RULE: {
				ExclusiveBranchRule exclusiveBranchRule = (ExclusiveBranchRule)theEObject;
				Object result = caseExclusiveBranchRule(exclusiveBranchRule);
				if (result == null) result = caseProcessWalkingRule(exclusiveBranchRule);
				if (result == null) result = caseConnectableRule(exclusiveBranchRule);
				if (result == null) result = caseAbstractProcDefRule(exclusiveBranchRule);
				if (result == null) result = caseTransformationRule(exclusiveBranchRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.CONCURRENT_BRANCH_RULE: {
				ConcurrentBranchRule concurrentBranchRule = (ConcurrentBranchRule)theEObject;
				Object result = caseConcurrentBranchRule(concurrentBranchRule);
				if (result == null) result = caseProcessWalkingRule(concurrentBranchRule);
				if (result == null) result = caseConnectableRule(concurrentBranchRule);
				if (result == null) result = caseAbstractProcDefRule(concurrentBranchRule);
				if (result == null) result = caseTransformationRule(concurrentBranchRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.DECISION_RULE: {
				DecisionRule decisionRule = (DecisionRule)theEObject;
				Object result = caseDecisionRule(decisionRule);
				if (result == null) result = caseConnectableRule(decisionRule);
				if (result == null) result = caseAbstractProcDefRule(decisionRule);
				if (result == null) result = caseTransformationRule(decisionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.MERGE_RULE: {
				MergeRule mergeRule = (MergeRule)theEObject;
				Object result = caseMergeRule(mergeRule);
				if (result == null) result = caseConnectableRule(mergeRule);
				if (result == null) result = caseAbstractProcDefRule(mergeRule);
				if (result == null) result = caseTransformationRule(mergeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.ASSIGN_RULE: {
				AssignRule assignRule = (AssignRule)theEObject;
				Object result = caseAssignRule(assignRule);
				if (result == null) result = caseConnectableRule(assignRule);
				if (result == null) result = caseAbstractProcDefRule(assignRule);
				if (result == null) result = caseTransformationRule(assignRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.LINK_RULE: {
				LinkRule linkRule = (LinkRule)theEObject;
				Object result = caseLinkRule(linkRule);
				if (result == null) result = caseAbstractProcDefRule(linkRule);
				if (result == null) result = caseTransformationRule(linkRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.PARTNER_RULE: {
				PartnerRule partnerRule = (PartnerRule)theEObject;
				Object result = casePartnerRule(partnerRule);
				if (result == null) result = caseAbstractProcDefRule(partnerRule);
				if (result == null) result = caseTransformationRule(partnerRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.INVOKE_RULE: {
				InvokeRule invokeRule = (InvokeRule)theEObject;
				Object result = caseInvokeRule(invokeRule);
				if (result == null) result = caseConnectableRule(invokeRule);
				if (result == null) result = caseAbstractProcDefRule(invokeRule);
				if (result == null) result = caseTransformationRule(invokeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.JOIN_RULE: {
				JoinRule joinRule = (JoinRule)theEObject;
				Object result = caseJoinRule(joinRule);
				if (result == null) result = caseConnectableRule(joinRule);
				if (result == null) result = caseAbstractProcDefRule(joinRule);
				if (result == null) result = caseTransformationRule(joinRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.FORK_RULE: {
				ForkRule forkRule = (ForkRule)theEObject;
				Object result = caseForkRule(forkRule);
				if (result == null) result = caseConnectableRule(forkRule);
				if (result == null) result = caseAbstractProcDefRule(forkRule);
				if (result == null) result = caseTransformationRule(forkRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.VARIABLE_ACCESS_RULE: {
				VariableAccessRule variableAccessRule = (VariableAccessRule)theEObject;
				Object result = caseVariableAccessRule(variableAccessRule);
				if (result == null) result = caseConnectableRule(variableAccessRule);
				if (result == null) result = caseAbstractProcDefRule(variableAccessRule);
				if (result == null) result = caseTransformationRule(variableAccessRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.DATASTORE_ACCESS_RULE: {
				DatastoreAccessRule datastoreAccessRule = (DatastoreAccessRule)theEObject;
				Object result = caseDatastoreAccessRule(datastoreAccessRule);
				if (result == null) result = caseConnectableRule(datastoreAccessRule);
				if (result == null) result = caseAbstractProcDefRule(datastoreAccessRule);
				if (result == null) result = caseTransformationRule(datastoreAccessRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.DATASTORE_RULE: {
				DatastoreRule datastoreRule = (DatastoreRule)theEObject;
				Object result = caseDatastoreRule(datastoreRule);
				if (result == null) result = caseAbstractProcDefRule(datastoreRule);
				if (result == null) result = caseTransformationRule(datastoreRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.VARIABLE_RULE: {
				VariableRule variableRule = (VariableRule)theEObject;
				Object result = caseVariableRule(variableRule);
				if (result == null) result = caseAbstractProcDefRule(variableRule);
				if (result == null) result = caseTransformationRule(variableRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.PROCESS_DEFINITION_RULE: {
				ProcessDefinitionRule processDefinitionRule = (ProcessDefinitionRule)theEObject;
				Object result = caseProcessDefinitionRule(processDefinitionRule);
				if (result == null) result = caseTransformationRule(processDefinitionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.PROCESS_INTERFACE_RULE: {
				ProcessInterfaceRule processInterfaceRule = (ProcessInterfaceRule)theEObject;
				Object result = caseProcessInterfaceRule(processInterfaceRule);
				if (result == null) result = caseTransformationRule(processInterfaceRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.EXPRESSION_RULE: {
				ExpressionRule expressionRule = (ExpressionRule)theEObject;
				Object result = caseExpressionRule(expressionRule);
				if (result == null) result = caseAbstractProcDefRule(expressionRule);
				if (result == null) result = caseTransformationRule(expressionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.STAFF_ACTIVITY_RULE: {
				StaffActivityRule staffActivityRule = (StaffActivityRule)theEObject;
				Object result = caseStaffActivityRule(staffActivityRule);
				if (result == null) result = caseAbstractProcDefRule(staffActivityRule);
				if (result == null) result = caseTransformationRule(staffActivityRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.TERMINATION_NODE_RULE: {
				TerminationNodeRule terminationNodeRule = (TerminationNodeRule)theEObject;
				Object result = caseTerminationNodeRule(terminationNodeRule);
				if (result == null) result = caseConnectableRule(terminationNodeRule);
				if (result == null) result = caseAbstractProcDefRule(terminationNodeRule);
				if (result == null) result = caseTransformationRule(terminationNodeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.INPUT_VALUE_PIN_RULE: {
				InputValuePinRule inputValuePinRule = (InputValuePinRule)theEObject;
				Object result = caseInputValuePinRule(inputValuePinRule);
				if (result == null) result = caseConnectableRule(inputValuePinRule);
				if (result == null) result = caseAbstractProcDefRule(inputValuePinRule);
				if (result == null) result = caseTransformationRule(inputValuePinRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.CALL_OPERATION_ACTION_RULE: {
				CallOperationActionRule callOperationActionRule = (CallOperationActionRule)theEObject;
				Object result = caseCallOperationActionRule(callOperationActionRule);
				if (result == null) result = caseActionRule(callOperationActionRule);
				if (result == null) result = caseConnectableRule(callOperationActionRule);
				if (result == null) result = caseAbstractProcDefRule(callOperationActionRule);
				if (result == null) result = caseTransformationRule(callOperationActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.LOOP_NODE_RULE: {
				LoopNodeRule loopNodeRule = (LoopNodeRule)theEObject;
				Object result = caseLoopNodeRule(loopNodeRule);
				if (result == null) result = caseProcessRule(loopNodeRule);
				if (result == null) result = caseProcessWalkingRule(loopNodeRule);
				if (result == null) result = caseConnectableRule(loopNodeRule);
				if (result == null) result = caseAbstractProcDefRule(loopNodeRule);
				if (result == null) result = caseTransformationRule(loopNodeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.MAP_RULE: {
				MapRule mapRule = (MapRule)theEObject;
				Object result = caseMapRule(mapRule);
				if (result == null) result = caseConnectableRule(mapRule);
				if (result == null) result = caseAbstractProcDefRule(mapRule);
				if (result == null) result = caseTransformationRule(mapRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.GENERIC_ACTION_RULE: {
				GenericActionRule genericActionRule = (GenericActionRule)theEObject;
				Object result = caseGenericActionRule(genericActionRule);
				if (result == null) result = caseConnectableRule(genericActionRule);
				if (result == null) result = caseAbstractProcDefRule(genericActionRule);
				if (result == null) result = caseTransformationRule(genericActionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.ONE_WAY_INVOKE_RULE: {
				OneWayInvokeRule oneWayInvokeRule = (OneWayInvokeRule)theEObject;
				Object result = caseOneWayInvokeRule(oneWayInvokeRule);
				if (result == null) result = caseInvokeRule(oneWayInvokeRule);
				if (result == null) result = caseConnectableRule(oneWayInvokeRule);
				if (result == null) result = caseAbstractProcDefRule(oneWayInvokeRule);
				if (result == null) result = caseTransformationRule(oneWayInvokeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.INVOKE_WITH_CALLBACK_RULE: {
				InvokeWithCallbackRule invokeWithCallbackRule = (InvokeWithCallbackRule)theEObject;
				Object result = caseInvokeWithCallbackRule(invokeWithCallbackRule);
				if (result == null) result = caseOneWayInvokeRule(invokeWithCallbackRule);
				if (result == null) result = caseInvokeRule(invokeWithCallbackRule);
				if (result == null) result = caseConnectableRule(invokeWithCallbackRule);
				if (result == null) result = caseAbstractProcDefRule(invokeWithCallbackRule);
				if (result == null) result = caseTransformationRule(invokeWithCallbackRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.BPEL_OPTIMIZATION_RULE: {
				BpelOptimizationRule bpelOptimizationRule = (BpelOptimizationRule)theEObject;
				Object result = caseBpelOptimizationRule(bpelOptimizationRule);
				if (result == null) result = caseTransformationRule(bpelOptimizationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.HUMAN_TASK_RULE: {
				HumanTaskRule humanTaskRule = (HumanTaskRule)theEObject;
				Object result = caseHumanTaskRule(humanTaskRule);
				if (result == null) result = caseAbstractProcDefRule(humanTaskRule);
				if (result == null) result = caseTransformationRule(humanTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.INPUT_RULE: {
				InputRule inputRule = (InputRule)theEObject;
				Object result = caseInputRule(inputRule);
				if (result == null) result = caseAbstractProcDefRule(inputRule);
				if (result == null) result = caseTransformationRule(inputRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.OUTPUT_RULE: {
				OutputRule outputRule = (OutputRule)theEObject;
				Object result = caseOutputRule(outputRule);
				if (result == null) result = caseAbstractProcDefRule(outputRule);
				if (result == null) result = caseTransformationRule(outputRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.BR_REUSABLE_TASK_RULE: {
				BRReusableTaskRule brReusableTaskRule = (BRReusableTaskRule)theEObject;
				Object result = caseBRReusableTaskRule(brReusableTaskRule);
				if (result == null) result = caseActionRule(brReusableTaskRule);
				if (result == null) result = caseConnectableRule(brReusableTaskRule);
				if (result == null) result = caseAbstractProcDefRule(brReusableTaskRule);
				if (result == null) result = caseTransformationRule(brReusableTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.BR_TASK_RULE: {
				BRTaskRule brTaskRule = (BRTaskRule)theEObject;
				Object result = caseBRTaskRule(brTaskRule);
				if (result == null) result = caseActionRule(brTaskRule);
				if (result == null) result = caseConnectableRule(brTaskRule);
				if (result == null) result = caseAbstractProcDefRule(brTaskRule);
				if (result == null) result = caseTransformationRule(brTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.HT_REUSABLE_TASK_RULE: {
				HTReusableTaskRule htReusableTaskRule = (HTReusableTaskRule)theEObject;
				Object result = caseHTReusableTaskRule(htReusableTaskRule);
				if (result == null) result = caseActionRule(htReusableTaskRule);
				if (result == null) result = caseConnectableRule(htReusableTaskRule);
				if (result == null) result = caseAbstractProcDefRule(htReusableTaskRule);
				if (result == null) result = caseTransformationRule(htReusableTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.HT_TASK_RULE: {
				HTTaskRule htTaskRule = (HTTaskRule)theEObject;
				Object result = caseHTTaskRule(htTaskRule);
				if (result == null) result = caseActionRule(htTaskRule);
				if (result == null) result = caseConnectableRule(htTaskRule);
				if (result == null) result = caseAbstractProcDefRule(htTaskRule);
				if (result == null) result = caseTransformationRule(htTaskRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.FORM_RULE: {
				FormRule formRule = (FormRule)theEObject;
				Object result = caseFormRule(formRule);
				if (result == null) result = caseAbstractProcDefRule(formRule);
				if (result == null) result = caseTransformationRule(formRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AbstractbpelPackage.HT_BUSINESS_CALENDAR_RULE: {
				HTBusinessCalendarRule htBusinessCalendarRule = (HTBusinessCalendarRule)theEObject;
				Object result = caseHTBusinessCalendarRule(htBusinessCalendarRule);
				if (result == null) result = caseTransformationRule(htBusinessCalendarRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Abstract Proc Def Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Abstract Proc Def Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAbstractProcDefRule(AbstractProcDefRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseActionRule(ActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Activity Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Activity Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseActivityRule(ActivityRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Reusable Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Reusable Process Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANReusableProcessRule(SANReusableProcessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Nested Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Nested Process Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANNestedProcessRule(SANNestedProcessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANTaskRule(SANTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessRule(ProcessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Container Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Container Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseContainerRule(ContainerRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Call Behavior Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Call Behavior Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCallBehaviorActionRule(CallBehaviorActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>SAN Reusable Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>SAN Reusable Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSANReusableTaskRule(SANReusableTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Connectable Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Connectable Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConnectableRule(ConnectableRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Walking Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Walking Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessWalkingRule(ProcessWalkingRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Exclusive Branch Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Exclusive Branch Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseExclusiveBranchRule(ExclusiveBranchRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Concurrent Branch Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Concurrent Branch Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseConcurrentBranchRule(ConcurrentBranchRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Decision Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Decision Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDecisionRule(DecisionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Merge Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Merge Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMergeRule(MergeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Assign Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Assign Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAssignRule(AssignRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Link Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Link Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLinkRule(LinkRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Partner Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Partner Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePartnerRule(PartnerRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Invoke Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Invoke Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInvokeRule(InvokeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Join Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Join Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseJoinRule(JoinRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Fork Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Fork Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseForkRule(ForkRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Variable Access Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Variable Access Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseVariableAccessRule(VariableAccessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Datastore Access Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Datastore Access Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDatastoreAccessRule(DatastoreAccessRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Datastore Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Datastore Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDatastoreRule(DatastoreRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Variable Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Variable Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseVariableRule(VariableRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Definition Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Definition Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessDefinitionRule(ProcessDefinitionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Interface Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Interface Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessInterfaceRule(ProcessInterfaceRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Expression Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Expression Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseExpressionRule(ExpressionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Staff Activity Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Staff Activity Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStaffActivityRule(StaffActivityRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Termination Node Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Termination Node Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTerminationNodeRule(TerminationNodeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Input Value Pin Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Input Value Pin Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInputValuePinRule(InputValuePinRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Call Operation Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Call Operation Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCallOperationActionRule(CallOperationActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Loop Node Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Loop Node Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLoopNodeRule(LoopNodeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Map Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Map Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMapRule(MapRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Generic Action Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Generic Action Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGenericActionRule(GenericActionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>One Way Invoke Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>One Way Invoke Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseOneWayInvokeRule(OneWayInvokeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Invoke With Callback Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Invoke With Callback Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInvokeWithCallbackRule(InvokeWithCallbackRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Bpel Optimization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Bpel Optimization Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBpelOptimizationRule(BpelOptimizationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Human Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Human Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHumanTaskRule(HumanTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Input Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Input Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInputRule(InputRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Output Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Output Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseOutputRule(OutputRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BR Reusable Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BR Reusable Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBRReusableTaskRule(BRReusableTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BR Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BR Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBRTaskRule(BRTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HT Reusable Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HT Reusable Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHTReusableTaskRule(HTReusableTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HT Task Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HT Task Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHTTaskRule(HTTaskRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Form Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Form Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFormRule(FormRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HT Business Calendar Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HT Business Calendar Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHTBusinessCalendarRule(HTBusinessCalendarRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTransformationRule(TransformationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} //AbstractbpelSwitch
