/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.bpelp.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.expression.model.Expression;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.impl.TransformationRuleImpl;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpPackage;
import com.ibm.btools.te.ilm.heuristics.bpelp.JavaExprSerializerRule;
import com.ibm.btools.te.ilm.heuristics.bpelp.util.JavaExpressionSerializer;
import com.ibm.btools.te.ilm.heuristics.bpelp.util.JavaExpressionSerializerDiamond;
import com.ibm.btools.te.ilm.heuristics.helper.BpelOptionsUtil;
import com.ibm.wbit.bpel.BPELFactory;
import com.ibm.wbit.bpelpp.BPELPlusFactory;
import com.ibm.wbit.bpelpp.JavaCode;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Java Expr Serializer Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class JavaExprSerializerRuleImpl extends TransformationRuleImpl implements JavaExprSerializerRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected JavaExprSerializerRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return BpelpPackage.Literals.JAVA_EXPR_SERIALIZER_RULE;
	}

	/**
	 * source = Expression Model
	 * target = JavaCode object containing the java expression string
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (getSource() == null || getSource().isEmpty()) {
			LoggingUtil.traceExit(this, "transformSource2Target","no source");
			return false;			
		}
		
		String javaStr = "";
		//temp testing Diamond serializer
		if(BpelOptionsUtil.isTargetDiamondCompatible()){
			JavaExpressionSerializerDiamond ser = new JavaExpressionSerializerDiamond();
			javaStr = ser.serialize((Expression)getSource().get(0));
		}else{
			JavaExpressionSerializer ser = new JavaExpressionSerializer();
			javaStr = ser.serialize((Expression)getSource().get(0));
		}
	
		
	
		
		JavaCode javaCode = BPELPlusFactory.eINSTANCE.createJavaCode();
		
	// TODO migration ??? seems that even if there is JavaCode it is not used anymore??? so what do we send back? for now, change the target to be an Expression
		//that has as body the  javaStr expression???
	//	javaCode.setValue(javaStr);
	//	getTarget().add(javaCode);
		//AR changed the target of the rule to String... no more JavaCode? 
		com.ibm.wbit.bpel.Expression expression = BPELFactory.eINSTANCE.createExpression();
		expression.setBody(javaStr);
		getTarget().add(expression);
		/* Rule completed */
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();	
	}

} //JavaExprSerializerRuleImpl
