/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * $Id: BrPackage.java,v 1.3.4.1 2009/04/13 18:47:12 build Exp $
 */
package com.ibm.btools.te.ilm.heuristics.br;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.FrameworkPackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.br.BrFactory
 * @model kind="package"
 * @generated
 */
public interface BrPackage extends EPackage {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "br";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///heuristics/br.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "heuristics.br";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	BrPackage eINSTANCE = com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRRuleImpl <em>BR Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRRule()
	 * @generated
	 */
	int BR_RULE = 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>BR Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRGroupRuleImpl <em>BR Group Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRGroupRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRGroupRule()
	 * @generated
	 */
	int BR_GROUP_RULE = 1;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>BR Group Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_GROUP_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRSetRuleImpl <em>BR Set Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRSetRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRSetRule()
	 * @generated
	 */
	int BR_SET_RULE = 2;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>BR Set Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_SET_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRTemplateRuleImpl <em>BR Template Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRTemplateRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRTemplateRule()
	 * @generated
	 */
	int BR_TEMPLATE_RULE = 3;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>BR Template Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BR_TEMPLATE_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.br.BRRule <em>BR Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BR Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.br.BRRule
	 * @generated
	 */
	EClass getBRRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.br.BRGroupRule <em>BR Group Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BR Group Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.br.BRGroupRule
	 * @generated
	 */
	EClass getBRGroupRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.br.BRSetRule <em>BR Set Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BR Set Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.br.BRSetRule
	 * @generated
	 */
	EClass getBRSetRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.br.BRTemplateRule <em>BR Template Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>BR Template Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.br.BRTemplateRule
	 * @generated
	 */
	EClass getBRTemplateRule();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	BrFactory getBrFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRRuleImpl <em>BR Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRRule()
		 * @generated
		 */
		EClass BR_RULE = eINSTANCE.getBRRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRGroupRuleImpl <em>BR Group Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRGroupRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRGroupRule()
		 * @generated
		 */
		EClass BR_GROUP_RULE = eINSTANCE.getBRGroupRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRSetRuleImpl <em>BR Set Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRSetRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRSetRule()
		 * @generated
		 */
		EClass BR_SET_RULE = eINSTANCE.getBRSetRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.br.impl.BRTemplateRuleImpl <em>BR Template Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BRTemplateRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl#getBRTemplateRule()
		 * @generated
		 */
		EClass BR_TEMPLATE_RULE = eINSTANCE.getBRTemplateRule();

	}

} //BrPackage
