package com.ibm.btools.te.ilm.heuristics.br.util;


/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * BRExpressionConstants
 */
public interface BRExpressionConstants {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	public final static String AND_OP 			= " && ";
	public final static String OR_OP		  	= " || ";

	public final static String ADDITION_OP                 = " + ";
	public final static String SUBTRACTION_OP              = " - ";
	public final static String MULTIPLICATION_OP           = " * ";
	public final static String DIVISION_OP                 = " / ";
	public final static String MODULUS_OP                  = " % ";
	public final static String EQUAL_TO_OP                 = " == ";
	public final static String NOT_EQUAL_TO_OP             = " != ";
	public final static String LESS_THAN_OP                = " < ";
	public final static String LESS_THAN_OR_EQUAL_TO_OP    = " <= ";
	public final static String GREATER_THAN_OP             = " > ";
	public final static String GREATER_THAN_OR_EQUAL_TO_OP = " >= ";
	public final static String CHECK_STRING_EXIST 		   = "!= -1";
	public final static String NEGATION_OP				   = "-";
	public final static String EQUALS_OP           		   = " = ";

	public final static String CURRENT_STEP_SEP = ".";	
	public final static String PARENTHESIS_START = "(";
	public final static String PARENTHESIS_END   = ")";
	public final static String STRING_DECOR      = "\"";
	public final static String PARAMETER_START = "'";
	public final static String PARAMETER_END = "'";
	public final static String PRESENTATION_PARAMETER_START = "{";
	public final static String PRESENTATION_PARAMETER_END = "}";
	
	public final static String TRUE_VALUE  = "true";
	public final static String FALSE_VALUE = "false";
	
	public final static String COUNT_FUNC 						= "count";
	public final static String STARTS_WITH_FUNC 				= "startsWith";
	public final static String CONTAINS_FUNC 					= "indexOf";
	public final static String EXIST_FUNC 						= "contains";
	public final static String SIZE_FUNC 						= "size";
	public final static String GET_FIRST_ELEMENT_OF_COLLECTION  = ".get(0)";
	public final static String SET_FIRST_ELEMENT_OF_COLLECTION  = ".set(0,";
	public final static String XSD_SIMPLE_CONTENT_VALUE			= ".value";
	
	// date and time
	public final static String YEAR 							= "year";
	public final static String MONTH 							= "month";
	public final static String DAY 								= "date";
	public final static String HOUR 							= "hours";
	public final static String MINUTE 							= "minutes";
	public final static String SECOND							= "seconds";
	
	// boolean
	public final static String BOOLEAN_TRUE						= "true";
	public final static String BOOLEAN_FALSE					= "false";
	
	// business rules (selection) table
	String CURRENT_DATE_TAG = "//@generated:com.ibm.wbit.selector.ui.CurrentDate"; //$NON-NLS-1$
	String CURRENT_TIME_JAVACODE = CURRENT_DATE_TAG + "\r\nreturn new java.util.Date();"; //$NON-NLS-1$
	public final static String LOCAL_TIME = "local";
	public final static String FILE_SEP = "/";
	
	//time conversion (String to Calendar)
	public final static String TIME_KEY   = "T";	
	public final static String DATE_SEPARATOR = "-";
	public final static String TIME_SEPARATOR = ":";
	public final static String UTC_TIME_ZONE_INDICATOR = "Z";
	public final static String ZONE_OFFSET_POS_SIGN = "+";
	public final static String ZONE_OFFSET_NEG_SIGN = "-";	
	public final static String WBM_IMPORT_TYPE_DERIVED_SIMPLE_TYPE_COMMENT = "WBM_IMPORT_TYPE_DERIVED_SIMPLE_TYPE_COMMENT#";
	
	public final static String PROPERTY_VALUE = "6.1.0";
	public final static String PROPERTY_SYSTEM_DEFINED = "SystemDefined";
	public final static String PROPERTY_IBM_SYSTEM_VERSION = "IBMSystemVersion";
	public final static String PROPERTY_INITIALIZE_BUSINESS_OBJECTS = "IBMSystemCreateIntermediateObjects";
}
