package com.ibm.btools.te.ilm.heuristics.extservice;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import com.ibm.btools.te.framework.FrameworkPackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.extservice.ExtserviceFactory
 * @model kind="package"
 * @generated
 */
public interface ExtservicePackage extends EPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "extservice";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///heuristics/extservice.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "heuristics.extservice";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ExtservicePackage eINSTANCE = com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.extservice.impl.WSDLDefinitionRuleImpl <em>WSDL Definition Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.WSDLDefinitionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl#getWSDLDefinitionRule()
	 * @generated
	 */
	int WSDL_DEFINITION_RULE = 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>WSDL Definition Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WSDL_DEFINITION_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.extservice.impl.PortTypeRuleImpl <em>Port Type Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.PortTypeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl#getPortTypeRule()
	 * @generated
	 */
	int PORT_TYPE_RULE = 1;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Port Type Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_TYPE_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.extservice.impl.OperationRuleImpl <em>Operation Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.OperationRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl#getOperationRule()
	 * @generated
	 */
	int OPERATION_RULE = 2;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Operation Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.extservice.WSDLDefinitionRule <em>WSDL Definition Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>WSDL Definition Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.WSDLDefinitionRule
	 * @generated
	 */
	EClass getWSDLDefinitionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.extservice.PortTypeRule <em>Port Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Type Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.PortTypeRule
	 * @generated
	 */
	EClass getPortTypeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.extservice.OperationRule <em>Operation Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operation Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.extservice.OperationRule
	 * @generated
	 */
	EClass getOperationRule();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ExtserviceFactory getExtserviceFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.extservice.impl.WSDLDefinitionRuleImpl <em>WSDL Definition Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.WSDLDefinitionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl#getWSDLDefinitionRule()
		 * @generated
		 */
		EClass WSDL_DEFINITION_RULE = eINSTANCE.getWSDLDefinitionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.extservice.impl.PortTypeRuleImpl <em>Port Type Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.PortTypeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl#getPortTypeRule()
		 * @generated
		 */
		EClass PORT_TYPE_RULE = eINSTANCE.getPortTypeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.extservice.impl.OperationRuleImpl <em>Operation Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.OperationRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl#getOperationRule()
		 * @generated
		 */
		EClass OPERATION_RULE = eINSTANCE.getOperationRule();

	}

} //ExtservicePackage
