/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.bom.model.processes.activities.Activity;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;

import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.fdl.ActivityRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlFactory;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;


import com.ibm.btools.te.ilm.heuristics.fdl.SANReusableProcessRule;
import com.ibm.btools.te.ilm.heuristics.helper.BomUtils;
import com.ibm.btools.te.ilm.heuristics.helper.ProcessUtil;

import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * 
 * Source: BOM Activity
 * Target: FDL Processes for each InputPinSet
 * This rule is responsible for map one BOM Activity to FDL Process or Processes. 
 * Each InputPinSet of the top level StructuredActivityNode is individually mapped to one FDL Process.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class ActivityRuleImpl extends AbstractFdlProcDefRuleImpl implements ActivityRule {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return FdlPackage.Literals.ACTIVITY_RULE;
	}

	/**
	 * Source: BOM Activity
	 * Target: FDL Processes for each InputPinSet of the Activity
	 * Maps BOM Activity to FDL Process or Processes. 
	 * Each InputPinSet of the top level StructuredActivityNode is individually mapped to one FDL Process.
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target() 
	 */
	public boolean transformSource2Target(){
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if(isComplete())
		   return true;
		if (getSource() == null || getSource().isEmpty())
			   return false;	
			
		Activity bomActivity = (Activity)getSource().get(0);
		StructuredActivityNode san = bomActivity.getImplementation();
		if (BomUtils.isTask(san) || BomUtils.isService(san)) {
			return true;
		}
		SANReusableProcessRule pr;
		InputPinSet inputPinSet;
		//for each InputPinSet, create a FDL Process
		for (Iterator it= san.getInputPinSet().iterator(); it.hasNext(); ){
			inputPinSet = (InputPinSet)it.next();
			pr = FdlFactory.eINSTANCE.createSANReusableProcessRule();
			pr.getSource().add(inputPinSet);
			getChildRules().add(pr);
			pr.transformSource2Target();
			getTarget().addAll(pr.getTarget());			
		}		
		setComplete(true);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
	}
	

} //ActivityRuleImpl
