/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.bom.model.processes.activities.ActivityEdge;
import com.ibm.btools.bom.model.processes.activities.PinSet;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.fdl.DataFlowRule;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Flow Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class DataFlowRuleImpl extends ConnectorRuleImpl implements DataFlowRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataFlowRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return FdlPackage.Literals.DATA_FLOW_RULE;
	}

	/**
	 * Source : BOM Activity Edge, Source PinSet, Target PinSet
	 * Target : FDL Data Flow  
	 */
	public boolean transformSource2Target()
	{
		LoggingUtil.traceEntry(this, "transformSource2Target");

		if (isComplete())
			return true;
		if (getSource() == null || getSource().isEmpty())
			return false;
			
		ActivityEdge edge = (ActivityEdge)getSource().get(0);
		PinSet srcPinSet = (PinSet)getSource().get(1);
		PinSet tarPinSet = (PinSet)getSource().get(2);

		if (isFirstTimeExec())
		{		
			setFirstTimeExec(false);
//			ArrayList pinSets = new ArrayList();
//			pinSets.add(srcPinSet);
//			pinSets.add(tarPinSet);
//			DataFlowRule rule = (DataFlowRule)TransformationUtil.getRuleForSource(getRoot(),DataFlowRule.class,pinSets,DataFlow.class);
//			if (rule != null)
//			{
//				dataFlow = (DataFlow)rule.getTarget().get(0);
//			} else {
				// Create a FDL DataFlow
				dataFlow = com.ibm.btools.fdl.model.ModelFactory.eINSTANCE.createDataFlow();
				dataFlow.setName(edge.getName());	
//			}
			getTarget().add(dataFlow);
		}
		updateDataMapping(edge,srcPinSet,tarPinSet);
		
		executeHandlers();
		
		LoggingUtil.traceExit(this, "transformSource2Target");		
		return true;
	}

} //DataFlowRuleImpl
