
/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.fdl.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationContext;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;
import com.ibm.btools.te.ilm.heuristics.fdl.ProgramRule;
import com.ibm.btools.te.ilm.heuristics.fdl.util.FdlConstants;
import com.ibm.btools.fdl.model.Program;
import com.ibm.btools.fdl.model.ProgramActivity;

/**
 * <!-- begin-user-doc -->
 * Source: FDL ProgramActivity
 * Target: FDL Program
 * 
 * This rule creates FDL Program for a ProgramActivity.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class ProgramRuleImpl extends AbstractFdlProcDefRuleImpl implements ProgramRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProgramRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return FdlPackage.Literals.PROGRAM_RULE;
	}

	/**
	 * Source: FDL ProgramActivity
	 * Target: FDL Program
	 * This rule creates FDL Program for a ProgramActivity.
	 * 
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target()
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		
	 if(isComplete())
	 	return true;
	 if (getSource() == null || getSource().isEmpty())
			return false;	 
	 
	 ProgramActivity pa = (ProgramActivity)getSource().get(0);
	 String prmName = pa.getProgramName();
	 	
	 Program prm = null;
	 
	//find if program exist
	 TransformationContext context = getContext();
	 prm = (Program)context.get(FdlConstants.FDL_PROGRAM_CONTEXT_KEY_PREFIX + prmName);  			  
	 if(prm == null){
	 	
	      //create new program
		  prm = getFdlModelFactoryInstance().createProgram();
		  // Ray May 19.04 - To ensure reuse of program based in multiple export session, we need
		  // to use special algorithm to generate the name.  See FdlNameRegistry
		  prm.setName(prmName);
		  if(prmName.equals(FdlConstants.NOOP_PROGRAM_NAME)){
		  	prm.setStructuresFromActivity(Boolean.TRUE);
		  	prm.setUnattended(Boolean.TRUE);
		  }
		  else{	
		  	prm.setInputDataStructure(pa.getInputDataStructure());		  		  		  
		  	prm.setOutputDataStructure(pa.getOutputDataStructure());
		  	//Ray May 19.04
			//prm.setName(getNameRegistry().getUniqueProgramName(pa.getName()));
			//pa.setProgramName(prm.getName());
			//AR us the Program name instead as this is unique defect 83842
			prm.setName(getNameRegistry().getUniqueProgramName(prm.getName()));
		  	/*
		  	if (pa.getInputDataStructure()!=null && pa.getOutputDataStructure()!=null) {
				prm.setName(getNameRegistry().getUniqueProgramName(pa.getInputDataStructure().getName()+pa.getOutputDataStructure().getName()));
				pa.setProgramName(prm.getName());
		  	}
		  	*/
		  	
		  	prm.setDescription(getNameRegistry().getDescription(pa.getDescription()));
		  	prm.setDocumentation(getNameRegistry().getDocumentation(pa.getDocumentation()));
		  }
		  //add to context
		  context.put(FdlConstants.FDL_PROGRAM_CONTEXT_KEY_PREFIX + prmName, prm);	
	  }	
	  pa.setProgramName(prm.getName());
	  getTarget().add(prm);			
	  setComplete(true);
	  LoggingUtil.traceExit(this, "transformSource2Target");	  
	  return isComplete();	
}

} //ProgramRuleImpl
