package com.ibm.btools.te.ilm.heuristics.fdl.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.ArrayList;
import java.util.List;

import com.ibm.btools.fdl.model.PaperSize;
import com.ibm.btools.fdl.model.Process;
import com.ibm.btools.te.ilm.LoggingUtil;

/**
 *  Layout manager can layout fdl Process
 */
public class FdlProcessGraphLayoutManager extends AbstractFdlLayoutManager {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

		
	protected Process ivFdlProcess;
	
	public FdlProcessGraphLayoutManager(Process fdlProcess){
		ivFdlProcess = fdlProcess;
	}
		
	public void setProcess(Process fdlProcess){
		ivFdlProcess = fdlProcess;	
	}

	/**
	 * Returns list of fdl nodes that need to be layed out.
	 */
	protected List getModelNodes() {
		LoggingUtil.traceEntry(this, "getModelNodes()");
		ArrayList nodes = new ArrayList();
		if(!ivFdlProcess.getSource().isEmpty()){
			nodes.addAll(ivFdlProcess.getSource());
		}
		if(!ivFdlProcess.getSink().isEmpty()){
			nodes.addAll(ivFdlProcess.getSink());
		}
		if(!ivFdlProcess.getConstructs().isEmpty()){
			nodes.addAll(ivFdlProcess.getConstructs());
		}
		LoggingUtil.traceExit(this, "getModelNodes()");
		return nodes;
	}

	/**
	 * Sets paper size for fdl process
	 */
	protected void setPaperSize(PaperSize paperSize) {
		ivFdlProcess.setPaperSize(paperSize);
	}

}
