package com.ibm.btools.te.ilm.heuristics.helper;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

/**
 * This class contains constants used when mapping from BOM to AbstractBPEL 
 */
public class AbstractbpelConstants {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/* Constants that define the names of the parts that contain the parameters used in the 
	 * invocation of the retrieve datastore partner */
	public static final String DATASTORE_LENGTH_PART_NAME = "lengthPart";
	public static final String DATASTORE_IS_REMOVE_PART_NAME = "isRemovePart";
	public static final String DATASTORE_AT_BEGINNING_PART_NAME = "atBeginningPart";
	public static final String DATASTORE_OVERFLOW_PART_NAME = "overflowPart";
	public static final String DATASTORE_IS_INSERT_PART_NAME = "isInsertPart";
	public static final String DATASTORE_DATA_PART_NAME = "dataPart";
	
	/* Constants that define the names of the operations used to interact with datastores */
	public static final String RETRIEVE_ARTIFACT_DATASTORE_OPERATION_NAME = "retrieveArtifact";
	public static final String STORE_ARTIFACT_DATASTORE_OPERATION_NAME = "storeArtifact";
	
	/* Constants that define the names of the MessageTypes used to interact with Datastores */
	public static final String RETRIEVE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME = "RetrieveArtifactMessage";
	public static final String STORE_ARTIFACT_DATASTORE_INPUT_MESSAGE_NAME = "StoreArtifactMessage";
	public static final String RETRIEVE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME = "RetrieveArtifactOutputMessage";
	public static final String STORE_ARTIFACT_DATASTORE_OUTPUT_MESSAGE_NAME = "StoreArtifactOutputMessage";

	/* Constants that define the names to use for the variables that contain the data for the
	 * datastore interactions */
	public static final String DATASTORE_ACCESS_VAR_POSTFIX = "DSAccessVar";
	public static final String DATASTORE_RESULT_VAR_POSTFIX = "DSResultVar";
	
	
	/* Constant context key prefix for the BPEL Variables corresponding to the BOM Termination Nodes*/
	public static final String TERMINATION_NODE_CONTEXT_PREFIX = "TerminationNodeContextPrefix";
	

	/* String used as the post-fix of the name of the activity that initializes the loop node
	 * index variables */
	public static final String LOOP_NODE_INDEX_INIT_ACTIVITY_NAME_POSFIX = "IndexInitialization";
	
	/* String used as the name of the activity that copies the data from the output set variable
	 * to the temporary storage variable at the end of every loop iteration */
	public static final String LOOP_NODE_OS_VAR_TO_TEMP_VAR_ACTIVITY_NAME_POSTFIX = "AssignToTempVariable";

	/* String used as the name of the activity that copies the data from the temporary variable
	 * to the output set variable once all the loopnode iterations are complete */
	public static final String LOOP_NODE_TEMP_VAR_TO_OS_VAR_ACTIVITY_NAME_POSTFIX = "AssignToOutputSetVariable";

	/*
	 * Display name for <sequence> that represents the loop
	 */
	public static final String LOOP_NODE_SEQUENCE_DSP_NAME = "Loop Sequence";
	
	/* Constant context key for the entry that will hold all actions that should be excluded for reusing variables*/
	public static final String NOT_QUALIFY_FOR_VARIABLE_REUSE_CONTEXT_KEY = "notQualifyForVariableReuseContextKey";
	
	public static final String EXPRESSION_JAVA_NAMESPACE = "http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/";
	public static final String WSDL_IMPORT_TYPE = "http://schemas.xmlsoap.org/wsdl/";
	public static final String XSD_IMPORT_TYPE = "http://www.w3.org/2001/XMLSchema";
	public static final String TASK_HUMAN_NAMESPACE = "http://www.ibm.com/xmlns/prod/websphere/human-task/6.0.0/";
	//TODO consider moving the constant to a common access place for TE and wsdlBom
//	feature 117494
	//public final static String MODELER_TAG = "Generated by WebSphere Business Modeler V6.0";
	//defect 157768 update the version message for the WBM generated interfaces
//	public final static String MODELER_VERSION_TAG = "Generated by WebSphere Business Modeler V6.1";
	public final static String MODELER_VERSION_TAG = "Generated by WebSphere Business Modeler V6.2";
	//public final static String SERVICE_FROM_WSDL_TAG = "Generated by Web Service Modeler Import V6.0";
	public final static String SERVICE_FROM_WSDL_TAG = "Generated by Web Service Modeler Import V6.1";
}
