package com.ibm.btools.te.ilm.heuristics.helper;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.te.ilm.heuristics.naming.NamingRegistry;


public class NamespaceNamingRegistry implements NamingRegistry{
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	static private NamespaceNamingRegistry registry = new NamespaceNamingRegistry();		
	private  HashMap namespaceRegistry = new HashMap();
	
	/**
	 * Returns a boolean whether the name is unique
	 * It searches the registry and and return false if name is not unique
	 * it returns true if name is unique and it stores the name in the registry.
	 * @param obj  the EObject of a construct
	 * @param name  the String name
	 * @return boolean the boolean value whether name is unique or not
	 */	
	public boolean isUniqueName(Object obj, String name)
	{		
		if (namespaceRegistry.values().contains(name)){
			return false;
		}
		else {
			//Store the name in the Registry
			namespaceRegistry.put(obj, name);
			return true;
		}
	}
	
	public boolean isNameSpaceExists(String namespaceName)
	{
		if (namespaceRegistry.get(namespaceName)==null)
			return false;
		else
			return true;
	}
	
	public String getNamespaceName(String sourceName)
	{
		return (String)namespaceRegistry.get(sourceName);
	}
	
	static public NamingRegistry getRegistry()
	{
		if(registry == null){
			registry = new NamespaceNamingRegistry();			
			return registry;
		}
		return registry;
	}
	
	public static void reset(){
		registry = null;
	}

	/* (non-Javadoc)
	 * @see com.ibm.btools.te.ilm.heuristics.naming.NamingRegistry#isUniqueName(java.lang.Object, java.lang.Object, java.lang.String)
	 */
	public boolean isUniqueName(Object obj, Object inParentContext, String name) {
		// TODO Auto-generated method stub
		return false;
	}
	
	public void deregister(Object obj, String name) {

		//we should not need to deregister Namespace.. Check !
	}
	/* (non-Javadoc)
	 * @see com.ibm.btools.te.ilm.heuristics.naming.NamingRegistry#retrieveFromRegistry(java.lang.String)
	 */
	public Object retrieveFromRegistry(Class obj, String registryEntry) {
		
		
		if(namespaceRegistry.containsValue(registryEntry)){
			//get the object container that was registered for that entry.. 
			Iterator it = namespaceRegistry.keySet().iterator();
			while(it.hasNext()){
				Object variable = (EObject)it.next();
				if(namespaceRegistry.get(variable).equals(registryEntry)){
					return variable;
				}
			}
			
		}
		return null;
	}
	/* (non-Javadoc)
	 * @see com.ibm.btools.te.ilm.heuristics.naming.NamingRegistry#register(java.lang.Object, java.lang.String)
	 */
	public void register(Object obj, String name) {
		return;
	}
}
