package com.ibm.btools.te.ilm.heuristics.helper;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
/**
 * This inteface defines Keys used in export session context  
 */
public interface TransformationSessionKeyConstants {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	// value is Boolean, used as additional option in export session
	public static final String GENERATE_DEFAULT_TECH_ATTRIBUTE = "_GENERATE_DEFAULT_TECH_ATTRIBUTE";
	
//	 value is Boolean, used as additional option in export session
	public static final String RUN_VALIDATION = "_RUN_VALIDATION";
	
	// value is list of Commands, key used for context in ExportSession 
	public static final String UPDATE_COMMANDS = "_UPDATE_COMMANDS";
	
//	 value is list of Commands, key used for context in ExportSession 
	public static final String UPDATE_COMMAND = "_UPDATE_COMMAND";
	
	// value is list of TeValidationRecords, key used for context in ExportSession
	public static final String TECH_ATTRIB_VALIDATION_RECORDS = "_TECH_ATTRIB_VALIDATION_RECORDS";

	// value is Activity, key used for context in ExportSession
	public static final String MASTER_COPY = "_MASTER_COPY";
	
	
	public static final String  TRANSFORMATION_SESSION_EXPORT_RESULT ="_TRANSFORMATION_SESSION_EXPORT_RESULT";
	
	public static final String  PROCESSED_ARTIFACTS_REGISTRY ="_PROCESSED_ARTIFACTS_REGISTRY";
	
	public static final String EXPORT_SESSION = "_EXPORT_SESSION";
	
	//value is the current project name 
	public static final String PROJECT_NAME = "PEOJECT_NAME";
	//value is the te setting
	public static final String TE_SETTING = "TE_SETTING";
	//value is the hashmap to record WSDL/XSD mapping to their corresponding file names
	public static final String OBJECT_TO_FILE_NAME_REGISTRY = "OBJECT_TO_FILE_NAME_REGISTRY";
	 //AZ WMT 20070321 constant to indicate if the document root is for top level element
	public static final String TOP_LEVEL_DOCUMENT_ROOT = "TOP_LEVEL_DOCUMENT_ROOT";

	public static final String TIMETABLE_NAME_REGISTRY = "TIMETABLE_NAME_REGISTRY";

	public static final String  TARGET_TO_PROJECT_NAME_REGISTRY_KEY = "TARGET_TO_PROJECT_NAME_REGISTRY_KEY";

	public static final String SOURCE_TO_PROJECT_NAME_REGISTRY_KEY = "SOURCE_TO_PROJECT_NAME_REGISTRY_KEY";
	
	public static final String PROJECT_TO_OBJECTDEFINITION_REGISTRY_KEY = "PROJECT_TO_OBJECTDEFINITION_REGISTRY_KEY";

	public static final String  LIB_PROJECT_REFERENCE_REGISTRY_KEY = "LIB_PROJECT_REFERENCE_REGISTRY_KEY";

	public static final String TARGET_TO_SOURCE_REGISTRY_KEY = "TARGET_TO_SOURCE_REGISTRY_KEY";

	public static final String SHARED_LIB_PROJECT_NAME_REGISTRY_KEY = "SHARED_LIB_PROJECT_NAME_REGISTRY_KEY";

	public static final String TARGET_TO_SRC_BOMUID_REGISTRY_KEY = "TARGET_TO_SRC_BOMUID_REGISTRY_KEY";

	public static final String PORTTYPE_LIST_REGISTRY_KEY = "PORTTYPE_LIST_REGISTRY_KEY";

	public static final String  TASK_RESOURCE_USE_IMPORT_FLAG = "TASK_RESOURCE_USE_IMPORT_FLAG";
	
	public static final String BRR_META_OBJECT_REGISTRY= "BRR_META_OBJECT_REGISTRY";
	
	public static final String BRR_META_DATA = "BRR_META_DATA";

	public static final String  CALLBACK_REFERRENCE_REGISTRY_KEY = "CALLBACK_REFERRENCE_REGISTRY_KEY";

	public static final String CALLBACK_REFERRENCE_SOURCE_REGISTRY_KEY = "CALLBACK_REFERRENCE_SOURCE_REGISTRY_KEY";

	public static final String QNAME_TO_IMPORT_REGISTRY_KEY = "QNAME_TO_IMPORT_REGISTRY_KEY";

	public static final String CALLBACK_IMPORT_REGISTRY_KEY = "CALLBACK_IMPORT_REGISTRY_KEY";

	public static final String MODEL_ELEMENTS_PER_SESSION = "MODEL_ELEMENTS_PER_SESSION";
}
