/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.ilm.heuristics.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class HeuristicsFactoryImpl extends EFactoryImpl implements HeuristicsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static HeuristicsFactory init() {
		try {
			HeuristicsFactory theHeuristicsFactory = (HeuristicsFactory)EPackage.Registry.INSTANCE.getEFactory("http:///heuristics.ecore"); 
			if (theHeuristicsFactory != null) {
				return theHeuristicsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new HeuristicsFactoryImpl();
	}

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeuristicsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case HeuristicsPackage.HEURISTICS_TRANSFORMATION: return createHeuristicsTransformation();
			case HeuristicsPackage.AE_BROKER_PATTERN_RULE: return createAEBrokerPatternRule();
			case HeuristicsPackage.AE_OBSERVER_PATTERN_RULE: return createAEObserverPatternRule();
			case HeuristicsPackage.PROCESS_FLOW_PATTERN_RULE: return createProcessFlowPatternRule();
			case HeuristicsPackage.PROCESS_FLOW_RULE: return createProcessFlowRule();
			case HeuristicsPackage.DATA_DEFINITION_RULE: return createDataDefinitionRule();
			case HeuristicsPackage.INTERFACE_RULE: return createInterfaceRule();
			case HeuristicsPackage.RESOURCE_RULE: return createResourceRule();
			case HeuristicsPackage.ORGANIZATION_RULE: return createOrganizationRule();
			case HeuristicsPackage.TIME_INTERVALS_RULE: return createTimeIntervalsRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeuristicsTransformation createHeuristicsTransformation() {
		HeuristicsTransformationImpl heuristicsTransformation = new HeuristicsTransformationImpl();
		return heuristicsTransformation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AEBrokerPatternRule createAEBrokerPatternRule() {
		AEBrokerPatternRuleImpl aeBrokerPatternRule = new AEBrokerPatternRuleImpl();
		return aeBrokerPatternRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AEObserverPatternRule createAEObserverPatternRule() {
		AEObserverPatternRuleImpl aeObserverPatternRule = new AEObserverPatternRuleImpl();
		return aeObserverPatternRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessFlowPatternRule createProcessFlowPatternRule() {
		ProcessFlowPatternRuleImpl processFlowPatternRule = new ProcessFlowPatternRuleImpl();
		return processFlowPatternRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessFlowRule createProcessFlowRule() {
		ProcessFlowRuleImpl processFlowRule = new ProcessFlowRuleImpl();
		return processFlowRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataDefinitionRule createDataDefinitionRule() {
		DataDefinitionRuleImpl dataDefinitionRule = new DataDefinitionRuleImpl();
		return dataDefinitionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRule createInterfaceRule() {
		InterfaceRuleImpl interfaceRule = new InterfaceRuleImpl();
		return interfaceRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceRule createResourceRule() {
		ResourceRuleImpl resourceRule = new ResourceRuleImpl();
		return resourceRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OrganizationRule createOrganizationRule() {
		OrganizationRuleImpl organizationRule = new OrganizationRuleImpl();
		return organizationRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeIntervalsRule createTimeIntervalsRule() {
		TimeIntervalsRuleImpl timeIntervalsRule = new TimeIntervalsRuleImpl();
		return timeIntervalsRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeuristicsPackage getHeuristicsPackage() {
		return (HeuristicsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static HeuristicsPackage getPackage() {
		return HeuristicsPackage.eINSTANCE;
	}

} //HeuristicsFactoryImpl
