/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.impl.EcorePackageImpl;

import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.impl.FrameworkPackageImpl;
import com.ibm.btools.te.ilm.heuristics.AEBrokerPatternRule;
import com.ibm.btools.te.ilm.heuristics.AEObserverPatternRule;
import com.ibm.btools.te.ilm.heuristics.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.HeuristicsFactory;
import com.ibm.btools.te.ilm.heuristics.HeuristicsPackage;
import com.ibm.btools.te.ilm.heuristics.HeuristicsTransformation;
import com.ibm.btools.te.ilm.heuristics.InterfaceRule;
import com.ibm.btools.te.ilm.heuristics.OrganizationRule;
import com.ibm.btools.te.ilm.heuristics.ProcessFlowPatternRule;
import com.ibm.btools.te.ilm.heuristics.ProcessFlowRule;
import com.ibm.btools.te.ilm.heuristics.ResourceRule;
import com.ibm.btools.te.ilm.heuristics.TimeIntervalsRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.AbstractbpelPackageImpl;
import com.ibm.btools.te.ilm.heuristics.bpelp.BpelpPackage;
import com.ibm.btools.te.ilm.heuristics.bpelp.impl.BpelpPackageImpl;
import com.ibm.btools.te.ilm.heuristics.br.BrPackage;
import com.ibm.btools.te.ilm.heuristics.br.impl.BrPackageImpl;
import com.ibm.btools.te.ilm.heuristics.extservice.ExtservicePackage;
import com.ibm.btools.te.ilm.heuristics.extservice.impl.ExtservicePackageImpl;
import com.ibm.btools.te.ilm.heuristics.fdl.FdlPackage;
import com.ibm.btools.te.ilm.heuristics.fdl.impl.FdlPackageImpl;
import com.ibm.btools.te.ilm.heuristics.scdl.ScdlPackage;
import com.ibm.btools.te.ilm.heuristics.scdl.impl.ScdlPackageImpl;
import com.ibm.btools.te.ilm.heuristics.wsdl.WsdlPackage;
import com.ibm.btools.te.ilm.heuristics.wsdl.impl.WsdlPackageImpl;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;
import com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class HeuristicsPackageImpl extends EPackageImpl implements HeuristicsPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass heuristicsTransformationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass aeBrokerPatternRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass aeObserverPatternRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processFlowPatternRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass processFlowRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataDefinitionRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass interfaceRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass resourceRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass organizationRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeIntervalsRuleEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.ibm.btools.te.ilm.heuristics.HeuristicsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private HeuristicsPackageImpl() {
		super(eNS_URI, HeuristicsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static HeuristicsPackage init() {
		if (isInited) return (HeuristicsPackage)EPackage.Registry.INSTANCE.getEPackage(HeuristicsPackage.eNS_URI);

		// Obtain or create and register package
		HeuristicsPackageImpl theHeuristicsPackage = (HeuristicsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof HeuristicsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new HeuristicsPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();
		FrameworkPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		XsdPackageImpl theXsdPackage = (XsdPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) instanceof XsdPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI) : XsdPackage.eINSTANCE);
		FdlPackageImpl theFdlPackage = (FdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI) instanceof FdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI) : FdlPackage.eINSTANCE);
		AbstractbpelPackageImpl theAbstractbpelPackage = (AbstractbpelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) instanceof AbstractbpelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) : AbstractbpelPackage.eINSTANCE);
		WsdlPackageImpl theWsdlPackage = (WsdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) instanceof WsdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI) : WsdlPackage.eINSTANCE);
		BpelpPackageImpl theBpelpPackage = (BpelpPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI) instanceof BpelpPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI) : BpelpPackage.eINSTANCE);
		ScdlPackageImpl theScdlPackage = (ScdlPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) instanceof ScdlPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI) : ScdlPackage.eINSTANCE);
		ExtservicePackageImpl theExtservicePackage = (ExtservicePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) instanceof ExtservicePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI) : ExtservicePackage.eINSTANCE);
		BrPackageImpl theBrPackage = (BrPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) instanceof BrPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI) : BrPackage.eINSTANCE);

		// Create package meta-data objects
		theHeuristicsPackage.createPackageContents();
		theXsdPackage.createPackageContents();
		theFdlPackage.createPackageContents();
		theAbstractbpelPackage.createPackageContents();
		theWsdlPackage.createPackageContents();
		theBpelpPackage.createPackageContents();
		theScdlPackage.createPackageContents();
		theExtservicePackage.createPackageContents();
		theBrPackage.createPackageContents();

		// Initialize created meta-data
		theHeuristicsPackage.initializePackageContents();
		theXsdPackage.initializePackageContents();
		theFdlPackage.initializePackageContents();
		theAbstractbpelPackage.initializePackageContents();
		theWsdlPackage.initializePackageContents();
		theBpelpPackage.initializePackageContents();
		theScdlPackage.initializePackageContents();
		theExtservicePackage.initializePackageContents();
		theBrPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theHeuristicsPackage.freeze();

		return theHeuristicsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHeuristicsTransformation() {
		return heuristicsTransformationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAEBrokerPatternRule() {
		return aeBrokerPatternRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAEObserverPatternRule() {
		return aeObserverPatternRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessFlowPatternRule() {
		return processFlowPatternRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProcessFlowRule() {
		return processFlowRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataDefinitionRule() {
		return dataDefinitionRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInterfaceRule() {
		return interfaceRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getResourceRule() {
		return resourceRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOrganizationRule() {
		return organizationRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeIntervalsRule() {
		return timeIntervalsRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeuristicsFactory getHeuristicsFactory() {
		return (HeuristicsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		heuristicsTransformationEClass = createEClass(HEURISTICS_TRANSFORMATION);

		aeBrokerPatternRuleEClass = createEClass(AE_BROKER_PATTERN_RULE);

		aeObserverPatternRuleEClass = createEClass(AE_OBSERVER_PATTERN_RULE);

		processFlowPatternRuleEClass = createEClass(PROCESS_FLOW_PATTERN_RULE);

		processFlowRuleEClass = createEClass(PROCESS_FLOW_RULE);

		dataDefinitionRuleEClass = createEClass(DATA_DEFINITION_RULE);

		interfaceRuleEClass = createEClass(INTERFACE_RULE);

		resourceRuleEClass = createEClass(RESOURCE_RULE);

		organizationRuleEClass = createEClass(ORGANIZATION_RULE);

		timeIntervalsRuleEClass = createEClass(TIME_INTERVALS_RULE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XsdPackage theXsdPackage = (XsdPackage)EPackage.Registry.INSTANCE.getEPackage(XsdPackage.eNS_URI);
		FdlPackage theFdlPackage = (FdlPackage)EPackage.Registry.INSTANCE.getEPackage(FdlPackage.eNS_URI);
		AbstractbpelPackage theAbstractbpelPackage = (AbstractbpelPackage)EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI);
		WsdlPackage theWsdlPackage = (WsdlPackage)EPackage.Registry.INSTANCE.getEPackage(WsdlPackage.eNS_URI);
		BpelpPackage theBpelpPackage = (BpelpPackage)EPackage.Registry.INSTANCE.getEPackage(BpelpPackage.eNS_URI);
		ScdlPackage theScdlPackage = (ScdlPackage)EPackage.Registry.INSTANCE.getEPackage(ScdlPackage.eNS_URI);
		ExtservicePackage theExtservicePackage = (ExtservicePackage)EPackage.Registry.INSTANCE.getEPackage(ExtservicePackage.eNS_URI);
		BrPackage theBrPackage = (BrPackage)EPackage.Registry.INSTANCE.getEPackage(BrPackage.eNS_URI);
		FrameworkPackage theFrameworkPackage = (FrameworkPackage)EPackage.Registry.INSTANCE.getEPackage(FrameworkPackage.eNS_URI);
		EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);

		// Add subpackages
		getESubpackages().add(theXsdPackage);
		getESubpackages().add(theFdlPackage);
		getESubpackages().add(theAbstractbpelPackage);
		getESubpackages().add(theWsdlPackage);
		getESubpackages().add(theBpelpPackage);
		getESubpackages().add(theScdlPackage);
		getESubpackages().add(theExtservicePackage);
		getESubpackages().add(theBrPackage);

		// Add supertypes to classes
		heuristicsTransformationEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRoot());
		aeBrokerPatternRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		aeObserverPatternRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		processFlowPatternRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		processFlowRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		dataDefinitionRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		interfaceRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		resourceRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		organizationRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());
		timeIntervalsRuleEClass.getESuperTypes().add(theFrameworkPackage.getTransformationRule());

		// Initialize classes and features; add operations and parameters
		initEClass(heuristicsTransformationEClass, HeuristicsTransformation.class, "HeuristicsTransformation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		EOperation op = addEOperation(heuristicsTransformationEClass, ecorePackage.getEBoolean(), "isFirstClassArtifact", 0, 1);
		addEParameter(op, theEcorePackage.getEObject(), "artifact", 0, 1);

		initEClass(aeBrokerPatternRuleEClass, AEBrokerPatternRule.class, "AEBrokerPatternRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(aeObserverPatternRuleEClass, AEObserverPatternRule.class, "AEObserverPatternRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processFlowPatternRuleEClass, ProcessFlowPatternRule.class, "ProcessFlowPatternRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(processFlowRuleEClass, ProcessFlowRule.class, "ProcessFlowRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataDefinitionRuleEClass, DataDefinitionRule.class, "DataDefinitionRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(interfaceRuleEClass, InterfaceRule.class, "InterfaceRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(resourceRuleEClass, ResourceRule.class, "ResourceRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(organizationRuleEClass, OrganizationRule.class, "OrganizationRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(timeIntervalsRuleEClass, TimeIntervalsRule.class, "TimeIntervalsRule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} //HeuristicsPackageImpl
