package com.ibm.btools.te.ilm.heuristics.scdl.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.wst.wsdl.Message;
import org.eclipse.wst.wsdl.Operation;
import org.eclipse.wst.wsdl.Part;
import org.eclipse.wst.wsdl.PortType;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDTypeDefinition;

import com.ibm.wbit.model.utils.TypeMappingUtils;
import com.ibm.wsspi.sca.scdl.Component;

/**
 * This is the template used to create the JavaImplementation class for a given component.
 */
public class JavaImplCreationTemplate {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2008, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	
	  private final String NL = System.getProperties().getProperty("line.separator");
	  private final String TEXT_1 = "\tpackage ";
	  private final String TEXT_2 = ";" + NL + "\t";
	  private final String TEXT_3 = NL;
	  private final String TEXT_4 = NL + "  import ";
	  private final String TEXT_5 = ";";
	  private final String TEXT_6 = NL + "import com.ibm.websphere.sca.ServiceManager;" + NL + "" + NL + "public class ";
	  private final String TEXT_7 = " ";
	  private final String TEXT_8 = "  implements ";
	  private final String TEXT_9 = ", ";
	  private final String TEXT_10 = " {" + NL + "/**" + NL + " * Default constructor." + NL + " */" + NL + "public ";
	  private final String TEXT_11 = "() {" + NL + "\tsuper();" + NL + "}" + NL + "  /**" + NL + "   * Return a reference to the component service instance for this implementation" + NL + "   * class.  This method should be used when passing this service to a partner reference" + NL + "   * or if you want to invoke this component service asynchronously.    " + NL + "   *" + NL + "   * @generated (com.ibm.wbit.java)" + NL + "   */" + NL + "\t";
	  private final String TEXT_12 = "private ";
	  private final String TEXT_13 = " getMyService() {" + NL + "\t\treturn (";
	  private final String TEXT_14 = ") ServiceManager.INSTANCE.locateService(\"self\");" + NL + "\t}";
	  private final String TEXT_15 = NL + "\t";
	  private final String TEXT_16 = "\t";
	  private final String TEXT_17 = NL + "\t/**" + NL + "\t * This method is used to locate the service for the reference" + NL + "\t * named \"";
	  private final String TEXT_18 = "\".  This will return a List containing " + NL + "\t * instances of {@link ";
	  private final String TEXT_19 = "}.  If you would like to use these service " + NL + "\t * types asynchronously then you will need to cast the elements" + NL + "\t * to {@link ";
	  private final String TEXT_20 = "Async}." + NL + "\t *" + NL + "\t * @generated (com.ibm.wbit.java)" + NL + "\t *" + NL + "\t * @return ";
	  private final String TEXT_21 = NL + "\t */" + NL + "\t";
	  private final String TEXT_22 = NL + "\t/**" + NL + "\t * This method is used to locate the service for the reference" + NL + "\t * named \"";
	  private final String TEXT_23 = "\".  This will return an instance of" + NL + "\t * {@link ";
	  private final String TEXT_24 = "}.  If you would like to use this service " + NL + "\t * asynchronously then you will need to cast the result" + NL + "\t * to {@link ";
	  private final String TEXT_25 = "Async}." + NL + "\t *" + NL + "\t * @generated (com.ibm.wbit.java)" + NL + "\t *" + NL + "\t * @return ";
	  private final String TEXT_26 = NL + "\t */";
	  private final String TEXT_27 = NL + "\tpublic ";
	  private final String TEXT_28 = " locateService_";
	  private final String TEXT_29 = "(){" + NL + "\t\treturn (";
	  private final String TEXT_30 = ") ServiceManager.INSTANCE.locateService(\"";
	  private final String TEXT_31 = "\");" + NL + "\t}\t\t" + NL + "\t";
	  private final String TEXT_32 = NL + NL + NL + NL + "\t";
	  private final String TEXT_33 = NL + NL + "\t";
	  private final String TEXT_34 = NL + "\t";
	  private final String TEXT_35 = "\t";
	  private final String TEXT_36 = NL + "\t/**" + NL + "\t * This method is used to locate the service for the reference" + NL + "\t * named \"";
	  private final String TEXT_37 = "\".  This will return a List containing " + NL + "\t * instances of {@link com.ibm.websphere.sca.Service}.  This is the dynamic" + NL + "\t * interface which is used to invoke operations on the reference service" + NL + "\t * either synchronously or asynchronously.  You will need to pass the operation" + NL + "\t * name in order to invoke an operation on the service." + NL + "\t *" + NL + "\t * @generated (com.ibm.wbit.java)" + NL + "\t *" + NL + "\t * @return ";
	  private final String TEXT_38 = NL + "\t */" + NL + "\t";
	  private final String TEXT_39 = NL + "\t/**" + NL + "\t * This method is used to locate the service for the reference" + NL + "\t * named \"";
	  private final String TEXT_40 = "\".  This will return an instance of " + NL + "\t * {@link com.ibm.websphere.sca.Service}.  This is the dynamic" + NL + "\t * interface which is used to invoke operations on the reference service" + NL + "\t * either synchronously or asynchronously.  You will need to pass the operation" + NL + "\t * name in order to invoke an operation on the service." + NL + "\t *" + NL + "\t * @generated (com.ibm.wbit.java)" + NL + "\t *" + NL + "\t * @return ";
	  private final String TEXT_41 = NL + "\t */";
	  private final String TEXT_42 = NL + "\tpublic ";
	  private final String TEXT_43 = " locateService_";
	  private final String TEXT_44 = "(){" + NL + "\t\treturn (";
	  private final String TEXT_45 = ") ServiceManager.INSTANCE.locateService(\"";
	  private final String TEXT_46 = "\");" + NL + "\t}\t\t" + NL + "\t";
	  private final String TEXT_47 = NL + "\t";
	  private final String TEXT_48 = " " + NL;
	  private final String TEXT_49 = NL + "/* (non-Javadoc)" + NL + " * @see ";
	  private final String TEXT_50 = "#";
	  private final String TEXT_51 = " " + NL + " */";
	  private final String TEXT_52 = NL + "/**" + NL + " * Method generated to support implemention of operation \"";
	  private final String TEXT_53 = "\" defined for WSDL port type " + NL + " * named \"";
	  private final String TEXT_54 = "\"." + NL + " * " + NL + " * ";
	  private final String TEXT_55 = "This WSDL operation has fault(s) defined. ";
	  private final String TEXT_56 = "The presence of commonj.sdo.DataObject as the return type and/or as a parameter " + NL + " * type conveys that its a complex type. ";
	  private final String TEXT_57 = "Please refer to the WSDL Definition for more information " + NL + " * on the type of input, output and fault(s)." + NL + " */";
	  private final String TEXT_58 = NL + "public ";
	  private final String TEXT_59 = " ";
	  private final String TEXT_60 = " ";
	  private final String TEXT_61 = "throws ";
	  private final String TEXT_62 = ", ";
	  private final String TEXT_63 = " {";
	  private final String TEXT_64 = NL;
	  private final String TEXT_65 = NL + "}";
	  private final String TEXT_66 = NL;
	  private final String TEXT_67 = " " + NL;
	  private final String TEXT_68 = NL + "\t/**" + NL + "\t* Method generated to support the async implementation using callback" + NL + "\t* for the operation (@link ";
	  private final String TEXT_69 = "#";
	  private final String TEXT_70 = ")" + NL + "\t* of java interface (@link ";
	  private final String TEXT_71 = ")\t" + NL + "\t* @see ";
	  private final String TEXT_72 = "#";
	  private final String TEXT_73 = "\t" + NL + "\t*/";
	  private final String TEXT_74 = "\t" + NL + "\t/**" + NL + "\t* Method generated to support the async implementation using callback" + NL + "\t* for the operation \"";
	  private final String TEXT_75 = "#";
	  private final String TEXT_76 = "\"" + NL + "\t* of wsdl interface \"";
	  private final String TEXT_77 = "\"\t" + NL + "\t*/";
	  private final String TEXT_78 = NL + "\tpublic void ";
	  private final String TEXT_79 = "(Ticket __ticket, ";
	  private final String TEXT_80 = " returnValue, Exception exception){" + NL + "\t\t//TODO Needs to be implemented." + NL + "\t}" + NL + NL;
	  private final String TEXT_81 = NL + NL + "}";

	
	/**
	 * Template for creating Java code implementation given a Component.
	 */
	public JavaImplCreationTemplate() {
		super();
	}

	 /**
	  * Returns the fully qualified name of the Java class for the <code>operation</code> return type. 
	  * It will be a "commonj.sdo.DataObject" if the return type is a complexType or if the operation has
	  * multiple return types or the mapped java type from the simple type. 
	  * @param operation a WSDL Operation
	  * @return fully qualified Java class name
	  */
	 private String getMethodReturnTypeName(Operation operation){
	 	
	 	List returnTypes = ScdlUtil.getTypeDeclarationElements(operation, ScdlUtil.OUTPUT_VARIABLE_TYPE);
	 	if(returnTypes.size() == 0){
	 		return "void";
	 	}
	 	if(returnTypes.size() >1){
	 		return "commonj.sdo.DataObject";
	 	}else{
	 		XSDElementDeclaration typeDefinition = (XSDElementDeclaration)returnTypes.get(0);
	 		return mapTypeToJava(typeDefinition.getTypeDefinition());
	 	}
	 	
	 }
	 
	 /**
	  * Return the simple name of the java class <code>javaClassName</code>
	  * This will be either the last segment of the class name or, in case of the java.lang classes
	  * the java primitive types. (as per WID)
	  * @param javaClassName a Java fully qualified class name
	  * @return
	  */
	 private String getSimpleName(String javaClassName){
	 	if(javaClassName.lastIndexOf(".") != -1){
	 		 if(javaClassName.equals("java.lang.Integer")){
	 			return "int";
	 			//defect 140212
	 		}else if(javaClassName.startsWith("java.lang") && !(javaClassName.equals("java.lang.String")||javaClassName.equals("java.lang.Boolean") || javaClassName.equals("java.lang.Object"))){
	 			return javaClassName.substring(javaClassName.lastIndexOf(".") +1).toLowerCase();
	 		}
	 	}
	 	//d154650
 		return javaClassName;	 	
	 }
	 /**
	  * Returns the simple name of the Java class name mapped for the <code>operation</code> return type. 
	  * @param operation a WSDL Operation
	  * @return simple Java class name
	  */
	 private String getMethodReturnTypeNameSimpleName(Operation operation){
	 	return getSimpleName(getMethodReturnTypeName(operation));
	 }
	 
	 /**
	  * Returns the corresponding Java class for the <code>typeDefinition</code>.
	  * @param typeDefinition an XSDTypeDefinition
	  * @return the fully qualified Java class name.
	  */
	 private String mapTypeToJava(XSDTypeDefinition typeDefinition){
	 	//TODO d140600
	 	if (typeDefinition == null) {	//anonymousType
 			return "commonj.sdo.DataObject";
	 	}
	 	
 		if(typeDefinition instanceof XSDComplexTypeDefinition){
 			return "commonj.sdo.DataObject";
 		}else{
 			String returnType = TypeMappingUtils.xsdToJava(typeDefinition, true, false);
 			// d154650
 			if (typeDefinition.getName().equals("dateTime")) {
 				return returnType;
 			//defect 140212
 			} else if(!returnType.startsWith("java.lang") || 
 					typeDefinition.getName().equals("time") ||
 					//d154651
 					typeDefinition.getName().equals("duration")){
 				return "Object";
 			}else{
 				return returnType;	
 			}
 			
 		}
	 }
	 
	 /**
	  * Returns the Java operation signature mapped from the <code>operation</code>
	  * @param operation a WSDL Operation
	  * @return String Java Operation signature
	  */
	 private String getMehodSignatureWithParamNames(Operation operation){
	 	StringBuffer buf = new StringBuffer("");
	 	buf.append(operation.getName());
	 	buf.append("(");
	 	Message wsdlMessage = (Message)operation.getInput().getMessage();
	 	Part singlePart = (Part)wsdlMessage.getEParts().get(0);
	 	List elementDeclarations = ScdlUtil.getUnwrappedElementDeclarations(singlePart);
	  	if(elementDeclarations != null && !elementDeclarations.isEmpty()){
	 		Iterator it = elementDeclarations.iterator();
	 		for(int i =0; i<elementDeclarations.size(); i++){
	 			XSDElementDeclaration elementDeclaration = (XSDElementDeclaration)elementDeclarations.get(i);
	 			//d140600 anonymous type
	 			String mappedType = null;
	 			if (elementDeclaration.getTypeDefinition() == null) {
	 				mappedType = mapTypeToJava(elementDeclaration.getResolvedElementDeclaration().getTypeDefinition());
	 			} else {
	 				mappedType = mapTypeToJava(elementDeclaration.getTypeDefinition());
	 			}
	 			buf.append(getSimpleName(mappedType));
	 			buf.append(" ");
	 			buf.append(elementDeclaration.getName());
	 			if(i != (elementDeclarations.size()-1)){
	 				buf.append(", ");
	 			}
	 		}
	 	}
	 	buf.append(")");
	 	
	 	
	 	return buf.toString();
	 	
	 }
	 
	 /**
	  * Returns the Java method body for the <code>operation</code>.
	  * @param operation a WSDL Operation
	  * @return String - Java method body.
	  */
	 private String generateMethodBody(Operation operation) {
	        StringBuffer sb = new StringBuffer("\t\t//TODO Needs to be implemented.");//$NON-NLS-1$
	        sb.append("\n\t\t");//$NON-NLS-1$
	        String opReturnType = getMethodReturnTypeName(operation);
	        if(opReturnType.equals("java.lang.String")){
	        	getStringMethodBody(sb, operation);
	        }else if(!(opReturnType.equals("void"))){
	        	getPrimitiveMethodBody(sb, opReturnType);
	        }
	        sb.append("\n");//$NON-NLS-1$
	        return sb.toString();
	    }


	    /**
	     * Returns the Java method body.
	     * @param returnType a fully qualified name of a JavaClass
	     * @param b StringBuffer
	     */
	    protected void getPrimitiveMethodBody(StringBuffer b, String returnType) {
	    	String methodBody = getDefaultValueStringForReturnType(returnType);
	    	if(!methodBody.equals("")){
	    		b.append("return ");//$NON-NLS-1$
	    		b.append(getDefaultValueStringForReturnType(returnType));
	    		b.append(';');//$NON-NLS-1$
	    	}
	    }

	    /**
	     * Returns the Java method body.
	     * @param returnType a fully qualified name of a JavaClass
	     * @param b StringBuffer
	     */
	    protected void getStringMethodBody(StringBuffer b, Operation operation) {
	        b.append("return \"");//$NON-NLS-1$
	        b.append("Result from calling the ");//$NON-NLS-1$
	        b.append(getMehodSignatureWithParamNames(operation));
	        b.append(" method.\";");//$NON-NLS-1$
	    }
	    
	    /**
	     * Returns the default value for the <code>returnType</code>
	     * @param returnType a fully qualified Java class name
	     * @return default return value for a Java method.
	     */
	    private String getDefaultValueStringForReturnType(String returnType){
	    	if(returnType.equals("void")){
	    		return "";
	    	}else if(returnType.equals("java.lang.Integer") ||  returnType.equals("java.lang.Byte") || returnType.equals("java.lang.Long") || returnType.equals("java.lang.Short")){
	    		return "0";
	    	}else if(returnType.equals("java.lang.Double")){
	    		return "0.0";
	    	}else if(returnType.equals("java.lang.Float")){
	    		return "0.0f";
	    	}else if (returnType.equals("java.lang.Boolean")){
	    		return "null";
	    	}
	    	return "null";
	    	
	    }
	   /**
	    * Returns the import class names based on the <code>operations<code> parameters and return type.
	    * @param operations a list of WSDL Operations belonging to a WSDL Interface.
	    * @return a list of java import class names.
	    */ 
	    private List getImplClassImportNames(List operations){
	    	List importList = new LinkedList();
			importList.add("commonj.sdo.DataObject");
	    	return importList;
	    }
	    
	    /**
	     * Returns true if the <code>operation</code> has a DataObject as Parameter or as Return.
	     * @param operation a WSDL Operation
	     * @return boolean
	     */
	    private boolean hasDataObjectAsParameterOrReturn(Operation operation){
	    	if(getMethodReturnTypeNameSimpleName(operation).equals("DataObject")){
	    		return true;
	    	}else{
	    		List types = new LinkedList();
	    		List inputTypes = ScdlUtil.getTypeDeclarationElements(operation, ScdlUtil.INPUT_VARIABLE_TYPE);
	    		Iterator it = types.iterator();
	    		while(it.hasNext()){
		    		XSDElementDeclaration elDeclaration = (XSDElementDeclaration)it.next();
		    		if(elDeclaration.getTypeDefinition() instanceof XSDComplexTypeDefinition){
		    			return true;
		    		}
	    		}
	    	}
	    	return false;
	    }
	    
	    public String generate(PortType wsdlPortType, Component component){
	    	
	    	StringBuffer stringBuffer = new StringBuffer();
	    	List operations = wsdlPortType.getOperations();
	    	
	    	//JavaImplementationCreationTemplateModel model = (JavaImplementationCreationTemplateModel) argument;
	    	//String packageName = model.getTargetPackageName();
	    	String packageName = ScdlUtil.getJavaPackageName(component);
	    	if (packageName != null && packageName.trim().length() > 0) { 
	    		stringBuffer.append(TEXT_1);
	    		stringBuffer.append(packageName);
	    		stringBuffer.append(TEXT_2);
	    	} 
	    	stringBuffer.append(TEXT_3);
	    	//String[] importNames = model.getImplClassImportNames();
	    	List importNames = getImplClassImportNames(operations);
	    	for (int i = 0; i < importNames.size(); i++) {
	    		stringBuffer.append(TEXT_4);
	    		stringBuffer.append(importNames.get(i));
	    		stringBuffer.append(TEXT_5);
	    	}
	    	
	    	stringBuffer.append(TEXT_6);
	    	//stringBuffer.append(model.getTargetSimpleTypeName());
	    	stringBuffer.append(ScdlUtil.getTargetSimpleTypeName(component));
	    	stringBuffer.append(TEXT_7);
	    	
//	    	if (model.hasImplementingInterface()) {
//	    		
//	    		stringBuffer.append(TEXT_8);
//	    		String[] intNames = model.getImplementsInterfaceNames();
//	    		for (int j=0; j < intNames.length; j++) {
//	    			if (j>0) {
//	    				
//	    				stringBuffer.append(TEXT_9);
//	    				
//	    			}
//	    			stringBuffer.append(intNames[j]);
//	    			
//	    		}
//	    	}
	    	stringBuffer.append(TEXT_10);
	    	stringBuffer.append(ScdlUtil.getTargetSimpleTypeName(component));
	    	stringBuffer.append(TEXT_11);
	    	String myServiceName ="Object";
	    	
	    	stringBuffer.append(TEXT_12);
	    	stringBuffer.append(myServiceName);
	    	stringBuffer.append(TEXT_13);
	    	stringBuffer.append(myServiceName);
	    	stringBuffer.append(TEXT_14);
	    	
//	    	if (model.hasAnyJavaReference()) {
//	    		
//	    		stringBuffer.append(TEXT_15);
//	    		stringBuffer.append(TEXT_16);
//	    		List javaRefs = model.getAllJavaReferences();
//	    		for(int index=0; index < javaRefs.size(); ++index) {
//	    			Reference javaRef = (Reference) javaRefs.get(index);
//	    			List interfaces = javaRef.getInterfaces();
//	    			if (interfaces.isEmpty()) continue;
//	    			JavaInterface javaInterface = (JavaInterface) interfaces.get(0);
//	    			boolean isMany = JavaComponentUtilities.INSTANCE.isZeroToMany(javaRef);			
//	    			String componentType = JavaComponentUtilities.INSTANCE.getInterfaceName(javaInterface.getInterface());
//	    			String returnType;
//	    			if (isMany)
//	    				returnType = "List";
//	    			else
//	    				returnType = componentType;
//	    			if (isMany) {
//	    				stringBuffer.append(TEXT_17);
//	    				stringBuffer.append(javaRef.getName());
//	    				stringBuffer.append(TEXT_18);
//	    				stringBuffer.append(componentType);
//	    				stringBuffer.append(TEXT_19);
//	    				stringBuffer.append(componentType);
//	    				stringBuffer.append(TEXT_20);
//	    				stringBuffer.append(returnType);
//	    				stringBuffer.append(TEXT_21);
//	    			} else { 
//	    				stringBuffer.append(TEXT_22);
//	    				stringBuffer.append(javaRef.getName());
//	    				stringBuffer.append(TEXT_23);
//	    				stringBuffer.append(returnType);
//	    				stringBuffer.append(TEXT_24);
//	    				stringBuffer.append(returnType);
//	    				stringBuffer.append(TEXT_25);
//	    				stringBuffer.append(returnType);
//	    				stringBuffer.append(TEXT_26);
//	    			}
//	    			stringBuffer.append(TEXT_27);
//	    			stringBuffer.append(returnType);
//	    			stringBuffer.append(TEXT_28);
//	    			stringBuffer.append(model.getLocateServiceMethodSuffix(javaRef.getName()));
//	    			stringBuffer.append(TEXT_29);
//	    			stringBuffer.append(returnType);
//	    			stringBuffer.append(TEXT_30);
//	    			stringBuffer.append(javaRef.getName());
//	    			stringBuffer.append(TEXT_31);
//	    			
//	    		}
//	    		
//	    		stringBuffer.append(TEXT_32);
//	    	}
//	    	stringBuffer.append(TEXT_33);
//	    	
//	    	if (model.hasAnyWSDLReference()) {
//	    		
//	    		stringBuffer.append(TEXT_34);
//	    		stringBuffer.append(TEXT_35);
//	    		List wsdlRefs = model.getAllWSDLReferences();
//	    		for(int index=0; index < wsdlRefs.size(); ++index) {
//	    			Reference wsdlRef = (Reference) wsdlRefs.get(index);
//	    			boolean isMany = JavaComponentUtilities.INSTANCE.isZeroToMany(wsdlRef);
//	    			String returnType = isMany ? "List" : "Service";
//	    			if (isMany) {
//	    				stringBuffer.append(TEXT_36);
//	    				stringBuffer.append(wsdlRef.getName());
//	    				stringBuffer.append(TEXT_37);
//	    				stringBuffer.append(returnType);
//	    				stringBuffer.append(TEXT_38);
//	    			} else { 
//	    				stringBuffer.append(TEXT_39);
//	    				stringBuffer.append(wsdlRef.getName());
//	    				stringBuffer.append(TEXT_40);
//	    				stringBuffer.append(returnType);
//	    				stringBuffer.append(TEXT_41);
//	    			}
//	    			stringBuffer.append(TEXT_42);
//	    			stringBuffer.append(returnType);
//	    			stringBuffer.append(TEXT_43);
//	    			stringBuffer.append(model.getLocateServiceMethodSuffix(wsdlRef.getName()));
//	    			stringBuffer.append(TEXT_44);
//	    			stringBuffer.append(returnType);
//	    			stringBuffer.append(TEXT_45);
//	    			stringBuffer.append(wsdlRef.getName());
//	    			stringBuffer.append(TEXT_46);
//	    			
//	    		}
	    		
//	    		stringBuffer.append(TEXT_47);
//	    	}
//	    	List methodModels = model.getMethodModels();
//	    	Iterator it = methodModels.iterator();
//	    	while (it.hasNext()) {
//	    		JavaImplementationMethodTemplateModel methodModel = (JavaImplementationMethodTemplateModel) it.next();
//	    		
//	    		stringBuffer.append(TEXT_48);
//	    		String interfaceQualifiedName = methodModel.getInterfaceQualifiedName();
//	    		if (interfaceQualifiedName != null) {
//	    			stringBuffer.append(TEXT_49);
//	    			stringBuffer.append(interfaceQualifiedName);
//	    			stringBuffer.append(TEXT_50);
//	    			stringBuffer.append(methodModel.getMethodSignatureWithParamNames());
//	    			stringBuffer.append(TEXT_51);
//	    		} else {
//	    			stringBuffer.append(TEXT_52);
//	    			stringBuffer.append(methodModel.getName());
//	    			stringBuffer.append(TEXT_53);
//	    			stringBuffer.append(methodModel.getTypeName());
//	    			stringBuffer.append(TEXT_54);
//	    			if (methodModel.hasExceptions()) { 
//	    				stringBuffer.append(TEXT_55);
//	    			} if (methodModel.hasDataObjectAsParamOrReturn()) {
//	    				stringBuffer.append(TEXT_56);
//	    			}
//	    			stringBuffer.append(TEXT_57);
//	    		}
//	    		stringBuffer.append(TEXT_58);
//	    		stringBuffer.append(methodModel.getReturnTypeName());
//	    		stringBuffer.append(TEXT_59);
//	    		stringBuffer.append(methodModel.getMethodSignatureWithParamNames()
//	    		);
//	    		stringBuffer.append(TEXT_60);
//	    		if (methodModel.hasExceptions()) {
//	    			
//	    			stringBuffer.append(TEXT_61);
//	    			
//	    			String[] exceptionTypes = methodModel.getExceptionTypeNames();
//	    			for (int exIndex = 0; exIndex < exceptionTypes.length; exIndex ++) {
//	    				if (exIndex > 0) {
//	    					
//	    					stringBuffer.append(TEXT_62);
//	    					
//	    				}
//	    				
//	    				stringBuffer.append(exceptionTypes[exIndex]);
//	    				
//	    			}
//	    		}
//	    		
//	    		stringBuffer.append(TEXT_63);
//	    		stringBuffer.append(TEXT_64);
//	    		stringBuffer.append(methodModel.getMethodBody());
//	    		stringBuffer.append(TEXT_65);
//	    	}
			Iterator it = operations.iterator();
			while (it.hasNext()) {
			//	JavaImplementationMethodTemplateModel methodModel = (JavaImplementationMethodTemplateModel) it.next();
				Operation operation = (Operation)it.next();
				stringBuffer.append(TEXT_48);
//				String interfaceQualifiedName = methodModel.getInterfaceQualifiedName();
//				if (interfaceQualifiedName != null) {
//					stringBuffer.append(TEXT_49);
//					stringBuffer.append(interfaceQualifiedName);
//					stringBuffer.append(TEXT_50);
//					stringBuffer.append(methodModel.getMethodSignatureWithParamNames());
//					stringBuffer.append(TEXT_51);
//				} else {
				
//				stringBuffer.append(TEXT_52);
//    			stringBuffer.append(methodModel.getName());
//    			stringBuffer.append(TEXT_53);
//    			stringBuffer.append(methodModel.getTypeName());
//    			stringBuffer.append(TEXT_54);
//    			if (methodModel.hasExceptions()) { 
//    				stringBuffer.append(TEXT_55);
//    			} if (methodModel.hasDataObjectAsParamOrReturn()) {
//    				stringBuffer.append(TEXT_56);
//    			}
//    			stringBuffer.append(TEXT_57);
				
					stringBuffer.append(TEXT_52);
					stringBuffer.append(operation.getName());
					stringBuffer.append(TEXT_53);
					//stringBuffer.append(methodModel.getTypeName());
					stringBuffer.append(wsdlPortType.getQName().getLocalPart());
					stringBuffer.append(TEXT_54);
					//stringBuffer.append(TEXT_79);
					if(hasDataObjectAsParameterOrReturn(operation)){
						stringBuffer.append(TEXT_56);
					
					}
					stringBuffer.append(TEXT_57);
					
				//}
				stringBuffer.append(TEXT_58);
				stringBuffer.append(getMethodReturnTypeNameSimpleName(operation));
				stringBuffer.append(TEXT_59);
				stringBuffer.append(getMehodSignatureWithParamNames(operation));
				stringBuffer.append(TEXT_60);
//				should not have exceptions

				stringBuffer.append(TEXT_63);
				stringBuffer.append(TEXT_64);
				stringBuffer.append(generateMethodBody(operation));
				
				stringBuffer.append(TEXT_65);
			}
			
//	    	stringBuffer.append(TEXT_66);
//	    	Collection respMethodModels = model.getJavaImplRefMethodModels();
//	    	Iterator respMethodModelsItr = respMethodModels.iterator();
//	    	while (respMethodModelsItr.hasNext()) {
//	    		JavaImplementationRefMethodTemplateModel respMethodModel = (JavaImplementationRefMethodTemplateModel) respMethodModelsItr.next();
//	    		
//	    		stringBuffer.append(TEXT_67);
//	    		if(respMethodModel.isJavaInterface()){
//	    			stringBuffer.append(TEXT_68);
//	    			stringBuffer.append(respMethodModel.getQualifiedIntfName());
//	    			stringBuffer.append(TEXT_69);
//	    			stringBuffer.append(respMethodModel.getMethodSignatureWithParamNames());
//	    			stringBuffer.append(TEXT_70);
//	    			stringBuffer.append(respMethodModel.getQualifiedIntfName());
//	    			stringBuffer.append(TEXT_71);
//	    			stringBuffer.append(respMethodModel.getQualifiedIntfName());
//	    			stringBuffer.append(TEXT_72);
//	    			stringBuffer.append(respMethodModel.getMethodSignatureWithParamNames());
//	    			stringBuffer.append(TEXT_73);
//	    		}else{
//	    			stringBuffer.append(TEXT_74);
//	    			stringBuffer.append(respMethodModel.getQualifiedIntfName());
//	    			stringBuffer.append(TEXT_75);
//	    			stringBuffer.append(respMethodModel.getMethodSignatureWithParamNames());
//	    			stringBuffer.append(TEXT_76);
//	    			stringBuffer.append(respMethodModel.getQualifiedIntfName());
//	    			stringBuffer.append(TEXT_77);
//	    		}
//	    		stringBuffer.append(TEXT_78);
//	    		stringBuffer.append(respMethodModel.getResponseMethodName());
//	    		stringBuffer.append(TEXT_79);
//	    		stringBuffer.append(respMethodModel.getReturnTypeName());
//	    		stringBuffer.append(TEXT_80);
//	    	}
	    	stringBuffer.append(TEXT_81);
	    	return stringBuffer.toString();
	    }
}

