/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.heuristics.AEBrokerPatternRule;
import com.ibm.btools.te.ilm.heuristics.AEObserverPatternRule;
import com.ibm.btools.te.ilm.heuristics.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.HeuristicsPackage;
import com.ibm.btools.te.ilm.heuristics.HeuristicsTransformation;
import com.ibm.btools.te.ilm.heuristics.InterfaceRule;
import com.ibm.btools.te.ilm.heuristics.OrganizationRule;
import com.ibm.btools.te.ilm.heuristics.ProcessFlowPatternRule;
import com.ibm.btools.te.ilm.heuristics.ProcessFlowRule;
import com.ibm.btools.te.ilm.heuristics.ResourceRule;
import com.ibm.btools.te.ilm.heuristics.TimeIntervalsRule;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.HeuristicsPackage
 * @generated
 */
public class HeuristicsSwitch {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static HeuristicsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HeuristicsSwitch() {
		if (modelPackage == null) {
			modelPackage = HeuristicsPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case HeuristicsPackage.HEURISTICS_TRANSFORMATION: {
				HeuristicsTransformation heuristicsTransformation = (HeuristicsTransformation)theEObject;
				Object result = caseHeuristicsTransformation(heuristicsTransformation);
				if (result == null) result = caseTransformationRoot(heuristicsTransformation);
				if (result == null) result = caseTransformationRule(heuristicsTransformation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.AE_BROKER_PATTERN_RULE: {
				AEBrokerPatternRule aeBrokerPatternRule = (AEBrokerPatternRule)theEObject;
				Object result = caseAEBrokerPatternRule(aeBrokerPatternRule);
				if (result == null) result = caseTransformationRule(aeBrokerPatternRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.AE_OBSERVER_PATTERN_RULE: {
				AEObserverPatternRule aeObserverPatternRule = (AEObserverPatternRule)theEObject;
				Object result = caseAEObserverPatternRule(aeObserverPatternRule);
				if (result == null) result = caseTransformationRule(aeObserverPatternRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.PROCESS_FLOW_PATTERN_RULE: {
				ProcessFlowPatternRule processFlowPatternRule = (ProcessFlowPatternRule)theEObject;
				Object result = caseProcessFlowPatternRule(processFlowPatternRule);
				if (result == null) result = caseTransformationRule(processFlowPatternRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.PROCESS_FLOW_RULE: {
				ProcessFlowRule processFlowRule = (ProcessFlowRule)theEObject;
				Object result = caseProcessFlowRule(processFlowRule);
				if (result == null) result = caseTransformationRule(processFlowRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.DATA_DEFINITION_RULE: {
				DataDefinitionRule dataDefinitionRule = (DataDefinitionRule)theEObject;
				Object result = caseDataDefinitionRule(dataDefinitionRule);
				if (result == null) result = caseTransformationRule(dataDefinitionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.INTERFACE_RULE: {
				InterfaceRule interfaceRule = (InterfaceRule)theEObject;
				Object result = caseInterfaceRule(interfaceRule);
				if (result == null) result = caseTransformationRule(interfaceRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.RESOURCE_RULE: {
				ResourceRule resourceRule = (ResourceRule)theEObject;
				Object result = caseResourceRule(resourceRule);
				if (result == null) result = caseTransformationRule(resourceRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.ORGANIZATION_RULE: {
				OrganizationRule organizationRule = (OrganizationRule)theEObject;
				Object result = caseOrganizationRule(organizationRule);
				if (result == null) result = caseTransformationRule(organizationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case HeuristicsPackage.TIME_INTERVALS_RULE: {
				TimeIntervalsRule timeIntervalsRule = (TimeIntervalsRule)theEObject;
				Object result = caseTimeIntervalsRule(timeIntervalsRule);
				if (result == null) result = caseTransformationRule(timeIntervalsRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transformation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transformation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHeuristicsTransformation(HeuristicsTransformation object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>AE Broker Pattern Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>AE Broker Pattern Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAEBrokerPatternRule(AEBrokerPatternRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>AE Observer Pattern Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>AE Observer Pattern Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAEObserverPatternRule(AEObserverPatternRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Flow Pattern Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Flow Pattern Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessFlowPatternRule(ProcessFlowPatternRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Process Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Process Flow Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProcessFlowRule(ProcessFlowRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Data Definition Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Definition Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataDefinitionRule(DataDefinitionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Interface Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Interface Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInterfaceRule(InterfaceRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Resource Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Resource Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseResourceRule(ResourceRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Organization Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Organization Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseOrganizationRule(OrganizationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Time Intervals Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Time Intervals Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTimeIntervalsRule(TimeIntervalsRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTransformationRule(TransformationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transformation Root</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transformation Root</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTransformationRoot(TransformationRoot object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} //HeuristicsSwitch
