/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.xsd;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.FrameworkPackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.xsd.XsdFactory
 * @model kind="package"
 * @generated
 */
public interface XsdPackage extends EPackage {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "xsd";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///heuristics/xsd.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "heuristics.xsd";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	XsdPackage eINSTANCE = com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.DataDefinitionRuleImpl <em>Data Definition Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.DataDefinitionRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getDataDefinitionRule()
	 * @generated
	 */
	int DATA_DEFINITION_RULE = 0;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Data Definition Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_DEFINITION_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.AbstractDataDefRuleImpl <em>Abstract Data Def Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.AbstractDataDefRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getAbstractDataDefRule()
	 * @generated
	 */
	int ABSTRACT_DATA_DEF_RULE = 3;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__COMPLETE = FrameworkPackage.TRANSFORMATION_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__FAILED = FrameworkPackage.TRANSFORMATION_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__CHILD_RULES = FrameworkPackage.TRANSFORMATION_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__PARENT_RULE = FrameworkPackage.TRANSFORMATION_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__TARGET = FrameworkPackage.TRANSFORMATION_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__SOURCE = FrameworkPackage.TRANSFORMATION_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE__ROOT = FrameworkPackage.TRANSFORMATION_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Abstract Data Def Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT = FrameworkPackage.TRANSFORMATION_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.ClassRuleImpl <em>Class Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.ClassRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getClassRule()
	 * @generated
	 */
	int CLASS_RULE = 1;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Class Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.PrimitiveDataTypeRuleImpl <em>Primitive Data Type Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.PrimitiveDataTypeRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getPrimitiveDataTypeRule()
	 * @generated
	 */
	int PRIMITIVE_DATA_TYPE_RULE = 2;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Primitive Data Type Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_DATA_TYPE_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.ListRuleImpl <em>List Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.ListRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getListRule()
	 * @generated
	 */
	int LIST_RULE = 4;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>List Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.XSDSchemaRuleImpl <em>XSD Schema Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XSDSchemaRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getXSDSchemaRule()
	 * @generated
	 */
	int XSD_SCHEMA_RULE = 5;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>XSD Schema Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XSD_SCHEMA_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.PropertyRuleImpl <em>Property Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.PropertyRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getPropertyRule()
	 * @generated
	 */
	int PROPERTY_RULE = 6;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Property Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.PinSetRuleImpl <em>Pin Set Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.PinSetRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getPinSetRule()
	 * @generated
	 */
	int PIN_SET_RULE = 7;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Pin Set Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_SET_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.ElementDeclarationRuleImpl <em>Element Declaration Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.ElementDeclarationRuleImpl
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getElementDeclarationRule()
	 * @generated
	 */
	int ELEMENT_DECLARATION_RULE = 8;

	/**
	 * The feature id for the '<em><b>Complete</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__COMPLETE = ABSTRACT_DATA_DEF_RULE__COMPLETE;

	/**
	 * The feature id for the '<em><b>Failed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__FAILED = ABSTRACT_DATA_DEF_RULE__FAILED;

	/**
	 * The feature id for the '<em><b>Child Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__CHILD_RULES = ABSTRACT_DATA_DEF_RULE__CHILD_RULES;

	/**
	 * The feature id for the '<em><b>Parent Rule</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__PARENT_RULE = ABSTRACT_DATA_DEF_RULE__PARENT_RULE;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__TARGET = ABSTRACT_DATA_DEF_RULE__TARGET;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__SOURCE = ABSTRACT_DATA_DEF_RULE__SOURCE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE__ROOT = ABSTRACT_DATA_DEF_RULE__ROOT;

	/**
	 * The number of structural features of the '<em>Element Declaration Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_DECLARATION_RULE_FEATURE_COUNT = ABSTRACT_DATA_DEF_RULE_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.DataDefinitionRule <em>Data Definition Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Definition Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.DataDefinitionRule
	 * @generated
	 */
	EClass getDataDefinitionRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.ClassRule <em>Class Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Class Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.ClassRule
	 * @generated
	 */
	EClass getClassRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.PrimitiveDataTypeRule <em>Primitive Data Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Primitive Data Type Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.PrimitiveDataTypeRule
	 * @generated
	 */
	EClass getPrimitiveDataTypeRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.AbstractDataDefRule <em>Abstract Data Def Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Data Def Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.AbstractDataDefRule
	 * @generated
	 */
	EClass getAbstractDataDefRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.ListRule <em>List Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.ListRule
	 * @generated
	 */
	EClass getListRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.XSDSchemaRule <em>XSD Schema Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>XSD Schema Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.XSDSchemaRule
	 * @generated
	 */
	EClass getXSDSchemaRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.PropertyRule <em>Property Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.PropertyRule
	 * @generated
	 */
	EClass getPropertyRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.PinSetRule <em>Pin Set Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pin Set Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.PinSetRule
	 * @generated
	 */
	EClass getPinSetRule();

	/**
	 * Returns the meta object for class '{@link com.ibm.btools.te.ilm.heuristics.xsd.ElementDeclarationRule <em>Element Declaration Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element Declaration Rule</em>'.
	 * @see com.ibm.btools.te.ilm.heuristics.xsd.ElementDeclarationRule
	 * @generated
	 */
	EClass getElementDeclarationRule();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	XsdFactory getXsdFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.DataDefinitionRuleImpl <em>Data Definition Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.DataDefinitionRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getDataDefinitionRule()
		 * @generated
		 */
		EClass DATA_DEFINITION_RULE = eINSTANCE.getDataDefinitionRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.ClassRuleImpl <em>Class Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.ClassRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getClassRule()
		 * @generated
		 */
		EClass CLASS_RULE = eINSTANCE.getClassRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.PrimitiveDataTypeRuleImpl <em>Primitive Data Type Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.PrimitiveDataTypeRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getPrimitiveDataTypeRule()
		 * @generated
		 */
		EClass PRIMITIVE_DATA_TYPE_RULE = eINSTANCE.getPrimitiveDataTypeRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.AbstractDataDefRuleImpl <em>Abstract Data Def Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.AbstractDataDefRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getAbstractDataDefRule()
		 * @generated
		 */
		EClass ABSTRACT_DATA_DEF_RULE = eINSTANCE.getAbstractDataDefRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.ListRuleImpl <em>List Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.ListRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getListRule()
		 * @generated
		 */
		EClass LIST_RULE = eINSTANCE.getListRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.XSDSchemaRuleImpl <em>XSD Schema Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XSDSchemaRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getXSDSchemaRule()
		 * @generated
		 */
		EClass XSD_SCHEMA_RULE = eINSTANCE.getXSDSchemaRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.PropertyRuleImpl <em>Property Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.PropertyRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getPropertyRule()
		 * @generated
		 */
		EClass PROPERTY_RULE = eINSTANCE.getPropertyRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.PinSetRuleImpl <em>Pin Set Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.PinSetRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getPinSetRule()
		 * @generated
		 */
		EClass PIN_SET_RULE = eINSTANCE.getPinSetRule();

		/**
		 * The meta object literal for the '{@link com.ibm.btools.te.ilm.heuristics.xsd.impl.ElementDeclarationRuleImpl <em>Element Declaration Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.ElementDeclarationRuleImpl
		 * @see com.ibm.btools.te.ilm.heuristics.xsd.impl.XsdPackageImpl#getElementDeclarationRule()
		 * @generated
		 */
		EClass ELEMENT_DECLARATION_RULE = eINSTANCE.getElementDeclarationRule();

	}

} //XsdPackage
