/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.xsd.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.xsd.XSDTypeDefinition;
import org.eclipse.xsd.util.XSDConstants;
import org.eclipse.xsd.util.XSDUtil;

import com.ibm.btools.bom.model.artifacts.Type;
import com.ibm.btools.te.framework.FrameworkPackage;
import com.ibm.btools.te.framework.TransformationRoot;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.LoggingUtil;
import com.ibm.btools.te.ilm.heuristics.xsd.PrimitiveDataTypeRule;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;
import com.ibm.btools.te.ilm.heuristics.xsd.util.DataDefinitionUtil;

/**
 * <!-- begin-user-doc -->
 * SOURCE: BOM Type (Predefined BOM primitive Type)
 * TARGET: XSDSimpleTypeDefinition
 * 
 * The Rule is responsible for mapping a tool predefined primitive BOM simple Type to a XSDSimpleTypeDefinition. 	
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 */
public class PrimitiveDataTypeRuleImpl extends AbstractDataDefRuleImpl implements PrimitiveDataTypeRule {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PrimitiveDataTypeRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return XsdPackage.Literals.PRIMITIVE_DATA_TYPE_RULE;
	}

	/**
	 * SOURCE: BOM Type - a tool predefined primitive type
	 * TARGET: XSDSimpleTypeDefinition 
	 * Maps the tool predefined primitive Type XSDSimpleTypeDefinition.
	 * @return boolean
	 * @see com.ibm.btools.te.framework.TransformationRule#transformSource2Target() 
	 */
	public boolean transformSource2Target() {
		LoggingUtil.traceEntry(this, "transformSource2Target");
		if( isComplete()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return true;
		}
		if( getSource() == null || getSource().isEmpty()){
			LoggingUtil.traceExit(this, "transformSource2Target");
			return false;
		}
		Type dataType = (Type)getSource().get(0);
		
		if( getTarget() == null || getTarget().isEmpty()){
			//XSDSimpleTypeDefinition	simpleType =  getSimpleXSDType(dataType.getName());
			XSDTypeDefinition	simpleType =  getSimpleXSDType(dataType.getName());	
			getTarget().add(simpleType);
		}
		setComplete(true);
		LoggingUtil.traceExit(this, "transformSource2Target");
		return isComplete();
	}
	
//	/**
//	 * Returns the XSD Definition for the simple types as defined be the XSD Schema
//	 * @param - dataTypeName the name of the BOM type. 
//	 * @return XSDSimpleTypeDefinition the xsd definition for the predefined types. 
//	 */
//	protected XSDSimpleTypeDefinition getSimpleXSDType(String dataTypeName) {
//	
//		// look for a pre-defined, atomic type first (they're not in packages or schemas)
//		String xsdTypeName = DataDefinitionUtil.primitiveType2xsdSimpleType(dataTypeName);
//		if (xsdTypeName != null) {
//			XSDTypeDefinition typeDef = XSDUtil.getSchemaForSchema(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001).resolveTypeDefinition("anyType");
//			return XSDUtil.getSchemaForSchema(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001).resolveSimpleTypeDefinition(xsdTypeName);
//		}
//		return null;
//	}

	protected XSDTypeDefinition getSimpleXSDType(String dataTypeName) {
	
		// look for a pre-defined, atomic type first (they're not in packages or schemas)
		String xsdTypeName = DataDefinitionUtil.primitiveType2xsdSimpleType(dataTypeName);
		if (xsdTypeName != null) {
			if(xsdTypeName.equals(DataDefinitionUtil.XSD_ANY_TYPE)){
				return XSDUtil.getSchemaForSchema(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001).resolveTypeDefinition(DataDefinitionUtil.XSD_ANY_TYPE);
			}else{
				return XSDUtil.getSchemaForSchema(XSDConstants.SCHEMA_FOR_SCHEMA_URI_2001).resolveSimpleTypeDefinition(xsdTypeName);
			}
			
			
		}
		return null;
	}
} //DataTypeRuleImpl
