/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.xsd.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.ilm.heuristics.xsd.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import com.ibm.btools.te.ilm.heuristics.xsd.ClassRule;
import com.ibm.btools.te.ilm.heuristics.xsd.DataDefinitionRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ElementDeclarationRule;
import com.ibm.btools.te.ilm.heuristics.xsd.ListRule;
import com.ibm.btools.te.ilm.heuristics.xsd.PinSetRule;
import com.ibm.btools.te.ilm.heuristics.xsd.PrimitiveDataTypeRule;
import com.ibm.btools.te.ilm.heuristics.xsd.PropertyRule;
import com.ibm.btools.te.ilm.heuristics.xsd.XSDSchemaRule;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdFactory;
import com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class XsdFactoryImpl extends EFactoryImpl implements XsdFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static XsdFactory init() {
		try {
			XsdFactory theXsdFactory = (XsdFactory)EPackage.Registry.INSTANCE.getEFactory("http:///heuristics/xsd.ecore"); 
			if (theXsdFactory != null) {
				return theXsdFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new XsdFactoryImpl();
	}

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XsdFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case XsdPackage.DATA_DEFINITION_RULE: return createDataDefinitionRule();
			case XsdPackage.CLASS_RULE: return createClassRule();
			case XsdPackage.PRIMITIVE_DATA_TYPE_RULE: return createPrimitiveDataTypeRule();
			case XsdPackage.LIST_RULE: return createListRule();
			case XsdPackage.XSD_SCHEMA_RULE: return createXSDSchemaRule();
			case XsdPackage.PROPERTY_RULE: return createPropertyRule();
			case XsdPackage.PIN_SET_RULE: return createPinSetRule();
			case XsdPackage.ELEMENT_DECLARATION_RULE: return createElementDeclarationRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataDefinitionRule createDataDefinitionRule() {
		DataDefinitionRuleImpl dataDefinitionRule = new DataDefinitionRuleImpl();
		return dataDefinitionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClassRule createClassRule() {
		ClassRuleImpl classRule = new ClassRuleImpl();
		return classRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrimitiveDataTypeRule createPrimitiveDataTypeRule() {
		PrimitiveDataTypeRuleImpl primitiveDataTypeRule = new PrimitiveDataTypeRuleImpl();
		return primitiveDataTypeRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ListRule createListRule() {
		ListRuleImpl listRule = new ListRuleImpl();
		return listRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XSDSchemaRule createXSDSchemaRule() {
		XSDSchemaRuleImpl xsdSchemaRule = new XSDSchemaRuleImpl();
		return xsdSchemaRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyRule createPropertyRule() {
		PropertyRuleImpl propertyRule = new PropertyRuleImpl();
		return propertyRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PinSetRule createPinSetRule() {
		PinSetRuleImpl pinSetRule = new PinSetRuleImpl();
		return pinSetRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElementDeclarationRule createElementDeclarationRule() {
		ElementDeclarationRuleImpl elementDeclarationRule = new ElementDeclarationRuleImpl();
		return elementDeclarationRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XsdPackage getXsdPackage() {
		return (XsdPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static XsdPackage getPackage() {
		return XsdPackage.eINSTANCE;
	}

} //XsdFactoryImpl
