/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.heuristics.xsd.util;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.te.framework.TransformationRule;

import com.ibm.btools.te.ilm.heuristics.xsd.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.heuristics.xsd.XsdPackage
 * @generated
 */
public class XsdSwitch {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static XsdPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XsdSwitch() {
		if (modelPackage == null) {
			modelPackage = XsdPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case XsdPackage.DATA_DEFINITION_RULE: {
				DataDefinitionRule dataDefinitionRule = (DataDefinitionRule)theEObject;
				Object result = caseDataDefinitionRule(dataDefinitionRule);
				if (result == null) result = caseTransformationRule(dataDefinitionRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.CLASS_RULE: {
				ClassRule classRule = (ClassRule)theEObject;
				Object result = caseClassRule(classRule);
				if (result == null) result = caseAbstractDataDefRule(classRule);
				if (result == null) result = caseTransformationRule(classRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.PRIMITIVE_DATA_TYPE_RULE: {
				PrimitiveDataTypeRule primitiveDataTypeRule = (PrimitiveDataTypeRule)theEObject;
				Object result = casePrimitiveDataTypeRule(primitiveDataTypeRule);
				if (result == null) result = caseAbstractDataDefRule(primitiveDataTypeRule);
				if (result == null) result = caseTransformationRule(primitiveDataTypeRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.ABSTRACT_DATA_DEF_RULE: {
				AbstractDataDefRule abstractDataDefRule = (AbstractDataDefRule)theEObject;
				Object result = caseAbstractDataDefRule(abstractDataDefRule);
				if (result == null) result = caseTransformationRule(abstractDataDefRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.LIST_RULE: {
				ListRule listRule = (ListRule)theEObject;
				Object result = caseListRule(listRule);
				if (result == null) result = caseAbstractDataDefRule(listRule);
				if (result == null) result = caseTransformationRule(listRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.XSD_SCHEMA_RULE: {
				XSDSchemaRule xsdSchemaRule = (XSDSchemaRule)theEObject;
				Object result = caseXSDSchemaRule(xsdSchemaRule);
				if (result == null) result = caseAbstractDataDefRule(xsdSchemaRule);
				if (result == null) result = caseTransformationRule(xsdSchemaRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.PROPERTY_RULE: {
				PropertyRule propertyRule = (PropertyRule)theEObject;
				Object result = casePropertyRule(propertyRule);
				if (result == null) result = caseAbstractDataDefRule(propertyRule);
				if (result == null) result = caseTransformationRule(propertyRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.PIN_SET_RULE: {
				PinSetRule pinSetRule = (PinSetRule)theEObject;
				Object result = casePinSetRule(pinSetRule);
				if (result == null) result = caseAbstractDataDefRule(pinSetRule);
				if (result == null) result = caseTransformationRule(pinSetRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case XsdPackage.ELEMENT_DECLARATION_RULE: {
				ElementDeclarationRule elementDeclarationRule = (ElementDeclarationRule)theEObject;
				Object result = caseElementDeclarationRule(elementDeclarationRule);
				if (result == null) result = caseAbstractDataDefRule(elementDeclarationRule);
				if (result == null) result = caseTransformationRule(elementDeclarationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Data Definition Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Definition Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataDefinitionRule(DataDefinitionRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Class Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Class Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseClassRule(ClassRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Primitive Data Type Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Primitive Data Type Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePrimitiveDataTypeRule(PrimitiveDataTypeRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Abstract Data Def Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Abstract Data Def Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAbstractDataDefRule(AbstractDataDefRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>List Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>List Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseListRule(ListRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>XSD Schema Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>XSD Schema Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseXSDSchemaRule(XSDSchemaRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Property Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Property Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePropertyRule(PropertyRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Pin Set Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Pin Set Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object casePinSetRule(PinSetRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Element Declaration Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Element Declaration Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseElementDeclarationRule(ElementDeclarationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Transformation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTransformationRule(TransformationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} //XsdSwitch
