/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Process Flow</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getType <em>Type</em>}</li>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessInterface <em>Process Interface</em>}</li>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessDefinition <em>Process Definition</em>}</li>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getRelatedArtifacts <em>Related Artifacts</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getProcessFlow()
 * @model
 * @generated
 */
public interface ProcessFlow extends ComposedArtifact {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link com.ibm.btools.te.ilm.model.sa.ProcessFlowType}.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlowType
	 * @see #setType(ProcessFlowType)
	 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getProcessFlow_Type()
	 * @model
	 * @generated
	 */
  ProcessFlowType getType();

	/**
	 * Sets the value of the '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.ibm.btools.te.ilm.model.sa.ProcessFlowType
	 * @see #getType()
	 * @generated
	 */
  void setType(ProcessFlowType value);

	/**
	 * Returns the value of the '<em><b>Process Interface</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EObject}.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Process Interface</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @return the value of the '<em>Process Interface</em>' reference list.
	 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getProcessFlow_ProcessInterface()
	 * @model type="org.eclipse.emf.ecore.EObject"
	 * @generated
	 */
  EList getProcessInterface();

	/**
	 * Returns the value of the '<em><b>Process Definition</b></em>' reference.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Process Definition</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @return the value of the '<em>Process Definition</em>' reference.
	 * @see #setProcessDefinition(EObject)
	 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getProcessFlow_ProcessDefinition()
	 * @model
	 * @generated
	 */
  EObject getProcessDefinition();

	/**
	 * Sets the value of the '{@link com.ibm.btools.te.ilm.model.sa.ProcessFlow#getProcessDefinition <em>Process Definition</em>}' reference.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process Definition</em>' reference.
	 * @see #getProcessDefinition()
	 * @generated
	 */
  void setProcessDefinition(EObject value);

	/**
	 * Returns the value of the '<em><b>Related Artifacts</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EObject}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Related Artifacts</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Related Artifacts</em>' reference list.
	 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getProcessFlow_RelatedArtifacts()
	 * @model type="org.eclipse.emf.ecore.EObject"
	 * @generated
	 */
	EList getRelatedArtifacts();

} // ProcessFlow
