/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Process Flow Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getProcessFlowType()
 * @model
 * @generated
 */
public final class ProcessFlowType extends AbstractEnumerator
{
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The '<em><b>BPEL</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #BPEL_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
  public static final int BPEL = 0;

	/**
	 * The '<em><b>BPELPP</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #BPELPP_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
  public static final int BPELPP = 1;

	/**
	 * The '<em><b>FDL</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #FDL_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
  public static final int FDL = 2;

	/**
	 * The '<em><b>BPEL</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>BPEL</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #BPEL
	 * @generated
	 * @ordered
	 */
  public static final ProcessFlowType BPEL_LITERAL = new ProcessFlowType(BPEL, "BPEL", "BPEL");

	/**
	 * The '<em><b>BPELPP</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>BPELPP</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #BPELPP
	 * @generated
	 * @ordered
	 */
  public static final ProcessFlowType BPELPP_LITERAL = new ProcessFlowType(BPELPP, "BPELPP", "BPELPP");

	/**
	 * The '<em><b>FDL</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>FDL</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #FDL
	 * @generated
	 * @ordered
	 */
  public static final ProcessFlowType FDL_LITERAL = new ProcessFlowType(FDL, "FDL", "FDL");

	/**
	 * An array of all the '<em><b>Process Flow Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private static final ProcessFlowType[] VALUES_ARRAY =
		new ProcessFlowType[] {
			BPEL_LITERAL,
			BPELPP_LITERAL,
			FDL_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Process Flow Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Process Flow Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static ProcessFlowType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ProcessFlowType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Process Flow Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ProcessFlowType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ProcessFlowType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Process Flow Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static ProcessFlowType get(int value) {
		switch (value) {
			case BPEL: return BPEL_LITERAL;
			case BPELPP: return BPELPP_LITERAL;
			case FDL: return FDL_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private ProcessFlowType(int value, String name, String literal) {
		super(value, name, literal);
	}

} //ProcessFlowType
