/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>SA Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#getSAType()
 * @model
 * @generated
 */
public final class SAType extends AbstractEnumerator
{
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The '<em><b>Process Flow</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #PROCESS_FLOW_LITERAL
	 * @model name="ProcessFlow"
	 * @generated
	 * @ordered
	 */
  public static final int PROCESS_FLOW = 0;

	/**
	 * The '<em><b>Adaptive Entity</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #ADAPTIVE_ENTITY_LITERAL
	 * @model name="AdaptiveEntity"
	 * @generated
	 * @ordered
	 */
  public static final int ADAPTIVE_ENTITY = 1;

	/**
	 * The '<em><b>SCDL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SCDL_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int SCDL = 2;

	/**
	 * The '<em><b>Unclassified</b></em>' literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #UNCLASSIFIED_LITERAL
	 * @model name="Unclassified"
	 * @generated
	 * @ordered
	 */
  public static final int UNCLASSIFIED = 3;

	/**
	 * The '<em><b>Human Task</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HUMAN_TASK_LITERAL
	 * @model name="HumanTask"
	 * @generated
	 * @ordered
	 */
	public static final int HUMAN_TASK = 4;

	/**
	 * The '<em><b>Process Flow</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Process Flow</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #PROCESS_FLOW
	 * @generated
	 * @ordered
	 */
  public static final SAType PROCESS_FLOW_LITERAL = new SAType(PROCESS_FLOW, "ProcessFlow", "ProcessFlow");

	/**
	 * The '<em><b>Adaptive Entity</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Adaptive Entity</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #ADAPTIVE_ENTITY
	 * @generated
	 * @ordered
	 */
  public static final SAType ADAPTIVE_ENTITY_LITERAL = new SAType(ADAPTIVE_ENTITY, "AdaptiveEntity", "AdaptiveEntity");

	/**
	 * The '<em><b>SCDL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>SCDL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SCDL
	 * @generated
	 * @ordered
	 */
	public static final SAType SCDL_LITERAL = new SAType(SCDL, "SCDL", "SCDL");

	/**
	 * The '<em><b>Unclassified</b></em>' literal object.
	 * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Unclassified</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
	 * @see #UNCLASSIFIED
	 * @generated
	 * @ordered
	 */
  public static final SAType UNCLASSIFIED_LITERAL = new SAType(UNCLASSIFIED, "Unclassified", "Unclassified");

	/**
	 * The '<em><b>Human Task</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Human Task</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HUMAN_TASK
	 * @generated
	 * @ordered
	 */
	public static final SAType HUMAN_TASK_LITERAL = new SAType(HUMAN_TASK, "HumanTask", "HumanTask");

	/**
	 * An array of all the '<em><b>SA Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private static final SAType[] VALUES_ARRAY =
		new SAType[] {
			PROCESS_FLOW_LITERAL,
			ADAPTIVE_ENTITY_LITERAL,
			SCDL_LITERAL,
			UNCLASSIFIED_LITERAL,
			HUMAN_TASK_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>SA Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>SA Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static SAType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SAType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>SA Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SAType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SAType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>SA Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public static SAType get(int value) {
		switch (value) {
			case PROCESS_FLOW: return PROCESS_FLOW_LITERAL;
			case ADAPTIVE_ENTITY: return ADAPTIVE_ENTITY_LITERAL;
			case SCDL: return SCDL_LITERAL;
			case UNCLASSIFIED: return UNCLASSIFIED_LITERAL;
			case HUMAN_TASK: return HUMAN_TASK_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private SAType(int value, String name, String literal) {
		super(value, name, literal);
	}

} //SAType
