/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import com.ibm.btools.te.ilm.model.sa.ProcessFlow;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.btools.te.ilm.model.sa.SaPackage;

import java.util.Collection;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Process Flow</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl#getProcessInterface <em>Process Interface</em>}</li>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl#getProcessDefinition <em>Process Definition</em>}</li>
 *   <li>{@link com.ibm.btools.te.ilm.model.sa.impl.ProcessFlowImpl#getRelatedArtifacts <em>Related Artifacts</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ProcessFlowImpl extends ComposedArtifactImpl implements ProcessFlow
{
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
  protected static final ProcessFlowType TYPE_EDEFAULT = ProcessFlowType.BPEL_LITERAL;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
  protected ProcessFlowType type = TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getProcessInterface() <em>Process Interface</em>}' reference list.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #getProcessInterface()
	 * @generated
	 * @ordered
	 */
  protected EList processInterface = null;

	/**
	 * The cached value of the '{@link #getProcessDefinition() <em>Process Definition</em>}' reference.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #getProcessDefinition()
	 * @generated
	 * @ordered
	 */
  protected EObject processDefinition = null;

	/**
	 * The cached value of the '{@link #getRelatedArtifacts() <em>Related Artifacts</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelatedArtifacts()
	 * @generated
	 * @ordered
	 */
	protected EList relatedArtifacts = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  protected ProcessFlowImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  protected EClass eStaticClass() {
		return SaPackage.Literals.PROCESS_FLOW;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public ProcessFlowType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public void setType(ProcessFlowType newType) {
		ProcessFlowType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SaPackage.PROCESS_FLOW__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EList getProcessInterface() {
		if (processInterface == null) {
			processInterface = new EObjectResolvingEList(EObject.class, this, SaPackage.PROCESS_FLOW__PROCESS_INTERFACE);
		}
		return processInterface;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EObject getProcessDefinition() {
		if (processDefinition != null && processDefinition.eIsProxy()) {
			InternalEObject oldProcessDefinition = (InternalEObject)processDefinition;
			processDefinition = eResolveProxy(oldProcessDefinition);
			if (processDefinition != oldProcessDefinition) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SaPackage.PROCESS_FLOW__PROCESS_DEFINITION, oldProcessDefinition, processDefinition));
			}
		}
		return processDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EObject basicGetProcessDefinition() {
		return processDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public void setProcessDefinition(EObject newProcessDefinition) {
		EObject oldProcessDefinition = processDefinition;
		processDefinition = newProcessDefinition;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SaPackage.PROCESS_FLOW__PROCESS_DEFINITION, oldProcessDefinition, processDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getRelatedArtifacts() {
		if (relatedArtifacts == null) {
			relatedArtifacts = new EObjectResolvingEList(EObject.class, this, SaPackage.PROCESS_FLOW__RELATED_ARTIFACTS);
		}
		return relatedArtifacts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SaPackage.PROCESS_FLOW__TYPE:
				return getType();
			case SaPackage.PROCESS_FLOW__PROCESS_INTERFACE:
				return getProcessInterface();
			case SaPackage.PROCESS_FLOW__PROCESS_DEFINITION:
				if (resolve) return getProcessDefinition();
				return basicGetProcessDefinition();
			case SaPackage.PROCESS_FLOW__RELATED_ARTIFACTS:
				return getRelatedArtifacts();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SaPackage.PROCESS_FLOW__TYPE:
				setType((ProcessFlowType)newValue);
				return;
			case SaPackage.PROCESS_FLOW__PROCESS_INTERFACE:
				getProcessInterface().clear();
				getProcessInterface().addAll((Collection)newValue);
				return;
			case SaPackage.PROCESS_FLOW__PROCESS_DEFINITION:
				setProcessDefinition((EObject)newValue);
				return;
			case SaPackage.PROCESS_FLOW__RELATED_ARTIFACTS:
				getRelatedArtifacts().clear();
				getRelatedArtifacts().addAll((Collection)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case SaPackage.PROCESS_FLOW__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case SaPackage.PROCESS_FLOW__PROCESS_INTERFACE:
				getProcessInterface().clear();
				return;
			case SaPackage.PROCESS_FLOW__PROCESS_DEFINITION:
				setProcessDefinition((EObject)null);
				return;
			case SaPackage.PROCESS_FLOW__RELATED_ARTIFACTS:
				getRelatedArtifacts().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SaPackage.PROCESS_FLOW__TYPE:
				return type != TYPE_EDEFAULT;
			case SaPackage.PROCESS_FLOW__PROCESS_INTERFACE:
				return processInterface != null && !processInterface.isEmpty();
			case SaPackage.PROCESS_FLOW__PROCESS_DEFINITION:
				return processDefinition != null;
			case SaPackage.PROCESS_FLOW__RELATED_ARTIFACTS:
				return relatedArtifacts != null && !relatedArtifacts.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //ProcessFlowImpl
