/**
 * <copyright>
 *
 *    Copyright IBM Corporation 2003, 2009. All rights reserved.
 *
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package com.ibm.btools.te.ilm.model.sa.impl;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2008, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


import com.ibm.btools.expression.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.impl.EcorePackageImpl;
import org.eclipse.wst.wsdl.WSDLPackage;
import org.eclipse.wst.wsdl.internal.impl.WSDLPackageImpl;

import com.ibm.btools.expression.model.impl.ModelPackageImpl;
import com.ibm.btools.te.ilm.model.abstractbpel.AbstractbpelPackage;
import com.ibm.btools.te.ilm.model.abstractbpel.impl.AbstractbpelPackageImpl;
import com.ibm.btools.te.ilm.model.sa.ComposedArtifact;
import com.ibm.btools.te.ilm.model.sa.HumanTask;
import com.ibm.btools.te.ilm.model.sa.ProcessFlow;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.btools.te.ilm.model.sa.SAType;
import com.ibm.btools.te.ilm.model.sa.SaFactory;
import com.ibm.btools.te.ilm.model.sa.SaPackage;
import com.ibm.btools.te.ilm.model.sa.ScdlArtifact;
import com.ibm.btools.te.ilm.model.sa.SolutionArtifact;
import com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifact;
import com.ibm.btools.te.ilm.model.sa.UnclassifiedArtifactType;
import com.ibm.wbit.bpel.BPELPackage;
import com.ibm.wbit.bpel.impl.BPELPackageImpl;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SaPackageImpl extends EPackageImpl implements SaPackage
{
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EClass solutionArtifactEClass = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EClass composedArtifactEClass = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EClass processFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EClass unclassifiedArtifactEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scdlArtifactEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass humanTaskEClass = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EEnum saTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EEnum processFlowTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private EEnum unclassifiedArtifactTypeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.ibm.btools.te.ilm.model.sa.SaPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
  private SaPackageImpl() {
		super(eNS_URI, SaFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
  public static SaPackage init() {
		if (isInited) return (SaPackage)EPackage.Registry.INSTANCE.getEPackage(SaPackage.eNS_URI);

		// Obtain or create and register package
		SaPackageImpl theSaPackage = (SaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof SaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new SaPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		ModelPackage.eINSTANCE.eClass();
		EcorePackage.eINSTANCE.eClass();
		com.ibm.btools.context.model.ModelPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		EcorePackageImpl theEcorePackage_1 = (EcorePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI) instanceof EcorePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI) : EcorePackage.eINSTANCE);
		AbstractbpelPackageImpl theAbstractbpelPackage = (AbstractbpelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) instanceof AbstractbpelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AbstractbpelPackage.eNS_URI) : AbstractbpelPackage.eINSTANCE);
		BPELPackageImpl theBPELPackage = (BPELPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BPELPackage.eNS_URI) instanceof BPELPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BPELPackage.eNS_URI) : BPELPackage.eINSTANCE);
		WSDLPackageImpl theWSDLPackage = (WSDLPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(WSDLPackage.eNS_URI) instanceof WSDLPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(WSDLPackage.eNS_URI) : WSDLPackage.eINSTANCE);

		// Create package meta-data objects
		theSaPackage.createPackageContents();
		theEcorePackage_1.createPackageContents();
		theAbstractbpelPackage.createPackageContents();
		theBPELPackage.createPackageContents();
		theWSDLPackage.createPackageContents();

		// Initialize created meta-data
		theSaPackage.initializePackageContents();
		theEcorePackage_1.initializePackageContents();
		theAbstractbpelPackage.initializePackageContents();
		theBPELPackage.initializePackageContents();
		theWSDLPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theSaPackage.freeze();

		return theSaPackage;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EClass getSolutionArtifact() {
		return solutionArtifactEClass;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EAttribute getSolutionArtifact_Name() {
		return (EAttribute)solutionArtifactEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EAttribute getSolutionArtifact_Type() {
		return (EAttribute)solutionArtifactEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSolutionArtifact_Package() {
		return (EAttribute)solutionArtifactEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EReference getSolutionArtifact_ComposedArtifacts() {
		return (EReference)solutionArtifactEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EClass getComposedArtifact() {
		return composedArtifactEClass;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EAttribute getComposedArtifact_Name() {
		return (EAttribute)composedArtifactEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EClass getProcessFlow() {
		return processFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EAttribute getProcessFlow_Type() {
		return (EAttribute)processFlowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EReference getProcessFlow_ProcessInterface() {
		return (EReference)processFlowEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EReference getProcessFlow_ProcessDefinition() {
		return (EReference)processFlowEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProcessFlow_RelatedArtifacts() {
		return (EReference)processFlowEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EClass getUnclassifiedArtifact() {
		return unclassifiedArtifactEClass;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EAttribute getUnclassifiedArtifact_Type() {
		return (EAttribute)unclassifiedArtifactEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EReference getUnclassifiedArtifact_Artifacts() {
		return (EReference)unclassifiedArtifactEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScdlArtifact() {
		return scdlArtifactEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScdlArtifact_Artifact() {
		return (EReference)scdlArtifactEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHumanTask() {
		return humanTaskEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHumanTask_Inline() {
		return (EAttribute)humanTaskEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHumanTask_HumanTask() {
		return (EReference)humanTaskEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EEnum getSAType() {
		return saTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EEnum getProcessFlowType() {
		return processFlowTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public EEnum getUnclassifiedArtifactType() {
		return unclassifiedArtifactTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public SaFactory getSaFactory() {
		return (SaFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		solutionArtifactEClass = createEClass(SOLUTION_ARTIFACT);
		createEAttribute(solutionArtifactEClass, SOLUTION_ARTIFACT__NAME);
		createEAttribute(solutionArtifactEClass, SOLUTION_ARTIFACT__TYPE);
		createEAttribute(solutionArtifactEClass, SOLUTION_ARTIFACT__PACKAGE);
		createEReference(solutionArtifactEClass, SOLUTION_ARTIFACT__COMPOSED_ARTIFACTS);

		composedArtifactEClass = createEClass(COMPOSED_ARTIFACT);
		createEAttribute(composedArtifactEClass, COMPOSED_ARTIFACT__NAME);

		processFlowEClass = createEClass(PROCESS_FLOW);
		createEAttribute(processFlowEClass, PROCESS_FLOW__TYPE);
		createEReference(processFlowEClass, PROCESS_FLOW__PROCESS_INTERFACE);
		createEReference(processFlowEClass, PROCESS_FLOW__PROCESS_DEFINITION);
		createEReference(processFlowEClass, PROCESS_FLOW__RELATED_ARTIFACTS);

		unclassifiedArtifactEClass = createEClass(UNCLASSIFIED_ARTIFACT);
		createEAttribute(unclassifiedArtifactEClass, UNCLASSIFIED_ARTIFACT__TYPE);
		createEReference(unclassifiedArtifactEClass, UNCLASSIFIED_ARTIFACT__ARTIFACTS);

		scdlArtifactEClass = createEClass(SCDL_ARTIFACT);
		createEReference(scdlArtifactEClass, SCDL_ARTIFACT__ARTIFACT);

		humanTaskEClass = createEClass(HUMAN_TASK);
		createEAttribute(humanTaskEClass, HUMAN_TASK__INLINE);
		createEReference(humanTaskEClass, HUMAN_TASK__HUMAN_TASK);

		// Create enums
		saTypeEEnum = createEEnum(SA_TYPE);
		processFlowTypeEEnum = createEEnum(PROCESS_FLOW_TYPE);
		unclassifiedArtifactTypeEEnum = createEEnum(UNCLASSIFIED_ARTIFACT_TYPE);
	}

	/**
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		EcorePackage theEcorePackage_1 = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);

		// Add supertypes to classes
		processFlowEClass.getESuperTypes().add(this.getComposedArtifact());
		unclassifiedArtifactEClass.getESuperTypes().add(this.getComposedArtifact());
		scdlArtifactEClass.getESuperTypes().add(this.getComposedArtifact());
		humanTaskEClass.getESuperTypes().add(this.getComposedArtifact());

		// Initialize classes and features; add operations and parameters
		initEClass(solutionArtifactEClass, SolutionArtifact.class, "SolutionArtifact", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSolutionArtifact_Name(), ecorePackage.getEString(), "name", null, 0, 1, SolutionArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSolutionArtifact_Type(), this.getSAType(), "type", null, 0, 1, SolutionArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSolutionArtifact_Package(), ecorePackage.getEString(), "package", null, 0, 1, SolutionArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSolutionArtifact_ComposedArtifacts(), this.getComposedArtifact(), null, "composedArtifacts", null, 0, -1, SolutionArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(composedArtifactEClass, ComposedArtifact.class, "ComposedArtifact", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getComposedArtifact_Name(), ecorePackage.getEString(), "name", null, 0, 1, ComposedArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(processFlowEClass, ProcessFlow.class, "ProcessFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getProcessFlow_Type(), this.getProcessFlowType(), "type", null, 0, 1, ProcessFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProcessFlow_ProcessInterface(), theEcorePackage_1.getEObject(), null, "processInterface", null, 0, -1, ProcessFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProcessFlow_ProcessDefinition(), theEcorePackage_1.getEObject(), null, "processDefinition", null, 0, 1, ProcessFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProcessFlow_RelatedArtifacts(), theEcorePackage_1.getEObject(), null, "relatedArtifacts", null, 0, -1, ProcessFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(unclassifiedArtifactEClass, UnclassifiedArtifact.class, "UnclassifiedArtifact", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUnclassifiedArtifact_Type(), this.getUnclassifiedArtifactType(), "type", null, 0, 1, UnclassifiedArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUnclassifiedArtifact_Artifacts(), theEcorePackage_1.getEObject(), null, "artifacts", null, 1, -1, UnclassifiedArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(scdlArtifactEClass, ScdlArtifact.class, "ScdlArtifact", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getScdlArtifact_Artifact(), theEcorePackage_1.getEObject(), null, "artifact", null, 0, 1, ScdlArtifact.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(humanTaskEClass, HumanTask.class, "HumanTask", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHumanTask_Inline(), ecorePackage.getEBoolean(), "inline", null, 0, 1, HumanTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHumanTask_HumanTask(), theEcorePackage_1.getEObject(), null, "humanTask", null, 0, 1, HumanTask.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(saTypeEEnum, SAType.class, "SAType");
		addEEnumLiteral(saTypeEEnum, SAType.PROCESS_FLOW_LITERAL);
		addEEnumLiteral(saTypeEEnum, SAType.ADAPTIVE_ENTITY_LITERAL);
		addEEnumLiteral(saTypeEEnum, SAType.SCDL_LITERAL);
		addEEnumLiteral(saTypeEEnum, SAType.UNCLASSIFIED_LITERAL);
		addEEnumLiteral(saTypeEEnum, SAType.HUMAN_TASK_LITERAL);

		initEEnum(processFlowTypeEEnum, ProcessFlowType.class, "ProcessFlowType");
		addEEnumLiteral(processFlowTypeEEnum, ProcessFlowType.BPEL_LITERAL);
		addEEnumLiteral(processFlowTypeEEnum, ProcessFlowType.BPELPP_LITERAL);
		addEEnumLiteral(processFlowTypeEEnum, ProcessFlowType.FDL_LITERAL);

		initEEnum(unclassifiedArtifactTypeEEnum, UnclassifiedArtifactType.class, "UnclassifiedArtifactType");
		addEEnumLiteral(unclassifiedArtifactTypeEEnum, UnclassifiedArtifactType.WEB_SERVICES_INTERFACE_LITERAL);
		addEEnumLiteral(unclassifiedArtifactTypeEEnum, UnclassifiedArtifactType.XML_SCHEMA_LITERAL);
		addEEnumLiteral(unclassifiedArtifactTypeEEnum, UnclassifiedArtifactType.WORKFLOW_DEFINITION_LITERAL);
		addEEnumLiteral(unclassifiedArtifactTypeEEnum, UnclassifiedArtifactType.XFDL_LITERAL);

		// Create resource
		createResource(eNS_URI);
	}

} //SaPackageImpl
