package com.ibm.btools.te.ilm.resource;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/
import java.util.ResourceBundle;

import com.ibm.btools.util.resource.ResourceBundleSingleton;
import com.ibm.btools.util.resource.UtilResourceBundleSingleton;

/**
 * This is the resource bundle singleton for the te heuristics project
 */
public class TEResourceBundleSingleton extends ResourceBundleSingleton {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	
	/* The resource bundle for the TE Heuristics project */
	private static ResourceBundle resourceBundle;
	
	/* The singleton instance of this class */
	public static final TEResourceBundleSingleton INSTANCE;

	static {
		/* Initialize the singleton instance only once */
		INSTANCE = new TEResourceBundleSingleton();
		resourceBundle = ResourceBundle.getBundle(MessageKeys.RESOURCE_PROPERTY_FILE);
	}

	protected TEResourceBundleSingleton(){
		super ();
		
	}	

	public String getMessage(String aKey) {
		final String message = UtilResourceBundleSingleton.INSTANCE.getMessage(MessageKeys.class, aKey);
			if (message == null) {
				return aKey;
			} else {
				return message;
			}
	}

}
