package com.ibm.btools.te.ilm.rulehandler.mapping;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.framework.rulehandler.RuleHandler;

/**
 * Generic RuleHandler for ObjectDefinition mapping which is the super class of all the 
 * mapping rule handlers
 */
public class MappingRuleHandler extends RuleHandler {
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	/**
	 * Generic handleRule. Given a rule it will create the <code>ObjectDefinitions</code>for it's source and 
	 * target. The first element of the source and the target will be assumed to be the mapping 
	 * source and target
	 */
	public void handleRule(TransformationRule rule) {
		// Default MapDefinition Handling		
		MappingManager mapMgr = getMappingManager(rule);
		if(!rule.getSource().isEmpty() && !rule.getTarget().isEmpty())
		mapMgr.addMapDefinition((EObject)rule.getSource().get(0),(EObject)rule.getTarget().get(0));

	}

	/**
	 * Returns the MappingMananger in the <code>TransformationRule</code> context 
	 * @param rule
	 * @return MappingManager in the rule context.
	 */
	protected MappingManager getMappingManager(TransformationRule rule) {
		return MappingManager.getInstance(rule.getRoot().getContext());
	}
}
