package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.wbit.bpel.Assign;

/**
 * This handler is responsbile for creating the ObjectDenifition mapping between 
 *BOM <code> ActivityEdge </code> and BPEL <code>Assign </code>
 */
public class AssignRuleHandler extends ConnectableRuleHandler {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 

	/**
	 * Handles the AssignRule.
	 * @param rule The AssignRule that has just executed.
	 */
	public void handleRule(TransformationRule rule) {
		//BOM edge, Outputset (source set), Inputset (target set) 
		//This should be the ActivityEdge
		EObject src = (EObject)rule.getSource().get(0);
		EObject tar = null;
		if(rule.getTarget() != null && !rule.getTarget().isEmpty()){
			Iterator tarIt = rule.getTarget().iterator();
			while(tarIt.hasNext()){
				Object each = tarIt.next();
				if(each instanceof Assign){
					tar = (Assign)each;
					break;
				}
			}
		}
		if(src != null && tar != null){
			MappingManager mapMgr = getMappingManager(rule);
			mapMgr.addMapDefinition(src,tar); 	
		}
	}		
}
