package com.ibm.btools.te.ilm.rulehandler.mapping.wps;
/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;

import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.StructuredActivityNode;
import com.ibm.btools.bom.model.processes.businessrules.BusinessRuleAction;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.wbiservers.businessrule.model.brg.BusinessRuleGroup;
import com.ibm.wbiservers.businessrule.model.brgt.BusinessRuleGroupTable;
import com.ibm.wbiservers.common.componentdef.PortType;
import com.ibm.wbiservers.common.componentdef.WSDL;
import com.ibm.wbit.br.core.model.RuleSet;
/**
 This handler is responsbile for creating the ObjectDefinition mapping between
 *the source and target: 
 *SOURCE: BOM InputPinSet
 *TARGET: BRG, BRGT, RULESET DocumentRoot
 */
public class BRTaskRuleHandler extends ConnectableRuleHandler {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 	
	/**	
	 * @param rule The BRTaskRule that has just executed.
	 */
	public void handleRule(TransformationRule rule) {

		InputPinSet inputSet = (InputPinSet)rule.getSource().get(0);
		BusinessRuleAction action = (BusinessRuleAction)inputSet.getAction();
		if (rule.getTarget() != null) {
			Iterator it = rule.getTarget().iterator();
			EObject component = null;
			while (it.hasNext()) {
				component = (EObject)it.next();				
				if (component instanceof BusinessRuleGroup || component instanceof BusinessRuleGroupTable || component instanceof RuleSet) {
					MappingManager mapMgr = getMappingManager(rule);
					WSDL  wsdl = null;
					PortType pt = null;
					BusinessRuleGroup brg = null;
					if(component instanceof BusinessRuleGroup ){
						brg = (BusinessRuleGroup)component;
						wsdl = brg.getWSDL();
						//assume only one portType						
						if(wsdl != null && wsdl.getPortTypes()!= null && wsdl.getPortTypes().size() > 0){
							pt = (PortType)wsdl.getPortTypes().get(0);
						}						
					}						
					if (((StructuredActivityNode)action).getActivity()!=null) {
						mapMgr.addMapDefinition(((StructuredActivityNode)action).getActivity(),component);
						if(wsdl != null && pt != null){
							mapMgr.addMapDefinition(((StructuredActivityNode)action).getActivity(), wsdl);
							mapMgr.addMapDefinition(((StructuredActivityNode)action).getActivity(), pt);
						}
						BusinessRuleGroupTable brgt = brg.getBusinessRuleGroupTable();
						mapMgr.addMapDefinition(((StructuredActivityNode)action).getActivity(), brgt);
						return;
					}					
					mapMgr.addMapDefinition(action,component);
					if(wsdl != null && pt != null){
						mapMgr.addMapDefinition(action, wsdl);
						mapMgr.addMapDefinition(action, pt);
					}
					if(brg != null){
						BusinessRuleGroupTable brgt = brg.getBusinessRuleGroupTable();
						mapMgr.addMapDefinition(action, brgt);
					}
				}
			}
		}
	}	
}
