package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.ForkRuleImpl;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.wbit.bpel.Activity;

/**
 *This handler is responsbile for creating the ObjectDefinition mapping between
 *the source and target: 
 * source = input set of a BOM fork node
 * target = <BPEL Empty>
 */
public class ForkRuleHandler extends ConnectableRuleHandler {
	
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	/**	 
	 * @param rule The Fork rule that has just executed.
	 */
	public void handleRule(TransformationRule rule) {		
	    InputPinSet inputPinSet = (InputPinSet)rule.getSource().get(0);
	    Action san = (Action)inputPinSet.getAction();
//		
	    Activity bpelForkActivity = (Activity)((ForkRuleImpl)rule).getForkActivity();
	    MappingManager mapMgr = getMappingManager(rule);
	    
	    if (bpelForkActivity != null){
	        mapMgr.addMapDefinition(san, bpelForkActivity);
	    } 
	}

}
