package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.List;

import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.InvokeRuleImpl;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingUtil;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpelpp.Task;
import com.ibm.wbit.bpelpp.impl.TaskImpl;


/**
 * This handler is responsible for creating the ObjectDefinition mapping between
 * the source and target: 
 * SOURCE: BOM InputPinSet (on a SAN or CBA)
 * TARGET: BPEL Task
 */
public class HTTaskRuleHandler extends ConnectableRuleHandler {

	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	@SuppressWarnings("unchecked")
	public void handleRule(TransformationRule rule) {
		InputPinSet inputPinSet = (InputPinSet)rule.getSource().get(0);	   
	    MappingManager mapMgr = getMappingManager(rule);
	    
		Invoke bpelInvoke = null;
		
		for (TransformationRule childRule : (List<TransformationRule>)rule.getChildRules()) {
			//(Invoke)rule.getTarget().get(0);	
			if (childRule instanceof InvokeRuleImpl) {
				bpelInvoke = (Invoke) childRule.getTarget().get(0);
				break;
			}
		}
		
		if (bpelInvoke == null) {
			//Can't find invoke rule
			return;
		}
		
        Task staffTask = (Task)MappingUtil.getExtensibilityElement(bpelInvoke, TaskImpl.class);
        if (staffTask!=null) {
        	mapMgr.addMapDefinition(inputPinSet,staffTask);	
        }
	    
	}
}
