package com.ibm.btools.te.ilm.rulehandler.mapping.wps;

/*
* Licensed Materials - Property of IBM
* 5724-I74, 5724-I75
*  Copyright IBM Corporation 2003, 2009. All rights reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.List;

import com.ibm.btools.bom.model.processes.activities.Action;
import com.ibm.btools.bom.model.processes.activities.InputPinSet;
import com.ibm.btools.bom.model.processes.activities.OutputPinSet;
import com.ibm.btools.te.framework.TransformationRule;
import com.ibm.btools.te.ilm.heuristics.abstractbpel.impl.MapRuleImpl;
import com.ibm.btools.te.ilm.model.abstractbpel.AlternativeActivity;
import com.ibm.btools.te.ilm.model.sa.ProcessFlowType;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingManager;
import com.ibm.btools.te.ilm.rulehandler.mapping.MappingUtil;
import com.ibm.wbit.bpel.Activity;
import com.ibm.wbit.bpel.Assign;
import com.ibm.wbit.bpel.Copy;
import com.ibm.wbit.bpel.Invoke;
import com.ibm.wbit.bpelpp.JavaScriptActivity;
import com.ibm.wbit.bpelpp.Task;
import com.ibm.wbit.bpelpp.impl.JavaScriptActivityImpl;
import com.ibm.wbit.bpelpp.impl.TaskImpl;

/**
 *This handler is responsbile for creating the ObjectDefinition mapping between
 *the source and target: 
 *SOURCE: BOM Action
 *TARGET: AlternativeActivity/JavaScriptActivity
 *
 */
public class MapRuleHandler extends ConnectableRuleHandler {
	
	public static final String copyright = "Licensed Material - Property of IBM " + " 5724-I74, 5724-I75 " + "(C) Copyright IBM Corporation 2003, 2009. All Rights Reserved. " + "U.S. Government Users Restricted Rights - Use, duplication or disclosure " + "restricted by GSA ADP Schedule Contract with IBM Corp.".intern(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ 
	
	/**
	 * @param rule The MapRule that has just executed.
	 */
	public void handleRule(TransformationRule rule) {		
		
	    InputPinSet inputPinSet = (InputPinSet)rule.getSource().get(0);
	    Action san = (Action)inputPinSet.getAction();
		
	    Activity bpelMapActivity = (Activity)((MapRuleImpl)rule).getMapActivity();
		
	  //  Invoke bpelInvoke = (Invoke)rule.getTarget().get(0);
	    
	    MappingManager mapMgr = getMappingManager(rule);
	   // mapMgr.addMapDefinition(san, bpelInvoke);
	    
	    if (bpelMapActivity instanceof AlternativeActivity){
	        bpelMapActivity = MappingUtil.getAlternative((AlternativeActivity)bpelMapActivity, ProcessFlowType.BPELPP_LITERAL);
	        mapMgr.addMapDefinition(san, bpelMapActivity);
	        
	        if (bpelMapActivity instanceof Assign) {
	        	for (Copy copy : (List<Copy>) ( ((Assign)bpelMapActivity).getCopy()) ) {
	        		mapMgr.addMapDefinition(((MapRuleImpl)rule).getObjectMappedToCopy(copy), copy);
	        	}
	        }
	        //Map the copies inside the assign
	    } 
	    //should we set the target the JavaScript or the BPELP Invoke?
	    if(bpelMapActivity instanceof Invoke && bpelMapActivity.getEExtensibilityElements()!= null && !bpelMapActivity.getEExtensibilityElements().isEmpty()){
	    	JavaScriptActivity scriptActivity = (JavaScriptActivity)MappingUtil.getExtensibilityElement(bpelMapActivity, JavaScriptActivityImpl.class);
	    	if(scriptActivity != null){	    		
	    		mapMgr.addMapDefinition(san, scriptActivity);
	    	}
	    }


	}

}
